#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1407
#define LARGE_STATE_COUNT 327
#define SYMBOL_COUNT 302
#define ALIAS_COUNT 1
#define TOKEN_COUNT 154
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 16
#define MAX_ALIAS_SEQUENCE_LENGTH 12

enum {
  sym_name = 1,
  sym_php_tag = 2,
  anon_sym_QMARK_GT = 3,
  aux_sym_text_token1 = 4,
  aux_sym_text_token2 = 5,
  anon_sym_SEMI = 6,
  anon_sym_static = 7,
  anon_sym_COMMA = 8,
  anon_sym_EQ = 9,
  anon_sym_global = 10,
  anon_sym_namespace = 11,
  anon_sym_use = 12,
  anon_sym_BSLASH = 13,
  anon_sym_function = 14,
  anon_sym_const = 15,
  anon_sym_as = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  anon_sym_trait = 19,
  anon_sym_interface = 20,
  anon_sym_extends = 21,
  anon_sym_class = 22,
  anon_sym_abstract = 23,
  anon_sym_final = 24,
  anon_sym_implements = 25,
  sym_var_modifier = 26,
  anon_sym_insteadof = 27,
  anon_sym_public = 28,
  anon_sym_protected = 29,
  anon_sym_private = 30,
  anon_sym_AMP = 31,
  anon_sym_LPAREN = 32,
  anon_sym_RPAREN = 33,
  anon_sym_DOT_DOT_DOT = 34,
  anon_sym_QMARK = 35,
  anon_sym_array = 36,
  anon_sym_callable = 37,
  anon_sym_iterable = 38,
  anon_sym_bool = 39,
  anon_sym_float = 40,
  anon_sym_int = 41,
  anon_sym_string = 42,
  anon_sym_void = 43,
  anon_sym_binary = 44,
  anon_sym_boolean = 45,
  anon_sym_double = 46,
  anon_sym_integer = 47,
  anon_sym_object = 48,
  anon_sym_real = 49,
  anon_sym_unset = 50,
  anon_sym_COLON = 51,
  anon_sym_echo = 52,
  anon_sym_declare = 53,
  anon_sym_enddeclare = 54,
  anon_sym_ticks = 55,
  anon_sym_encoding = 56,
  anon_sym_strict_types = 57,
  sym_float = 58,
  anon_sym_try = 59,
  anon_sym_catch = 60,
  anon_sym_finally = 61,
  anon_sym_goto = 62,
  anon_sym_continue = 63,
  anon_sym_break = 64,
  sym_integer = 65,
  anon_sym_return = 66,
  anon_sym_throw = 67,
  anon_sym_while = 68,
  anon_sym_endwhile = 69,
  anon_sym_do = 70,
  anon_sym_for = 71,
  anon_sym_endfor = 72,
  anon_sym_foreach = 73,
  anon_sym_endforeach = 74,
  anon_sym_EQ_GT = 75,
  anon_sym_if = 76,
  anon_sym_endif = 77,
  anon_sym_elseif = 78,
  anon_sym_else = 79,
  anon_sym_switch = 80,
  anon_sym_endswitch = 81,
  anon_sym_case = 82,
  anon_sym_default = 83,
  anon_sym_AT = 84,
  anon_sym_PLUS = 85,
  anon_sym_DASH = 86,
  anon_sym_TILDE = 87,
  anon_sym_BANG = 88,
  anon_sym_STAR_STAR = 89,
  anon_sym_clone = 90,
  anon_sym_COLON_COLON = 91,
  anon_sym_print = 92,
  anon_sym_new = 93,
  anon_sym_LBRACK = 94,
  anon_sym_RBRACK = 95,
  anon_sym_DASH_GT = 96,
  anon_sym_PLUS_PLUS = 97,
  anon_sym_DASH_DASH = 98,
  sym_shell_command_expression = 99,
  anon_sym_STAR_STAR_EQ = 100,
  anon_sym_STAR_EQ = 101,
  anon_sym_SLASH_EQ = 102,
  anon_sym_PERCENT_EQ = 103,
  anon_sym_PLUS_EQ = 104,
  anon_sym_DASH_EQ = 105,
  anon_sym_DOT_EQ = 106,
  anon_sym_LT_LT_EQ = 107,
  anon_sym_GT_GT_EQ = 108,
  anon_sym_AMP_EQ = 109,
  anon_sym_CARET_EQ = 110,
  anon_sym_PIPE_EQ = 111,
  anon_sym_list = 112,
  anon_sym_self = 113,
  anon_sym_parent = 114,
  sym_string = 115,
  sym_boolean = 116,
  sym_null = 117,
  anon_sym_DOLLAR = 118,
  anon_sym_yield = 119,
  anon_sym_from = 120,
  anon_sym_instanceof = 121,
  anon_sym_QMARK_QMARK = 122,
  aux_sym_binary_expression_token1 = 123,
  aux_sym_binary_expression_token2 = 124,
  aux_sym_binary_expression_token3 = 125,
  anon_sym_PIPE_PIPE = 126,
  anon_sym_AMP_AMP = 127,
  anon_sym_PIPE = 128,
  anon_sym_CARET = 129,
  anon_sym_EQ_EQ = 130,
  anon_sym_BANG_EQ = 131,
  anon_sym_LT_GT = 132,
  anon_sym_EQ_EQ_EQ = 133,
  anon_sym_BANG_EQ_EQ = 134,
  anon_sym_LT = 135,
  anon_sym_GT = 136,
  anon_sym_LT_EQ = 137,
  anon_sym_GT_EQ = 138,
  anon_sym_LT_EQ_GT = 139,
  anon_sym_LT_LT = 140,
  anon_sym_GT_GT = 141,
  anon_sym_DOT = 142,
  anon_sym_STAR = 143,
  anon_sym_SLASH = 144,
  anon_sym_PERCENT = 145,
  anon_sym_include = 146,
  anon_sym_include_once = 147,
  anon_sym_require = 148,
  anon_sym_require_once = 149,
  sym_comment = 150,
  sym__automatic_semicolon = 151,
  sym_heredoc = 152,
  sym__eof = 153,
  sym_program = 154,
  sym_text_interpolation = 155,
  sym_text = 156,
  sym_empty_statement = 157,
  sym_function_static_declaration = 158,
  sym_static_variable_declaration = 159,
  sym_global_declaration = 160,
  sym_namespace_definition = 161,
  sym_namespace_use_declaration = 162,
  sym_namespace_function_or_const = 163,
  sym_namespace_use_clause = 164,
  sym_qualified_name = 165,
  sym_namespace_name_as_prefix = 166,
  sym_namespace_name = 167,
  sym_namespace_aliasing_clause = 168,
  sym_namespace_use_group = 169,
  sym_namespace_use_group_clause = 170,
  sym_trait_declaration = 171,
  sym_interface_declaration = 172,
  sym_interface_base_clause = 173,
  sym_class_declaration = 174,
  sym_declaration_list = 175,
  sym_class_modifier = 176,
  sym_class_base_clause = 177,
  sym_class_interface_clause = 178,
  sym__member_declaration = 179,
  sym_const_declaration = 180,
  sym_property_declaration = 181,
  sym__modifier = 182,
  sym_property_element = 183,
  sym_property_initializer = 184,
  sym_method_declaration = 185,
  sym_static_modifier = 186,
  sym_use_declaration = 187,
  sym_use_list = 188,
  sym_use_instead_of_clause = 189,
  sym_use_as_clause = 190,
  sym_visibility_modifier = 191,
  sym_function_definition = 192,
  sym__function_definition_header = 193,
  sym_formal_parameters = 194,
  sym_simple_parameter = 195,
  sym_variadic_parameter = 196,
  sym__type = 197,
  sym_optional_type = 198,
  sym_primitive_type = 199,
  sym_cast_type = 200,
  sym__return_type = 201,
  sym_const_element = 202,
  sym_echo_statement = 203,
  sym_unset_statement = 204,
  sym_declare_statement = 205,
  sym_declare_directive = 206,
  sym_try_statement = 207,
  sym_catch_clause = 208,
  sym_finally_clause = 209,
  sym__jump_statement = 210,
  sym_goto_statement = 211,
  sym_continue_statement = 212,
  sym_break_statement = 213,
  sym_return_statement = 214,
  sym_throw_statement = 215,
  sym_while_statement = 216,
  sym_do_statement = 217,
  sym_for_statement = 218,
  sym__expressions = 219,
  sym_sequence_expression = 220,
  sym_foreach_statement = 221,
  sym_foreach_pair = 222,
  sym_if_statement = 223,
  sym_colon_block = 224,
  sym_else_if_clause = 225,
  sym_else_clause = 226,
  sym_else_if_clause_2 = 227,
  sym_else_clause_2 = 228,
  sym_switch_statement = 229,
  sym_switch_block = 230,
  sym_case_statement = 231,
  sym_default_statement = 232,
  sym_compound_statement = 233,
  sym_named_label_statement = 234,
  sym_expression_statement = 235,
  sym__expression = 236,
  sym__unary_expression = 237,
  sym_unary_op_expression = 238,
  sym_exponentiation_expression = 239,
  sym_clone_expression = 240,
  sym__primary_expression = 241,
  sym_parenthesized_expression = 242,
  sym_class_constant_access_expression = 243,
  sym_print_intrinsic = 244,
  sym_anonymous_function_creation_expression = 245,
  sym_anonymous_function_use_clause = 246,
  sym_object_creation_expression = 247,
  sym_new_variable = 248,
  sym_update_expression = 249,
  sym_cast_expression = 250,
  sym_cast_variable = 251,
  sym_assignment_expression = 252,
  sym_conditional_expression = 253,
  sym_augmented_assignment_expression = 254,
  sym_member_access_expression = 255,
  sym_scoped_property_access_expression = 256,
  sym_list_literal = 257,
  sym_function_call_expression = 258,
  sym_scoped_call_expression = 259,
  sym__scope_resolution_qualifier = 260,
  sym_relative_scope = 261,
  sym_arguments = 262,
  sym_member_call_expression = 263,
  sym_variadic_unpacking = 264,
  sym_subscript_expression = 265,
  sym__dereferencable_expression = 266,
  sym_array_creation_expression = 267,
  sym__string = 268,
  sym_dynamic_variable_name = 269,
  sym_variable_name = 270,
  sym_yield_expression = 271,
  sym_array_element_initializer = 272,
  sym_binary_expression = 273,
  sym_include_expression = 274,
  sym_include_once_expression = 275,
  sym_require_expression = 276,
  sym_require_once_expression = 277,
  sym__reserved_identifier = 278,
  aux_sym_program_repeat1 = 279,
  aux_sym_text_repeat1 = 280,
  aux_sym_function_static_declaration_repeat1 = 281,
  aux_sym_global_declaration_repeat1 = 282,
  aux_sym_namespace_use_declaration_repeat1 = 283,
  aux_sym_namespace_name_repeat1 = 284,
  aux_sym_namespace_use_group_repeat1 = 285,
  aux_sym_interface_base_clause_repeat1 = 286,
  aux_sym_declaration_list_repeat1 = 287,
  aux_sym_const_declaration_repeat1 = 288,
  aux_sym_property_declaration_repeat1 = 289,
  aux_sym_property_declaration_repeat2 = 290,
  aux_sym_use_list_repeat1 = 291,
  aux_sym_formal_parameters_repeat1 = 292,
  aux_sym_unset_statement_repeat1 = 293,
  aux_sym_try_statement_repeat1 = 294,
  aux_sym_if_statement_repeat1 = 295,
  aux_sym_if_statement_repeat2 = 296,
  aux_sym_switch_block_repeat1 = 297,
  aux_sym_anonymous_function_use_clause_repeat1 = 298,
  aux_sym_list_literal_repeat1 = 299,
  aux_sym_arguments_repeat1 = 300,
  aux_sym_array_creation_expression_repeat1 = 301,
  alias_sym_type_name = 302,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [sym_php_tag] = "php_tag",
  [anon_sym_QMARK_GT] = "?>",
  [aux_sym_text_token1] = "text_token1",
  [aux_sym_text_token2] = "text_token2",
  [anon_sym_SEMI] = ";",
  [anon_sym_static] = "static",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_namespace] = "namespace",
  [anon_sym_use] = "use",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_function] = "function",
  [anon_sym_const] = "const",
  [anon_sym_as] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_trait] = "trait",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_class] = "class",
  [anon_sym_abstract] = "abstract",
  [anon_sym_final] = "final",
  [anon_sym_implements] = "implements",
  [sym_var_modifier] = "var_modifier",
  [anon_sym_insteadof] = "insteadof",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_AMP] = "&",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_array] = "array",
  [anon_sym_callable] = "callable",
  [anon_sym_iterable] = "iterable",
  [anon_sym_bool] = "bool",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [anon_sym_void] = "void",
  [anon_sym_binary] = "binary",
  [anon_sym_boolean] = "boolean",
  [anon_sym_double] = "double",
  [anon_sym_integer] = "integer",
  [anon_sym_object] = "object",
  [anon_sym_real] = "real",
  [anon_sym_unset] = "unset",
  [anon_sym_COLON] = ":",
  [anon_sym_echo] = "echo",
  [anon_sym_declare] = "declare",
  [anon_sym_enddeclare] = "enddeclare",
  [anon_sym_ticks] = "ticks",
  [anon_sym_encoding] = "encoding",
  [anon_sym_strict_types] = "strict_types",
  [sym_float] = "float",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_goto] = "goto",
  [anon_sym_continue] = "continue",
  [anon_sym_break] = "break",
  [sym_integer] = "integer",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_while] = "while",
  [anon_sym_endwhile] = "endwhile",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_endfor] = "endfor",
  [anon_sym_foreach] = "foreach",
  [anon_sym_endforeach] = "endforeach",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_if] = "if",
  [anon_sym_endif] = "endif",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_endswitch] = "endswitch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_AT] = "@",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_clone] = "clone",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_print] = "print",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_shell_command_expression] = "shell_command_expression",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_list] = "list",
  [anon_sym_self] = "self",
  [anon_sym_parent] = "parent",
  [sym_string] = "string",
  [sym_boolean] = "boolean",
  [sym_null] = "null",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_yield] = "yield",
  [anon_sym_from] = "from",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_QMARK_QMARK] = "??",
  [aux_sym_binary_expression_token1] = "and",
  [aux_sym_binary_expression_token2] = "or",
  [aux_sym_binary_expression_token3] = "xor",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_include] = "include",
  [anon_sym_include_once] = "include_once",
  [anon_sym_require] = "require",
  [anon_sym_require_once] = "require_once",
  [sym_comment] = "comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym_heredoc] = "heredoc",
  [sym__eof] = "_eof",
  [sym_program] = "program",
  [sym_text_interpolation] = "text_interpolation",
  [sym_text] = "text",
  [sym_empty_statement] = "empty_statement",
  [sym_function_static_declaration] = "function_static_declaration",
  [sym_static_variable_declaration] = "static_variable_declaration",
  [sym_global_declaration] = "global_declaration",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_use_declaration] = "namespace_use_declaration",
  [sym_namespace_function_or_const] = "namespace_function_or_const",
  [sym_namespace_use_clause] = "namespace_use_clause",
  [sym_qualified_name] = "qualified_name",
  [sym_namespace_name_as_prefix] = "namespace_name_as_prefix",
  [sym_namespace_name] = "namespace_name",
  [sym_namespace_aliasing_clause] = "namespace_aliasing_clause",
  [sym_namespace_use_group] = "namespace_use_group",
  [sym_namespace_use_group_clause] = "namespace_use_group_clause",
  [sym_trait_declaration] = "trait_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_interface_base_clause] = "interface_base_clause",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_class_modifier] = "class_modifier",
  [sym_class_base_clause] = "class_base_clause",
  [sym_class_interface_clause] = "class_interface_clause",
  [sym__member_declaration] = "_member_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__modifier] = "_modifier",
  [sym_property_element] = "property_element",
  [sym_property_initializer] = "property_initializer",
  [sym_method_declaration] = "method_declaration",
  [sym_static_modifier] = "static_modifier",
  [sym_use_declaration] = "use_declaration",
  [sym_use_list] = "use_list",
  [sym_use_instead_of_clause] = "use_instead_of_clause",
  [sym_use_as_clause] = "use_as_clause",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_function_definition] = "function_definition",
  [sym__function_definition_header] = "_function_definition_header",
  [sym_formal_parameters] = "formal_parameters",
  [sym_simple_parameter] = "simple_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym__type] = "_type",
  [sym_optional_type] = "optional_type",
  [sym_primitive_type] = "primitive_type",
  [sym_cast_type] = "cast_type",
  [sym__return_type] = "_return_type",
  [sym_const_element] = "const_element",
  [sym_echo_statement] = "echo_statement",
  [sym_unset_statement] = "unset_statement",
  [sym_declare_statement] = "declare_statement",
  [sym_declare_directive] = "declare_directive",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym__jump_statement] = "_jump_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__expressions] = "_expressions",
  [sym_sequence_expression] = "sequence_expression",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_pair] = "pair",
  [sym_if_statement] = "if_statement",
  [sym_colon_block] = "colon_block",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_else_if_clause_2] = "else_if_clause",
  [sym_else_clause_2] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_case_statement] = "case_statement",
  [sym_default_statement] = "default_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_named_label_statement] = "named_label_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_op_expression] = "unary_op_expression",
  [sym_exponentiation_expression] = "exponentiation_expression",
  [sym_clone_expression] = "clone_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_constant_access_expression] = "class_constant_access_expression",
  [sym_print_intrinsic] = "print_intrinsic",
  [sym_anonymous_function_creation_expression] = "anonymous_function_creation_expression",
  [sym_anonymous_function_use_clause] = "anonymous_function_use_clause",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_new_variable] = "new_variable",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_variable] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_scoped_property_access_expression] = "scoped_property_access_expression",
  [sym_list_literal] = "list_literal",
  [sym_function_call_expression] = "function_call_expression",
  [sym_scoped_call_expression] = "scoped_call_expression",
  [sym__scope_resolution_qualifier] = "_scope_resolution_qualifier",
  [sym_relative_scope] = "relative_scope",
  [sym_arguments] = "arguments",
  [sym_member_call_expression] = "member_call_expression",
  [sym_variadic_unpacking] = "variadic_unpacking",
  [sym_subscript_expression] = "subscript_expression",
  [sym__dereferencable_expression] = "_dereferencable_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym__string] = "_string",
  [sym_dynamic_variable_name] = "dynamic_variable_name",
  [sym_variable_name] = "variable_name",
  [sym_yield_expression] = "yield_expression",
  [sym_array_element_initializer] = "array_element_initializer",
  [sym_binary_expression] = "binary_expression",
  [sym_include_expression] = "include_expression",
  [sym_include_once_expression] = "include_once_expression",
  [sym_require_expression] = "require_expression",
  [sym_require_once_expression] = "require_once_expression",
  [sym__reserved_identifier] = "name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_text_repeat1] = "text_repeat1",
  [aux_sym_function_static_declaration_repeat1] = "function_static_declaration_repeat1",
  [aux_sym_global_declaration_repeat1] = "global_declaration_repeat1",
  [aux_sym_namespace_use_declaration_repeat1] = "namespace_use_declaration_repeat1",
  [aux_sym_namespace_name_repeat1] = "namespace_name_repeat1",
  [aux_sym_namespace_use_group_repeat1] = "namespace_use_group_repeat1",
  [aux_sym_interface_base_clause_repeat1] = "interface_base_clause_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_property_declaration_repeat1] = "property_declaration_repeat1",
  [aux_sym_property_declaration_repeat2] = "property_declaration_repeat2",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_unset_statement_repeat1] = "unset_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_if_statement_repeat2] = "if_statement_repeat2",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_anonymous_function_use_clause_repeat1] = "anonymous_function_use_clause_repeat1",
  [aux_sym_list_literal_repeat1] = "list_literal_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [alias_sym_type_name] = "type_name",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [sym_php_tag] = sym_php_tag,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [aux_sym_text_token2] = aux_sym_text_token2,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_implements] = anon_sym_implements,
  [sym_var_modifier] = sym_var_modifier,
  [anon_sym_insteadof] = anon_sym_insteadof,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_array] = anon_sym_array,
  [anon_sym_callable] = anon_sym_callable,
  [anon_sym_iterable] = anon_sym_iterable,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_integer] = anon_sym_integer,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_real] = anon_sym_real,
  [anon_sym_unset] = anon_sym_unset,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_echo] = anon_sym_echo,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_enddeclare] = anon_sym_enddeclare,
  [anon_sym_ticks] = anon_sym_ticks,
  [anon_sym_encoding] = anon_sym_encoding,
  [anon_sym_strict_types] = anon_sym_strict_types,
  [sym_float] = sym_float,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_break] = anon_sym_break,
  [sym_integer] = sym_integer,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_endwhile] = anon_sym_endwhile,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_endfor] = anon_sym_endfor,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_endforeach] = anon_sym_endforeach,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_endif] = anon_sym_endif,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_endswitch] = anon_sym_endswitch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_clone] = anon_sym_clone,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_shell_command_expression] = sym_shell_command_expression,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_list] = anon_sym_list,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_parent] = anon_sym_parent,
  [sym_string] = sym_string,
  [sym_boolean] = sym_boolean,
  [sym_null] = sym_null,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [aux_sym_binary_expression_token1] = aux_sym_binary_expression_token1,
  [aux_sym_binary_expression_token2] = aux_sym_binary_expression_token2,
  [aux_sym_binary_expression_token3] = aux_sym_binary_expression_token3,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_include_once] = anon_sym_include_once,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_require_once] = anon_sym_require_once,
  [sym_comment] = sym_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym_heredoc] = sym_heredoc,
  [sym__eof] = sym__eof,
  [sym_program] = sym_program,
  [sym_text_interpolation] = sym_text_interpolation,
  [sym_text] = sym_text,
  [sym_empty_statement] = sym_empty_statement,
  [sym_function_static_declaration] = sym_function_static_declaration,
  [sym_static_variable_declaration] = sym_static_variable_declaration,
  [sym_global_declaration] = sym_global_declaration,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_use_declaration] = sym_namespace_use_declaration,
  [sym_namespace_function_or_const] = sym_namespace_function_or_const,
  [sym_namespace_use_clause] = sym_namespace_use_clause,
  [sym_qualified_name] = sym_qualified_name,
  [sym_namespace_name_as_prefix] = sym_namespace_name_as_prefix,
  [sym_namespace_name] = sym_namespace_name,
  [sym_namespace_aliasing_clause] = sym_namespace_aliasing_clause,
  [sym_namespace_use_group] = sym_namespace_use_group,
  [sym_namespace_use_group_clause] = sym_namespace_use_group_clause,
  [sym_trait_declaration] = sym_trait_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_interface_base_clause] = sym_interface_base_clause,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_class_modifier] = sym_class_modifier,
  [sym_class_base_clause] = sym_class_base_clause,
  [sym_class_interface_clause] = sym_class_interface_clause,
  [sym__member_declaration] = sym__member_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym__modifier] = sym__modifier,
  [sym_property_element] = sym_property_element,
  [sym_property_initializer] = sym_property_initializer,
  [sym_method_declaration] = sym_method_declaration,
  [sym_static_modifier] = sym_static_modifier,
  [sym_use_declaration] = sym_use_declaration,
  [sym_use_list] = sym_use_list,
  [sym_use_instead_of_clause] = sym_use_instead_of_clause,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_function_definition] = sym_function_definition,
  [sym__function_definition_header] = sym__function_definition_header,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_simple_parameter] = sym_simple_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym__type] = sym__type,
  [sym_optional_type] = sym_optional_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_cast_type] = sym_cast_type,
  [sym__return_type] = sym__return_type,
  [sym_const_element] = sym_const_element,
  [sym_echo_statement] = sym_echo_statement,
  [sym_unset_statement] = sym_unset_statement,
  [sym_declare_statement] = sym_declare_statement,
  [sym_declare_directive] = sym_declare_directive,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym__jump_statement] = sym__jump_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__expressions] = sym__expressions,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_pair] = sym_foreach_pair,
  [sym_if_statement] = sym_if_statement,
  [sym_colon_block] = sym_colon_block,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_else_if_clause_2] = sym_else_if_clause,
  [sym_else_clause_2] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_case_statement] = sym_case_statement,
  [sym_default_statement] = sym_default_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_named_label_statement] = sym_named_label_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__expression] = sym__expression,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_op_expression] = sym_unary_op_expression,
  [sym_exponentiation_expression] = sym_exponentiation_expression,
  [sym_clone_expression] = sym_clone_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_constant_access_expression] = sym_class_constant_access_expression,
  [sym_print_intrinsic] = sym_print_intrinsic,
  [sym_anonymous_function_creation_expression] = sym_anonymous_function_creation_expression,
  [sym_anonymous_function_use_clause] = sym_anonymous_function_use_clause,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_new_variable] = sym_new_variable,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_variable] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_scoped_property_access_expression] = sym_scoped_property_access_expression,
  [sym_list_literal] = sym_list_literal,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_scoped_call_expression] = sym_scoped_call_expression,
  [sym__scope_resolution_qualifier] = sym__scope_resolution_qualifier,
  [sym_relative_scope] = sym_relative_scope,
  [sym_arguments] = sym_arguments,
  [sym_member_call_expression] = sym_member_call_expression,
  [sym_variadic_unpacking] = sym_variadic_unpacking,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym__dereferencable_expression] = sym__dereferencable_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym__string] = sym__string,
  [sym_dynamic_variable_name] = sym_dynamic_variable_name,
  [sym_variable_name] = sym_variable_name,
  [sym_yield_expression] = sym_yield_expression,
  [sym_array_element_initializer] = sym_array_element_initializer,
  [sym_binary_expression] = sym_binary_expression,
  [sym_include_expression] = sym_include_expression,
  [sym_include_once_expression] = sym_include_once_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_require_once_expression] = sym_require_once_expression,
  [sym__reserved_identifier] = sym_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_text_repeat1] = aux_sym_text_repeat1,
  [aux_sym_function_static_declaration_repeat1] = aux_sym_function_static_declaration_repeat1,
  [aux_sym_global_declaration_repeat1] = aux_sym_global_declaration_repeat1,
  [aux_sym_namespace_use_declaration_repeat1] = aux_sym_namespace_use_declaration_repeat1,
  [aux_sym_namespace_name_repeat1] = aux_sym_namespace_name_repeat1,
  [aux_sym_namespace_use_group_repeat1] = aux_sym_namespace_use_group_repeat1,
  [aux_sym_interface_base_clause_repeat1] = aux_sym_interface_base_clause_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_property_declaration_repeat1] = aux_sym_property_declaration_repeat1,
  [aux_sym_property_declaration_repeat2] = aux_sym_property_declaration_repeat2,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_unset_statement_repeat1] = aux_sym_unset_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_if_statement_repeat2] = aux_sym_if_statement_repeat2,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_anonymous_function_use_clause_repeat1] = aux_sym_anonymous_function_use_clause_repeat1,
  [aux_sym_list_literal_repeat1] = aux_sym_list_literal_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [alias_sym_type_name] = alias_sym_type_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_php_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [sym_var_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_insteadof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iterable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_echo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enddeclare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ticks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_encoding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strict_types] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endwhile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endfor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endforeach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endswitch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_clone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shell_command_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include_once] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require_once] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_text_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_static_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_function_or_const] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name_as_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_aliasing_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_class_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_class_interface_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__modifier] = {
    .visible = false,
    .named = true,
  },
  [sym_property_element] = {
    .visible = true,
    .named = true,
  },
  [sym_property_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_instead_of_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_definition_header] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_type] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_const_element] = {
    .visible = true,
    .named = true,
  },
  [sym_echo_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__jump_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_colon_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_default_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_op_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_exponentiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_clone_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_constant_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_print_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_property_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_relative_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_unpacking] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dereferencable_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_dynamic_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_static_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_base_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_name] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_condition = 4,
  field_default_value = 5,
  field_function = 6,
  field_left = 7,
  field_name = 8,
  field_object = 9,
  field_operator = 10,
  field_parameters = 11,
  field_return_type = 12,
  field_right = 13,
  field_scope = 14,
  field_type = 15,
  field_value = 16,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_default_value] = "default_value",
  [field_function] = "function",
  [field_left] = "left",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[64] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 4},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 2},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 3},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 2},
  [14] = {.index = 24, .length = 2},
  [15] = {.index = 26, .length = 2},
  [16] = {.index = 28, .length = 2},
  [17] = {.index = 30, .length = 2},
  [19] = {.index = 32, .length = 2},
  [20] = {.index = 34, .length = 3},
  [21] = {.index = 37, .length = 1},
  [22] = {.index = 38, .length = 3},
  [23] = {.index = 41, .length = 2},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 1},
  [26] = {.index = 46, .length = 3},
  [27] = {.index = 49, .length = 3},
  [28] = {.index = 52, .length = 2},
  [29] = {.index = 54, .length = 2},
  [30] = {.index = 56, .length = 2},
  [31] = {.index = 58, .length = 3},
  [32] = {.index = 61, .length = 3},
  [33] = {.index = 64, .length = 2},
  [34] = {.index = 66, .length = 3},
  [35] = {.index = 69, .length = 3},
  [36] = {.index = 72, .length = 1},
  [37] = {.index = 73, .length = 2},
  [38] = {.index = 75, .length = 2},
  [39] = {.index = 77, .length = 3},
  [40] = {.index = 80, .length = 3},
  [41] = {.index = 83, .length = 2},
  [42] = {.index = 85, .length = 2},
  [43] = {.index = 87, .length = 4},
  [44] = {.index = 91, .length = 2},
  [45] = {.index = 93, .length = 2},
  [46] = {.index = 95, .length = 3},
  [47] = {.index = 98, .length = 4},
  [48] = {.index = 102, .length = 3},
  [49] = {.index = 105, .length = 3},
  [50] = {.index = 108, .length = 2},
  [51] = {.index = 110, .length = 2},
  [52] = {.index = 112, .length = 3},
  [53] = {.index = 115, .length = 3},
  [54] = {.index = 118, .length = 4},
  [55] = {.index = 122, .length = 1},
  [56] = {.index = 123, .length = 2},
  [57] = {.index = 125, .length = 5},
  [58] = {.index = 130, .length = 5},
  [59] = {.index = 135, .length = 3},
  [60] = {.index = 138, .length = 3},
  [61] = {.index = 141, .length = 1},
  [62] = {.index = 142, .length = 3},
  [63] = {.index = 145, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_body, 1},
  [2] =
    {field_arguments, 1},
    {field_function, 0},
  [4] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [8] =
    {field_name, 1},
  [9] =
    {field_body, 2},
    {field_name, 1},
  [11] =
    {field_name, 1},
    {field_parameters, 2},
  [13] =
    {field_body, 2},
    {field_parameters, 1},
  [15] =
    {field_body, 2},
    {field_condition, 1},
  [17] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_name, 2},
    {field_scope, 0},
  [24] =
    {field_name, 2},
    {field_object, 0},
  [26] =
    {field_body, 3},
    {field_parameters, 2},
  [28] =
    {field_name, 0},
    {field_value, 2},
  [30] =
    {field_name, 2},
    {field_parameters, 3},
  [32] =
    {field_name, 1},
    {field_type, 0},
  [34] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [37] =
    {field_return_type, 1},
  [38] =
    {field_body, 3},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [41] =
    {field_body, 3},
    {field_name, 1},
  [43] =
    {field_type, 1},
    {field_value, 3},
  [45] =
    {field_alternative, 0},
  [46] =
    {field_alternative, 3},
    {field_body, 2},
    {field_condition, 1},
  [49] =
    {field_alternative, 3, .inherited = true},
    {field_body, 2},
    {field_condition, 1},
  [52] =
    {field_body, 3},
    {field_name, 2},
  [54] =
    {field_alternative, 3},
    {field_condition, 0},
  [56] =
    {field_left, 0},
    {field_right, 3},
  [58] =
    {field_arguments, 3},
    {field_name, 2},
    {field_scope, 0},
  [61] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [64] =
    {field_body, 4},
    {field_parameters, 3},
  [66] =
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [69] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [72] =
    {field_name, 2},
  [73] =
    {field_name, 2},
    {field_type, 0},
  [75] =
    {field_default_value, 2},
    {field_name, 0},
  [77] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3, .inherited = true},
  [80] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [83] =
    {field_body, 4},
    {field_name, 1},
  [85] =
    {field_body, 1},
    {field_condition, 3},
  [87] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 1},
  [91] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [93] =
    {field_body, 4},
    {field_name, 2},
  [95] =
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 0},
  [98] =
    {field_name, 2},
    {field_name, 3},
    {field_name, 4},
    {field_object, 0},
  [102] =
    {field_body, 5},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [105] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [108] =
    {field_default_value, 3},
    {field_name, 1},
  [110] =
    {field_name, 3},
    {field_type, 0},
  [112] =
    {field_default_value, 3},
    {field_name, 1},
    {field_type, 0},
  [115] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [118] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [122] =
    {field_value, 1},
  [123] =
    {field_body, 5},
    {field_name, 2},
  [125] =
    {field_arguments, 5},
    {field_name, 2},
    {field_name, 3},
    {field_name, 4},
    {field_scope, 0},
  [130] =
    {field_arguments, 5},
    {field_name, 2},
    {field_name, 3},
    {field_name, 4},
    {field_object, 0},
  [135] =
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 5, .inherited = true},
  [138] =
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 0},
  [141] =
    {field_body, 6},
  [142] =
    {field_body, 5},
    {field_name, 3},
    {field_type, 2},
  [145] =
    {field_body, 7},
};

static TSSymbol ts_alias_sequences[64][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [7] = {
    [0] = alias_sym_type_name,
  },
  [18] = {
    [1] = alias_sym_type_name,
  },
  [62] = {
    [2] = alias_sym_type_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(80);
      if (lookahead == '!') ADVANCE(132);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(187);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '/') ADVANCE(190);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(174);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(137);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(205);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(205);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(206);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(132);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(176);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(137);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(131);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(187);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == '/') ADVANCE(190);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(137);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(176);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(137);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(8);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(61);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(71);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '\'') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(20);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(10);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(16);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(9);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(18);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(14);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'F') ADVANCE(16);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'F') ADVANCE(18);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(16);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(18);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == '{') ADVANCE(17);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(25);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == ':') ADVANCE(42);
      if (lookahead == '=') ADVANCE(98);
      if (lookahead == '?') ADVANCE(109);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(27)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 28:
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0) ADVANCE(95);
      END_STATE();
    case 29:
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(74);
      if (lookahead != 0) ADVANCE(29);
      END_STATE();
    case 30:
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      END_STATE();
    case 31:
      if (lookahead == '*') ADVANCE(31);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == '*') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 36:
      if (lookahead == '-') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 37:
      if (lookahead == '-') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 38:
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == '.') ADVANCE(108);
      END_STATE();
    case 42:
      if (lookahead == ':') ADVANCE(135);
      END_STATE();
    case 43:
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 44:
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 45:
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 46:
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 47:
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 48:
      if (lookahead == 'A') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'a') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 49:
      if (lookahead == 'A') ADVANCE(36);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 50:
      if (lookahead == 'A') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'a') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 51:
      if (lookahead == 'A') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == 'F') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 53:
      if (lookahead == 'F') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 54:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'f') ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 55:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 56:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead == '{') ADVANCE(50);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 59:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(120);
      END_STATE();
    case 61:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 62:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 63:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(67);
      END_STATE();
    case 64:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 65:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 66:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 67:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(81);
      END_STATE();
    case 68:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 69:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(62);
      END_STATE();
    case 70:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 71:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 74:
      if (lookahead != 0) ADVANCE(29);
      END_STATE();
    case 75:
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      END_STATE();
    case 76:
      if (lookahead != 0 &&
          (lookahead < '0' || '7' < lookahead) &&
          lookahead != 'X' &&
          lookahead != 'u' &&
          lookahead != 'x') ADVANCE(25);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(24);
      END_STATE();
    case 77:
      if (lookahead != 0 &&
          (lookahead < '0' || '7' < lookahead) &&
          lookahead != 'X' &&
          lookahead != 'u' &&
          lookahead != 'x') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(56);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(57);
      END_STATE();
    case 78:
      if (eof) ADVANCE(80);
      if (lookahead == '!') ADVANCE(131);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(47);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(137);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 79:
      if (eof) ADVANCE(80);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(79)
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(88);
      if (lookahead != 0) ADVANCE(95);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_php_tag);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_php_tag);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(63);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(95);
      if (lookahead == '\r') ADVANCE(87);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead != 0) ADVANCE(93);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(88);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(89);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(92);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead != 0) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead != 0) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '?') ADVANCE(86);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(95);
      if (lookahead != 0) ADVANCE(93);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(162);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(135);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(39);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(60);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(118);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(139);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(140);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_shell_command_expression);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_boolean);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_boolean);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_null);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '|') ADVANCE(161);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(161);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(180);
      if (lookahead == '=') ADVANCE(177);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(181);
      if (lookahead == '=') ADVANCE(177);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(178);
      if (lookahead == '>') ADVANCE(183);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(178);
      if (lookahead == '>') ADVANCE(182);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(179);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(134);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(133);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '\'') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(206);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'O') ADVANCE(2);
      if (lookahead == 'X') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      if (lookahead == 'p') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      if (lookahead == 'w') ADVANCE(21);
      if (lookahead == 'x') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'N') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == 'R') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'O') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'r') ADVANCE(29);
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 8:
      if (lookahead == 'c') ADVANCE(39);
      if (lookahead == 'l') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(42);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(43);
      if (lookahead == 'l') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      if (lookahead == 'r') ADVANCE(46);
      if (lookahead == 'u') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(52);
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(55);
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 14:
      if (lookahead == 'b') ADVANCE(57);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'r') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      if (lookahead == 'w') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'i') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(72);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 24:
      if (lookahead == 'D') ADVANCE(75);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(aux_sym_binary_expression_token2);
      END_STATE();
    case 26:
      if (lookahead == 'R') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(82);
      if (lookahead == 's') ADVANCE(83);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 35:
      if (lookahead == 'a') ADVANCE(85);
      if (lookahead == 'o') ADVANCE(86);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(88);
      if (lookahead == 'f') ADVANCE(89);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 39:
      if (lookahead == 'h') ADVANCE(91);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(93);
      if (lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 46:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'c') ADVANCE(104);
      if (lookahead == 's') ADVANCE(105);
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'm') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'w') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'j') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(113);
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 60:
      if (lookahead == 'b') ADVANCE(115);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'q') ADVANCE(117);
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 66:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(125);
      if (lookahead == 'y') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(76);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_binary_expression_token1);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_binary_expression_token3);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(134);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(138);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(143);
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 88:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 'b') ADVANCE(147);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(151);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == 's') ADVANCE(154);
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(158);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 99:
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 100:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 101:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(173);
      if (lookahead == 'v') ADVANCE(174);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(176);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 118:
      if (lookahead == 'u') ADVANCE(179);
      END_STATE();
    case 119:
      if (lookahead == 'f') ADVANCE(180);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(184);
      END_STATE();
    case 124:
      if (lookahead == 'k') ADVANCE(185);
      END_STATE();
    case 125:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_var_modifier);
      END_STATE();
    case 130:
      if (lookahead == 'd') ADVANCE(188);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(191);
      END_STATE();
    case 134:
      if (lookahead == 'y') ADVANCE(192);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_bool);
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 137:
      if (lookahead == 'k') ADVANCE(195);
      END_STATE();
    case 138:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(197);
      END_STATE();
    case 141:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(203);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(204);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_echo);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(205);
      END_STATE();
    case 150:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 152:
      if (lookahead == 'o') ADVANCE(208);
      END_STATE();
    case 153:
      if (lookahead == 'f') ADVANCE(209);
      END_STATE();
    case 154:
      if (lookahead == 'w') ADVANCE(210);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 165:
      if (lookahead == 'u') ADVANCE(219);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(220);
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 167:
      if (lookahead == 'g') ADVANCE(222);
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 168:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_list);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 171:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 172:
      if (lookahead == 'n') ADVANCE(227);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_real);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 179:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 181:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 182:
      if (lookahead == 'c') ADVANCE(235);
      if (lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 183:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 184:
      if (lookahead == 'w') ADVANCE(238);
      END_STATE();
    case 185:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 190:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 193:
      if (lookahead == 'y') ADVANCE(245);
      END_STATE();
    case 194:
      if (lookahead == 'a') ADVANCE(246);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 196:
      if (lookahead == 'b') ADVANCE(247);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_clone);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 201:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 203:
      if (lookahead == 'l') ADVANCE(250);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 205:
      if (lookahead == 'f') ADVANCE(252);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(253);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(255);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_endif);
      END_STATE();
    case 210:
      if (lookahead == 'i') ADVANCE(256);
      END_STATE();
    case 211:
      if (lookahead == 'i') ADVANCE(257);
      END_STATE();
    case 212:
      if (lookahead == 'd') ADVANCE(258);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(259);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 215:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 218:
      if (lookahead == 'm') ADVANCE(263);
      END_STATE();
    case 219:
      if (lookahead == 'd') ADVANCE(264);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(265);
      END_STATE();
    case 221:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 222:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 223:
      if (lookahead == 'f') ADVANCE(268);
      END_STATE();
    case 224:
      if (lookahead == 'b') ADVANCE(269);
      END_STATE();
    case 225:
      if (lookahead == 'p') ADVANCE(270);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(274);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(275);
      END_STATE();
    case 232:
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 236:
      if (lookahead == 'g') ADVANCE(280);
      END_STATE();
    case 237:
      if (lookahead == 'h') ADVANCE(281);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_ticks);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 244:
      if (lookahead == 'c') ADVANCE(282);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 246:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 247:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 248:
      if (lookahead == 'u') ADVANCE(285);
      END_STATE();
    case 249:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 250:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 253:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 254:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_endfor);
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 257:
      if (lookahead == 'l') ADVANCE(292);
      END_STATE();
    case 258:
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 259:
      if (lookahead == 'y') ADVANCE(294);
      END_STATE();
    case 260:
      if (lookahead == 'h') ADVANCE(295);
      END_STATE();
    case 261:
      if (lookahead == 'o') ADVANCE(296);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 265:
      if (lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 266:
      if (lookahead == 'd') ADVANCE(300);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(301);
      END_STATE();
    case 268:
      if (lookahead == 'a') ADVANCE(302);
      END_STATE();
    case 269:
      if (lookahead == 'l') ADVANCE(303);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(304);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 279:
      if (lookahead == '_') ADVANCE(308);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 288:
      if (lookahead == 'g') ADVANCE(312);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(314);
      END_STATE();
    case 291:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 296:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 297:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_include);
      if (lookahead == '_') ADVANCE(319);
      END_STATE();
    case 299:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 300:
      if (lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_integer);
      END_STATE();
    case 302:
      if (lookahead == 'c') ADVANCE(322);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 304:
      if (lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '_') ADVANCE(326);
      END_STATE();
    case 308:
      if (lookahead == 't') ADVANCE(327);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_callable);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_encoding);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(328);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(329);
      END_STATE();
    case 315:
      if (lookahead == 'h') ADVANCE(330);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_endwhile);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 318:
      if (lookahead == 't') ADVANCE(331);
      END_STATE();
    case 319:
      if (lookahead == 'o') ADVANCE(332);
      END_STATE();
    case 320:
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 321:
      if (lookahead == 'f') ADVANCE(334);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_iterable);
      END_STATE();
    case 324:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 325:
      if (lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 326:
      if (lookahead == 'o') ADVANCE(338);
      END_STATE();
    case 327:
      if (lookahead == 'y') ADVANCE(339);
      END_STATE();
    case 328:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 329:
      if (lookahead == 'h') ADVANCE(341);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_endswitch);
      END_STATE();
    case 331:
      if (lookahead == 's') ADVANCE(342);
      END_STATE();
    case 332:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 333:
      if (lookahead == 'f') ADVANCE(344);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_insteadof);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 338:
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 339:
      if (lookahead == 'p') ADVANCE(346);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_enddeclare);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_endforeach);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 343:
      if (lookahead == 'c') ADVANCE(347);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 345:
      if (lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(349);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 349:
      if (lookahead == 's') ADVANCE(352);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_include_once);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_require_once);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_strict_types);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 79},
  [2] = {.lex_state = 78, .external_lex_state = 2},
  [3] = {.lex_state = 78, .external_lex_state = 2},
  [4] = {.lex_state = 78, .external_lex_state = 2},
  [5] = {.lex_state = 78, .external_lex_state = 2},
  [6] = {.lex_state = 78, .external_lex_state = 2},
  [7] = {.lex_state = 78, .external_lex_state = 2},
  [8] = {.lex_state = 78, .external_lex_state = 2},
  [9] = {.lex_state = 78, .external_lex_state = 3},
  [10] = {.lex_state = 78, .external_lex_state = 3},
  [11] = {.lex_state = 78, .external_lex_state = 3},
  [12] = {.lex_state = 78, .external_lex_state = 3},
  [13] = {.lex_state = 78, .external_lex_state = 2},
  [14] = {.lex_state = 78, .external_lex_state = 2},
  [15] = {.lex_state = 78, .external_lex_state = 2},
  [16] = {.lex_state = 78, .external_lex_state = 2},
  [17] = {.lex_state = 78, .external_lex_state = 2},
  [18] = {.lex_state = 78, .external_lex_state = 2},
  [19] = {.lex_state = 78, .external_lex_state = 2},
  [20] = {.lex_state = 78, .external_lex_state = 2},
  [21] = {.lex_state = 78, .external_lex_state = 2},
  [22] = {.lex_state = 78, .external_lex_state = 2},
  [23] = {.lex_state = 78, .external_lex_state = 3},
  [24] = {.lex_state = 78, .external_lex_state = 2},
  [25] = {.lex_state = 78, .external_lex_state = 3},
  [26] = {.lex_state = 78, .external_lex_state = 3},
  [27] = {.lex_state = 78, .external_lex_state = 3},
  [28] = {.lex_state = 78, .external_lex_state = 2},
  [29] = {.lex_state = 78, .external_lex_state = 2},
  [30] = {.lex_state = 78, .external_lex_state = 2},
  [31] = {.lex_state = 78, .external_lex_state = 2},
  [32] = {.lex_state = 78, .external_lex_state = 2},
  [33] = {.lex_state = 78, .external_lex_state = 2},
  [34] = {.lex_state = 78, .external_lex_state = 3},
  [35] = {.lex_state = 78, .external_lex_state = 2},
  [36] = {.lex_state = 78, .external_lex_state = 2},
  [37] = {.lex_state = 78, .external_lex_state = 2},
  [38] = {.lex_state = 78, .external_lex_state = 2},
  [39] = {.lex_state = 78, .external_lex_state = 2},
  [40] = {.lex_state = 78, .external_lex_state = 2},
  [41] = {.lex_state = 78, .external_lex_state = 2},
  [42] = {.lex_state = 78, .external_lex_state = 2},
  [43] = {.lex_state = 78, .external_lex_state = 2},
  [44] = {.lex_state = 78, .external_lex_state = 3},
  [45] = {.lex_state = 78, .external_lex_state = 2},
  [46] = {.lex_state = 78, .external_lex_state = 2},
  [47] = {.lex_state = 78, .external_lex_state = 3},
  [48] = {.lex_state = 78, .external_lex_state = 2},
  [49] = {.lex_state = 78, .external_lex_state = 2},
  [50] = {.lex_state = 78, .external_lex_state = 2},
  [51] = {.lex_state = 78, .external_lex_state = 3},
  [52] = {.lex_state = 78, .external_lex_state = 2},
  [53] = {.lex_state = 78, .external_lex_state = 3},
  [54] = {.lex_state = 78, .external_lex_state = 2},
  [55] = {.lex_state = 78, .external_lex_state = 3},
  [56] = {.lex_state = 78, .external_lex_state = 2},
  [57] = {.lex_state = 78, .external_lex_state = 2},
  [58] = {.lex_state = 78, .external_lex_state = 2},
  [59] = {.lex_state = 78, .external_lex_state = 2},
  [60] = {.lex_state = 78, .external_lex_state = 2},
  [61] = {.lex_state = 78, .external_lex_state = 2},
  [62] = {.lex_state = 78, .external_lex_state = 2},
  [63] = {.lex_state = 3, .external_lex_state = 2},
  [64] = {.lex_state = 3, .external_lex_state = 3},
  [65] = {.lex_state = 78, .external_lex_state = 2},
  [66] = {.lex_state = 78, .external_lex_state = 2},
  [67] = {.lex_state = 78, .external_lex_state = 2},
  [68] = {.lex_state = 78, .external_lex_state = 2},
  [69] = {.lex_state = 78, .external_lex_state = 2},
  [70] = {.lex_state = 78, .external_lex_state = 2},
  [71] = {.lex_state = 78, .external_lex_state = 2},
  [72] = {.lex_state = 78, .external_lex_state = 2},
  [73] = {.lex_state = 78, .external_lex_state = 2},
  [74] = {.lex_state = 78, .external_lex_state = 2},
  [75] = {.lex_state = 78, .external_lex_state = 2},
  [76] = {.lex_state = 78, .external_lex_state = 2},
  [77] = {.lex_state = 78, .external_lex_state = 2},
  [78] = {.lex_state = 78, .external_lex_state = 2},
  [79] = {.lex_state = 78, .external_lex_state = 2},
  [80] = {.lex_state = 78, .external_lex_state = 2},
  [81] = {.lex_state = 78, .external_lex_state = 2},
  [82] = {.lex_state = 78, .external_lex_state = 2},
  [83] = {.lex_state = 78, .external_lex_state = 2},
  [84] = {.lex_state = 78, .external_lex_state = 2},
  [85] = {.lex_state = 78, .external_lex_state = 2},
  [86] = {.lex_state = 78, .external_lex_state = 2},
  [87] = {.lex_state = 78, .external_lex_state = 2},
  [88] = {.lex_state = 4, .external_lex_state = 2},
  [89] = {.lex_state = 78, .external_lex_state = 2},
  [90] = {.lex_state = 78, .external_lex_state = 2},
  [91] = {.lex_state = 78, .external_lex_state = 2},
  [92] = {.lex_state = 4, .external_lex_state = 2},
  [93] = {.lex_state = 78, .external_lex_state = 2},
  [94] = {.lex_state = 78, .external_lex_state = 2},
  [95] = {.lex_state = 78, .external_lex_state = 2},
  [96] = {.lex_state = 78, .external_lex_state = 2},
  [97] = {.lex_state = 78, .external_lex_state = 2},
  [98] = {.lex_state = 78, .external_lex_state = 2},
  [99] = {.lex_state = 78, .external_lex_state = 2},
  [100] = {.lex_state = 78, .external_lex_state = 2},
  [101] = {.lex_state = 4, .external_lex_state = 2},
  [102] = {.lex_state = 78, .external_lex_state = 2},
  [103] = {.lex_state = 4, .external_lex_state = 2},
  [104] = {.lex_state = 78, .external_lex_state = 2},
  [105] = {.lex_state = 4, .external_lex_state = 2},
  [106] = {.lex_state = 78, .external_lex_state = 2},
  [107] = {.lex_state = 78, .external_lex_state = 2},
  [108] = {.lex_state = 78, .external_lex_state = 2},
  [109] = {.lex_state = 78, .external_lex_state = 2},
  [110] = {.lex_state = 78, .external_lex_state = 3},
  [111] = {.lex_state = 78, .external_lex_state = 3},
  [112] = {.lex_state = 78, .external_lex_state = 3},
  [113] = {.lex_state = 78, .external_lex_state = 3},
  [114] = {.lex_state = 78, .external_lex_state = 3},
  [115] = {.lex_state = 78, .external_lex_state = 3},
  [116] = {.lex_state = 78, .external_lex_state = 2},
  [117] = {.lex_state = 78, .external_lex_state = 2},
  [118] = {.lex_state = 78, .external_lex_state = 2},
  [119] = {.lex_state = 78, .external_lex_state = 2},
  [120] = {.lex_state = 78, .external_lex_state = 2},
  [121] = {.lex_state = 78, .external_lex_state = 2},
  [122] = {.lex_state = 78, .external_lex_state = 2},
  [123] = {.lex_state = 78, .external_lex_state = 2},
  [124] = {.lex_state = 78, .external_lex_state = 2},
  [125] = {.lex_state = 78, .external_lex_state = 2},
  [126] = {.lex_state = 78, .external_lex_state = 2},
  [127] = {.lex_state = 78, .external_lex_state = 2},
  [128] = {.lex_state = 78, .external_lex_state = 2},
  [129] = {.lex_state = 78, .external_lex_state = 2},
  [130] = {.lex_state = 78, .external_lex_state = 2},
  [131] = {.lex_state = 78, .external_lex_state = 2},
  [132] = {.lex_state = 78, .external_lex_state = 2},
  [133] = {.lex_state = 78, .external_lex_state = 2},
  [134] = {.lex_state = 78, .external_lex_state = 2},
  [135] = {.lex_state = 78, .external_lex_state = 2},
  [136] = {.lex_state = 78, .external_lex_state = 2},
  [137] = {.lex_state = 78, .external_lex_state = 2},
  [138] = {.lex_state = 78, .external_lex_state = 2},
  [139] = {.lex_state = 78, .external_lex_state = 2},
  [140] = {.lex_state = 78, .external_lex_state = 2},
  [141] = {.lex_state = 78, .external_lex_state = 2},
  [142] = {.lex_state = 78, .external_lex_state = 2},
  [143] = {.lex_state = 78, .external_lex_state = 2},
  [144] = {.lex_state = 78, .external_lex_state = 2},
  [145] = {.lex_state = 78, .external_lex_state = 2},
  [146] = {.lex_state = 78, .external_lex_state = 2},
  [147] = {.lex_state = 78, .external_lex_state = 3},
  [148] = {.lex_state = 78, .external_lex_state = 2},
  [149] = {.lex_state = 78, .external_lex_state = 2},
  [150] = {.lex_state = 78, .external_lex_state = 3},
  [151] = {.lex_state = 78, .external_lex_state = 2},
  [152] = {.lex_state = 78, .external_lex_state = 2},
  [153] = {.lex_state = 78, .external_lex_state = 2},
  [154] = {.lex_state = 78, .external_lex_state = 3},
  [155] = {.lex_state = 78, .external_lex_state = 2},
  [156] = {.lex_state = 78, .external_lex_state = 2},
  [157] = {.lex_state = 78, .external_lex_state = 2},
  [158] = {.lex_state = 78, .external_lex_state = 3},
  [159] = {.lex_state = 78, .external_lex_state = 2},
  [160] = {.lex_state = 78, .external_lex_state = 3},
  [161] = {.lex_state = 78, .external_lex_state = 2},
  [162] = {.lex_state = 78, .external_lex_state = 2},
  [163] = {.lex_state = 78, .external_lex_state = 2},
  [164] = {.lex_state = 78, .external_lex_state = 2},
  [165] = {.lex_state = 78, .external_lex_state = 2},
  [166] = {.lex_state = 78, .external_lex_state = 2},
  [167] = {.lex_state = 78, .external_lex_state = 2},
  [168] = {.lex_state = 78, .external_lex_state = 2},
  [169] = {.lex_state = 78, .external_lex_state = 2},
  [170] = {.lex_state = 78, .external_lex_state = 2},
  [171] = {.lex_state = 78, .external_lex_state = 2},
  [172] = {.lex_state = 78, .external_lex_state = 2},
  [173] = {.lex_state = 78, .external_lex_state = 3},
  [174] = {.lex_state = 78, .external_lex_state = 2},
  [175] = {.lex_state = 78, .external_lex_state = 2},
  [176] = {.lex_state = 78, .external_lex_state = 2},
  [177] = {.lex_state = 78, .external_lex_state = 2},
  [178] = {.lex_state = 78, .external_lex_state = 2},
  [179] = {.lex_state = 78, .external_lex_state = 2},
  [180] = {.lex_state = 78, .external_lex_state = 2},
  [181] = {.lex_state = 78, .external_lex_state = 2},
  [182] = {.lex_state = 78, .external_lex_state = 2},
  [183] = {.lex_state = 78, .external_lex_state = 2},
  [184] = {.lex_state = 78, .external_lex_state = 2},
  [185] = {.lex_state = 78, .external_lex_state = 2},
  [186] = {.lex_state = 78, .external_lex_state = 2},
  [187] = {.lex_state = 78, .external_lex_state = 2},
  [188] = {.lex_state = 78, .external_lex_state = 2},
  [189] = {.lex_state = 78, .external_lex_state = 2},
  [190] = {.lex_state = 78, .external_lex_state = 2},
  [191] = {.lex_state = 78, .external_lex_state = 2},
  [192] = {.lex_state = 78, .external_lex_state = 2},
  [193] = {.lex_state = 78, .external_lex_state = 2},
  [194] = {.lex_state = 78, .external_lex_state = 2},
  [195] = {.lex_state = 78, .external_lex_state = 2},
  [196] = {.lex_state = 78, .external_lex_state = 2},
  [197] = {.lex_state = 78, .external_lex_state = 2},
  [198] = {.lex_state = 78, .external_lex_state = 2},
  [199] = {.lex_state = 78, .external_lex_state = 2},
  [200] = {.lex_state = 78, .external_lex_state = 2},
  [201] = {.lex_state = 78, .external_lex_state = 2},
  [202] = {.lex_state = 78, .external_lex_state = 2},
  [203] = {.lex_state = 78, .external_lex_state = 2},
  [204] = {.lex_state = 78, .external_lex_state = 2},
  [205] = {.lex_state = 78, .external_lex_state = 2},
  [206] = {.lex_state = 78, .external_lex_state = 2},
  [207] = {.lex_state = 78, .external_lex_state = 2},
  [208] = {.lex_state = 78, .external_lex_state = 2},
  [209] = {.lex_state = 78, .external_lex_state = 2},
  [210] = {.lex_state = 78, .external_lex_state = 2},
  [211] = {.lex_state = 78, .external_lex_state = 2},
  [212] = {.lex_state = 78, .external_lex_state = 2},
  [213] = {.lex_state = 78, .external_lex_state = 3},
  [214] = {.lex_state = 78, .external_lex_state = 2},
  [215] = {.lex_state = 78, .external_lex_state = 2},
  [216] = {.lex_state = 78, .external_lex_state = 2},
  [217] = {.lex_state = 78, .external_lex_state = 2},
  [218] = {.lex_state = 78, .external_lex_state = 2},
  [219] = {.lex_state = 78, .external_lex_state = 2},
  [220] = {.lex_state = 78, .external_lex_state = 2},
  [221] = {.lex_state = 78, .external_lex_state = 2},
  [222] = {.lex_state = 78, .external_lex_state = 2},
  [223] = {.lex_state = 78, .external_lex_state = 2},
  [224] = {.lex_state = 78, .external_lex_state = 2},
  [225] = {.lex_state = 78, .external_lex_state = 2},
  [226] = {.lex_state = 78, .external_lex_state = 2},
  [227] = {.lex_state = 78, .external_lex_state = 2},
  [228] = {.lex_state = 78, .external_lex_state = 2},
  [229] = {.lex_state = 78, .external_lex_state = 2},
  [230] = {.lex_state = 78, .external_lex_state = 3},
  [231] = {.lex_state = 78, .external_lex_state = 2},
  [232] = {.lex_state = 78, .external_lex_state = 2},
  [233] = {.lex_state = 78, .external_lex_state = 2},
  [234] = {.lex_state = 78, .external_lex_state = 2},
  [235] = {.lex_state = 78, .external_lex_state = 2},
  [236] = {.lex_state = 78, .external_lex_state = 2},
  [237] = {.lex_state = 78, .external_lex_state = 2},
  [238] = {.lex_state = 78, .external_lex_state = 2},
  [239] = {.lex_state = 78, .external_lex_state = 2},
  [240] = {.lex_state = 78, .external_lex_state = 2},
  [241] = {.lex_state = 78, .external_lex_state = 2},
  [242] = {.lex_state = 78, .external_lex_state = 2},
  [243] = {.lex_state = 78, .external_lex_state = 2},
  [244] = {.lex_state = 78, .external_lex_state = 2},
  [245] = {.lex_state = 78, .external_lex_state = 2},
  [246] = {.lex_state = 78, .external_lex_state = 2},
  [247] = {.lex_state = 78, .external_lex_state = 2},
  [248] = {.lex_state = 78, .external_lex_state = 2},
  [249] = {.lex_state = 78, .external_lex_state = 2},
  [250] = {.lex_state = 78, .external_lex_state = 2},
  [251] = {.lex_state = 78, .external_lex_state = 2},
  [252] = {.lex_state = 78, .external_lex_state = 2},
  [253] = {.lex_state = 78, .external_lex_state = 2},
  [254] = {.lex_state = 78, .external_lex_state = 2},
  [255] = {.lex_state = 78, .external_lex_state = 2},
  [256] = {.lex_state = 78, .external_lex_state = 2},
  [257] = {.lex_state = 78, .external_lex_state = 2},
  [258] = {.lex_state = 78, .external_lex_state = 2},
  [259] = {.lex_state = 78, .external_lex_state = 2},
  [260] = {.lex_state = 78, .external_lex_state = 2},
  [261] = {.lex_state = 78, .external_lex_state = 2},
  [262] = {.lex_state = 78, .external_lex_state = 2},
  [263] = {.lex_state = 78, .external_lex_state = 2},
  [264] = {.lex_state = 78, .external_lex_state = 2},
  [265] = {.lex_state = 78, .external_lex_state = 2},
  [266] = {.lex_state = 78, .external_lex_state = 2},
  [267] = {.lex_state = 78, .external_lex_state = 2},
  [268] = {.lex_state = 78, .external_lex_state = 2},
  [269] = {.lex_state = 78, .external_lex_state = 2},
  [270] = {.lex_state = 78, .external_lex_state = 2},
  [271] = {.lex_state = 78, .external_lex_state = 2},
  [272] = {.lex_state = 78, .external_lex_state = 2},
  [273] = {.lex_state = 78, .external_lex_state = 2},
  [274] = {.lex_state = 78, .external_lex_state = 2},
  [275] = {.lex_state = 78, .external_lex_state = 2},
  [276] = {.lex_state = 78, .external_lex_state = 2},
  [277] = {.lex_state = 78, .external_lex_state = 2},
  [278] = {.lex_state = 78, .external_lex_state = 2},
  [279] = {.lex_state = 78, .external_lex_state = 2},
  [280] = {.lex_state = 78, .external_lex_state = 2},
  [281] = {.lex_state = 78, .external_lex_state = 2},
  [282] = {.lex_state = 78, .external_lex_state = 2},
  [283] = {.lex_state = 78, .external_lex_state = 2},
  [284] = {.lex_state = 78, .external_lex_state = 2},
  [285] = {.lex_state = 78, .external_lex_state = 2},
  [286] = {.lex_state = 78, .external_lex_state = 2},
  [287] = {.lex_state = 78, .external_lex_state = 2},
  [288] = {.lex_state = 78, .external_lex_state = 2},
  [289] = {.lex_state = 78, .external_lex_state = 2},
  [290] = {.lex_state = 78, .external_lex_state = 2},
  [291] = {.lex_state = 78, .external_lex_state = 2},
  [292] = {.lex_state = 78, .external_lex_state = 2},
  [293] = {.lex_state = 78, .external_lex_state = 2},
  [294] = {.lex_state = 78, .external_lex_state = 2},
  [295] = {.lex_state = 78, .external_lex_state = 2},
  [296] = {.lex_state = 78, .external_lex_state = 2},
  [297] = {.lex_state = 78, .external_lex_state = 2},
  [298] = {.lex_state = 78, .external_lex_state = 2},
  [299] = {.lex_state = 78, .external_lex_state = 2},
  [300] = {.lex_state = 78, .external_lex_state = 2},
  [301] = {.lex_state = 78, .external_lex_state = 2},
  [302] = {.lex_state = 78, .external_lex_state = 2},
  [303] = {.lex_state = 78, .external_lex_state = 2},
  [304] = {.lex_state = 78, .external_lex_state = 2},
  [305] = {.lex_state = 78, .external_lex_state = 2},
  [306] = {.lex_state = 78, .external_lex_state = 2},
  [307] = {.lex_state = 78, .external_lex_state = 2},
  [308] = {.lex_state = 78, .external_lex_state = 2},
  [309] = {.lex_state = 78, .external_lex_state = 2},
  [310] = {.lex_state = 78, .external_lex_state = 2},
  [311] = {.lex_state = 78, .external_lex_state = 2},
  [312] = {.lex_state = 78, .external_lex_state = 2},
  [313] = {.lex_state = 78, .external_lex_state = 2},
  [314] = {.lex_state = 78, .external_lex_state = 2},
  [315] = {.lex_state = 78, .external_lex_state = 2},
  [316] = {.lex_state = 78, .external_lex_state = 2},
  [317] = {.lex_state = 78, .external_lex_state = 2},
  [318] = {.lex_state = 78, .external_lex_state = 2},
  [319] = {.lex_state = 78, .external_lex_state = 2},
  [320] = {.lex_state = 78, .external_lex_state = 2},
  [321] = {.lex_state = 78, .external_lex_state = 2},
  [322] = {.lex_state = 78, .external_lex_state = 2},
  [323] = {.lex_state = 78, .external_lex_state = 2},
  [324] = {.lex_state = 78, .external_lex_state = 2},
  [325] = {.lex_state = 78, .external_lex_state = 2},
  [326] = {.lex_state = 78, .external_lex_state = 2},
  [327] = {.lex_state = 5},
  [328] = {.lex_state = 5},
  [329] = {.lex_state = 5},
  [330] = {.lex_state = 5},
  [331] = {.lex_state = 5},
  [332] = {.lex_state = 5},
  [333] = {.lex_state = 5},
  [334] = {.lex_state = 5},
  [335] = {.lex_state = 78, .external_lex_state = 2},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 5},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 5},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 5},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 5},
  [344] = {.lex_state = 78, .external_lex_state = 2},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 78, .external_lex_state = 2},
  [347] = {.lex_state = 5},
  [348] = {.lex_state = 5},
  [349] = {.lex_state = 5},
  [350] = {.lex_state = 5},
  [351] = {.lex_state = 5, .external_lex_state = 4},
  [352] = {.lex_state = 5},
  [353] = {.lex_state = 5, .external_lex_state = 4},
  [354] = {.lex_state = 5, .external_lex_state = 4},
  [355] = {.lex_state = 5, .external_lex_state = 4},
  [356] = {.lex_state = 5, .external_lex_state = 4},
  [357] = {.lex_state = 5, .external_lex_state = 4},
  [358] = {.lex_state = 5, .external_lex_state = 4},
  [359] = {.lex_state = 5, .external_lex_state = 4},
  [360] = {.lex_state = 5, .external_lex_state = 4},
  [361] = {.lex_state = 5, .external_lex_state = 4},
  [362] = {.lex_state = 5, .external_lex_state = 4},
  [363] = {.lex_state = 5, .external_lex_state = 4},
  [364] = {.lex_state = 5, .external_lex_state = 4},
  [365] = {.lex_state = 5, .external_lex_state = 4},
  [366] = {.lex_state = 5, .external_lex_state = 4},
  [367] = {.lex_state = 5, .external_lex_state = 4},
  [368] = {.lex_state = 5},
  [369] = {.lex_state = 5, .external_lex_state = 4},
  [370] = {.lex_state = 5, .external_lex_state = 4},
  [371] = {.lex_state = 5, .external_lex_state = 4},
  [372] = {.lex_state = 5},
  [373] = {.lex_state = 6},
  [374] = {.lex_state = 5},
  [375] = {.lex_state = 5, .external_lex_state = 4},
  [376] = {.lex_state = 6},
  [377] = {.lex_state = 5, .external_lex_state = 4},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 78, .external_lex_state = 2},
  [381] = {.lex_state = 78, .external_lex_state = 2},
  [382] = {.lex_state = 78, .external_lex_state = 2},
  [383] = {.lex_state = 78, .external_lex_state = 2},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 5},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 5, .external_lex_state = 4},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 5, .external_lex_state = 4},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6, .external_lex_state = 4},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6, .external_lex_state = 4},
  [438] = {.lex_state = 6, .external_lex_state = 4},
  [439] = {.lex_state = 6, .external_lex_state = 4},
  [440] = {.lex_state = 6, .external_lex_state = 4},
  [441] = {.lex_state = 5, .external_lex_state = 4},
  [442] = {.lex_state = 6, .external_lex_state = 4},
  [443] = {.lex_state = 6, .external_lex_state = 4},
  [444] = {.lex_state = 6, .external_lex_state = 4},
  [445] = {.lex_state = 6, .external_lex_state = 4},
  [446] = {.lex_state = 6, .external_lex_state = 4},
  [447] = {.lex_state = 6, .external_lex_state = 4},
  [448] = {.lex_state = 6, .external_lex_state = 4},
  [449] = {.lex_state = 5, .external_lex_state = 4},
  [450] = {.lex_state = 6, .external_lex_state = 4},
  [451] = {.lex_state = 6, .external_lex_state = 4},
  [452] = {.lex_state = 6, .external_lex_state = 4},
  [453] = {.lex_state = 6, .external_lex_state = 4},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6, .external_lex_state = 4},
  [456] = {.lex_state = 6, .external_lex_state = 4},
  [457] = {.lex_state = 6, .external_lex_state = 4},
  [458] = {.lex_state = 6, .external_lex_state = 4},
  [459] = {.lex_state = 6, .external_lex_state = 4},
  [460] = {.lex_state = 6, .external_lex_state = 4},
  [461] = {.lex_state = 6, .external_lex_state = 4},
  [462] = {.lex_state = 6, .external_lex_state = 4},
  [463] = {.lex_state = 6, .external_lex_state = 4},
  [464] = {.lex_state = 6, .external_lex_state = 4},
  [465] = {.lex_state = 6, .external_lex_state = 4},
  [466] = {.lex_state = 6, .external_lex_state = 4},
  [467] = {.lex_state = 6, .external_lex_state = 4},
  [468] = {.lex_state = 6, .external_lex_state = 4},
  [469] = {.lex_state = 6, .external_lex_state = 4},
  [470] = {.lex_state = 6, .external_lex_state = 4},
  [471] = {.lex_state = 6, .external_lex_state = 4},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 6, .external_lex_state = 4},
  [474] = {.lex_state = 6, .external_lex_state = 4},
  [475] = {.lex_state = 6},
  [476] = {.lex_state = 6},
  [477] = {.lex_state = 6},
  [478] = {.lex_state = 6},
  [479] = {.lex_state = 6, .external_lex_state = 4},
  [480] = {.lex_state = 6},
  [481] = {.lex_state = 6},
  [482] = {.lex_state = 6},
  [483] = {.lex_state = 6},
  [484] = {.lex_state = 6},
  [485] = {.lex_state = 6},
  [486] = {.lex_state = 6},
  [487] = {.lex_state = 6},
  [488] = {.lex_state = 6},
  [489] = {.lex_state = 6, .external_lex_state = 4},
  [490] = {.lex_state = 6},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 6, .external_lex_state = 4},
  [497] = {.lex_state = 6},
  [498] = {.lex_state = 6, .external_lex_state = 4},
  [499] = {.lex_state = 6},
  [500] = {.lex_state = 6},
  [501] = {.lex_state = 6},
  [502] = {.lex_state = 6},
  [503] = {.lex_state = 6, .external_lex_state = 4},
  [504] = {.lex_state = 6},
  [505] = {.lex_state = 6},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 6},
  [508] = {.lex_state = 6},
  [509] = {.lex_state = 6},
  [510] = {.lex_state = 6},
  [511] = {.lex_state = 6},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 6},
  [514] = {.lex_state = 6},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 6},
  [517] = {.lex_state = 6},
  [518] = {.lex_state = 6, .external_lex_state = 4},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6, .external_lex_state = 4},
  [522] = {.lex_state = 6},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 6},
  [528] = {.lex_state = 6},
  [529] = {.lex_state = 6},
  [530] = {.lex_state = 6},
  [531] = {.lex_state = 6},
  [532] = {.lex_state = 6, .external_lex_state = 4},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 6},
  [535] = {.lex_state = 6},
  [536] = {.lex_state = 6},
  [537] = {.lex_state = 6},
  [538] = {.lex_state = 6, .external_lex_state = 4},
  [539] = {.lex_state = 6, .external_lex_state = 4},
  [540] = {.lex_state = 6, .external_lex_state = 4},
  [541] = {.lex_state = 6, .external_lex_state = 4},
  [542] = {.lex_state = 6, .external_lex_state = 4},
  [543] = {.lex_state = 6, .external_lex_state = 4},
  [544] = {.lex_state = 6, .external_lex_state = 4},
  [545] = {.lex_state = 5, .external_lex_state = 2},
  [546] = {.lex_state = 5, .external_lex_state = 2},
  [547] = {.lex_state = 6, .external_lex_state = 4},
  [548] = {.lex_state = 5, .external_lex_state = 2},
  [549] = {.lex_state = 6, .external_lex_state = 4},
  [550] = {.lex_state = 6, .external_lex_state = 4},
  [551] = {.lex_state = 6, .external_lex_state = 4},
  [552] = {.lex_state = 6, .external_lex_state = 4},
  [553] = {.lex_state = 6, .external_lex_state = 4},
  [554] = {.lex_state = 6, .external_lex_state = 4},
  [555] = {.lex_state = 6, .external_lex_state = 4},
  [556] = {.lex_state = 6, .external_lex_state = 4},
  [557] = {.lex_state = 6, .external_lex_state = 4},
  [558] = {.lex_state = 6, .external_lex_state = 4},
  [559] = {.lex_state = 6, .external_lex_state = 4},
  [560] = {.lex_state = 6, .external_lex_state = 4},
  [561] = {.lex_state = 6, .external_lex_state = 4},
  [562] = {.lex_state = 6, .external_lex_state = 4},
  [563] = {.lex_state = 6, .external_lex_state = 4},
  [564] = {.lex_state = 6, .external_lex_state = 4},
  [565] = {.lex_state = 6, .external_lex_state = 4},
  [566] = {.lex_state = 6, .external_lex_state = 4},
  [567] = {.lex_state = 6, .external_lex_state = 4},
  [568] = {.lex_state = 6, .external_lex_state = 4},
  [569] = {.lex_state = 6, .external_lex_state = 4},
  [570] = {.lex_state = 6, .external_lex_state = 4},
  [571] = {.lex_state = 6, .external_lex_state = 4},
  [572] = {.lex_state = 6, .external_lex_state = 4},
  [573] = {.lex_state = 6, .external_lex_state = 4},
  [574] = {.lex_state = 6, .external_lex_state = 4},
  [575] = {.lex_state = 6, .external_lex_state = 4},
  [576] = {.lex_state = 6, .external_lex_state = 4},
  [577] = {.lex_state = 6, .external_lex_state = 4},
  [578] = {.lex_state = 6, .external_lex_state = 4},
  [579] = {.lex_state = 6, .external_lex_state = 4},
  [580] = {.lex_state = 6, .external_lex_state = 4},
  [581] = {.lex_state = 6, .external_lex_state = 4},
  [582] = {.lex_state = 6, .external_lex_state = 4},
  [583] = {.lex_state = 6, .external_lex_state = 4},
  [584] = {.lex_state = 6, .external_lex_state = 4},
  [585] = {.lex_state = 6, .external_lex_state = 4},
  [586] = {.lex_state = 6, .external_lex_state = 4},
  [587] = {.lex_state = 6, .external_lex_state = 4},
  [588] = {.lex_state = 6, .external_lex_state = 4},
  [589] = {.lex_state = 5, .external_lex_state = 2},
  [590] = {.lex_state = 6, .external_lex_state = 4},
  [591] = {.lex_state = 6, .external_lex_state = 4},
  [592] = {.lex_state = 6, .external_lex_state = 4},
  [593] = {.lex_state = 6, .external_lex_state = 4},
  [594] = {.lex_state = 5, .external_lex_state = 2},
  [595] = {.lex_state = 6, .external_lex_state = 4},
  [596] = {.lex_state = 6, .external_lex_state = 4},
  [597] = {.lex_state = 6, .external_lex_state = 4},
  [598] = {.lex_state = 6, .external_lex_state = 4},
  [599] = {.lex_state = 6, .external_lex_state = 4},
  [600] = {.lex_state = 6, .external_lex_state = 4},
  [601] = {.lex_state = 6, .external_lex_state = 4},
  [602] = {.lex_state = 6, .external_lex_state = 4},
  [603] = {.lex_state = 6, .external_lex_state = 4},
  [604] = {.lex_state = 6, .external_lex_state = 4},
  [605] = {.lex_state = 6, .external_lex_state = 4},
  [606] = {.lex_state = 6, .external_lex_state = 4},
  [607] = {.lex_state = 6, .external_lex_state = 4},
  [608] = {.lex_state = 6, .external_lex_state = 4},
  [609] = {.lex_state = 5, .external_lex_state = 2},
  [610] = {.lex_state = 5, .external_lex_state = 2},
  [611] = {.lex_state = 5, .external_lex_state = 2},
  [612] = {.lex_state = 5, .external_lex_state = 2},
  [613] = {.lex_state = 5, .external_lex_state = 2},
  [614] = {.lex_state = 5, .external_lex_state = 2},
  [615] = {.lex_state = 5, .external_lex_state = 2},
  [616] = {.lex_state = 5, .external_lex_state = 2},
  [617] = {.lex_state = 5, .external_lex_state = 2},
  [618] = {.lex_state = 5, .external_lex_state = 2},
  [619] = {.lex_state = 6},
  [620] = {.lex_state = 6},
  [621] = {.lex_state = 6, .external_lex_state = 4},
  [622] = {.lex_state = 6},
  [623] = {.lex_state = 6},
  [624] = {.lex_state = 6, .external_lex_state = 4},
  [625] = {.lex_state = 6, .external_lex_state = 4},
  [626] = {.lex_state = 6, .external_lex_state = 4},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 6, .external_lex_state = 4},
  [629] = {.lex_state = 6},
  [630] = {.lex_state = 6},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 6, .external_lex_state = 4},
  [633] = {.lex_state = 6},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 6},
  [636] = {.lex_state = 6},
  [637] = {.lex_state = 6, .external_lex_state = 4},
  [638] = {.lex_state = 6},
  [639] = {.lex_state = 6, .external_lex_state = 4},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6, .external_lex_state = 4},
  [642] = {.lex_state = 6, .external_lex_state = 4},
  [643] = {.lex_state = 6, .external_lex_state = 4},
  [644] = {.lex_state = 6, .external_lex_state = 4},
  [645] = {.lex_state = 6, .external_lex_state = 4},
  [646] = {.lex_state = 6, .external_lex_state = 4},
  [647] = {.lex_state = 6, .external_lex_state = 4},
  [648] = {.lex_state = 6},
  [649] = {.lex_state = 6},
  [650] = {.lex_state = 6},
  [651] = {.lex_state = 27},
  [652] = {.lex_state = 6},
  [653] = {.lex_state = 6},
  [654] = {.lex_state = 6},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 6},
  [657] = {.lex_state = 6},
  [658] = {.lex_state = 6},
  [659] = {.lex_state = 6},
  [660] = {.lex_state = 6},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 6},
  [663] = {.lex_state = 6},
  [664] = {.lex_state = 6},
  [665] = {.lex_state = 6},
  [666] = {.lex_state = 6},
  [667] = {.lex_state = 6},
  [668] = {.lex_state = 6},
  [669] = {.lex_state = 6},
  [670] = {.lex_state = 6},
  [671] = {.lex_state = 6},
  [672] = {.lex_state = 27},
  [673] = {.lex_state = 6},
  [674] = {.lex_state = 6},
  [675] = {.lex_state = 6},
  [676] = {.lex_state = 6},
  [677] = {.lex_state = 6},
  [678] = {.lex_state = 6},
  [679] = {.lex_state = 6},
  [680] = {.lex_state = 6},
  [681] = {.lex_state = 6},
  [682] = {.lex_state = 6},
  [683] = {.lex_state = 6},
  [684] = {.lex_state = 6},
  [685] = {.lex_state = 6},
  [686] = {.lex_state = 6},
  [687] = {.lex_state = 6},
  [688] = {.lex_state = 6},
  [689] = {.lex_state = 6},
  [690] = {.lex_state = 27},
  [691] = {.lex_state = 5},
  [692] = {.lex_state = 5},
  [693] = {.lex_state = 5},
  [694] = {.lex_state = 5},
  [695] = {.lex_state = 5},
  [696] = {.lex_state = 5},
  [697] = {.lex_state = 5},
  [698] = {.lex_state = 5},
  [699] = {.lex_state = 5},
  [700] = {.lex_state = 5},
  [701] = {.lex_state = 5},
  [702] = {.lex_state = 5},
  [703] = {.lex_state = 5},
  [704] = {.lex_state = 5},
  [705] = {.lex_state = 5},
  [706] = {.lex_state = 5},
  [707] = {.lex_state = 5},
  [708] = {.lex_state = 5},
  [709] = {.lex_state = 5},
  [710] = {.lex_state = 5},
  [711] = {.lex_state = 5},
  [712] = {.lex_state = 5},
  [713] = {.lex_state = 5},
  [714] = {.lex_state = 5},
  [715] = {.lex_state = 5},
  [716] = {.lex_state = 27},
  [717] = {.lex_state = 5, .external_lex_state = 2},
  [718] = {.lex_state = 5},
  [719] = {.lex_state = 5},
  [720] = {.lex_state = 5},
  [721] = {.lex_state = 5},
  [722] = {.lex_state = 5},
  [723] = {.lex_state = 5},
  [724] = {.lex_state = 5},
  [725] = {.lex_state = 5},
  [726] = {.lex_state = 5},
  [727] = {.lex_state = 5},
  [728] = {.lex_state = 5},
  [729] = {.lex_state = 5},
  [730] = {.lex_state = 5},
  [731] = {.lex_state = 5},
  [732] = {.lex_state = 5},
  [733] = {.lex_state = 5},
  [734] = {.lex_state = 5},
  [735] = {.lex_state = 5},
  [736] = {.lex_state = 5},
  [737] = {.lex_state = 5},
  [738] = {.lex_state = 5},
  [739] = {.lex_state = 5},
  [740] = {.lex_state = 5},
  [741] = {.lex_state = 5},
  [742] = {.lex_state = 5},
  [743] = {.lex_state = 5},
  [744] = {.lex_state = 5},
  [745] = {.lex_state = 5},
  [746] = {.lex_state = 5},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 5},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 5},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 5},
  [753] = {.lex_state = 5},
  [754] = {.lex_state = 5},
  [755] = {.lex_state = 5},
  [756] = {.lex_state = 5},
  [757] = {.lex_state = 5},
  [758] = {.lex_state = 5},
  [759] = {.lex_state = 5},
  [760] = {.lex_state = 5},
  [761] = {.lex_state = 5},
  [762] = {.lex_state = 5},
  [763] = {.lex_state = 5},
  [764] = {.lex_state = 5},
  [765] = {.lex_state = 5},
  [766] = {.lex_state = 5},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 5},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 5},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 5},
  [773] = {.lex_state = 7, .external_lex_state = 2},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 5},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 5},
  [779] = {.lex_state = 5},
  [780] = {.lex_state = 5},
  [781] = {.lex_state = 5},
  [782] = {.lex_state = 5},
  [783] = {.lex_state = 5},
  [784] = {.lex_state = 5},
  [785] = {.lex_state = 5},
  [786] = {.lex_state = 5},
  [787] = {.lex_state = 5},
  [788] = {.lex_state = 5},
  [789] = {.lex_state = 5},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 5},
  [792] = {.lex_state = 5},
  [793] = {.lex_state = 5},
  [794] = {.lex_state = 5},
  [795] = {.lex_state = 5},
  [796] = {.lex_state = 5},
  [797] = {.lex_state = 5},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 5},
  [800] = {.lex_state = 5},
  [801] = {.lex_state = 5},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 5},
  [804] = {.lex_state = 5},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 5},
  [807] = {.lex_state = 5},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 5},
  [810] = {.lex_state = 5},
  [811] = {.lex_state = 5},
  [812] = {.lex_state = 5},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 5},
  [816] = {.lex_state = 5},
  [817] = {.lex_state = 5},
  [818] = {.lex_state = 5},
  [819] = {.lex_state = 0, .external_lex_state = 4},
  [820] = {.lex_state = 5},
  [821] = {.lex_state = 5},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 5},
  [824] = {.lex_state = 5},
  [825] = {.lex_state = 5},
  [826] = {.lex_state = 0, .external_lex_state = 4},
  [827] = {.lex_state = 5},
  [828] = {.lex_state = 5},
  [829] = {.lex_state = 5},
  [830] = {.lex_state = 5},
  [831] = {.lex_state = 5},
  [832] = {.lex_state = 5},
  [833] = {.lex_state = 5, .external_lex_state = 4},
  [834] = {.lex_state = 5},
  [835] = {.lex_state = 5, .external_lex_state = 4},
  [836] = {.lex_state = 0, .external_lex_state = 4},
  [837] = {.lex_state = 0, .external_lex_state = 4},
  [838] = {.lex_state = 79},
  [839] = {.lex_state = 5},
  [840] = {.lex_state = 0, .external_lex_state = 4},
  [841] = {.lex_state = 5},
  [842] = {.lex_state = 5},
  [843] = {.lex_state = 5},
  [844] = {.lex_state = 5},
  [845] = {.lex_state = 0, .external_lex_state = 4},
  [846] = {.lex_state = 5},
  [847] = {.lex_state = 5},
  [848] = {.lex_state = 0, .external_lex_state = 4},
  [849] = {.lex_state = 5},
  [850] = {.lex_state = 5, .external_lex_state = 4},
  [851] = {.lex_state = 0, .external_lex_state = 4},
  [852] = {.lex_state = 5},
  [853] = {.lex_state = 0, .external_lex_state = 4},
  [854] = {.lex_state = 5},
  [855] = {.lex_state = 5},
  [856] = {.lex_state = 5, .external_lex_state = 4},
  [857] = {.lex_state = 5},
  [858] = {.lex_state = 5, .external_lex_state = 4},
  [859] = {.lex_state = 5},
  [860] = {.lex_state = 79},
  [861] = {.lex_state = 0, .external_lex_state = 4},
  [862] = {.lex_state = 5},
  [863] = {.lex_state = 5},
  [864] = {.lex_state = 5},
  [865] = {.lex_state = 5},
  [866] = {.lex_state = 5},
  [867] = {.lex_state = 28, .external_lex_state = 5},
  [868] = {.lex_state = 5},
  [869] = {.lex_state = 4},
  [870] = {.lex_state = 5, .external_lex_state = 4},
  [871] = {.lex_state = 0, .external_lex_state = 4},
  [872] = {.lex_state = 5},
  [873] = {.lex_state = 5},
  [874] = {.lex_state = 5},
  [875] = {.lex_state = 5},
  [876] = {.lex_state = 5},
  [877] = {.lex_state = 5, .external_lex_state = 4},
  [878] = {.lex_state = 5},
  [879] = {.lex_state = 5},
  [880] = {.lex_state = 5},
  [881] = {.lex_state = 0, .external_lex_state = 4},
  [882] = {.lex_state = 0, .external_lex_state = 4},
  [883] = {.lex_state = 0, .external_lex_state = 4},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0, .external_lex_state = 4},
  [886] = {.lex_state = 0, .external_lex_state = 4},
  [887] = {.lex_state = 0, .external_lex_state = 4},
  [888] = {.lex_state = 0, .external_lex_state = 4},
  [889] = {.lex_state = 5},
  [890] = {.lex_state = 0, .external_lex_state = 4},
  [891] = {.lex_state = 5},
  [892] = {.lex_state = 0, .external_lex_state = 4},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0, .external_lex_state = 4},
  [895] = {.lex_state = 0, .external_lex_state = 4},
  [896] = {.lex_state = 5},
  [897] = {.lex_state = 5},
  [898] = {.lex_state = 0, .external_lex_state = 4},
  [899] = {.lex_state = 0, .external_lex_state = 4},
  [900] = {.lex_state = 0, .external_lex_state = 4},
  [901] = {.lex_state = 0, .external_lex_state = 4},
  [902] = {.lex_state = 5},
  [903] = {.lex_state = 0, .external_lex_state = 4},
  [904] = {.lex_state = 0, .external_lex_state = 4},
  [905] = {.lex_state = 0, .external_lex_state = 4},
  [906] = {.lex_state = 0, .external_lex_state = 4},
  [907] = {.lex_state = 0, .external_lex_state = 4},
  [908] = {.lex_state = 0, .external_lex_state = 4},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0, .external_lex_state = 4},
  [911] = {.lex_state = 0, .external_lex_state = 4},
  [912] = {.lex_state = 0, .external_lex_state = 4},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 0, .external_lex_state = 4},
  [915] = {.lex_state = 0, .external_lex_state = 4},
  [916] = {.lex_state = 0, .external_lex_state = 4},
  [917] = {.lex_state = 5},
  [918] = {.lex_state = 0, .external_lex_state = 4},
  [919] = {.lex_state = 0, .external_lex_state = 4},
  [920] = {.lex_state = 5},
  [921] = {.lex_state = 0, .external_lex_state = 4},
  [922] = {.lex_state = 4},
  [923] = {.lex_state = 4},
  [924] = {.lex_state = 5},
  [925] = {.lex_state = 5},
  [926] = {.lex_state = 4},
  [927] = {.lex_state = 4},
  [928] = {.lex_state = 0, .external_lex_state = 4},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0, .external_lex_state = 4},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0, .external_lex_state = 4},
  [934] = {.lex_state = 5},
  [935] = {.lex_state = 0, .external_lex_state = 4},
  [936] = {.lex_state = 5},
  [937] = {.lex_state = 5},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0, .external_lex_state = 4},
  [940] = {.lex_state = 0, .external_lex_state = 4},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0, .external_lex_state = 4},
  [944] = {.lex_state = 28, .external_lex_state = 5},
  [945] = {.lex_state = 5},
  [946] = {.lex_state = 5},
  [947] = {.lex_state = 5},
  [948] = {.lex_state = 4},
  [949] = {.lex_state = 0, .external_lex_state = 4},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 5},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 5},
  [954] = {.lex_state = 4},
  [955] = {.lex_state = 5},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0, .external_lex_state = 4},
  [958] = {.lex_state = 28, .external_lex_state = 5},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 79},
  [961] = {.lex_state = 0, .external_lex_state = 4},
  [962] = {.lex_state = 5},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 5},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 5},
  [969] = {.lex_state = 0, .external_lex_state = 4},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 5},
  [974] = {.lex_state = 5},
  [975] = {.lex_state = 5},
  [976] = {.lex_state = 5},
  [977] = {.lex_state = 5},
  [978] = {.lex_state = 5},
  [979] = {.lex_state = 5},
  [980] = {.lex_state = 5},
  [981] = {.lex_state = 5},
  [982] = {.lex_state = 5},
  [983] = {.lex_state = 5},
  [984] = {.lex_state = 5},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 5},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 5},
  [992] = {.lex_state = 5},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 5},
  [995] = {.lex_state = 5},
  [996] = {.lex_state = 5},
  [997] = {.lex_state = 5},
  [998] = {.lex_state = 5},
  [999] = {.lex_state = 5},
  [1000] = {.lex_state = 5},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 5},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 5},
  [1007] = {.lex_state = 5},
  [1008] = {.lex_state = 5},
  [1009] = {.lex_state = 5},
  [1010] = {.lex_state = 5},
  [1011] = {.lex_state = 5},
  [1012] = {.lex_state = 5},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 5},
  [1015] = {.lex_state = 5},
  [1016] = {.lex_state = 5},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 5},
  [1019] = {.lex_state = 5},
  [1020] = {.lex_state = 5},
  [1021] = {.lex_state = 5},
  [1022] = {.lex_state = 5},
  [1023] = {.lex_state = 5},
  [1024] = {.lex_state = 5},
  [1025] = {.lex_state = 5},
  [1026] = {.lex_state = 5},
  [1027] = {.lex_state = 5},
  [1028] = {.lex_state = 5},
  [1029] = {.lex_state = 5},
  [1030] = {.lex_state = 4},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 4},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 4},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 5},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 5},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 5},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 5},
  [1051] = {.lex_state = 0, .external_lex_state = 4},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 5},
  [1054] = {.lex_state = 5},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 5},
  [1060] = {.lex_state = 5},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0, .external_lex_state = 4},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0, .external_lex_state = 4},
  [1073] = {.lex_state = 5},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 5},
  [1076] = {.lex_state = 4},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 5},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0, .external_lex_state = 4},
  [1082] = {.lex_state = 5},
  [1083] = {.lex_state = 0, .external_lex_state = 4},
  [1084] = {.lex_state = 0, .external_lex_state = 4},
  [1085] = {.lex_state = 5},
  [1086] = {.lex_state = 5, .external_lex_state = 4},
  [1087] = {.lex_state = 0, .external_lex_state = 4},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 5},
  [1091] = {.lex_state = 5},
  [1092] = {.lex_state = 5},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 5},
  [1095] = {.lex_state = 5},
  [1096] = {.lex_state = 5},
  [1097] = {.lex_state = 5},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0, .external_lex_state = 4},
  [1100] = {.lex_state = 0, .external_lex_state = 4},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0, .external_lex_state = 4},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0, .external_lex_state = 4},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 5},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 5},
  [1111] = {.lex_state = 0, .external_lex_state = 4},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0, .external_lex_state = 4},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 5, .external_lex_state = 4},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 5},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 5},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 5},
  [1126] = {.lex_state = 0, .external_lex_state = 4},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 5},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 5},
  [1134] = {.lex_state = 5},
  [1135] = {.lex_state = 5},
  [1136] = {.lex_state = 5},
  [1137] = {.lex_state = 5},
  [1138] = {.lex_state = 5},
  [1139] = {.lex_state = 5},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0, .external_lex_state = 4},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0, .external_lex_state = 4},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0, .external_lex_state = 4},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0, .external_lex_state = 4},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0, .external_lex_state = 4},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0, .external_lex_state = 4},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0, .external_lex_state = 4},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0, .external_lex_state = 4},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0, .external_lex_state = 4},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0, .external_lex_state = 4},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0, .external_lex_state = 4},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0, .external_lex_state = 4},
  [1189] = {.lex_state = 0, .external_lex_state = 4},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0, .external_lex_state = 4},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0, .external_lex_state = 4},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0, .external_lex_state = 4},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0, .external_lex_state = 4},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0, .external_lex_state = 4},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0, .external_lex_state = 4},
  [1209] = {.lex_state = 0, .external_lex_state = 4},
  [1210] = {.lex_state = 0, .external_lex_state = 4},
  [1211] = {.lex_state = 0, .external_lex_state = 4},
  [1212] = {.lex_state = 0, .external_lex_state = 4},
  [1213] = {.lex_state = 0, .external_lex_state = 4},
  [1214] = {.lex_state = 0, .external_lex_state = 4},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0, .external_lex_state = 4},
  [1221] = {.lex_state = 0, .external_lex_state = 4},
  [1222] = {.lex_state = 0, .external_lex_state = 4},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0, .external_lex_state = 4},
  [1225] = {.lex_state = 0, .external_lex_state = 4},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0, .external_lex_state = 4},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0, .external_lex_state = 4},
  [1230] = {.lex_state = 0, .external_lex_state = 4},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0, .external_lex_state = 4},
  [1233] = {.lex_state = 0, .external_lex_state = 4},
  [1234] = {.lex_state = 0, .external_lex_state = 4},
  [1235] = {.lex_state = 0, .external_lex_state = 4},
  [1236] = {.lex_state = 0, .external_lex_state = 4},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0, .external_lex_state = 4},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0, .external_lex_state = 4},
  [1242] = {.lex_state = 0, .external_lex_state = 4},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0, .external_lex_state = 4},
  [1247] = {.lex_state = 0, .external_lex_state = 4},
  [1248] = {.lex_state = 0, .external_lex_state = 4},
  [1249] = {.lex_state = 0, .external_lex_state = 4},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 78},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0, .external_lex_state = 4},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 5},
  [1256] = {.lex_state = 0, .external_lex_state = 4},
  [1257] = {.lex_state = 5},
  [1258] = {.lex_state = 0, .external_lex_state = 4},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0, .external_lex_state = 4},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0, .external_lex_state = 4},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0, .external_lex_state = 4},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0, .external_lex_state = 4},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0, .external_lex_state = 4},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0, .external_lex_state = 4},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0, .external_lex_state = 4},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0, .external_lex_state = 4},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 5},
  [1300] = {.lex_state = 5},
  [1301] = {.lex_state = 5},
  [1302] = {.lex_state = 5},
  [1303] = {.lex_state = 5},
  [1304] = {.lex_state = 5},
  [1305] = {.lex_state = 5},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 5},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 5},
  [1316] = {.lex_state = 5},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 5},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 5},
  [1326] = {.lex_state = 5},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 5},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 5},
  [1338] = {.lex_state = 5},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 5},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 5},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 5},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 5},
  [1351] = {.lex_state = 5},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 5},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 5},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 5},
  [1364] = {.lex_state = 5},
  [1365] = {.lex_state = 5},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 5},
  [1369] = {.lex_state = 5},
  [1370] = {.lex_state = 5},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 5},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 5},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 5},
  [1390] = {.lex_state = 78, .external_lex_state = 5},
  [1391] = {.lex_state = 5},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 0},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 5},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {-1},
  [1406] = {-1},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token_heredoc = 1,
  ts_external_token__eof = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token_heredoc] = sym_heredoc,
  [ts_external_token__eof] = sym__eof,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_heredoc] = true,
    [ts_external_token__eof] = true,
  },
  [2] = {
    [ts_external_token_heredoc] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_heredoc] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__eof] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_text_interpolation] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [sym_php_tag] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_text_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [sym_var_modifier] = ACTIONS(1),
    [anon_sym_insteadof] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [anon_sym_callable] = ACTIONS(1),
    [anon_sym_iterable] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_integer] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_real] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_echo] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_enddeclare] = ACTIONS(1),
    [anon_sym_ticks] = ACTIONS(1),
    [anon_sym_encoding] = ACTIONS(1),
    [anon_sym_strict_types] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_endwhile] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_endfor] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_endforeach] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_endif] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_endswitch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_clone] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_shell_command_expression] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_boolean] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [aux_sym_binary_expression_token1] = ACTIONS(1),
    [aux_sym_binary_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token3] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_include_once] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_require_once] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym_heredoc] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1396),
    [sym_text_interpolation] = STATE(1),
    [sym_text] = STATE(1251),
    [aux_sym_text_repeat1] = STATE(860),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_php_tag] = ACTIONS(9),
    [anon_sym_QMARK_GT] = ACTIONS(11),
    [aux_sym_text_token1] = ACTIONS(13),
    [aux_sym_text_token2] = ACTIONS(13),
    [sym_comment] = ACTIONS(15),
  },
  [2] = {
    [sym_text_interpolation] = STATE(2),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(17),
    [sym_name] = ACTIONS(19),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(22),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_global] = ACTIONS(28),
    [anon_sym_namespace] = ACTIONS(31),
    [anon_sym_use] = ACTIONS(34),
    [anon_sym_BSLASH] = ACTIONS(37),
    [anon_sym_function] = ACTIONS(40),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(46),
    [anon_sym_RBRACE] = ACTIONS(17),
    [anon_sym_trait] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(52),
    [anon_sym_class] = ACTIONS(55),
    [anon_sym_abstract] = ACTIONS(58),
    [anon_sym_final] = ACTIONS(58),
    [anon_sym_public] = ACTIONS(61),
    [anon_sym_protected] = ACTIONS(61),
    [anon_sym_private] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_array] = ACTIONS(67),
    [anon_sym_unset] = ACTIONS(70),
    [anon_sym_echo] = ACTIONS(73),
    [anon_sym_declare] = ACTIONS(76),
    [anon_sym_enddeclare] = ACTIONS(79),
    [sym_float] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(84),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_continue] = ACTIONS(90),
    [anon_sym_break] = ACTIONS(93),
    [sym_integer] = ACTIONS(81),
    [anon_sym_return] = ACTIONS(96),
    [anon_sym_throw] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(102),
    [anon_sym_endwhile] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(105),
    [anon_sym_for] = ACTIONS(108),
    [anon_sym_endfor] = ACTIONS(79),
    [anon_sym_foreach] = ACTIONS(111),
    [anon_sym_endforeach] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(114),
    [anon_sym_endif] = ACTIONS(79),
    [anon_sym_elseif] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(117),
    [anon_sym_endswitch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(79),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_AT] = ACTIONS(120),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_clone] = ACTIONS(129),
    [anon_sym_print] = ACTIONS(132),
    [anon_sym_new] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(138),
    [anon_sym_PLUS_PLUS] = ACTIONS(141),
    [anon_sym_DASH_DASH] = ACTIONS(141),
    [sym_shell_command_expression] = ACTIONS(144),
    [anon_sym_list] = ACTIONS(147),
    [anon_sym_self] = ACTIONS(150),
    [anon_sym_parent] = ACTIONS(150),
    [sym_string] = ACTIONS(153),
    [sym_boolean] = ACTIONS(81),
    [sym_null] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(159),
    [anon_sym_include] = ACTIONS(162),
    [anon_sym_include_once] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(168),
    [anon_sym_require_once] = ACTIONS(171),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(153),
  },
  [3] = {
    [sym_text_interpolation] = STATE(3),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_endwhile] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_endforeach] = ACTIONS(230),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_endif] = ACTIONS(230),
    [anon_sym_elseif] = ACTIONS(230),
    [anon_sym_else] = ACTIONS(230),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [4] = {
    [sym_text_interpolation] = STATE(4),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(3),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_endwhile] = ACTIONS(278),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_endforeach] = ACTIONS(278),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_endif] = ACTIONS(278),
    [anon_sym_elseif] = ACTIONS(278),
    [anon_sym_else] = ACTIONS(278),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [5] = {
    [sym_text_interpolation] = STATE(5),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(280),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(282),
    [anon_sym_case] = ACTIONS(282),
    [anon_sym_default] = ACTIONS(282),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [6] = {
    [sym_text_interpolation] = STATE(6),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(7),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(284),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(286),
    [anon_sym_case] = ACTIONS(286),
    [anon_sym_default] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [7] = {
    [sym_text_interpolation] = STATE(7),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(290),
    [anon_sym_case] = ACTIONS(290),
    [anon_sym_default] = ACTIONS(290),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [8] = {
    [sym_text_interpolation] = STATE(8),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(5),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(294),
    [anon_sym_case] = ACTIONS(294),
    [anon_sym_default] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [9] = {
    [sym_text_interpolation] = STATE(9),
    [sym_empty_statement] = STATE(324),
    [sym_function_static_declaration] = STATE(324),
    [sym_global_declaration] = STATE(324),
    [sym_namespace_definition] = STATE(324),
    [sym_namespace_use_declaration] = STATE(324),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(324),
    [sym_interface_declaration] = STATE(324),
    [sym_class_declaration] = STATE(324),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(324),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(324),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(324),
    [sym_unset_statement] = STATE(324),
    [sym_declare_statement] = STATE(324),
    [sym_try_statement] = STATE(324),
    [sym__jump_statement] = STATE(324),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(324),
    [sym_do_statement] = STATE(324),
    [sym_for_statement] = STATE(324),
    [sym_foreach_statement] = STATE(324),
    [sym_if_statement] = STATE(324),
    [sym_colon_block] = STATE(1325),
    [sym_switch_statement] = STATE(324),
    [sym_compound_statement] = STATE(324),
    [sym_named_label_statement] = STATE(324),
    [sym_expression_statement] = STATE(324),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(296),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(300),
    [sym_heredoc] = ACTIONS(264),
  },
  [10] = {
    [sym_text_interpolation] = STATE(10),
    [sym_empty_statement] = STATE(1022),
    [sym_function_static_declaration] = STATE(1022),
    [sym_global_declaration] = STATE(1022),
    [sym_namespace_definition] = STATE(1022),
    [sym_namespace_use_declaration] = STATE(1022),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1022),
    [sym_interface_declaration] = STATE(1022),
    [sym_class_declaration] = STATE(1022),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1022),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1022),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1022),
    [sym_unset_statement] = STATE(1022),
    [sym_declare_statement] = STATE(1022),
    [sym_try_statement] = STATE(1022),
    [sym__jump_statement] = STATE(1022),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1022),
    [sym_do_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_foreach_statement] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_colon_block] = STATE(1351),
    [sym_switch_statement] = STATE(1022),
    [sym_compound_statement] = STATE(1022),
    [sym_named_label_statement] = STATE(1022),
    [sym_expression_statement] = STATE(1022),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(354),
    [sym_heredoc] = ACTIONS(264),
  },
  [11] = {
    [sym_text_interpolation] = STATE(11),
    [sym_empty_statement] = STATE(1013),
    [sym_function_static_declaration] = STATE(1013),
    [sym_global_declaration] = STATE(1013),
    [sym_namespace_definition] = STATE(1013),
    [sym_namespace_use_declaration] = STATE(1013),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1013),
    [sym_interface_declaration] = STATE(1013),
    [sym_class_declaration] = STATE(1013),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1013),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1013),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1013),
    [sym_unset_statement] = STATE(1013),
    [sym_declare_statement] = STATE(1013),
    [sym_try_statement] = STATE(1013),
    [sym__jump_statement] = STATE(1013),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1013),
    [sym_do_statement] = STATE(1013),
    [sym_for_statement] = STATE(1013),
    [sym_foreach_statement] = STATE(1013),
    [sym_if_statement] = STATE(1013),
    [sym_colon_block] = STATE(1348),
    [sym_switch_statement] = STATE(1013),
    [sym_compound_statement] = STATE(1013),
    [sym_named_label_statement] = STATE(1013),
    [sym_expression_statement] = STATE(1013),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(356),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(358),
    [sym_heredoc] = ACTIONS(264),
  },
  [12] = {
    [sym_text_interpolation] = STATE(12),
    [sym_empty_statement] = STATE(311),
    [sym_function_static_declaration] = STATE(311),
    [sym_global_declaration] = STATE(311),
    [sym_namespace_definition] = STATE(311),
    [sym_namespace_use_declaration] = STATE(311),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(311),
    [sym_interface_declaration] = STATE(311),
    [sym_class_declaration] = STATE(311),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(311),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(311),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(311),
    [sym_unset_statement] = STATE(311),
    [sym_declare_statement] = STATE(311),
    [sym_try_statement] = STATE(311),
    [sym__jump_statement] = STATE(311),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(311),
    [sym_do_statement] = STATE(311),
    [sym_for_statement] = STATE(311),
    [sym_foreach_statement] = STATE(311),
    [sym_if_statement] = STATE(311),
    [sym_colon_block] = STATE(1316),
    [sym_switch_statement] = STATE(311),
    [sym_compound_statement] = STATE(311),
    [sym_named_label_statement] = STATE(311),
    [sym_expression_statement] = STATE(311),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(360),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(362),
    [sym_heredoc] = ACTIONS(264),
  },
  [13] = {
    [sym_text_interpolation] = STATE(13),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(364),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [14] = {
    [sym_text_interpolation] = STATE(14),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(366),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [15] = {
    [sym_text_interpolation] = STATE(15),
    [sym_empty_statement] = STATE(116),
    [sym_function_static_declaration] = STATE(116),
    [sym_global_declaration] = STATE(116),
    [sym_namespace_definition] = STATE(116),
    [sym_namespace_use_declaration] = STATE(116),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(116),
    [sym_interface_declaration] = STATE(116),
    [sym_class_declaration] = STATE(116),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(116),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(116),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(116),
    [sym_unset_statement] = STATE(116),
    [sym_declare_statement] = STATE(116),
    [sym_try_statement] = STATE(116),
    [sym__jump_statement] = STATE(116),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(116),
    [sym_do_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_foreach_statement] = STATE(116),
    [sym_if_statement] = STATE(116),
    [sym_colon_block] = STATE(780),
    [sym_switch_statement] = STATE(116),
    [sym_compound_statement] = STATE(116),
    [sym_named_label_statement] = STATE(116),
    [sym_expression_statement] = STATE(116),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [16] = {
    [sym_text_interpolation] = STATE(16),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(18),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [17] = {
    [sym_text_interpolation] = STATE(17),
    [sym_empty_statement] = STATE(801),
    [sym_function_static_declaration] = STATE(801),
    [sym_global_declaration] = STATE(801),
    [sym_namespace_definition] = STATE(801),
    [sym_namespace_use_declaration] = STATE(801),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(801),
    [sym_interface_declaration] = STATE(801),
    [sym_class_declaration] = STATE(801),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(801),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(801),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(801),
    [sym_unset_statement] = STATE(801),
    [sym_declare_statement] = STATE(801),
    [sym_try_statement] = STATE(801),
    [sym__jump_statement] = STATE(801),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(801),
    [sym_do_statement] = STATE(801),
    [sym_for_statement] = STATE(801),
    [sym_foreach_statement] = STATE(801),
    [sym_if_statement] = STATE(801),
    [sym_colon_block] = STATE(792),
    [sym_switch_statement] = STATE(801),
    [sym_compound_statement] = STATE(801),
    [sym_named_label_statement] = STATE(801),
    [sym_expression_statement] = STATE(801),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [18] = {
    [sym_text_interpolation] = STATE(18),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [19] = {
    [sym_text_interpolation] = STATE(19),
    [sym_empty_statement] = STATE(1133),
    [sym_function_static_declaration] = STATE(1133),
    [sym_global_declaration] = STATE(1133),
    [sym_namespace_definition] = STATE(1133),
    [sym_namespace_use_declaration] = STATE(1133),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1133),
    [sym_interface_declaration] = STATE(1133),
    [sym_class_declaration] = STATE(1133),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1133),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1133),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1133),
    [sym_unset_statement] = STATE(1133),
    [sym_declare_statement] = STATE(1133),
    [sym_try_statement] = STATE(1133),
    [sym__jump_statement] = STATE(1133),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1133),
    [sym_do_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_foreach_statement] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_colon_block] = STATE(1315),
    [sym_switch_statement] = STATE(1133),
    [sym_compound_statement] = STATE(1133),
    [sym_named_label_statement] = STATE(1133),
    [sym_expression_statement] = STATE(1133),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [20] = {
    [sym_text_interpolation] = STATE(20),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(54),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(374),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [21] = {
    [sym_text_interpolation] = STATE(21),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(52),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [22] = {
    [sym_text_interpolation] = STATE(22),
    [sym_empty_statement] = STATE(290),
    [sym_function_static_declaration] = STATE(290),
    [sym_global_declaration] = STATE(290),
    [sym_namespace_definition] = STATE(290),
    [sym_namespace_use_declaration] = STATE(290),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(290),
    [sym_interface_declaration] = STATE(290),
    [sym_class_declaration] = STATE(290),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(290),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(290),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(290),
    [sym_unset_statement] = STATE(290),
    [sym_declare_statement] = STATE(290),
    [sym_try_statement] = STATE(290),
    [sym__jump_statement] = STATE(290),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(290),
    [sym_do_statement] = STATE(290),
    [sym_for_statement] = STATE(290),
    [sym_foreach_statement] = STATE(290),
    [sym_if_statement] = STATE(290),
    [sym_colon_block] = STATE(1323),
    [sym_switch_statement] = STATE(290),
    [sym_compound_statement] = STATE(290),
    [sym_named_label_statement] = STATE(290),
    [sym_expression_statement] = STATE(290),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [23] = {
    [sym_text_interpolation] = STATE(23),
    [sym_empty_statement] = STATE(263),
    [sym_function_static_declaration] = STATE(263),
    [sym_global_declaration] = STATE(263),
    [sym_namespace_definition] = STATE(263),
    [sym_namespace_use_declaration] = STATE(263),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(263),
    [sym_interface_declaration] = STATE(263),
    [sym_class_declaration] = STATE(263),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(263),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(263),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(263),
    [sym_unset_statement] = STATE(263),
    [sym_declare_statement] = STATE(263),
    [sym_try_statement] = STATE(263),
    [sym__jump_statement] = STATE(263),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(263),
    [sym_do_statement] = STATE(263),
    [sym_for_statement] = STATE(263),
    [sym_foreach_statement] = STATE(263),
    [sym_if_statement] = STATE(263),
    [sym_switch_statement] = STATE(263),
    [sym_compound_statement] = STATE(263),
    [sym_named_label_statement] = STATE(263),
    [sym_expression_statement] = STATE(263),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(378),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(380),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(382),
    [sym_heredoc] = ACTIONS(264),
  },
  [24] = {
    [sym_text_interpolation] = STATE(24),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(384),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [25] = {
    [sym_text_interpolation] = STATE(25),
    [sym_empty_statement] = STATE(976),
    [sym_function_static_declaration] = STATE(976),
    [sym_global_declaration] = STATE(976),
    [sym_namespace_definition] = STATE(976),
    [sym_namespace_use_declaration] = STATE(976),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(976),
    [sym_interface_declaration] = STATE(976),
    [sym_class_declaration] = STATE(976),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(976),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(976),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(976),
    [sym_unset_statement] = STATE(976),
    [sym_declare_statement] = STATE(976),
    [sym_try_statement] = STATE(976),
    [sym__jump_statement] = STATE(976),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(976),
    [sym_do_statement] = STATE(976),
    [sym_for_statement] = STATE(976),
    [sym_foreach_statement] = STATE(976),
    [sym_if_statement] = STATE(976),
    [sym_switch_statement] = STATE(976),
    [sym_compound_statement] = STATE(976),
    [sym_named_label_statement] = STATE(976),
    [sym_expression_statement] = STATE(976),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(386),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(388),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(390),
    [sym_heredoc] = ACTIONS(264),
  },
  [26] = {
    [sym_text_interpolation] = STATE(26),
    [sym_empty_statement] = STATE(995),
    [sym_function_static_declaration] = STATE(995),
    [sym_global_declaration] = STATE(995),
    [sym_namespace_definition] = STATE(995),
    [sym_namespace_use_declaration] = STATE(995),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(995),
    [sym_interface_declaration] = STATE(995),
    [sym_class_declaration] = STATE(995),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(995),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(995),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(995),
    [sym_unset_statement] = STATE(995),
    [sym_declare_statement] = STATE(995),
    [sym_try_statement] = STATE(995),
    [sym__jump_statement] = STATE(995),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(995),
    [sym_do_statement] = STATE(995),
    [sym_for_statement] = STATE(995),
    [sym_foreach_statement] = STATE(995),
    [sym_if_statement] = STATE(995),
    [sym_switch_statement] = STATE(995),
    [sym_compound_statement] = STATE(995),
    [sym_named_label_statement] = STATE(995),
    [sym_expression_statement] = STATE(995),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(394),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(396),
    [sym_heredoc] = ACTIONS(264),
  },
  [27] = {
    [sym_text_interpolation] = STATE(27),
    [sym_empty_statement] = STATE(1009),
    [sym_function_static_declaration] = STATE(1009),
    [sym_global_declaration] = STATE(1009),
    [sym_namespace_definition] = STATE(1009),
    [sym_namespace_use_declaration] = STATE(1009),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1009),
    [sym_interface_declaration] = STATE(1009),
    [sym_class_declaration] = STATE(1009),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1009),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1009),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1009),
    [sym_unset_statement] = STATE(1009),
    [sym_declare_statement] = STATE(1009),
    [sym_try_statement] = STATE(1009),
    [sym__jump_statement] = STATE(1009),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1009),
    [sym_do_statement] = STATE(1009),
    [sym_for_statement] = STATE(1009),
    [sym_foreach_statement] = STATE(1009),
    [sym_if_statement] = STATE(1009),
    [sym_switch_statement] = STATE(1009),
    [sym_compound_statement] = STATE(1009),
    [sym_named_label_statement] = STATE(1009),
    [sym_expression_statement] = STATE(1009),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(402),
    [sym_heredoc] = ACTIONS(264),
  },
  [28] = {
    [sym_text_interpolation] = STATE(28),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(404),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [29] = {
    [sym_text_interpolation] = STATE(29),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(28),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(406),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [30] = {
    [sym_text_interpolation] = STATE(30),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(406),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [31] = {
    [sym_text_interpolation] = STATE(31),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(30),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(364),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [32] = {
    [sym_text_interpolation] = STATE(32),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(38),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(408),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [33] = {
    [sym_text_interpolation] = STATE(33),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(24),
    [ts_builtin_sym_end] = ACTIONS(410),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [34] = {
    [sym_text_interpolation] = STATE(34),
    [sym_empty_statement] = STATE(306),
    [sym_function_static_declaration] = STATE(306),
    [sym_global_declaration] = STATE(306),
    [sym_namespace_definition] = STATE(306),
    [sym_namespace_use_declaration] = STATE(306),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(306),
    [sym_interface_declaration] = STATE(306),
    [sym_class_declaration] = STATE(306),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(306),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(306),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(306),
    [sym_unset_statement] = STATE(306),
    [sym_declare_statement] = STATE(306),
    [sym_try_statement] = STATE(306),
    [sym__jump_statement] = STATE(306),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(306),
    [sym_do_statement] = STATE(306),
    [sym_for_statement] = STATE(306),
    [sym_foreach_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(306),
    [sym_compound_statement] = STATE(306),
    [sym_named_label_statement] = STATE(306),
    [sym_expression_statement] = STATE(306),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(412),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(414),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(416),
    [sym_heredoc] = ACTIONS(264),
  },
  [35] = {
    [sym_text_interpolation] = STATE(35),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(36),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(418),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [36] = {
    [sym_text_interpolation] = STATE(36),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(420),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [37] = {
    [sym_text_interpolation] = STATE(37),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(13),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(366),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [38] = {
    [sym_text_interpolation] = STATE(38),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(422),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [39] = {
    [sym_text_interpolation] = STATE(39),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(374),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [40] = {
    [sym_text_interpolation] = STATE(40),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(410),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [41] = {
    [sym_text_interpolation] = STATE(41),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(14),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(424),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [42] = {
    [sym_text_interpolation] = STATE(42),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(426),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [43] = {
    [sym_text_interpolation] = STATE(43),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(428),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [44] = {
    [sym_text_interpolation] = STATE(44),
    [sym_empty_statement] = STATE(325),
    [sym_function_static_declaration] = STATE(325),
    [sym_global_declaration] = STATE(325),
    [sym_namespace_definition] = STATE(325),
    [sym_namespace_use_declaration] = STATE(325),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(325),
    [sym_interface_declaration] = STATE(325),
    [sym_class_declaration] = STATE(325),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(325),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(325),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(325),
    [sym_unset_statement] = STATE(325),
    [sym_declare_statement] = STATE(325),
    [sym_try_statement] = STATE(325),
    [sym__jump_statement] = STATE(325),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(325),
    [sym_do_statement] = STATE(325),
    [sym_for_statement] = STATE(325),
    [sym_foreach_statement] = STATE(325),
    [sym_if_statement] = STATE(325),
    [sym_switch_statement] = STATE(325),
    [sym_compound_statement] = STATE(325),
    [sym_named_label_statement] = STATE(325),
    [sym_expression_statement] = STATE(325),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(430),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(432),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(434),
    [sym_heredoc] = ACTIONS(264),
  },
  [45] = {
    [sym_text_interpolation] = STATE(45),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(48),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(420),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [46] = {
    [sym_text_interpolation] = STATE(46),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(39),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(436),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [47] = {
    [sym_text_interpolation] = STATE(47),
    [sym_empty_statement] = STATE(1018),
    [sym_function_static_declaration] = STATE(1018),
    [sym_global_declaration] = STATE(1018),
    [sym_namespace_definition] = STATE(1018),
    [sym_namespace_use_declaration] = STATE(1018),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1018),
    [sym_interface_declaration] = STATE(1018),
    [sym_class_declaration] = STATE(1018),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1018),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1018),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1018),
    [sym_unset_statement] = STATE(1018),
    [sym_declare_statement] = STATE(1018),
    [sym_try_statement] = STATE(1018),
    [sym__jump_statement] = STATE(1018),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1018),
    [sym_do_statement] = STATE(1018),
    [sym_for_statement] = STATE(1018),
    [sym_foreach_statement] = STATE(1018),
    [sym_if_statement] = STATE(1018),
    [sym_switch_statement] = STATE(1018),
    [sym_compound_statement] = STATE(1018),
    [sym_named_label_statement] = STATE(1018),
    [sym_expression_statement] = STATE(1018),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(442),
    [sym_heredoc] = ACTIONS(264),
  },
  [48] = {
    [sym_text_interpolation] = STATE(48),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(436),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [49] = {
    [sym_text_interpolation] = STATE(49),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(42),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(444),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [50] = {
    [sym_text_interpolation] = STATE(50),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(40),
    [ts_builtin_sym_end] = ACTIONS(446),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [51] = {
    [sym_text_interpolation] = STATE(51),
    [sym_empty_statement] = STATE(1023),
    [sym_function_static_declaration] = STATE(1023),
    [sym_global_declaration] = STATE(1023),
    [sym_namespace_definition] = STATE(1023),
    [sym_namespace_use_declaration] = STATE(1023),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1023),
    [sym_interface_declaration] = STATE(1023),
    [sym_class_declaration] = STATE(1023),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1023),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1023),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1023),
    [sym_unset_statement] = STATE(1023),
    [sym_declare_statement] = STATE(1023),
    [sym_try_statement] = STATE(1023),
    [sym__jump_statement] = STATE(1023),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1023),
    [sym_do_statement] = STATE(1023),
    [sym_for_statement] = STATE(1023),
    [sym_foreach_statement] = STATE(1023),
    [sym_if_statement] = STATE(1023),
    [sym_switch_statement] = STATE(1023),
    [sym_compound_statement] = STATE(1023),
    [sym_named_label_statement] = STATE(1023),
    [sym_expression_statement] = STATE(1023),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(448),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(450),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(452),
    [sym_heredoc] = ACTIONS(264),
  },
  [52] = {
    [sym_text_interpolation] = STATE(52),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(454),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [53] = {
    [sym_text_interpolation] = STATE(53),
    [sym_empty_statement] = STATE(317),
    [sym_function_static_declaration] = STATE(317),
    [sym_global_declaration] = STATE(317),
    [sym_namespace_definition] = STATE(317),
    [sym_namespace_use_declaration] = STATE(317),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class_declaration] = STATE(317),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(317),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(317),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(317),
    [sym_unset_statement] = STATE(317),
    [sym_declare_statement] = STATE(317),
    [sym_try_statement] = STATE(317),
    [sym__jump_statement] = STATE(317),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(317),
    [sym_do_statement] = STATE(317),
    [sym_for_statement] = STATE(317),
    [sym_foreach_statement] = STATE(317),
    [sym_if_statement] = STATE(317),
    [sym_switch_statement] = STATE(317),
    [sym_compound_statement] = STATE(317),
    [sym_named_label_statement] = STATE(317),
    [sym_expression_statement] = STATE(317),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(456),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(458),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(460),
    [sym_heredoc] = ACTIONS(264),
  },
  [54] = {
    [sym_text_interpolation] = STATE(54),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(462),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [55] = {
    [sym_text_interpolation] = STATE(55),
    [sym_empty_statement] = STATE(282),
    [sym_function_static_declaration] = STATE(282),
    [sym_global_declaration] = STATE(282),
    [sym_namespace_definition] = STATE(282),
    [sym_namespace_use_declaration] = STATE(282),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(282),
    [sym_interface_declaration] = STATE(282),
    [sym_class_declaration] = STATE(282),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(282),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(282),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(282),
    [sym_unset_statement] = STATE(282),
    [sym_declare_statement] = STATE(282),
    [sym_try_statement] = STATE(282),
    [sym__jump_statement] = STATE(282),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(282),
    [sym_do_statement] = STATE(282),
    [sym_for_statement] = STATE(282),
    [sym_foreach_statement] = STATE(282),
    [sym_if_statement] = STATE(282),
    [sym_switch_statement] = STATE(282),
    [sym_compound_statement] = STATE(282),
    [sym_named_label_statement] = STATE(282),
    [sym_expression_statement] = STATE(282),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(466),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(468),
    [sym_heredoc] = ACTIONS(264),
  },
  [56] = {
    [sym_text_interpolation] = STATE(56),
    [sym_empty_statement] = STATE(250),
    [sym_function_static_declaration] = STATE(250),
    [sym_global_declaration] = STATE(250),
    [sym_namespace_definition] = STATE(250),
    [sym_namespace_use_declaration] = STATE(250),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(250),
    [sym_interface_declaration] = STATE(250),
    [sym_class_declaration] = STATE(250),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(250),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(250),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(250),
    [sym_unset_statement] = STATE(250),
    [sym_declare_statement] = STATE(250),
    [sym_try_statement] = STATE(250),
    [sym__jump_statement] = STATE(250),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_foreach_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_compound_statement] = STATE(250),
    [sym_named_label_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [aux_sym_program_repeat1] = STATE(43),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(470),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [57] = {
    [sym_text_interpolation] = STATE(57),
    [sym_empty_statement] = STATE(997),
    [sym_function_static_declaration] = STATE(997),
    [sym_global_declaration] = STATE(997),
    [sym_namespace_definition] = STATE(997),
    [sym_namespace_use_declaration] = STATE(997),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(997),
    [sym_interface_declaration] = STATE(997),
    [sym_class_declaration] = STATE(997),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(997),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(997),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(997),
    [sym_unset_statement] = STATE(997),
    [sym_declare_statement] = STATE(997),
    [sym_try_statement] = STATE(997),
    [sym__jump_statement] = STATE(997),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(997),
    [sym_do_statement] = STATE(997),
    [sym_for_statement] = STATE(997),
    [sym_foreach_statement] = STATE(997),
    [sym_if_statement] = STATE(997),
    [sym_switch_statement] = STATE(997),
    [sym_compound_statement] = STATE(997),
    [sym_named_label_statement] = STATE(997),
    [sym_expression_statement] = STATE(997),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [58] = {
    [sym_text_interpolation] = STATE(58),
    [sym_empty_statement] = STATE(1374),
    [sym_function_static_declaration] = STATE(1374),
    [sym_global_declaration] = STATE(1374),
    [sym_namespace_definition] = STATE(1374),
    [sym_namespace_use_declaration] = STATE(1374),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1374),
    [sym_interface_declaration] = STATE(1374),
    [sym_class_declaration] = STATE(1374),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1374),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1374),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1374),
    [sym_unset_statement] = STATE(1374),
    [sym_declare_statement] = STATE(1374),
    [sym_try_statement] = STATE(1374),
    [sym__jump_statement] = STATE(1374),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1374),
    [sym_do_statement] = STATE(1374),
    [sym_for_statement] = STATE(1374),
    [sym_foreach_statement] = STATE(1374),
    [sym_if_statement] = STATE(1374),
    [sym_switch_statement] = STATE(1374),
    [sym_compound_statement] = STATE(1374),
    [sym_named_label_statement] = STATE(1374),
    [sym_expression_statement] = STATE(1374),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [59] = {
    [sym_text_interpolation] = STATE(59),
    [sym_empty_statement] = STATE(981),
    [sym_function_static_declaration] = STATE(981),
    [sym_global_declaration] = STATE(981),
    [sym_namespace_definition] = STATE(981),
    [sym_namespace_use_declaration] = STATE(981),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(981),
    [sym_interface_declaration] = STATE(981),
    [sym_class_declaration] = STATE(981),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(981),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(981),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(981),
    [sym_unset_statement] = STATE(981),
    [sym_declare_statement] = STATE(981),
    [sym_try_statement] = STATE(981),
    [sym__jump_statement] = STATE(981),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(981),
    [sym_do_statement] = STATE(981),
    [sym_for_statement] = STATE(981),
    [sym_foreach_statement] = STATE(981),
    [sym_if_statement] = STATE(981),
    [sym_switch_statement] = STATE(981),
    [sym_compound_statement] = STATE(981),
    [sym_named_label_statement] = STATE(981),
    [sym_expression_statement] = STATE(981),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [60] = {
    [sym_text_interpolation] = STATE(60),
    [sym_empty_statement] = STATE(294),
    [sym_function_static_declaration] = STATE(294),
    [sym_global_declaration] = STATE(294),
    [sym_namespace_definition] = STATE(294),
    [sym_namespace_use_declaration] = STATE(294),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(294),
    [sym_interface_declaration] = STATE(294),
    [sym_class_declaration] = STATE(294),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(294),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(294),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(294),
    [sym_unset_statement] = STATE(294),
    [sym_declare_statement] = STATE(294),
    [sym_try_statement] = STATE(294),
    [sym__jump_statement] = STATE(294),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(294),
    [sym_do_statement] = STATE(294),
    [sym_for_statement] = STATE(294),
    [sym_foreach_statement] = STATE(294),
    [sym_if_statement] = STATE(294),
    [sym_switch_statement] = STATE(294),
    [sym_compound_statement] = STATE(294),
    [sym_named_label_statement] = STATE(294),
    [sym_expression_statement] = STATE(294),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [61] = {
    [sym_text_interpolation] = STATE(61),
    [sym_empty_statement] = STATE(245),
    [sym_function_static_declaration] = STATE(245),
    [sym_global_declaration] = STATE(245),
    [sym_namespace_definition] = STATE(245),
    [sym_namespace_use_declaration] = STATE(245),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(245),
    [sym_interface_declaration] = STATE(245),
    [sym_class_declaration] = STATE(245),
    [sym_class_modifier] = STATE(1305),
    [sym_const_declaration] = STATE(245),
    [sym_visibility_modifier] = STATE(1300),
    [sym_function_definition] = STATE(245),
    [sym__function_definition_header] = STATE(1289),
    [sym_echo_statement] = STATE(245),
    [sym_unset_statement] = STATE(245),
    [sym_declare_statement] = STATE(245),
    [sym_try_statement] = STATE(245),
    [sym__jump_statement] = STATE(245),
    [sym_goto_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_throw_statement] = STATE(252),
    [sym_while_statement] = STATE(245),
    [sym_do_statement] = STATE(245),
    [sym_for_statement] = STATE(245),
    [sym_foreach_statement] = STATE(245),
    [sym_if_statement] = STATE(245),
    [sym_switch_statement] = STATE(245),
    [sym_compound_statement] = STATE(245),
    [sym_named_label_statement] = STATE(245),
    [sym_expression_statement] = STATE(245),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [62] = {
    [sym_text_interpolation] = STATE(62),
    [sym_empty_statement] = STATE(1389),
    [sym_function_static_declaration] = STATE(1389),
    [sym_global_declaration] = STATE(1389),
    [sym_namespace_definition] = STATE(1389),
    [sym_namespace_use_declaration] = STATE(1389),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_trait_declaration] = STATE(1389),
    [sym_interface_declaration] = STATE(1389),
    [sym_class_declaration] = STATE(1389),
    [sym_class_modifier] = STATE(1369),
    [sym_const_declaration] = STATE(1389),
    [sym_visibility_modifier] = STATE(1370),
    [sym_function_definition] = STATE(1389),
    [sym__function_definition_header] = STATE(1173),
    [sym_echo_statement] = STATE(1389),
    [sym_unset_statement] = STATE(1389),
    [sym_declare_statement] = STATE(1389),
    [sym_try_statement] = STATE(1389),
    [sym__jump_statement] = STATE(1389),
    [sym_goto_statement] = STATE(1125),
    [sym_continue_statement] = STATE(1125),
    [sym_break_statement] = STATE(1125),
    [sym_return_statement] = STATE(1125),
    [sym_throw_statement] = STATE(1125),
    [sym_while_statement] = STATE(1389),
    [sym_do_statement] = STATE(1389),
    [sym_for_statement] = STATE(1389),
    [sym_foreach_statement] = STATE(1389),
    [sym_if_statement] = STATE(1389),
    [sym_switch_statement] = STATE(1389),
    [sym_compound_statement] = STATE(1389),
    [sym_named_label_statement] = STATE(1389),
    [sym_expression_statement] = STATE(1389),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_global] = ACTIONS(308),
    [anon_sym_namespace] = ACTIONS(310),
    [anon_sym_use] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_trait] = ACTIONS(318),
    [anon_sym_interface] = ACTIONS(320),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(324),
    [anon_sym_echo] = ACTIONS(326),
    [anon_sym_declare] = ACTIONS(328),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(330),
    [anon_sym_goto] = ACTIONS(332),
    [anon_sym_continue] = ACTIONS(334),
    [anon_sym_break] = ACTIONS(336),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(340),
    [anon_sym_while] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(344),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_foreach] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(352),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [63] = {
    [sym_text_interpolation] = STATE(63),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(509),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_as] = ACTIONS(482),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(482),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(474),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_EQ_GT] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(474),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_from] = ACTIONS(518),
    [anon_sym_instanceof] = ACTIONS(482),
    [anon_sym_QMARK_QMARK] = ACTIONS(474),
    [aux_sym_binary_expression_token1] = ACTIONS(482),
    [aux_sym_binary_expression_token2] = ACTIONS(482),
    [aux_sym_binary_expression_token3] = ACTIONS(482),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_CARET] = ACTIONS(474),
    [anon_sym_EQ_EQ] = ACTIONS(482),
    [anon_sym_BANG_EQ] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(482),
    [anon_sym_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_EQ_GT] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_SLASH] = ACTIONS(482),
    [anon_sym_PERCENT] = ACTIONS(474),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [64] = {
    [sym_text_interpolation] = STATE(64),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(580),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_array_element_initializer] = STATE(608),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_QMARK] = ACTIONS(482),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_EQ_GT] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(244),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_from] = ACTIONS(536),
    [anon_sym_instanceof] = ACTIONS(482),
    [anon_sym_QMARK_QMARK] = ACTIONS(474),
    [aux_sym_binary_expression_token1] = ACTIONS(482),
    [aux_sym_binary_expression_token2] = ACTIONS(482),
    [aux_sym_binary_expression_token3] = ACTIONS(482),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_CARET] = ACTIONS(474),
    [anon_sym_EQ_EQ] = ACTIONS(482),
    [anon_sym_BANG_EQ] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(482),
    [anon_sym_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_EQ_GT] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_SLASH] = ACTIONS(482),
    [anon_sym_PERCENT] = ACTIONS(474),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(474),
    [sym_heredoc] = ACTIONS(264),
  },
  [65] = {
    [sym_text_interpolation] = STATE(65),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1395),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [66] = {
    [sym_text_interpolation] = STATE(66),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1388),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [67] = {
    [sym_text_interpolation] = STATE(67),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1395),
    [sym__expression] = STATE(655),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [68] = {
    [sym_text_interpolation] = STATE(68),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1366),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [69] = {
    [sym_text_interpolation] = STATE(69),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1360),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [70] = {
    [sym_text_interpolation] = STATE(70),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1357),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [71] = {
    [sym_text_interpolation] = STATE(71),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1319),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [72] = {
    [sym_text_interpolation] = STATE(72),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1321),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [73] = {
    [sym_text_interpolation] = STATE(73),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_cast_type] = STATE(1386),
    [sym__expression] = STATE(655),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [74] = {
    [sym_text_interpolation] = STATE(74),
    [sym_catch_clause] = STATE(134),
    [sym_finally_clause] = STATE(134),
    [aux_sym_try_statement_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(542),
    [sym_name] = ACTIONS(544),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_global] = ACTIONS(544),
    [anon_sym_namespace] = ACTIONS(544),
    [anon_sym_use] = ACTIONS(544),
    [anon_sym_BSLASH] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_const] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_trait] = ACTIONS(544),
    [anon_sym_interface] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(544),
    [anon_sym_final] = ACTIONS(544),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_array] = ACTIONS(544),
    [anon_sym_unset] = ACTIONS(544),
    [anon_sym_echo] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(544),
    [anon_sym_enddeclare] = ACTIONS(544),
    [sym_float] = ACTIONS(544),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_catch] = ACTIONS(546),
    [anon_sym_finally] = ACTIONS(548),
    [anon_sym_goto] = ACTIONS(544),
    [anon_sym_continue] = ACTIONS(544),
    [anon_sym_break] = ACTIONS(544),
    [sym_integer] = ACTIONS(544),
    [anon_sym_return] = ACTIONS(544),
    [anon_sym_throw] = ACTIONS(544),
    [anon_sym_while] = ACTIONS(544),
    [anon_sym_endwhile] = ACTIONS(544),
    [anon_sym_do] = ACTIONS(544),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_endfor] = ACTIONS(544),
    [anon_sym_foreach] = ACTIONS(544),
    [anon_sym_endforeach] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(544),
    [anon_sym_endif] = ACTIONS(544),
    [anon_sym_elseif] = ACTIONS(544),
    [anon_sym_else] = ACTIONS(544),
    [anon_sym_switch] = ACTIONS(544),
    [anon_sym_endswitch] = ACTIONS(544),
    [anon_sym_case] = ACTIONS(544),
    [anon_sym_default] = ACTIONS(544),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_clone] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(544),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [sym_shell_command_expression] = ACTIONS(542),
    [anon_sym_list] = ACTIONS(544),
    [anon_sym_self] = ACTIONS(544),
    [anon_sym_parent] = ACTIONS(544),
    [sym_string] = ACTIONS(542),
    [sym_boolean] = ACTIONS(544),
    [sym_null] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(542),
    [anon_sym_yield] = ACTIONS(544),
    [anon_sym_include] = ACTIONS(544),
    [anon_sym_include_once] = ACTIONS(544),
    [anon_sym_require] = ACTIONS(544),
    [anon_sym_require_once] = ACTIONS(544),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(542),
  },
  [75] = {
    [sym_text_interpolation] = STATE(75),
    [sym_catch_clause] = STATE(134),
    [sym_finally_clause] = STATE(134),
    [aux_sym_try_statement_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(550),
    [sym_name] = ACTIONS(552),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_global] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_BSLASH] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_interface] = ACTIONS(552),
    [anon_sym_class] = ACTIONS(552),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_final] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_array] = ACTIONS(552),
    [anon_sym_unset] = ACTIONS(552),
    [anon_sym_echo] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_enddeclare] = ACTIONS(552),
    [sym_float] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(552),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_finally] = ACTIONS(557),
    [anon_sym_goto] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [sym_integer] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_throw] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [anon_sym_endwhile] = ACTIONS(552),
    [anon_sym_do] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_endfor] = ACTIONS(552),
    [anon_sym_foreach] = ACTIONS(552),
    [anon_sym_endforeach] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_endif] = ACTIONS(552),
    [anon_sym_elseif] = ACTIONS(552),
    [anon_sym_else] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(552),
    [anon_sym_endswitch] = ACTIONS(552),
    [anon_sym_case] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_AT] = ACTIONS(550),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(550),
    [anon_sym_BANG] = ACTIONS(550),
    [anon_sym_clone] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [sym_shell_command_expression] = ACTIONS(550),
    [anon_sym_list] = ACTIONS(552),
    [anon_sym_self] = ACTIONS(552),
    [anon_sym_parent] = ACTIONS(552),
    [sym_string] = ACTIONS(550),
    [sym_boolean] = ACTIONS(552),
    [sym_null] = ACTIONS(552),
    [anon_sym_DOLLAR] = ACTIONS(550),
    [anon_sym_yield] = ACTIONS(552),
    [anon_sym_include] = ACTIONS(552),
    [anon_sym_include_once] = ACTIONS(552),
    [anon_sym_require] = ACTIONS(552),
    [anon_sym_require_once] = ACTIONS(552),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(550),
  },
  [76] = {
    [sym_text_interpolation] = STATE(76),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(1131),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [77] = {
    [sym_text_interpolation] = STATE(77),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(1118),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(568),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [78] = {
    [sym_text_interpolation] = STATE(78),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(989),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [79] = {
    [sym_text_interpolation] = STATE(79),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(1002),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [80] = {
    [sym_text_interpolation] = STATE(80),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1381),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [81] = {
    [sym_text_interpolation] = STATE(81),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1398),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(580),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [82] = {
    [sym_text_interpolation] = STATE(82),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [83] = {
    [sym_text_interpolation] = STATE(83),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1347),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(584),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [84] = {
    [sym_text_interpolation] = STATE(84),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1317),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [85] = {
    [sym_text_interpolation] = STATE(85),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1378),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [86] = {
    [sym_text_interpolation] = STATE(86),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(590),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [87] = {
    [sym_text_interpolation] = STATE(87),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(592),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [88] = {
    [sym_text_interpolation] = STATE(88),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(627),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_variadic_unpacking] = STATE(1109),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [89] = {
    [sym_text_interpolation] = STATE(89),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(592),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [90] = {
    [sym_text_interpolation] = STATE(90),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [91] = {
    [sym_text_interpolation] = STATE(91),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1373),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(600),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [92] = {
    [sym_text_interpolation] = STATE(92),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(622),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_variadic_unpacking] = STATE(1101),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [93] = {
    [sym_text_interpolation] = STATE(93),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1342),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(604),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [94] = {
    [sym_text_interpolation] = STATE(94),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(656),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(374),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(374),
    [sym_scoped_property_access_expression] = STATE(374),
    [sym_list_literal] = STATE(959),
    [sym_function_call_expression] = STATE(352),
    [sym_scoped_call_expression] = STATE(352),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(352),
    [sym_subscript_expression] = STATE(352),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(352),
    [sym_variable_name] = STATE(352),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [aux_sym_list_literal_repeat1] = STATE(1049),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [95] = {
    [sym_text_interpolation] = STATE(95),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [96] = {
    [sym_text_interpolation] = STATE(96),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1333),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(614),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [97] = {
    [sym_text_interpolation] = STATE(97),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1328),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [98] = {
    [sym_text_interpolation] = STATE(98),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [99] = {
    [sym_text_interpolation] = STATE(99),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1380),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(618),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [100] = {
    [sym_text_interpolation] = STATE(100),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1384),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(620),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [101] = {
    [sym_text_interpolation] = STATE(101),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(623),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_variadic_unpacking] = STATE(1045),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [102] = {
    [sym_text_interpolation] = STATE(102),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1359),
    [sym_sequence_expression] = STATE(1266),
    [sym__expression] = STATE(629),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [103] = {
    [sym_text_interpolation] = STATE(103),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(620),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_variadic_unpacking] = STATE(1032),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [104] = {
    [sym_text_interpolation] = STATE(104),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(628),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [105] = {
    [sym_text_interpolation] = STATE(105),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(635),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_variadic_unpacking] = STATE(1268),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [106] = {
    [sym_text_interpolation] = STATE(106),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_foreach_pair] = STATE(1296),
    [sym__expression] = STATE(636),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1201),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [107] = {
    [sym_text_interpolation] = STATE(107),
    [sym_else_if_clause] = STATE(249),
    [sym_else_clause] = STATE(270),
    [aux_sym_if_statement_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(632),
    [sym_name] = ACTIONS(634),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_global] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(634),
    [anon_sym_use] = ACTIONS(634),
    [anon_sym_BSLASH] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_const] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_trait] = ACTIONS(634),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_class] = ACTIONS(634),
    [anon_sym_abstract] = ACTIONS(634),
    [anon_sym_final] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_array] = ACTIONS(634),
    [anon_sym_unset] = ACTIONS(634),
    [anon_sym_echo] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_enddeclare] = ACTIONS(634),
    [sym_float] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_goto] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [sym_integer] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_throw] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_endwhile] = ACTIONS(634),
    [anon_sym_do] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_endfor] = ACTIONS(634),
    [anon_sym_foreach] = ACTIONS(634),
    [anon_sym_endforeach] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_endif] = ACTIONS(634),
    [anon_sym_elseif] = ACTIONS(636),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_switch] = ACTIONS(634),
    [anon_sym_endswitch] = ACTIONS(634),
    [anon_sym_case] = ACTIONS(634),
    [anon_sym_default] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_clone] = ACTIONS(634),
    [anon_sym_print] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [sym_shell_command_expression] = ACTIONS(632),
    [anon_sym_list] = ACTIONS(634),
    [anon_sym_self] = ACTIONS(634),
    [anon_sym_parent] = ACTIONS(634),
    [sym_string] = ACTIONS(632),
    [sym_boolean] = ACTIONS(634),
    [sym_null] = ACTIONS(634),
    [anon_sym_DOLLAR] = ACTIONS(632),
    [anon_sym_yield] = ACTIONS(634),
    [anon_sym_include] = ACTIONS(634),
    [anon_sym_include_once] = ACTIONS(634),
    [anon_sym_require] = ACTIONS(634),
    [anon_sym_require_once] = ACTIONS(634),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(632),
  },
  [108] = {
    [sym_text_interpolation] = STATE(108),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_foreach_pair] = STATE(1335),
    [sym__expression] = STATE(638),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1217),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(640),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [109] = {
    [sym_text_interpolation] = STATE(109),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1197),
    [sym_sequence_expression] = STATE(1200),
    [sym__expression] = STATE(626),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [110] = {
    [sym_text_interpolation] = STATE(110),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(647),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(642),
    [sym_heredoc] = ACTIONS(264),
  },
  [111] = {
    [sym_text_interpolation] = STATE(111),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(632),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(644),
    [sym_heredoc] = ACTIONS(264),
  },
  [112] = {
    [sym_text_interpolation] = STATE(112),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(646),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(646),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(646),
    [sym_heredoc] = ACTIONS(264),
  },
  [113] = {
    [sym_text_interpolation] = STATE(113),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(645),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(648),
    [sym_heredoc] = ACTIONS(264),
  },
  [114] = {
    [sym_text_interpolation] = STATE(114),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(639),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(650),
    [sym_heredoc] = ACTIONS(264),
  },
  [115] = {
    [sym_text_interpolation] = STATE(115),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(642),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(652),
    [sym_heredoc] = ACTIONS(264),
  },
  [116] = {
    [sym_text_interpolation] = STATE(116),
    [sym_else_if_clause] = STATE(249),
    [sym_else_clause] = STATE(246),
    [aux_sym_if_statement_repeat1] = STATE(107),
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_name] = ACTIONS(656),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(654),
    [anon_sym_static] = ACTIONS(656),
    [anon_sym_global] = ACTIONS(656),
    [anon_sym_namespace] = ACTIONS(656),
    [anon_sym_use] = ACTIONS(656),
    [anon_sym_BSLASH] = ACTIONS(654),
    [anon_sym_function] = ACTIONS(656),
    [anon_sym_const] = ACTIONS(656),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_RBRACE] = ACTIONS(654),
    [anon_sym_trait] = ACTIONS(656),
    [anon_sym_interface] = ACTIONS(656),
    [anon_sym_class] = ACTIONS(656),
    [anon_sym_abstract] = ACTIONS(656),
    [anon_sym_final] = ACTIONS(656),
    [anon_sym_public] = ACTIONS(656),
    [anon_sym_protected] = ACTIONS(656),
    [anon_sym_private] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_array] = ACTIONS(656),
    [anon_sym_unset] = ACTIONS(656),
    [anon_sym_echo] = ACTIONS(656),
    [anon_sym_declare] = ACTIONS(656),
    [anon_sym_enddeclare] = ACTIONS(656),
    [sym_float] = ACTIONS(656),
    [anon_sym_try] = ACTIONS(656),
    [anon_sym_goto] = ACTIONS(656),
    [anon_sym_continue] = ACTIONS(656),
    [anon_sym_break] = ACTIONS(656),
    [sym_integer] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(656),
    [anon_sym_throw] = ACTIONS(656),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_endwhile] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(656),
    [anon_sym_endfor] = ACTIONS(656),
    [anon_sym_foreach] = ACTIONS(656),
    [anon_sym_endforeach] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_endif] = ACTIONS(656),
    [anon_sym_elseif] = ACTIONS(636),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_switch] = ACTIONS(656),
    [anon_sym_endswitch] = ACTIONS(656),
    [anon_sym_case] = ACTIONS(656),
    [anon_sym_default] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(654),
    [anon_sym_clone] = ACTIONS(656),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_new] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_PLUS_PLUS] = ACTIONS(654),
    [anon_sym_DASH_DASH] = ACTIONS(654),
    [sym_shell_command_expression] = ACTIONS(654),
    [anon_sym_list] = ACTIONS(656),
    [anon_sym_self] = ACTIONS(656),
    [anon_sym_parent] = ACTIONS(656),
    [sym_string] = ACTIONS(654),
    [sym_boolean] = ACTIONS(656),
    [sym_null] = ACTIONS(656),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_include] = ACTIONS(656),
    [anon_sym_include_once] = ACTIONS(656),
    [anon_sym_require] = ACTIONS(656),
    [anon_sym_require_once] = ACTIONS(656),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(654),
  },
  [117] = {
    [sym_text_interpolation] = STATE(117),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_array_element_initializer] = STATE(965),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [118] = {
    [sym_text_interpolation] = STATE(118),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expressions] = STATE(1156),
    [sym_sequence_expression] = STATE(1200),
    [sym__expression] = STATE(626),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [119] = {
    [sym_text_interpolation] = STATE(119),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(663),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(379),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(379),
    [sym_scoped_property_access_expression] = STATE(379),
    [sym_list_literal] = STATE(987),
    [sym_function_call_expression] = STATE(372),
    [sym_scoped_call_expression] = STATE(372),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(372),
    [sym_subscript_expression] = STATE(372),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(372),
    [sym_variable_name] = STATE(372),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [120] = {
    [sym_text_interpolation] = STATE(120),
    [ts_builtin_sym_end] = ACTIONS(660),
    [sym_name] = ACTIONS(662),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(660),
    [anon_sym_static] = ACTIONS(662),
    [anon_sym_global] = ACTIONS(662),
    [anon_sym_namespace] = ACTIONS(662),
    [anon_sym_use] = ACTIONS(662),
    [anon_sym_BSLASH] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_trait] = ACTIONS(662),
    [anon_sym_interface] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(662),
    [anon_sym_abstract] = ACTIONS(662),
    [anon_sym_final] = ACTIONS(662),
    [anon_sym_public] = ACTIONS(662),
    [anon_sym_protected] = ACTIONS(662),
    [anon_sym_private] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_array] = ACTIONS(662),
    [anon_sym_unset] = ACTIONS(662),
    [anon_sym_echo] = ACTIONS(662),
    [anon_sym_declare] = ACTIONS(662),
    [anon_sym_enddeclare] = ACTIONS(662),
    [sym_float] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_catch] = ACTIONS(662),
    [anon_sym_finally] = ACTIONS(662),
    [anon_sym_goto] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [sym_integer] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_throw] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_endwhile] = ACTIONS(662),
    [anon_sym_do] = ACTIONS(662),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_endfor] = ACTIONS(662),
    [anon_sym_foreach] = ACTIONS(662),
    [anon_sym_endforeach] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(662),
    [anon_sym_endif] = ACTIONS(662),
    [anon_sym_elseif] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(662),
    [anon_sym_switch] = ACTIONS(662),
    [anon_sym_endswitch] = ACTIONS(662),
    [anon_sym_case] = ACTIONS(662),
    [anon_sym_default] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(660),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_clone] = ACTIONS(662),
    [anon_sym_print] = ACTIONS(662),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [sym_shell_command_expression] = ACTIONS(660),
    [anon_sym_list] = ACTIONS(662),
    [anon_sym_self] = ACTIONS(662),
    [anon_sym_parent] = ACTIONS(662),
    [sym_string] = ACTIONS(660),
    [sym_boolean] = ACTIONS(662),
    [sym_null] = ACTIONS(662),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_yield] = ACTIONS(662),
    [anon_sym_include] = ACTIONS(662),
    [anon_sym_include_once] = ACTIONS(662),
    [anon_sym_require] = ACTIONS(662),
    [anon_sym_require_once] = ACTIONS(662),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(660),
  },
  [121] = {
    [sym_text_interpolation] = STATE(121),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(487),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [122] = {
    [sym_text_interpolation] = STATE(122),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(660),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [123] = {
    [sym_text_interpolation] = STATE(123),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(681),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(668),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [124] = {
    [sym_text_interpolation] = STATE(124),
    [sym_else_if_clause] = STATE(249),
    [aux_sym_if_statement_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(670),
    [sym_name] = ACTIONS(672),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(670),
    [anon_sym_static] = ACTIONS(672),
    [anon_sym_global] = ACTIONS(672),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_use] = ACTIONS(672),
    [anon_sym_BSLASH] = ACTIONS(670),
    [anon_sym_function] = ACTIONS(672),
    [anon_sym_const] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_trait] = ACTIONS(672),
    [anon_sym_interface] = ACTIONS(672),
    [anon_sym_class] = ACTIONS(672),
    [anon_sym_abstract] = ACTIONS(672),
    [anon_sym_final] = ACTIONS(672),
    [anon_sym_public] = ACTIONS(672),
    [anon_sym_protected] = ACTIONS(672),
    [anon_sym_private] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_array] = ACTIONS(672),
    [anon_sym_unset] = ACTIONS(672),
    [anon_sym_echo] = ACTIONS(672),
    [anon_sym_declare] = ACTIONS(672),
    [anon_sym_enddeclare] = ACTIONS(672),
    [sym_float] = ACTIONS(672),
    [anon_sym_try] = ACTIONS(672),
    [anon_sym_goto] = ACTIONS(672),
    [anon_sym_continue] = ACTIONS(672),
    [anon_sym_break] = ACTIONS(672),
    [sym_integer] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(672),
    [anon_sym_throw] = ACTIONS(672),
    [anon_sym_while] = ACTIONS(672),
    [anon_sym_endwhile] = ACTIONS(672),
    [anon_sym_do] = ACTIONS(672),
    [anon_sym_for] = ACTIONS(672),
    [anon_sym_endfor] = ACTIONS(672),
    [anon_sym_foreach] = ACTIONS(672),
    [anon_sym_endforeach] = ACTIONS(672),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_endif] = ACTIONS(672),
    [anon_sym_elseif] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(672),
    [anon_sym_switch] = ACTIONS(672),
    [anon_sym_endswitch] = ACTIONS(672),
    [anon_sym_case] = ACTIONS(672),
    [anon_sym_default] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(670),
    [anon_sym_clone] = ACTIONS(672),
    [anon_sym_print] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(672),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [sym_shell_command_expression] = ACTIONS(670),
    [anon_sym_list] = ACTIONS(672),
    [anon_sym_self] = ACTIONS(672),
    [anon_sym_parent] = ACTIONS(672),
    [sym_string] = ACTIONS(670),
    [sym_boolean] = ACTIONS(672),
    [sym_null] = ACTIONS(672),
    [anon_sym_DOLLAR] = ACTIONS(670),
    [anon_sym_yield] = ACTIONS(672),
    [anon_sym_include] = ACTIONS(672),
    [anon_sym_include_once] = ACTIONS(672),
    [anon_sym_require] = ACTIONS(672),
    [anon_sym_require_once] = ACTIONS(672),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(670),
  },
  [125] = {
    [sym_text_interpolation] = STATE(125),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(562),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [126] = {
    [sym_text_interpolation] = STATE(126),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(667),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [127] = {
    [sym_text_interpolation] = STATE(127),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(673),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(681),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [128] = {
    [sym_text_interpolation] = STATE(128),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(671),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(683),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [129] = {
    [sym_text_interpolation] = STATE(129),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(687),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [130] = {
    [sym_text_interpolation] = STATE(130),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(515),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [131] = {
    [sym_text_interpolation] = STATE(131),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [132] = {
    [sym_text_interpolation] = STATE(132),
    [ts_builtin_sym_end] = ACTIONS(691),
    [sym_name] = ACTIONS(693),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_global] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_BSLASH] = ACTIONS(691),
    [anon_sym_function] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_interface] = ACTIONS(693),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_abstract] = ACTIONS(693),
    [anon_sym_final] = ACTIONS(693),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_array] = ACTIONS(693),
    [anon_sym_unset] = ACTIONS(693),
    [anon_sym_echo] = ACTIONS(693),
    [anon_sym_declare] = ACTIONS(693),
    [anon_sym_enddeclare] = ACTIONS(693),
    [sym_float] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_catch] = ACTIONS(693),
    [anon_sym_finally] = ACTIONS(693),
    [anon_sym_goto] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [sym_integer] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [anon_sym_endwhile] = ACTIONS(693),
    [anon_sym_do] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_endfor] = ACTIONS(693),
    [anon_sym_foreach] = ACTIONS(693),
    [anon_sym_endforeach] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_endif] = ACTIONS(693),
    [anon_sym_elseif] = ACTIONS(693),
    [anon_sym_else] = ACTIONS(693),
    [anon_sym_switch] = ACTIONS(693),
    [anon_sym_endswitch] = ACTIONS(693),
    [anon_sym_case] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_clone] = ACTIONS(693),
    [anon_sym_print] = ACTIONS(693),
    [anon_sym_new] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(691),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [sym_shell_command_expression] = ACTIONS(691),
    [anon_sym_list] = ACTIONS(693),
    [anon_sym_self] = ACTIONS(693),
    [anon_sym_parent] = ACTIONS(693),
    [sym_string] = ACTIONS(691),
    [sym_boolean] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(693),
    [anon_sym_include] = ACTIONS(693),
    [anon_sym_include_once] = ACTIONS(693),
    [anon_sym_require] = ACTIONS(693),
    [anon_sym_require_once] = ACTIONS(693),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(691),
  },
  [133] = {
    [sym_text_interpolation] = STATE(133),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(649),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1269),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [134] = {
    [sym_text_interpolation] = STATE(134),
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_name] = ACTIONS(699),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_static] = ACTIONS(699),
    [anon_sym_global] = ACTIONS(699),
    [anon_sym_namespace] = ACTIONS(699),
    [anon_sym_use] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_const] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_trait] = ACTIONS(699),
    [anon_sym_interface] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(699),
    [anon_sym_abstract] = ACTIONS(699),
    [anon_sym_final] = ACTIONS(699),
    [anon_sym_public] = ACTIONS(699),
    [anon_sym_protected] = ACTIONS(699),
    [anon_sym_private] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(697),
    [anon_sym_array] = ACTIONS(699),
    [anon_sym_unset] = ACTIONS(699),
    [anon_sym_echo] = ACTIONS(699),
    [anon_sym_declare] = ACTIONS(699),
    [anon_sym_enddeclare] = ACTIONS(699),
    [sym_float] = ACTIONS(699),
    [anon_sym_try] = ACTIONS(699),
    [anon_sym_catch] = ACTIONS(699),
    [anon_sym_finally] = ACTIONS(699),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_continue] = ACTIONS(699),
    [anon_sym_break] = ACTIONS(699),
    [sym_integer] = ACTIONS(699),
    [anon_sym_return] = ACTIONS(699),
    [anon_sym_throw] = ACTIONS(699),
    [anon_sym_while] = ACTIONS(699),
    [anon_sym_endwhile] = ACTIONS(699),
    [anon_sym_do] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(699),
    [anon_sym_endfor] = ACTIONS(699),
    [anon_sym_foreach] = ACTIONS(699),
    [anon_sym_endforeach] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_endif] = ACTIONS(699),
    [anon_sym_elseif] = ACTIONS(699),
    [anon_sym_else] = ACTIONS(699),
    [anon_sym_switch] = ACTIONS(699),
    [anon_sym_endswitch] = ACTIONS(699),
    [anon_sym_case] = ACTIONS(699),
    [anon_sym_default] = ACTIONS(699),
    [anon_sym_AT] = ACTIONS(697),
    [anon_sym_PLUS] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(697),
    [anon_sym_clone] = ACTIONS(699),
    [anon_sym_print] = ACTIONS(699),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [sym_shell_command_expression] = ACTIONS(697),
    [anon_sym_list] = ACTIONS(699),
    [anon_sym_self] = ACTIONS(699),
    [anon_sym_parent] = ACTIONS(699),
    [sym_string] = ACTIONS(697),
    [sym_boolean] = ACTIONS(699),
    [sym_null] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_yield] = ACTIONS(699),
    [anon_sym_include] = ACTIONS(699),
    [anon_sym_include_once] = ACTIONS(699),
    [anon_sym_require] = ACTIONS(699),
    [anon_sym_require_once] = ACTIONS(699),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(697),
  },
  [135] = {
    [sym_text_interpolation] = STATE(135),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym_sequence_expression] = STATE(1279),
    [sym__expression] = STATE(625),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [136] = {
    [sym_text_interpolation] = STATE(136),
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_global] = ACTIONS(703),
    [anon_sym_namespace] = ACTIONS(703),
    [anon_sym_use] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_trait] = ACTIONS(703),
    [anon_sym_interface] = ACTIONS(703),
    [anon_sym_class] = ACTIONS(703),
    [anon_sym_abstract] = ACTIONS(703),
    [anon_sym_final] = ACTIONS(703),
    [anon_sym_public] = ACTIONS(703),
    [anon_sym_protected] = ACTIONS(703),
    [anon_sym_private] = ACTIONS(703),
    [anon_sym_LPAREN] = ACTIONS(701),
    [anon_sym_array] = ACTIONS(703),
    [anon_sym_unset] = ACTIONS(703),
    [anon_sym_echo] = ACTIONS(703),
    [anon_sym_declare] = ACTIONS(703),
    [anon_sym_enddeclare] = ACTIONS(703),
    [sym_float] = ACTIONS(703),
    [anon_sym_try] = ACTIONS(703),
    [anon_sym_catch] = ACTIONS(703),
    [anon_sym_finally] = ACTIONS(703),
    [anon_sym_goto] = ACTIONS(703),
    [anon_sym_continue] = ACTIONS(703),
    [anon_sym_break] = ACTIONS(703),
    [sym_integer] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(703),
    [anon_sym_throw] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_endwhile] = ACTIONS(703),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_for] = ACTIONS(703),
    [anon_sym_endfor] = ACTIONS(703),
    [anon_sym_foreach] = ACTIONS(703),
    [anon_sym_endforeach] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_endif] = ACTIONS(703),
    [anon_sym_elseif] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_switch] = ACTIONS(703),
    [anon_sym_endswitch] = ACTIONS(703),
    [anon_sym_case] = ACTIONS(703),
    [anon_sym_default] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_clone] = ACTIONS(703),
    [anon_sym_print] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(703),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [sym_shell_command_expression] = ACTIONS(701),
    [anon_sym_list] = ACTIONS(703),
    [anon_sym_self] = ACTIONS(703),
    [anon_sym_parent] = ACTIONS(703),
    [sym_string] = ACTIONS(701),
    [sym_boolean] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_include] = ACTIONS(703),
    [anon_sym_include_once] = ACTIONS(703),
    [anon_sym_require] = ACTIONS(703),
    [anon_sym_require_once] = ACTIONS(703),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(701),
  },
  [137] = {
    [sym_text_interpolation] = STATE(137),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(560),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [138] = {
    [sym_text_interpolation] = STATE(138),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(662),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(707),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [139] = {
    [sym_text_interpolation] = STATE(139),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym_sequence_expression] = STATE(1223),
    [sym__expression] = STATE(619),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [140] = {
    [sym_text_interpolation] = STATE(140),
    [ts_builtin_sym_end] = ACTIONS(709),
    [sym_name] = ACTIONS(711),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(709),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_global] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(711),
    [anon_sym_use] = ACTIONS(711),
    [anon_sym_BSLASH] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(711),
    [anon_sym_const] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_trait] = ACTIONS(711),
    [anon_sym_interface] = ACTIONS(711),
    [anon_sym_class] = ACTIONS(711),
    [anon_sym_abstract] = ACTIONS(711),
    [anon_sym_final] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_array] = ACTIONS(711),
    [anon_sym_unset] = ACTIONS(711),
    [anon_sym_echo] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_enddeclare] = ACTIONS(711),
    [sym_float] = ACTIONS(711),
    [anon_sym_try] = ACTIONS(711),
    [anon_sym_catch] = ACTIONS(711),
    [anon_sym_finally] = ACTIONS(711),
    [anon_sym_goto] = ACTIONS(711),
    [anon_sym_continue] = ACTIONS(711),
    [anon_sym_break] = ACTIONS(711),
    [sym_integer] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(711),
    [anon_sym_throw] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(711),
    [anon_sym_endwhile] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(711),
    [anon_sym_endfor] = ACTIONS(711),
    [anon_sym_foreach] = ACTIONS(711),
    [anon_sym_endforeach] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(711),
    [anon_sym_endif] = ACTIONS(711),
    [anon_sym_elseif] = ACTIONS(711),
    [anon_sym_else] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_endswitch] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(711),
    [anon_sym_default] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_TILDE] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_clone] = ACTIONS(711),
    [anon_sym_print] = ACTIONS(711),
    [anon_sym_new] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(709),
    [sym_shell_command_expression] = ACTIONS(709),
    [anon_sym_list] = ACTIONS(711),
    [anon_sym_self] = ACTIONS(711),
    [anon_sym_parent] = ACTIONS(711),
    [sym_string] = ACTIONS(709),
    [sym_boolean] = ACTIONS(711),
    [sym_null] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_include] = ACTIONS(711),
    [anon_sym_include_once] = ACTIONS(711),
    [anon_sym_require] = ACTIONS(711),
    [anon_sym_require_once] = ACTIONS(711),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(709),
  },
  [141] = {
    [sym_text_interpolation] = STATE(141),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(661),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [142] = {
    [sym_text_interpolation] = STATE(142),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(640),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [143] = {
    [sym_text_interpolation] = STATE(143),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(624),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [144] = {
    [sym_text_interpolation] = STATE(144),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(683),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [145] = {
    [sym_text_interpolation] = STATE(145),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(648),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [146] = {
    [sym_text_interpolation] = STATE(146),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(653),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [147] = {
    [sym_text_interpolation] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(713),
    [sym_name] = ACTIONS(715),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(717),
    [anon_sym_static] = ACTIONS(715),
    [anon_sym_global] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_use] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_trait] = ACTIONS(715),
    [anon_sym_interface] = ACTIONS(715),
    [anon_sym_class] = ACTIONS(715),
    [anon_sym_abstract] = ACTIONS(715),
    [anon_sym_final] = ACTIONS(715),
    [anon_sym_public] = ACTIONS(715),
    [anon_sym_protected] = ACTIONS(715),
    [anon_sym_private] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_array] = ACTIONS(715),
    [anon_sym_unset] = ACTIONS(715),
    [anon_sym_echo] = ACTIONS(715),
    [anon_sym_declare] = ACTIONS(715),
    [anon_sym_enddeclare] = ACTIONS(715),
    [sym_float] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_goto] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(715),
    [anon_sym_break] = ACTIONS(715),
    [sym_integer] = ACTIONS(715),
    [anon_sym_return] = ACTIONS(715),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_while] = ACTIONS(715),
    [anon_sym_endwhile] = ACTIONS(715),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(715),
    [anon_sym_endfor] = ACTIONS(715),
    [anon_sym_foreach] = ACTIONS(715),
    [anon_sym_endforeach] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(715),
    [anon_sym_endif] = ACTIONS(715),
    [anon_sym_elseif] = ACTIONS(715),
    [anon_sym_else] = ACTIONS(715),
    [anon_sym_switch] = ACTIONS(715),
    [anon_sym_endswitch] = ACTIONS(715),
    [anon_sym_case] = ACTIONS(715),
    [anon_sym_default] = ACTIONS(715),
    [anon_sym_AT] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_TILDE] = ACTIONS(713),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_clone] = ACTIONS(715),
    [anon_sym_print] = ACTIONS(715),
    [anon_sym_new] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(713),
    [anon_sym_DASH_DASH] = ACTIONS(713),
    [sym_shell_command_expression] = ACTIONS(713),
    [anon_sym_list] = ACTIONS(715),
    [anon_sym_self] = ACTIONS(715),
    [anon_sym_parent] = ACTIONS(715),
    [sym_string] = ACTIONS(713),
    [sym_boolean] = ACTIONS(715),
    [sym_null] = ACTIONS(715),
    [anon_sym_DOLLAR] = ACTIONS(713),
    [anon_sym_yield] = ACTIONS(715),
    [anon_sym_include] = ACTIONS(715),
    [anon_sym_include_once] = ACTIONS(715),
    [anon_sym_require] = ACTIONS(715),
    [anon_sym_require_once] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(717),
    [sym_heredoc] = ACTIONS(713),
  },
  [148] = {
    [sym_text_interpolation] = STATE(148),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(650),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [149] = {
    [sym_text_interpolation] = STATE(149),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(677),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [150] = {
    [sym_text_interpolation] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(719),
    [sym_name] = ACTIONS(721),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_static] = ACTIONS(721),
    [anon_sym_global] = ACTIONS(721),
    [anon_sym_namespace] = ACTIONS(721),
    [anon_sym_use] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(719),
    [anon_sym_function] = ACTIONS(721),
    [anon_sym_const] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_trait] = ACTIONS(721),
    [anon_sym_interface] = ACTIONS(721),
    [anon_sym_class] = ACTIONS(721),
    [anon_sym_abstract] = ACTIONS(721),
    [anon_sym_final] = ACTIONS(721),
    [anon_sym_public] = ACTIONS(721),
    [anon_sym_protected] = ACTIONS(721),
    [anon_sym_private] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(719),
    [anon_sym_array] = ACTIONS(721),
    [anon_sym_unset] = ACTIONS(721),
    [anon_sym_echo] = ACTIONS(721),
    [anon_sym_declare] = ACTIONS(721),
    [anon_sym_enddeclare] = ACTIONS(721),
    [sym_float] = ACTIONS(721),
    [anon_sym_try] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_continue] = ACTIONS(721),
    [anon_sym_break] = ACTIONS(721),
    [sym_integer] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(721),
    [anon_sym_throw] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(721),
    [anon_sym_endwhile] = ACTIONS(721),
    [anon_sym_do] = ACTIONS(721),
    [anon_sym_for] = ACTIONS(721),
    [anon_sym_endfor] = ACTIONS(721),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_endforeach] = ACTIONS(721),
    [anon_sym_if] = ACTIONS(721),
    [anon_sym_endif] = ACTIONS(721),
    [anon_sym_elseif] = ACTIONS(721),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(721),
    [anon_sym_endswitch] = ACTIONS(721),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_clone] = ACTIONS(721),
    [anon_sym_print] = ACTIONS(721),
    [anon_sym_new] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [sym_shell_command_expression] = ACTIONS(719),
    [anon_sym_list] = ACTIONS(721),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [sym_string] = ACTIONS(719),
    [sym_boolean] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [anon_sym_DOLLAR] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_include] = ACTIONS(721),
    [anon_sym_include_once] = ACTIONS(721),
    [anon_sym_require] = ACTIONS(721),
    [anon_sym_require_once] = ACTIONS(721),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(723),
    [sym_heredoc] = ACTIONS(719),
  },
  [151] = {
    [sym_text_interpolation] = STATE(151),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(565),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [152] = {
    [sym_text_interpolation] = STATE(152),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(689),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [153] = {
    [sym_text_interpolation] = STATE(153),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(666),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [154] = {
    [sym_text_interpolation] = STATE(154),
    [ts_builtin_sym_end] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(727),
    [anon_sym_use] = ACTIONS(727),
    [anon_sym_BSLASH] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_trait] = ACTIONS(727),
    [anon_sym_interface] = ACTIONS(727),
    [anon_sym_class] = ACTIONS(727),
    [anon_sym_abstract] = ACTIONS(727),
    [anon_sym_final] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_array] = ACTIONS(727),
    [anon_sym_unset] = ACTIONS(727),
    [anon_sym_echo] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_enddeclare] = ACTIONS(727),
    [sym_float] = ACTIONS(727),
    [anon_sym_try] = ACTIONS(727),
    [anon_sym_goto] = ACTIONS(727),
    [anon_sym_continue] = ACTIONS(727),
    [anon_sym_break] = ACTIONS(727),
    [sym_integer] = ACTIONS(727),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_throw] = ACTIONS(727),
    [anon_sym_while] = ACTIONS(727),
    [anon_sym_endwhile] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(727),
    [anon_sym_endfor] = ACTIONS(727),
    [anon_sym_foreach] = ACTIONS(727),
    [anon_sym_endforeach] = ACTIONS(727),
    [anon_sym_if] = ACTIONS(727),
    [anon_sym_endif] = ACTIONS(727),
    [anon_sym_elseif] = ACTIONS(727),
    [anon_sym_else] = ACTIONS(727),
    [anon_sym_switch] = ACTIONS(727),
    [anon_sym_endswitch] = ACTIONS(727),
    [anon_sym_case] = ACTIONS(727),
    [anon_sym_default] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(725),
    [anon_sym_clone] = ACTIONS(727),
    [anon_sym_print] = ACTIONS(727),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(725),
    [anon_sym_DASH_DASH] = ACTIONS(725),
    [sym_shell_command_expression] = ACTIONS(725),
    [anon_sym_list] = ACTIONS(727),
    [anon_sym_self] = ACTIONS(727),
    [anon_sym_parent] = ACTIONS(727),
    [sym_string] = ACTIONS(725),
    [sym_boolean] = ACTIONS(727),
    [sym_null] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_include] = ACTIONS(727),
    [anon_sym_include_once] = ACTIONS(727),
    [anon_sym_require] = ACTIONS(727),
    [anon_sym_require_once] = ACTIONS(727),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(729),
    [sym_heredoc] = ACTIONS(725),
  },
  [155] = {
    [sym_text_interpolation] = STATE(155),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(686),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [156] = {
    [sym_text_interpolation] = STATE(156),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(634),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [157] = {
    [sym_text_interpolation] = STATE(157),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(491),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [158] = {
    [sym_text_interpolation] = STATE(158),
    [ts_builtin_sym_end] = ACTIONS(731),
    [sym_name] = ACTIONS(733),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(733),
    [anon_sym_global] = ACTIONS(733),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_use] = ACTIONS(733),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_function] = ACTIONS(733),
    [anon_sym_const] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(733),
    [anon_sym_interface] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_abstract] = ACTIONS(733),
    [anon_sym_final] = ACTIONS(733),
    [anon_sym_public] = ACTIONS(733),
    [anon_sym_protected] = ACTIONS(733),
    [anon_sym_private] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_array] = ACTIONS(733),
    [anon_sym_unset] = ACTIONS(733),
    [anon_sym_echo] = ACTIONS(733),
    [anon_sym_declare] = ACTIONS(733),
    [anon_sym_enddeclare] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [anon_sym_try] = ACTIONS(733),
    [anon_sym_goto] = ACTIONS(733),
    [anon_sym_continue] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [sym_integer] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_endwhile] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_endfor] = ACTIONS(733),
    [anon_sym_foreach] = ACTIONS(733),
    [anon_sym_endforeach] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_endif] = ACTIONS(733),
    [anon_sym_elseif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_switch] = ACTIONS(733),
    [anon_sym_endswitch] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_default] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_clone] = ACTIONS(733),
    [anon_sym_print] = ACTIONS(733),
    [anon_sym_new] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(731),
    [anon_sym_PLUS_PLUS] = ACTIONS(731),
    [anon_sym_DASH_DASH] = ACTIONS(731),
    [sym_shell_command_expression] = ACTIONS(731),
    [anon_sym_list] = ACTIONS(733),
    [anon_sym_self] = ACTIONS(733),
    [anon_sym_parent] = ACTIONS(733),
    [sym_string] = ACTIONS(731),
    [sym_boolean] = ACTIONS(733),
    [sym_null] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_include] = ACTIONS(733),
    [anon_sym_include_once] = ACTIONS(733),
    [anon_sym_require] = ACTIONS(733),
    [anon_sym_require_once] = ACTIONS(733),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(735),
    [sym_heredoc] = ACTIONS(731),
  },
  [159] = {
    [sym_text_interpolation] = STATE(159),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(630),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [160] = {
    [sym_text_interpolation] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(737),
    [sym_name] = ACTIONS(739),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(739),
    [anon_sym_global] = ACTIONS(739),
    [anon_sym_namespace] = ACTIONS(739),
    [anon_sym_use] = ACTIONS(739),
    [anon_sym_BSLASH] = ACTIONS(737),
    [anon_sym_function] = ACTIONS(739),
    [anon_sym_const] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_trait] = ACTIONS(739),
    [anon_sym_interface] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(739),
    [anon_sym_abstract] = ACTIONS(739),
    [anon_sym_final] = ACTIONS(739),
    [anon_sym_public] = ACTIONS(739),
    [anon_sym_protected] = ACTIONS(739),
    [anon_sym_private] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(737),
    [anon_sym_array] = ACTIONS(739),
    [anon_sym_unset] = ACTIONS(739),
    [anon_sym_echo] = ACTIONS(739),
    [anon_sym_declare] = ACTIONS(739),
    [anon_sym_enddeclare] = ACTIONS(739),
    [sym_float] = ACTIONS(739),
    [anon_sym_try] = ACTIONS(739),
    [anon_sym_goto] = ACTIONS(739),
    [anon_sym_continue] = ACTIONS(739),
    [anon_sym_break] = ACTIONS(739),
    [sym_integer] = ACTIONS(739),
    [anon_sym_return] = ACTIONS(739),
    [anon_sym_throw] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(739),
    [anon_sym_endwhile] = ACTIONS(739),
    [anon_sym_do] = ACTIONS(739),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_endfor] = ACTIONS(739),
    [anon_sym_foreach] = ACTIONS(739),
    [anon_sym_endforeach] = ACTIONS(739),
    [anon_sym_if] = ACTIONS(739),
    [anon_sym_endif] = ACTIONS(739),
    [anon_sym_elseif] = ACTIONS(739),
    [anon_sym_else] = ACTIONS(739),
    [anon_sym_switch] = ACTIONS(739),
    [anon_sym_endswitch] = ACTIONS(739),
    [anon_sym_case] = ACTIONS(739),
    [anon_sym_default] = ACTIONS(739),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(739),
    [anon_sym_DASH] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(737),
    [anon_sym_clone] = ACTIONS(739),
    [anon_sym_print] = ACTIONS(739),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [sym_shell_command_expression] = ACTIONS(737),
    [anon_sym_list] = ACTIONS(739),
    [anon_sym_self] = ACTIONS(739),
    [anon_sym_parent] = ACTIONS(739),
    [sym_string] = ACTIONS(737),
    [sym_boolean] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_yield] = ACTIONS(739),
    [anon_sym_include] = ACTIONS(739),
    [anon_sym_include_once] = ACTIONS(739),
    [anon_sym_require] = ACTIONS(739),
    [anon_sym_require_once] = ACTIONS(739),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(741),
    [sym_heredoc] = ACTIONS(737),
  },
  [161] = {
    [sym_text_interpolation] = STATE(161),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(566),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [162] = {
    [sym_text_interpolation] = STATE(162),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(599),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [163] = {
    [sym_text_interpolation] = STATE(163),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(633),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [164] = {
    [sym_text_interpolation] = STATE(164),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(665),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [165] = {
    [sym_text_interpolation] = STATE(165),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(631),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [166] = {
    [sym_text_interpolation] = STATE(166),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [167] = {
    [sym_text_interpolation] = STATE(167),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [168] = {
    [sym_text_interpolation] = STATE(168),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(655),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [169] = {
    [sym_text_interpolation] = STATE(169),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(637),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [170] = {
    [sym_text_interpolation] = STATE(170),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(607),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [171] = {
    [sym_text_interpolation] = STATE(171),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [172] = {
    [sym_text_interpolation] = STATE(172),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(536),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [173] = {
    [sym_text_interpolation] = STATE(173),
    [ts_builtin_sym_end] = ACTIONS(743),
    [sym_name] = ACTIONS(745),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_global] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_BSLASH] = ACTIONS(743),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(745),
    [anon_sym_final] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_array] = ACTIONS(745),
    [anon_sym_unset] = ACTIONS(745),
    [anon_sym_echo] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_enddeclare] = ACTIONS(745),
    [sym_float] = ACTIONS(745),
    [anon_sym_try] = ACTIONS(745),
    [anon_sym_goto] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [sym_integer] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_throw] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_endwhile] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_endfor] = ACTIONS(745),
    [anon_sym_foreach] = ACTIONS(745),
    [anon_sym_endforeach] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_endif] = ACTIONS(745),
    [anon_sym_elseif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_switch] = ACTIONS(745),
    [anon_sym_endswitch] = ACTIONS(745),
    [anon_sym_case] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_AT] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_BANG] = ACTIONS(743),
    [anon_sym_clone] = ACTIONS(745),
    [anon_sym_print] = ACTIONS(745),
    [anon_sym_new] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [sym_shell_command_expression] = ACTIONS(743),
    [anon_sym_list] = ACTIONS(745),
    [anon_sym_self] = ACTIONS(745),
    [anon_sym_parent] = ACTIONS(745),
    [sym_string] = ACTIONS(743),
    [sym_boolean] = ACTIONS(745),
    [sym_null] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(743),
    [anon_sym_yield] = ACTIONS(745),
    [anon_sym_include] = ACTIONS(745),
    [anon_sym_include_once] = ACTIONS(745),
    [anon_sym_require] = ACTIONS(745),
    [anon_sym_require_once] = ACTIONS(745),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(743),
    [sym_heredoc] = ACTIONS(743),
  },
  [174] = {
    [sym_text_interpolation] = STATE(174),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(664),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [175] = {
    [sym_text_interpolation] = STATE(175),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(478),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [176] = {
    [sym_text_interpolation] = STATE(176),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(669),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [177] = {
    [sym_text_interpolation] = STATE(177),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(658),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [178] = {
    [sym_text_interpolation] = STATE(178),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(480),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [179] = {
    [sym_text_interpolation] = STATE(179),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(564),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [180] = {
    [sym_text_interpolation] = STATE(180),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(481),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [181] = {
    [sym_text_interpolation] = STATE(181),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(486),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [182] = {
    [sym_text_interpolation] = STATE(182),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(568),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [183] = {
    [sym_text_interpolation] = STATE(183),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(605),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [184] = {
    [sym_text_interpolation] = STATE(184),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(510),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [185] = {
    [sym_text_interpolation] = STATE(185),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(511),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [186] = {
    [sym_text_interpolation] = STATE(186),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(513),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [187] = {
    [sym_text_interpolation] = STATE(187),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(551),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [188] = {
    [sym_text_interpolation] = STATE(188),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(569),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [189] = {
    [sym_text_interpolation] = STATE(189),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(578),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [190] = {
    [sym_text_interpolation] = STATE(190),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(575),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [191] = {
    [sym_text_interpolation] = STATE(191),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(550),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [192] = {
    [sym_text_interpolation] = STATE(192),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(579),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [193] = {
    [sym_text_interpolation] = STATE(193),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(583),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [194] = {
    [sym_text_interpolation] = STATE(194),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(603),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [195] = {
    [sym_text_interpolation] = STATE(195),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(598),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [196] = {
    [sym_text_interpolation] = STATE(196),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(597),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [197] = {
    [sym_text_interpolation] = STATE(197),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(596),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [198] = {
    [sym_text_interpolation] = STATE(198),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(592),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [199] = {
    [sym_text_interpolation] = STATE(199),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(590),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [200] = {
    [sym_text_interpolation] = STATE(200),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(587),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [201] = {
    [sym_text_interpolation] = STATE(201),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(586),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [202] = {
    [sym_text_interpolation] = STATE(202),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(577),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [203] = {
    [sym_text_interpolation] = STATE(203),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(514),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [204] = {
    [sym_text_interpolation] = STATE(204),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(674),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [205] = {
    [sym_text_interpolation] = STATE(205),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(678),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [206] = {
    [sym_text_interpolation] = STATE(206),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(555),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [207] = {
    [sym_text_interpolation] = STATE(207),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(582),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [208] = {
    [sym_text_interpolation] = STATE(208),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(684),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [209] = {
    [sym_text_interpolation] = STATE(209),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(576),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [210] = {
    [sym_text_interpolation] = STATE(210),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(573),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [211] = {
    [sym_text_interpolation] = STATE(211),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(644),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [212] = {
    [sym_text_interpolation] = STATE(212),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(685),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [213] = {
    [sym_text_interpolation] = STATE(213),
    [ts_builtin_sym_end] = ACTIONS(747),
    [sym_name] = ACTIONS(749),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(749),
    [anon_sym_use] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(747),
    [anon_sym_function] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_trait] = ACTIONS(749),
    [anon_sym_interface] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(749),
    [anon_sym_abstract] = ACTIONS(749),
    [anon_sym_final] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_array] = ACTIONS(749),
    [anon_sym_unset] = ACTIONS(749),
    [anon_sym_echo] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_enddeclare] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [anon_sym_try] = ACTIONS(749),
    [anon_sym_goto] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [sym_integer] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [anon_sym_endwhile] = ACTIONS(749),
    [anon_sym_do] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_endfor] = ACTIONS(749),
    [anon_sym_foreach] = ACTIONS(749),
    [anon_sym_endforeach] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_endif] = ACTIONS(749),
    [anon_sym_elseif] = ACTIONS(749),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_switch] = ACTIONS(749),
    [anon_sym_endswitch] = ACTIONS(749),
    [anon_sym_case] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(747),
    [anon_sym_clone] = ACTIONS(749),
    [anon_sym_print] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(747),
    [sym_shell_command_expression] = ACTIONS(747),
    [anon_sym_list] = ACTIONS(749),
    [anon_sym_self] = ACTIONS(749),
    [anon_sym_parent] = ACTIONS(749),
    [sym_string] = ACTIONS(747),
    [sym_boolean] = ACTIONS(749),
    [sym_null] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_yield] = ACTIONS(749),
    [anon_sym_include] = ACTIONS(749),
    [anon_sym_include_once] = ACTIONS(749),
    [anon_sym_require] = ACTIONS(749),
    [anon_sym_require_once] = ACTIONS(749),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(747),
    [sym_heredoc] = ACTIONS(747),
  },
  [214] = {
    [sym_text_interpolation] = STATE(214),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(688),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [215] = {
    [sym_text_interpolation] = STATE(215),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(680),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [216] = {
    [sym_text_interpolation] = STATE(216),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(676),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [217] = {
    [sym_text_interpolation] = STATE(217),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(675),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [218] = {
    [sym_text_interpolation] = STATE(218),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(621),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [219] = {
    [sym_text_interpolation] = STATE(219),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(668),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [220] = {
    [sym_text_interpolation] = STATE(220),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(537),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [221] = {
    [sym_text_interpolation] = STATE(221),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(502),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [222] = {
    [sym_text_interpolation] = STATE(222),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(534),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [223] = {
    [sym_text_interpolation] = STATE(223),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(533),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [224] = {
    [sym_text_interpolation] = STATE(224),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(504),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [225] = {
    [sym_text_interpolation] = STATE(225),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(475),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [226] = {
    [sym_text_interpolation] = STATE(226),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(531),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [227] = {
    [sym_text_interpolation] = STATE(227),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(657),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [228] = {
    [sym_text_interpolation] = STATE(228),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [229] = {
    [sym_text_interpolation] = STATE(229),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(530),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [230] = {
    [sym_text_interpolation] = STATE(230),
    [ts_builtin_sym_end] = ACTIONS(751),
    [sym_name] = ACTIONS(753),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_static] = ACTIONS(753),
    [anon_sym_global] = ACTIONS(753),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_use] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_const] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_trait] = ACTIONS(753),
    [anon_sym_interface] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(753),
    [anon_sym_abstract] = ACTIONS(753),
    [anon_sym_final] = ACTIONS(753),
    [anon_sym_public] = ACTIONS(753),
    [anon_sym_protected] = ACTIONS(753),
    [anon_sym_private] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_array] = ACTIONS(753),
    [anon_sym_unset] = ACTIONS(753),
    [anon_sym_echo] = ACTIONS(753),
    [anon_sym_declare] = ACTIONS(753),
    [anon_sym_enddeclare] = ACTIONS(753),
    [sym_float] = ACTIONS(753),
    [anon_sym_try] = ACTIONS(753),
    [anon_sym_goto] = ACTIONS(753),
    [anon_sym_continue] = ACTIONS(753),
    [anon_sym_break] = ACTIONS(753),
    [sym_integer] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_while] = ACTIONS(753),
    [anon_sym_endwhile] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(753),
    [anon_sym_endfor] = ACTIONS(753),
    [anon_sym_foreach] = ACTIONS(753),
    [anon_sym_endforeach] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_endif] = ACTIONS(753),
    [anon_sym_elseif] = ACTIONS(753),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_switch] = ACTIONS(753),
    [anon_sym_endswitch] = ACTIONS(753),
    [anon_sym_case] = ACTIONS(753),
    [anon_sym_default] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_clone] = ACTIONS(753),
    [anon_sym_print] = ACTIONS(753),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(751),
    [anon_sym_DASH_DASH] = ACTIONS(751),
    [sym_shell_command_expression] = ACTIONS(751),
    [anon_sym_list] = ACTIONS(753),
    [anon_sym_self] = ACTIONS(753),
    [anon_sym_parent] = ACTIONS(753),
    [sym_string] = ACTIONS(751),
    [sym_boolean] = ACTIONS(753),
    [sym_null] = ACTIONS(753),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_include] = ACTIONS(753),
    [anon_sym_include_once] = ACTIONS(753),
    [anon_sym_require] = ACTIONS(753),
    [anon_sym_require_once] = ACTIONS(753),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(755),
    [sym_heredoc] = ACTIONS(751),
  },
  [231] = {
    [sym_text_interpolation] = STATE(231),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(679),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [232] = {
    [sym_text_interpolation] = STATE(232),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(628),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [233] = {
    [sym_text_interpolation] = STATE(233),
    [sym_qualified_name] = STATE(539),
    [sym_namespace_name_as_prefix] = STATE(875),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(600),
    [sym__unary_expression] = STATE(561),
    [sym_unary_op_expression] = STATE(557),
    [sym_exponentiation_expression] = STATE(557),
    [sym_clone_expression] = STATE(553),
    [sym__primary_expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(446),
    [sym_class_constant_access_expression] = STATE(518),
    [sym_print_intrinsic] = STATE(570),
    [sym_anonymous_function_creation_expression] = STATE(570),
    [sym_object_creation_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_cast_expression] = STATE(557),
    [sym_cast_variable] = STATE(377),
    [sym_assignment_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_augmented_assignment_expression] = STATE(585),
    [sym_member_access_expression] = STATE(377),
    [sym_scoped_property_access_expression] = STATE(377),
    [sym_list_literal] = STATE(1324),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1327),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(431),
    [sym__string] = STATE(446),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(585),
    [sym_binary_expression] = STATE(585),
    [sym_include_expression] = STATE(585),
    [sym_include_once_expression] = STATE(585),
    [sym_require_expression] = STATE(585),
    [sym_require_once_expression] = STATE(585),
    [sym__reserved_identifier] = STATE(521),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [sym_shell_command_expression] = ACTIONS(258),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(262),
    [anon_sym_parent] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [234] = {
    [sym_text_interpolation] = STATE(234),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(512),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [235] = {
    [sym_text_interpolation] = STATE(235),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(682),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [236] = {
    [sym_text_interpolation] = STATE(236),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(529),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [237] = {
    [sym_text_interpolation] = STATE(237),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(520),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [238] = {
    [sym_text_interpolation] = STATE(238),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(523),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [239] = {
    [sym_text_interpolation] = STATE(239),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(525),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [240] = {
    [sym_text_interpolation] = STATE(240),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(476),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [241] = {
    [sym_text_interpolation] = STATE(241),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(526),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [242] = {
    [sym_text_interpolation] = STATE(242),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(527),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [243] = {
    [sym_text_interpolation] = STATE(243),
    [sym_qualified_name] = STATE(432),
    [sym_namespace_name_as_prefix] = STATE(847),
    [sym_namespace_name] = STATE(1307),
    [sym__expression] = STATE(528),
    [sym__unary_expression] = STATE(492),
    [sym_unary_op_expression] = STATE(493),
    [sym_exponentiation_expression] = STATE(493),
    [sym_clone_expression] = STATE(495),
    [sym__primary_expression] = STATE(495),
    [sym_parenthesized_expression] = STATE(396),
    [sym_class_constant_access_expression] = STATE(430),
    [sym_print_intrinsic] = STATE(535),
    [sym_anonymous_function_creation_expression] = STATE(535),
    [sym_object_creation_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_cast_expression] = STATE(493),
    [sym_cast_variable] = STATE(349),
    [sym_assignment_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_member_access_expression] = STATE(349),
    [sym_scoped_property_access_expression] = STATE(349),
    [sym_list_literal] = STATE(1331),
    [sym_function_call_expression] = STATE(334),
    [sym_scoped_call_expression] = STATE(334),
    [sym__scope_resolution_qualifier] = STATE(1367),
    [sym_relative_scope] = STATE(1329),
    [sym_member_call_expression] = STATE(334),
    [sym_subscript_expression] = STATE(334),
    [sym__dereferencable_expression] = STATE(942),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(396),
    [sym_dynamic_variable_name] = STATE(334),
    [sym_variable_name] = STATE(334),
    [sym_yield_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_include_expression] = STATE(497),
    [sym_include_once_expression] = STATE(497),
    [sym_require_expression] = STATE(497),
    [sym_require_once_expression] = STATE(497),
    [sym__reserved_identifier] = STATE(420),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [sym_shell_command_expression] = ACTIONS(508),
    [anon_sym_list] = ACTIONS(260),
    [anon_sym_self] = ACTIONS(510),
    [anon_sym_parent] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [244] = {
    [sym_text_interpolation] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_name] = ACTIONS(759),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(757),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_global] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_use] = ACTIONS(759),
    [anon_sym_BSLASH] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(759),
    [anon_sym_const] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(757),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_trait] = ACTIONS(759),
    [anon_sym_interface] = ACTIONS(759),
    [anon_sym_class] = ACTIONS(759),
    [anon_sym_abstract] = ACTIONS(759),
    [anon_sym_final] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_array] = ACTIONS(759),
    [anon_sym_unset] = ACTIONS(759),
    [anon_sym_echo] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_enddeclare] = ACTIONS(759),
    [sym_float] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(759),
    [anon_sym_goto] = ACTIONS(759),
    [anon_sym_continue] = ACTIONS(759),
    [anon_sym_break] = ACTIONS(759),
    [sym_integer] = ACTIONS(759),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_throw] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(759),
    [anon_sym_endwhile] = ACTIONS(759),
    [anon_sym_do] = ACTIONS(759),
    [anon_sym_for] = ACTIONS(759),
    [anon_sym_endfor] = ACTIONS(759),
    [anon_sym_foreach] = ACTIONS(759),
    [anon_sym_endforeach] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(759),
    [anon_sym_endif] = ACTIONS(759),
    [anon_sym_elseif] = ACTIONS(759),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(759),
    [anon_sym_endswitch] = ACTIONS(759),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(757),
    [anon_sym_PLUS] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_TILDE] = ACTIONS(757),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_clone] = ACTIONS(759),
    [anon_sym_print] = ACTIONS(759),
    [anon_sym_new] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(757),
    [anon_sym_PLUS_PLUS] = ACTIONS(757),
    [anon_sym_DASH_DASH] = ACTIONS(757),
    [sym_shell_command_expression] = ACTIONS(757),
    [anon_sym_list] = ACTIONS(759),
    [anon_sym_self] = ACTIONS(759),
    [anon_sym_parent] = ACTIONS(759),
    [sym_string] = ACTIONS(757),
    [sym_boolean] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_include] = ACTIONS(759),
    [anon_sym_include_once] = ACTIONS(759),
    [anon_sym_require] = ACTIONS(759),
    [anon_sym_require_once] = ACTIONS(759),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(757),
  },
  [245] = {
    [sym_text_interpolation] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(761),
    [sym_name] = ACTIONS(763),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(763),
    [anon_sym_global] = ACTIONS(763),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_use] = ACTIONS(763),
    [anon_sym_BSLASH] = ACTIONS(761),
    [anon_sym_function] = ACTIONS(763),
    [anon_sym_const] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_trait] = ACTIONS(763),
    [anon_sym_interface] = ACTIONS(763),
    [anon_sym_class] = ACTIONS(763),
    [anon_sym_abstract] = ACTIONS(763),
    [anon_sym_final] = ACTIONS(763),
    [anon_sym_public] = ACTIONS(763),
    [anon_sym_protected] = ACTIONS(763),
    [anon_sym_private] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_array] = ACTIONS(763),
    [anon_sym_unset] = ACTIONS(763),
    [anon_sym_echo] = ACTIONS(763),
    [anon_sym_declare] = ACTIONS(763),
    [anon_sym_enddeclare] = ACTIONS(763),
    [sym_float] = ACTIONS(763),
    [anon_sym_try] = ACTIONS(763),
    [anon_sym_goto] = ACTIONS(763),
    [anon_sym_continue] = ACTIONS(763),
    [anon_sym_break] = ACTIONS(763),
    [sym_integer] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(763),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(763),
    [anon_sym_endwhile] = ACTIONS(763),
    [anon_sym_do] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_endfor] = ACTIONS(763),
    [anon_sym_foreach] = ACTIONS(763),
    [anon_sym_endforeach] = ACTIONS(763),
    [anon_sym_if] = ACTIONS(763),
    [anon_sym_endif] = ACTIONS(763),
    [anon_sym_elseif] = ACTIONS(763),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(763),
    [anon_sym_endswitch] = ACTIONS(763),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(763),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_TILDE] = ACTIONS(761),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_clone] = ACTIONS(763),
    [anon_sym_print] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_PLUS_PLUS] = ACTIONS(761),
    [anon_sym_DASH_DASH] = ACTIONS(761),
    [sym_shell_command_expression] = ACTIONS(761),
    [anon_sym_list] = ACTIONS(763),
    [anon_sym_self] = ACTIONS(763),
    [anon_sym_parent] = ACTIONS(763),
    [sym_string] = ACTIONS(761),
    [sym_boolean] = ACTIONS(763),
    [sym_null] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_include] = ACTIONS(763),
    [anon_sym_include_once] = ACTIONS(763),
    [anon_sym_require] = ACTIONS(763),
    [anon_sym_require_once] = ACTIONS(763),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(761),
  },
  [246] = {
    [sym_text_interpolation] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_name] = ACTIONS(767),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_trait] = ACTIONS(767),
    [anon_sym_interface] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(767),
    [anon_sym_abstract] = ACTIONS(767),
    [anon_sym_final] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_array] = ACTIONS(767),
    [anon_sym_unset] = ACTIONS(767),
    [anon_sym_echo] = ACTIONS(767),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_enddeclare] = ACTIONS(767),
    [sym_float] = ACTIONS(767),
    [anon_sym_try] = ACTIONS(767),
    [anon_sym_goto] = ACTIONS(767),
    [anon_sym_continue] = ACTIONS(767),
    [anon_sym_break] = ACTIONS(767),
    [sym_integer] = ACTIONS(767),
    [anon_sym_return] = ACTIONS(767),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_while] = ACTIONS(767),
    [anon_sym_endwhile] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(767),
    [anon_sym_for] = ACTIONS(767),
    [anon_sym_endfor] = ACTIONS(767),
    [anon_sym_foreach] = ACTIONS(767),
    [anon_sym_endforeach] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_endif] = ACTIONS(767),
    [anon_sym_elseif] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(767),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_endswitch] = ACTIONS(767),
    [anon_sym_case] = ACTIONS(767),
    [anon_sym_default] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(765),
    [anon_sym_BANG] = ACTIONS(765),
    [anon_sym_clone] = ACTIONS(767),
    [anon_sym_print] = ACTIONS(767),
    [anon_sym_new] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(765),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [sym_shell_command_expression] = ACTIONS(765),
    [anon_sym_list] = ACTIONS(767),
    [anon_sym_self] = ACTIONS(767),
    [anon_sym_parent] = ACTIONS(767),
    [sym_string] = ACTIONS(765),
    [sym_boolean] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(767),
    [anon_sym_include] = ACTIONS(767),
    [anon_sym_include_once] = ACTIONS(767),
    [anon_sym_require] = ACTIONS(767),
    [anon_sym_require_once] = ACTIONS(767),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(765),
  },
  [247] = {
    [sym_text_interpolation] = STATE(247),
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_global] = ACTIONS(771),
    [anon_sym_namespace] = ACTIONS(771),
    [anon_sym_use] = ACTIONS(771),
    [anon_sym_BSLASH] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_trait] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_protected] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_array] = ACTIONS(771),
    [anon_sym_unset] = ACTIONS(771),
    [anon_sym_echo] = ACTIONS(771),
    [anon_sym_declare] = ACTIONS(771),
    [anon_sym_enddeclare] = ACTIONS(771),
    [sym_float] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [sym_integer] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_endwhile] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_endfor] = ACTIONS(771),
    [anon_sym_foreach] = ACTIONS(771),
    [anon_sym_endforeach] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_endif] = ACTIONS(771),
    [anon_sym_elseif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_endswitch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_clone] = ACTIONS(771),
    [anon_sym_print] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [sym_shell_command_expression] = ACTIONS(769),
    [anon_sym_list] = ACTIONS(771),
    [anon_sym_self] = ACTIONS(771),
    [anon_sym_parent] = ACTIONS(771),
    [sym_string] = ACTIONS(769),
    [sym_boolean] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_yield] = ACTIONS(771),
    [anon_sym_include] = ACTIONS(771),
    [anon_sym_include_once] = ACTIONS(771),
    [anon_sym_require] = ACTIONS(771),
    [anon_sym_require_once] = ACTIONS(771),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(769),
  },
  [248] = {
    [sym_text_interpolation] = STATE(248),
    [ts_builtin_sym_end] = ACTIONS(773),
    [sym_name] = ACTIONS(775),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(775),
    [anon_sym_global] = ACTIONS(775),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(775),
    [anon_sym_const] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_trait] = ACTIONS(775),
    [anon_sym_interface] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(775),
    [anon_sym_abstract] = ACTIONS(775),
    [anon_sym_final] = ACTIONS(775),
    [anon_sym_public] = ACTIONS(775),
    [anon_sym_protected] = ACTIONS(775),
    [anon_sym_private] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_array] = ACTIONS(775),
    [anon_sym_unset] = ACTIONS(775),
    [anon_sym_echo] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(775),
    [anon_sym_enddeclare] = ACTIONS(775),
    [sym_float] = ACTIONS(775),
    [anon_sym_try] = ACTIONS(775),
    [anon_sym_goto] = ACTIONS(775),
    [anon_sym_continue] = ACTIONS(775),
    [anon_sym_break] = ACTIONS(775),
    [sym_integer] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(775),
    [anon_sym_throw] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_endwhile] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(775),
    [anon_sym_endfor] = ACTIONS(775),
    [anon_sym_foreach] = ACTIONS(775),
    [anon_sym_endforeach] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_endif] = ACTIONS(775),
    [anon_sym_elseif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_endswitch] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(775),
    [anon_sym_default] = ACTIONS(775),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(773),
    [anon_sym_clone] = ACTIONS(775),
    [anon_sym_print] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [sym_shell_command_expression] = ACTIONS(773),
    [anon_sym_list] = ACTIONS(775),
    [anon_sym_self] = ACTIONS(775),
    [anon_sym_parent] = ACTIONS(775),
    [sym_string] = ACTIONS(773),
    [sym_boolean] = ACTIONS(775),
    [sym_null] = ACTIONS(775),
    [anon_sym_DOLLAR] = ACTIONS(773),
    [anon_sym_yield] = ACTIONS(775),
    [anon_sym_include] = ACTIONS(775),
    [anon_sym_include_once] = ACTIONS(775),
    [anon_sym_require] = ACTIONS(775),
    [anon_sym_require_once] = ACTIONS(775),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(773),
  },
  [249] = {
    [sym_text_interpolation] = STATE(249),
    [ts_builtin_sym_end] = ACTIONS(777),
    [sym_name] = ACTIONS(779),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_static] = ACTIONS(779),
    [anon_sym_global] = ACTIONS(779),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_use] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_trait] = ACTIONS(779),
    [anon_sym_interface] = ACTIONS(779),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_abstract] = ACTIONS(779),
    [anon_sym_final] = ACTIONS(779),
    [anon_sym_public] = ACTIONS(779),
    [anon_sym_protected] = ACTIONS(779),
    [anon_sym_private] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_array] = ACTIONS(779),
    [anon_sym_unset] = ACTIONS(779),
    [anon_sym_echo] = ACTIONS(779),
    [anon_sym_declare] = ACTIONS(779),
    [anon_sym_enddeclare] = ACTIONS(779),
    [sym_float] = ACTIONS(779),
    [anon_sym_try] = ACTIONS(779),
    [anon_sym_goto] = ACTIONS(779),
    [anon_sym_continue] = ACTIONS(779),
    [anon_sym_break] = ACTIONS(779),
    [sym_integer] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(779),
    [anon_sym_throw] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_endwhile] = ACTIONS(779),
    [anon_sym_do] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_endfor] = ACTIONS(779),
    [anon_sym_foreach] = ACTIONS(779),
    [anon_sym_endforeach] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_endif] = ACTIONS(779),
    [anon_sym_elseif] = ACTIONS(779),
    [anon_sym_else] = ACTIONS(779),
    [anon_sym_switch] = ACTIONS(779),
    [anon_sym_endswitch] = ACTIONS(779),
    [anon_sym_case] = ACTIONS(779),
    [anon_sym_default] = ACTIONS(779),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_clone] = ACTIONS(779),
    [anon_sym_print] = ACTIONS(779),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(777),
    [anon_sym_DASH_DASH] = ACTIONS(777),
    [sym_shell_command_expression] = ACTIONS(777),
    [anon_sym_list] = ACTIONS(779),
    [anon_sym_self] = ACTIONS(779),
    [anon_sym_parent] = ACTIONS(779),
    [sym_string] = ACTIONS(777),
    [sym_boolean] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_include] = ACTIONS(779),
    [anon_sym_include_once] = ACTIONS(779),
    [anon_sym_require] = ACTIONS(779),
    [anon_sym_require_once] = ACTIONS(779),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(777),
  },
  [250] = {
    [sym_text_interpolation] = STATE(250),
    [ts_builtin_sym_end] = ACTIONS(781),
    [sym_name] = ACTIONS(783),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_static] = ACTIONS(783),
    [anon_sym_global] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_use] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_const] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(781),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_trait] = ACTIONS(783),
    [anon_sym_interface] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_abstract] = ACTIONS(783),
    [anon_sym_final] = ACTIONS(783),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_array] = ACTIONS(783),
    [anon_sym_unset] = ACTIONS(783),
    [anon_sym_echo] = ACTIONS(783),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_enddeclare] = ACTIONS(783),
    [sym_float] = ACTIONS(783),
    [anon_sym_try] = ACTIONS(783),
    [anon_sym_goto] = ACTIONS(783),
    [anon_sym_continue] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(783),
    [sym_integer] = ACTIONS(783),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_throw] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_endwhile] = ACTIONS(783),
    [anon_sym_do] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_endfor] = ACTIONS(783),
    [anon_sym_foreach] = ACTIONS(783),
    [anon_sym_endforeach] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_endif] = ACTIONS(783),
    [anon_sym_elseif] = ACTIONS(783),
    [anon_sym_else] = ACTIONS(783),
    [anon_sym_switch] = ACTIONS(783),
    [anon_sym_endswitch] = ACTIONS(783),
    [anon_sym_case] = ACTIONS(783),
    [anon_sym_default] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(781),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_clone] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(781),
    [anon_sym_PLUS_PLUS] = ACTIONS(781),
    [anon_sym_DASH_DASH] = ACTIONS(781),
    [sym_shell_command_expression] = ACTIONS(781),
    [anon_sym_list] = ACTIONS(783),
    [anon_sym_self] = ACTIONS(783),
    [anon_sym_parent] = ACTIONS(783),
    [sym_string] = ACTIONS(781),
    [sym_boolean] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_include] = ACTIONS(783),
    [anon_sym_include_once] = ACTIONS(783),
    [anon_sym_require] = ACTIONS(783),
    [anon_sym_require_once] = ACTIONS(783),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(781),
  },
  [251] = {
    [sym_text_interpolation] = STATE(251),
    [ts_builtin_sym_end] = ACTIONS(785),
    [sym_name] = ACTIONS(787),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(787),
    [anon_sym_global] = ACTIONS(787),
    [anon_sym_namespace] = ACTIONS(787),
    [anon_sym_use] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(787),
    [anon_sym_interface] = ACTIONS(787),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_abstract] = ACTIONS(787),
    [anon_sym_final] = ACTIONS(787),
    [anon_sym_public] = ACTIONS(787),
    [anon_sym_protected] = ACTIONS(787),
    [anon_sym_private] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(785),
    [anon_sym_array] = ACTIONS(787),
    [anon_sym_unset] = ACTIONS(787),
    [anon_sym_echo] = ACTIONS(787),
    [anon_sym_declare] = ACTIONS(787),
    [anon_sym_enddeclare] = ACTIONS(787),
    [sym_float] = ACTIONS(787),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_goto] = ACTIONS(787),
    [anon_sym_continue] = ACTIONS(787),
    [anon_sym_break] = ACTIONS(787),
    [sym_integer] = ACTIONS(787),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_throw] = ACTIONS(787),
    [anon_sym_while] = ACTIONS(787),
    [anon_sym_endwhile] = ACTIONS(787),
    [anon_sym_do] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(787),
    [anon_sym_endfor] = ACTIONS(787),
    [anon_sym_foreach] = ACTIONS(787),
    [anon_sym_endforeach] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_endif] = ACTIONS(787),
    [anon_sym_elseif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(787),
    [anon_sym_endswitch] = ACTIONS(787),
    [anon_sym_case] = ACTIONS(787),
    [anon_sym_default] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_clone] = ACTIONS(787),
    [anon_sym_print] = ACTIONS(787),
    [anon_sym_new] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(785),
    [sym_shell_command_expression] = ACTIONS(785),
    [anon_sym_list] = ACTIONS(787),
    [anon_sym_self] = ACTIONS(787),
    [anon_sym_parent] = ACTIONS(787),
    [sym_string] = ACTIONS(785),
    [sym_boolean] = ACTIONS(787),
    [sym_null] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [anon_sym_yield] = ACTIONS(787),
    [anon_sym_include] = ACTIONS(787),
    [anon_sym_include_once] = ACTIONS(787),
    [anon_sym_require] = ACTIONS(787),
    [anon_sym_require_once] = ACTIONS(787),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(785),
  },
  [252] = {
    [sym_text_interpolation] = STATE(252),
    [ts_builtin_sym_end] = ACTIONS(789),
    [sym_name] = ACTIONS(791),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(791),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(791),
    [anon_sym_use] = ACTIONS(791),
    [anon_sym_BSLASH] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_const] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(789),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_trait] = ACTIONS(791),
    [anon_sym_interface] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(791),
    [anon_sym_abstract] = ACTIONS(791),
    [anon_sym_final] = ACTIONS(791),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_array] = ACTIONS(791),
    [anon_sym_unset] = ACTIONS(791),
    [anon_sym_echo] = ACTIONS(791),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_enddeclare] = ACTIONS(791),
    [sym_float] = ACTIONS(791),
    [anon_sym_try] = ACTIONS(791),
    [anon_sym_goto] = ACTIONS(791),
    [anon_sym_continue] = ACTIONS(791),
    [anon_sym_break] = ACTIONS(791),
    [sym_integer] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(791),
    [anon_sym_throw] = ACTIONS(791),
    [anon_sym_while] = ACTIONS(791),
    [anon_sym_endwhile] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_endfor] = ACTIONS(791),
    [anon_sym_foreach] = ACTIONS(791),
    [anon_sym_endforeach] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_endif] = ACTIONS(791),
    [anon_sym_elseif] = ACTIONS(791),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_endswitch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(789),
    [anon_sym_clone] = ACTIONS(791),
    [anon_sym_print] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_DASH_DASH] = ACTIONS(789),
    [sym_shell_command_expression] = ACTIONS(789),
    [anon_sym_list] = ACTIONS(791),
    [anon_sym_self] = ACTIONS(791),
    [anon_sym_parent] = ACTIONS(791),
    [sym_string] = ACTIONS(789),
    [sym_boolean] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [anon_sym_yield] = ACTIONS(791),
    [anon_sym_include] = ACTIONS(791),
    [anon_sym_include_once] = ACTIONS(791),
    [anon_sym_require] = ACTIONS(791),
    [anon_sym_require_once] = ACTIONS(791),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(789),
  },
  [253] = {
    [sym_text_interpolation] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(793),
    [sym_name] = ACTIONS(795),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(795),
    [anon_sym_namespace] = ACTIONS(795),
    [anon_sym_use] = ACTIONS(795),
    [anon_sym_BSLASH] = ACTIONS(793),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_const] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_trait] = ACTIONS(795),
    [anon_sym_interface] = ACTIONS(795),
    [anon_sym_class] = ACTIONS(795),
    [anon_sym_abstract] = ACTIONS(795),
    [anon_sym_final] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(795),
    [anon_sym_protected] = ACTIONS(795),
    [anon_sym_private] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_array] = ACTIONS(795),
    [anon_sym_unset] = ACTIONS(795),
    [anon_sym_echo] = ACTIONS(795),
    [anon_sym_declare] = ACTIONS(795),
    [anon_sym_enddeclare] = ACTIONS(795),
    [sym_float] = ACTIONS(795),
    [anon_sym_try] = ACTIONS(795),
    [anon_sym_goto] = ACTIONS(795),
    [anon_sym_continue] = ACTIONS(795),
    [anon_sym_break] = ACTIONS(795),
    [sym_integer] = ACTIONS(795),
    [anon_sym_return] = ACTIONS(795),
    [anon_sym_throw] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_endwhile] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_endfor] = ACTIONS(795),
    [anon_sym_foreach] = ACTIONS(795),
    [anon_sym_endforeach] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_endif] = ACTIONS(795),
    [anon_sym_elseif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(795),
    [anon_sym_switch] = ACTIONS(795),
    [anon_sym_endswitch] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_AT] = ACTIONS(793),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_clone] = ACTIONS(795),
    [anon_sym_print] = ACTIONS(795),
    [anon_sym_new] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(793),
    [sym_shell_command_expression] = ACTIONS(793),
    [anon_sym_list] = ACTIONS(795),
    [anon_sym_self] = ACTIONS(795),
    [anon_sym_parent] = ACTIONS(795),
    [sym_string] = ACTIONS(793),
    [sym_boolean] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(795),
    [anon_sym_include] = ACTIONS(795),
    [anon_sym_include_once] = ACTIONS(795),
    [anon_sym_require] = ACTIONS(795),
    [anon_sym_require_once] = ACTIONS(795),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(793),
  },
  [254] = {
    [sym_text_interpolation] = STATE(254),
    [ts_builtin_sym_end] = ACTIONS(797),
    [sym_name] = ACTIONS(799),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_global] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(799),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_function] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(799),
    [anon_sym_class] = ACTIONS(799),
    [anon_sym_abstract] = ACTIONS(799),
    [anon_sym_final] = ACTIONS(799),
    [anon_sym_public] = ACTIONS(799),
    [anon_sym_protected] = ACTIONS(799),
    [anon_sym_private] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_array] = ACTIONS(799),
    [anon_sym_unset] = ACTIONS(799),
    [anon_sym_echo] = ACTIONS(799),
    [anon_sym_declare] = ACTIONS(799),
    [anon_sym_enddeclare] = ACTIONS(799),
    [sym_float] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [sym_integer] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_throw] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_endwhile] = ACTIONS(799),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_endfor] = ACTIONS(799),
    [anon_sym_foreach] = ACTIONS(799),
    [anon_sym_endforeach] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_endif] = ACTIONS(799),
    [anon_sym_elseif] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_endswitch] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_clone] = ACTIONS(799),
    [anon_sym_print] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [sym_shell_command_expression] = ACTIONS(797),
    [anon_sym_list] = ACTIONS(799),
    [anon_sym_self] = ACTIONS(799),
    [anon_sym_parent] = ACTIONS(799),
    [sym_string] = ACTIONS(797),
    [sym_boolean] = ACTIONS(799),
    [sym_null] = ACTIONS(799),
    [anon_sym_DOLLAR] = ACTIONS(797),
    [anon_sym_yield] = ACTIONS(799),
    [anon_sym_include] = ACTIONS(799),
    [anon_sym_include_once] = ACTIONS(799),
    [anon_sym_require] = ACTIONS(799),
    [anon_sym_require_once] = ACTIONS(799),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(797),
  },
  [255] = {
    [sym_text_interpolation] = STATE(255),
    [ts_builtin_sym_end] = ACTIONS(801),
    [sym_name] = ACTIONS(803),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_use] = ACTIONS(803),
    [anon_sym_BSLASH] = ACTIONS(801),
    [anon_sym_function] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_trait] = ACTIONS(803),
    [anon_sym_interface] = ACTIONS(803),
    [anon_sym_class] = ACTIONS(803),
    [anon_sym_abstract] = ACTIONS(803),
    [anon_sym_final] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(803),
    [anon_sym_protected] = ACTIONS(803),
    [anon_sym_private] = ACTIONS(803),
    [anon_sym_LPAREN] = ACTIONS(801),
    [anon_sym_array] = ACTIONS(803),
    [anon_sym_unset] = ACTIONS(803),
    [anon_sym_echo] = ACTIONS(803),
    [anon_sym_declare] = ACTIONS(803),
    [anon_sym_enddeclare] = ACTIONS(803),
    [sym_float] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [sym_integer] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_throw] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_endwhile] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_endfor] = ACTIONS(803),
    [anon_sym_foreach] = ACTIONS(803),
    [anon_sym_endforeach] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_endif] = ACTIONS(803),
    [anon_sym_elseif] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_endswitch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_clone] = ACTIONS(803),
    [anon_sym_print] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [sym_shell_command_expression] = ACTIONS(801),
    [anon_sym_list] = ACTIONS(803),
    [anon_sym_self] = ACTIONS(803),
    [anon_sym_parent] = ACTIONS(803),
    [sym_string] = ACTIONS(801),
    [sym_boolean] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_include] = ACTIONS(803),
    [anon_sym_include_once] = ACTIONS(803),
    [anon_sym_require] = ACTIONS(803),
    [anon_sym_require_once] = ACTIONS(803),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(801),
  },
  [256] = {
    [sym_text_interpolation] = STATE(256),
    [ts_builtin_sym_end] = ACTIONS(805),
    [sym_name] = ACTIONS(807),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(807),
    [anon_sym_global] = ACTIONS(807),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_use] = ACTIONS(807),
    [anon_sym_BSLASH] = ACTIONS(805),
    [anon_sym_function] = ACTIONS(807),
    [anon_sym_const] = ACTIONS(807),
    [anon_sym_LBRACE] = ACTIONS(805),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_trait] = ACTIONS(807),
    [anon_sym_interface] = ACTIONS(807),
    [anon_sym_class] = ACTIONS(807),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_final] = ACTIONS(807),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(805),
    [anon_sym_array] = ACTIONS(807),
    [anon_sym_unset] = ACTIONS(807),
    [anon_sym_echo] = ACTIONS(807),
    [anon_sym_declare] = ACTIONS(807),
    [anon_sym_enddeclare] = ACTIONS(807),
    [sym_float] = ACTIONS(807),
    [anon_sym_try] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_break] = ACTIONS(807),
    [sym_integer] = ACTIONS(807),
    [anon_sym_return] = ACTIONS(807),
    [anon_sym_throw] = ACTIONS(807),
    [anon_sym_while] = ACTIONS(807),
    [anon_sym_endwhile] = ACTIONS(807),
    [anon_sym_do] = ACTIONS(807),
    [anon_sym_for] = ACTIONS(807),
    [anon_sym_endfor] = ACTIONS(807),
    [anon_sym_foreach] = ACTIONS(807),
    [anon_sym_endforeach] = ACTIONS(807),
    [anon_sym_if] = ACTIONS(807),
    [anon_sym_endif] = ACTIONS(807),
    [anon_sym_elseif] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(807),
    [anon_sym_switch] = ACTIONS(807),
    [anon_sym_endswitch] = ACTIONS(807),
    [anon_sym_case] = ACTIONS(807),
    [anon_sym_default] = ACTIONS(807),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_clone] = ACTIONS(807),
    [anon_sym_print] = ACTIONS(807),
    [anon_sym_new] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(805),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [sym_shell_command_expression] = ACTIONS(805),
    [anon_sym_list] = ACTIONS(807),
    [anon_sym_self] = ACTIONS(807),
    [anon_sym_parent] = ACTIONS(807),
    [sym_string] = ACTIONS(805),
    [sym_boolean] = ACTIONS(807),
    [sym_null] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [anon_sym_yield] = ACTIONS(807),
    [anon_sym_include] = ACTIONS(807),
    [anon_sym_include_once] = ACTIONS(807),
    [anon_sym_require] = ACTIONS(807),
    [anon_sym_require_once] = ACTIONS(807),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(805),
  },
  [257] = {
    [sym_text_interpolation] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(743),
    [sym_name] = ACTIONS(745),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_global] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_BSLASH] = ACTIONS(743),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(745),
    [anon_sym_final] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_array] = ACTIONS(745),
    [anon_sym_unset] = ACTIONS(745),
    [anon_sym_echo] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_enddeclare] = ACTIONS(745),
    [sym_float] = ACTIONS(745),
    [anon_sym_try] = ACTIONS(745),
    [anon_sym_goto] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [sym_integer] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_throw] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_endwhile] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_endfor] = ACTIONS(745),
    [anon_sym_foreach] = ACTIONS(745),
    [anon_sym_endforeach] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_endif] = ACTIONS(745),
    [anon_sym_elseif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_switch] = ACTIONS(745),
    [anon_sym_endswitch] = ACTIONS(745),
    [anon_sym_case] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_AT] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_BANG] = ACTIONS(743),
    [anon_sym_clone] = ACTIONS(745),
    [anon_sym_print] = ACTIONS(745),
    [anon_sym_new] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [sym_shell_command_expression] = ACTIONS(743),
    [anon_sym_list] = ACTIONS(745),
    [anon_sym_self] = ACTIONS(745),
    [anon_sym_parent] = ACTIONS(745),
    [sym_string] = ACTIONS(743),
    [sym_boolean] = ACTIONS(745),
    [sym_null] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(743),
    [anon_sym_yield] = ACTIONS(745),
    [anon_sym_include] = ACTIONS(745),
    [anon_sym_include_once] = ACTIONS(745),
    [anon_sym_require] = ACTIONS(745),
    [anon_sym_require_once] = ACTIONS(745),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(743),
  },
  [258] = {
    [sym_text_interpolation] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(809),
    [sym_name] = ACTIONS(811),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(811),
    [anon_sym_global] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_use] = ACTIONS(811),
    [anon_sym_BSLASH] = ACTIONS(809),
    [anon_sym_function] = ACTIONS(811),
    [anon_sym_const] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(809),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_trait] = ACTIONS(811),
    [anon_sym_interface] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(811),
    [anon_sym_abstract] = ACTIONS(811),
    [anon_sym_final] = ACTIONS(811),
    [anon_sym_public] = ACTIONS(811),
    [anon_sym_protected] = ACTIONS(811),
    [anon_sym_private] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_array] = ACTIONS(811),
    [anon_sym_unset] = ACTIONS(811),
    [anon_sym_echo] = ACTIONS(811),
    [anon_sym_declare] = ACTIONS(811),
    [anon_sym_enddeclare] = ACTIONS(811),
    [sym_float] = ACTIONS(811),
    [anon_sym_try] = ACTIONS(811),
    [anon_sym_goto] = ACTIONS(811),
    [anon_sym_continue] = ACTIONS(811),
    [anon_sym_break] = ACTIONS(811),
    [sym_integer] = ACTIONS(811),
    [anon_sym_return] = ACTIONS(811),
    [anon_sym_throw] = ACTIONS(811),
    [anon_sym_while] = ACTIONS(811),
    [anon_sym_endwhile] = ACTIONS(811),
    [anon_sym_do] = ACTIONS(811),
    [anon_sym_for] = ACTIONS(811),
    [anon_sym_endfor] = ACTIONS(811),
    [anon_sym_foreach] = ACTIONS(811),
    [anon_sym_endforeach] = ACTIONS(811),
    [anon_sym_if] = ACTIONS(811),
    [anon_sym_endif] = ACTIONS(811),
    [anon_sym_elseif] = ACTIONS(811),
    [anon_sym_else] = ACTIONS(811),
    [anon_sym_switch] = ACTIONS(811),
    [anon_sym_endswitch] = ACTIONS(811),
    [anon_sym_case] = ACTIONS(811),
    [anon_sym_default] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_clone] = ACTIONS(811),
    [anon_sym_print] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(809),
    [anon_sym_DASH_DASH] = ACTIONS(809),
    [sym_shell_command_expression] = ACTIONS(809),
    [anon_sym_list] = ACTIONS(811),
    [anon_sym_self] = ACTIONS(811),
    [anon_sym_parent] = ACTIONS(811),
    [sym_string] = ACTIONS(809),
    [sym_boolean] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_include] = ACTIONS(811),
    [anon_sym_include_once] = ACTIONS(811),
    [anon_sym_require] = ACTIONS(811),
    [anon_sym_require_once] = ACTIONS(811),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(809),
  },
  [259] = {
    [sym_text_interpolation] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(813),
    [sym_name] = ACTIONS(815),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_global] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_use] = ACTIONS(815),
    [anon_sym_BSLASH] = ACTIONS(813),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(815),
    [anon_sym_interface] = ACTIONS(815),
    [anon_sym_class] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(815),
    [anon_sym_final] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_array] = ACTIONS(815),
    [anon_sym_unset] = ACTIONS(815),
    [anon_sym_echo] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_enddeclare] = ACTIONS(815),
    [sym_float] = ACTIONS(815),
    [anon_sym_try] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [sym_integer] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_throw] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_endwhile] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_endfor] = ACTIONS(815),
    [anon_sym_foreach] = ACTIONS(815),
    [anon_sym_endforeach] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_endif] = ACTIONS(815),
    [anon_sym_elseif] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_endswitch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_clone] = ACTIONS(815),
    [anon_sym_print] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_shell_command_expression] = ACTIONS(813),
    [anon_sym_list] = ACTIONS(815),
    [anon_sym_self] = ACTIONS(815),
    [anon_sym_parent] = ACTIONS(815),
    [sym_string] = ACTIONS(813),
    [sym_boolean] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [anon_sym_yield] = ACTIONS(815),
    [anon_sym_include] = ACTIONS(815),
    [anon_sym_include_once] = ACTIONS(815),
    [anon_sym_require] = ACTIONS(815),
    [anon_sym_require_once] = ACTIONS(815),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(813),
  },
  [260] = {
    [sym_text_interpolation] = STATE(260),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_name] = ACTIONS(819),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_global] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_use] = ACTIONS(819),
    [anon_sym_BSLASH] = ACTIONS(817),
    [anon_sym_function] = ACTIONS(819),
    [anon_sym_const] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_trait] = ACTIONS(819),
    [anon_sym_interface] = ACTIONS(819),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_abstract] = ACTIONS(819),
    [anon_sym_final] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_array] = ACTIONS(819),
    [anon_sym_unset] = ACTIONS(819),
    [anon_sym_echo] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_enddeclare] = ACTIONS(819),
    [sym_float] = ACTIONS(819),
    [anon_sym_try] = ACTIONS(819),
    [anon_sym_goto] = ACTIONS(819),
    [anon_sym_continue] = ACTIONS(819),
    [anon_sym_break] = ACTIONS(819),
    [sym_integer] = ACTIONS(819),
    [anon_sym_return] = ACTIONS(819),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_while] = ACTIONS(819),
    [anon_sym_endwhile] = ACTIONS(819),
    [anon_sym_do] = ACTIONS(819),
    [anon_sym_for] = ACTIONS(819),
    [anon_sym_endfor] = ACTIONS(819),
    [anon_sym_foreach] = ACTIONS(819),
    [anon_sym_endforeach] = ACTIONS(819),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_endif] = ACTIONS(819),
    [anon_sym_elseif] = ACTIONS(819),
    [anon_sym_else] = ACTIONS(819),
    [anon_sym_switch] = ACTIONS(819),
    [anon_sym_endswitch] = ACTIONS(819),
    [anon_sym_case] = ACTIONS(819),
    [anon_sym_default] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_clone] = ACTIONS(819),
    [anon_sym_print] = ACTIONS(819),
    [anon_sym_new] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_shell_command_expression] = ACTIONS(817),
    [anon_sym_list] = ACTIONS(819),
    [anon_sym_self] = ACTIONS(819),
    [anon_sym_parent] = ACTIONS(819),
    [sym_string] = ACTIONS(817),
    [sym_boolean] = ACTIONS(819),
    [sym_null] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(817),
    [anon_sym_yield] = ACTIONS(819),
    [anon_sym_include] = ACTIONS(819),
    [anon_sym_include_once] = ACTIONS(819),
    [anon_sym_require] = ACTIONS(819),
    [anon_sym_require_once] = ACTIONS(819),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(817),
  },
  [261] = {
    [sym_text_interpolation] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(821),
    [sym_name] = ACTIONS(823),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_static] = ACTIONS(823),
    [anon_sym_global] = ACTIONS(823),
    [anon_sym_namespace] = ACTIONS(823),
    [anon_sym_use] = ACTIONS(823),
    [anon_sym_BSLASH] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_const] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_trait] = ACTIONS(823),
    [anon_sym_interface] = ACTIONS(823),
    [anon_sym_class] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_final] = ACTIONS(823),
    [anon_sym_public] = ACTIONS(823),
    [anon_sym_protected] = ACTIONS(823),
    [anon_sym_private] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(821),
    [anon_sym_array] = ACTIONS(823),
    [anon_sym_unset] = ACTIONS(823),
    [anon_sym_echo] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(823),
    [anon_sym_enddeclare] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_try] = ACTIONS(823),
    [anon_sym_goto] = ACTIONS(823),
    [anon_sym_continue] = ACTIONS(823),
    [anon_sym_break] = ACTIONS(823),
    [sym_integer] = ACTIONS(823),
    [anon_sym_return] = ACTIONS(823),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(823),
    [anon_sym_endwhile] = ACTIONS(823),
    [anon_sym_do] = ACTIONS(823),
    [anon_sym_for] = ACTIONS(823),
    [anon_sym_endfor] = ACTIONS(823),
    [anon_sym_foreach] = ACTIONS(823),
    [anon_sym_endforeach] = ACTIONS(823),
    [anon_sym_if] = ACTIONS(823),
    [anon_sym_endif] = ACTIONS(823),
    [anon_sym_elseif] = ACTIONS(823),
    [anon_sym_else] = ACTIONS(823),
    [anon_sym_switch] = ACTIONS(823),
    [anon_sym_endswitch] = ACTIONS(823),
    [anon_sym_case] = ACTIONS(823),
    [anon_sym_default] = ACTIONS(823),
    [anon_sym_AT] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_clone] = ACTIONS(823),
    [anon_sym_print] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(823),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_shell_command_expression] = ACTIONS(821),
    [anon_sym_list] = ACTIONS(823),
    [anon_sym_self] = ACTIONS(823),
    [anon_sym_parent] = ACTIONS(823),
    [sym_string] = ACTIONS(821),
    [sym_boolean] = ACTIONS(823),
    [sym_null] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(821),
    [anon_sym_yield] = ACTIONS(823),
    [anon_sym_include] = ACTIONS(823),
    [anon_sym_include_once] = ACTIONS(823),
    [anon_sym_require] = ACTIONS(823),
    [anon_sym_require_once] = ACTIONS(823),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(821),
  },
  [262] = {
    [sym_text_interpolation] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(825),
    [sym_name] = ACTIONS(827),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_global] = ACTIONS(827),
    [anon_sym_namespace] = ACTIONS(827),
    [anon_sym_use] = ACTIONS(827),
    [anon_sym_BSLASH] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_trait] = ACTIONS(827),
    [anon_sym_interface] = ACTIONS(827),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_abstract] = ACTIONS(827),
    [anon_sym_final] = ACTIONS(827),
    [anon_sym_public] = ACTIONS(827),
    [anon_sym_protected] = ACTIONS(827),
    [anon_sym_private] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [anon_sym_array] = ACTIONS(827),
    [anon_sym_unset] = ACTIONS(827),
    [anon_sym_echo] = ACTIONS(827),
    [anon_sym_declare] = ACTIONS(827),
    [anon_sym_enddeclare] = ACTIONS(827),
    [sym_float] = ACTIONS(827),
    [anon_sym_try] = ACTIONS(827),
    [anon_sym_goto] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [sym_integer] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_throw] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_endwhile] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_endfor] = ACTIONS(827),
    [anon_sym_foreach] = ACTIONS(827),
    [anon_sym_endforeach] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_endif] = ACTIONS(827),
    [anon_sym_elseif] = ACTIONS(827),
    [anon_sym_else] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_endswitch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_AT] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_clone] = ACTIONS(827),
    [anon_sym_print] = ACTIONS(827),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_shell_command_expression] = ACTIONS(825),
    [anon_sym_list] = ACTIONS(827),
    [anon_sym_self] = ACTIONS(827),
    [anon_sym_parent] = ACTIONS(827),
    [sym_string] = ACTIONS(825),
    [sym_boolean] = ACTIONS(827),
    [sym_null] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_include] = ACTIONS(827),
    [anon_sym_include_once] = ACTIONS(827),
    [anon_sym_require] = ACTIONS(827),
    [anon_sym_require_once] = ACTIONS(827),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(825),
  },
  [263] = {
    [sym_text_interpolation] = STATE(263),
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_name] = ACTIONS(831),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_global] = ACTIONS(831),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_BSLASH] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_const] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_abstract] = ACTIONS(831),
    [anon_sym_final] = ACTIONS(831),
    [anon_sym_public] = ACTIONS(831),
    [anon_sym_protected] = ACTIONS(831),
    [anon_sym_private] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_array] = ACTIONS(831),
    [anon_sym_unset] = ACTIONS(831),
    [anon_sym_echo] = ACTIONS(831),
    [anon_sym_declare] = ACTIONS(831),
    [anon_sym_enddeclare] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_goto] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [sym_integer] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_endwhile] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_endfor] = ACTIONS(831),
    [anon_sym_foreach] = ACTIONS(831),
    [anon_sym_endforeach] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_endif] = ACTIONS(831),
    [anon_sym_elseif] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_endswitch] = ACTIONS(831),
    [anon_sym_case] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_clone] = ACTIONS(831),
    [anon_sym_print] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_PLUS_PLUS] = ACTIONS(829),
    [anon_sym_DASH_DASH] = ACTIONS(829),
    [sym_shell_command_expression] = ACTIONS(829),
    [anon_sym_list] = ACTIONS(831),
    [anon_sym_self] = ACTIONS(831),
    [anon_sym_parent] = ACTIONS(831),
    [sym_string] = ACTIONS(829),
    [sym_boolean] = ACTIONS(831),
    [sym_null] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_include] = ACTIONS(831),
    [anon_sym_include_once] = ACTIONS(831),
    [anon_sym_require] = ACTIONS(831),
    [anon_sym_require_once] = ACTIONS(831),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(829),
  },
  [264] = {
    [sym_text_interpolation] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(833),
    [sym_name] = ACTIONS(835),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_static] = ACTIONS(835),
    [anon_sym_global] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(835),
    [anon_sym_use] = ACTIONS(835),
    [anon_sym_BSLASH] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_const] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_trait] = ACTIONS(835),
    [anon_sym_interface] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(835),
    [anon_sym_abstract] = ACTIONS(835),
    [anon_sym_final] = ACTIONS(835),
    [anon_sym_public] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_array] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_echo] = ACTIONS(835),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_enddeclare] = ACTIONS(835),
    [sym_float] = ACTIONS(835),
    [anon_sym_try] = ACTIONS(835),
    [anon_sym_goto] = ACTIONS(835),
    [anon_sym_continue] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(835),
    [sym_integer] = ACTIONS(835),
    [anon_sym_return] = ACTIONS(835),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_endwhile] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_endfor] = ACTIONS(835),
    [anon_sym_foreach] = ACTIONS(835),
    [anon_sym_endforeach] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_endif] = ACTIONS(835),
    [anon_sym_elseif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_switch] = ACTIONS(835),
    [anon_sym_endswitch] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_clone] = ACTIONS(835),
    [anon_sym_print] = ACTIONS(835),
    [anon_sym_new] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [sym_shell_command_expression] = ACTIONS(833),
    [anon_sym_list] = ACTIONS(835),
    [anon_sym_self] = ACTIONS(835),
    [anon_sym_parent] = ACTIONS(835),
    [sym_string] = ACTIONS(833),
    [sym_boolean] = ACTIONS(835),
    [sym_null] = ACTIONS(835),
    [anon_sym_DOLLAR] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_include] = ACTIONS(835),
    [anon_sym_include_once] = ACTIONS(835),
    [anon_sym_require] = ACTIONS(835),
    [anon_sym_require_once] = ACTIONS(835),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(833),
  },
  [265] = {
    [sym_text_interpolation] = STATE(265),
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_name] = ACTIONS(831),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_global] = ACTIONS(831),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_BSLASH] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_const] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_abstract] = ACTIONS(831),
    [anon_sym_final] = ACTIONS(831),
    [anon_sym_public] = ACTIONS(831),
    [anon_sym_protected] = ACTIONS(831),
    [anon_sym_private] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_array] = ACTIONS(831),
    [anon_sym_unset] = ACTIONS(831),
    [anon_sym_echo] = ACTIONS(831),
    [anon_sym_declare] = ACTIONS(831),
    [anon_sym_enddeclare] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_goto] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [sym_integer] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_endwhile] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_endfor] = ACTIONS(831),
    [anon_sym_foreach] = ACTIONS(831),
    [anon_sym_endforeach] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_endif] = ACTIONS(831),
    [anon_sym_elseif] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_endswitch] = ACTIONS(831),
    [anon_sym_case] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_clone] = ACTIONS(831),
    [anon_sym_print] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_PLUS_PLUS] = ACTIONS(829),
    [anon_sym_DASH_DASH] = ACTIONS(829),
    [sym_shell_command_expression] = ACTIONS(829),
    [anon_sym_list] = ACTIONS(831),
    [anon_sym_self] = ACTIONS(831),
    [anon_sym_parent] = ACTIONS(831),
    [sym_string] = ACTIONS(829),
    [sym_boolean] = ACTIONS(831),
    [sym_null] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_include] = ACTIONS(831),
    [anon_sym_include_once] = ACTIONS(831),
    [anon_sym_require] = ACTIONS(831),
    [anon_sym_require_once] = ACTIONS(831),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(829),
  },
  [266] = {
    [sym_text_interpolation] = STATE(266),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_name] = ACTIONS(839),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_global] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(839),
    [anon_sym_BSLASH] = ACTIONS(837),
    [anon_sym_function] = ACTIONS(839),
    [anon_sym_const] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_trait] = ACTIONS(839),
    [anon_sym_interface] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(839),
    [anon_sym_abstract] = ACTIONS(839),
    [anon_sym_final] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_array] = ACTIONS(839),
    [anon_sym_unset] = ACTIONS(839),
    [anon_sym_echo] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_enddeclare] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(839),
    [anon_sym_goto] = ACTIONS(839),
    [anon_sym_continue] = ACTIONS(839),
    [anon_sym_break] = ACTIONS(839),
    [sym_integer] = ACTIONS(839),
    [anon_sym_return] = ACTIONS(839),
    [anon_sym_throw] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(839),
    [anon_sym_endwhile] = ACTIONS(839),
    [anon_sym_do] = ACTIONS(839),
    [anon_sym_for] = ACTIONS(839),
    [anon_sym_endfor] = ACTIONS(839),
    [anon_sym_foreach] = ACTIONS(839),
    [anon_sym_endforeach] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_endif] = ACTIONS(839),
    [anon_sym_elseif] = ACTIONS(839),
    [anon_sym_else] = ACTIONS(839),
    [anon_sym_switch] = ACTIONS(839),
    [anon_sym_endswitch] = ACTIONS(839),
    [anon_sym_case] = ACTIONS(839),
    [anon_sym_default] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(837),
    [anon_sym_clone] = ACTIONS(839),
    [anon_sym_print] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_PLUS_PLUS] = ACTIONS(837),
    [anon_sym_DASH_DASH] = ACTIONS(837),
    [sym_shell_command_expression] = ACTIONS(837),
    [anon_sym_list] = ACTIONS(839),
    [anon_sym_self] = ACTIONS(839),
    [anon_sym_parent] = ACTIONS(839),
    [sym_string] = ACTIONS(837),
    [sym_boolean] = ACTIONS(839),
    [sym_null] = ACTIONS(839),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_yield] = ACTIONS(839),
    [anon_sym_include] = ACTIONS(839),
    [anon_sym_include_once] = ACTIONS(839),
    [anon_sym_require] = ACTIONS(839),
    [anon_sym_require_once] = ACTIONS(839),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(837),
  },
  [267] = {
    [sym_text_interpolation] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(747),
    [sym_name] = ACTIONS(749),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(749),
    [anon_sym_use] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(747),
    [anon_sym_function] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_trait] = ACTIONS(749),
    [anon_sym_interface] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(749),
    [anon_sym_abstract] = ACTIONS(749),
    [anon_sym_final] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_array] = ACTIONS(749),
    [anon_sym_unset] = ACTIONS(749),
    [anon_sym_echo] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_enddeclare] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [anon_sym_try] = ACTIONS(749),
    [anon_sym_goto] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [sym_integer] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [anon_sym_endwhile] = ACTIONS(749),
    [anon_sym_do] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_endfor] = ACTIONS(749),
    [anon_sym_foreach] = ACTIONS(749),
    [anon_sym_endforeach] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_endif] = ACTIONS(749),
    [anon_sym_elseif] = ACTIONS(749),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_switch] = ACTIONS(749),
    [anon_sym_endswitch] = ACTIONS(749),
    [anon_sym_case] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(747),
    [anon_sym_clone] = ACTIONS(749),
    [anon_sym_print] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(747),
    [sym_shell_command_expression] = ACTIONS(747),
    [anon_sym_list] = ACTIONS(749),
    [anon_sym_self] = ACTIONS(749),
    [anon_sym_parent] = ACTIONS(749),
    [sym_string] = ACTIONS(747),
    [sym_boolean] = ACTIONS(749),
    [sym_null] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_yield] = ACTIONS(749),
    [anon_sym_include] = ACTIONS(749),
    [anon_sym_include_once] = ACTIONS(749),
    [anon_sym_require] = ACTIONS(749),
    [anon_sym_require_once] = ACTIONS(749),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(747),
  },
  [268] = {
    [sym_text_interpolation] = STATE(268),
    [ts_builtin_sym_end] = ACTIONS(841),
    [sym_name] = ACTIONS(843),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_global] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(843),
    [anon_sym_use] = ACTIONS(843),
    [anon_sym_BSLASH] = ACTIONS(841),
    [anon_sym_function] = ACTIONS(843),
    [anon_sym_const] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_trait] = ACTIONS(843),
    [anon_sym_interface] = ACTIONS(843),
    [anon_sym_class] = ACTIONS(843),
    [anon_sym_abstract] = ACTIONS(843),
    [anon_sym_final] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(843),
    [anon_sym_protected] = ACTIONS(843),
    [anon_sym_private] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(841),
    [anon_sym_array] = ACTIONS(843),
    [anon_sym_unset] = ACTIONS(843),
    [anon_sym_echo] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_enddeclare] = ACTIONS(843),
    [sym_float] = ACTIONS(843),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_goto] = ACTIONS(843),
    [anon_sym_continue] = ACTIONS(843),
    [anon_sym_break] = ACTIONS(843),
    [sym_integer] = ACTIONS(843),
    [anon_sym_return] = ACTIONS(843),
    [anon_sym_throw] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(843),
    [anon_sym_endwhile] = ACTIONS(843),
    [anon_sym_do] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_endfor] = ACTIONS(843),
    [anon_sym_foreach] = ACTIONS(843),
    [anon_sym_endforeach] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_endif] = ACTIONS(843),
    [anon_sym_elseif] = ACTIONS(843),
    [anon_sym_else] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(843),
    [anon_sym_endswitch] = ACTIONS(843),
    [anon_sym_case] = ACTIONS(843),
    [anon_sym_default] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_clone] = ACTIONS(843),
    [anon_sym_print] = ACTIONS(843),
    [anon_sym_new] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [sym_shell_command_expression] = ACTIONS(841),
    [anon_sym_list] = ACTIONS(843),
    [anon_sym_self] = ACTIONS(843),
    [anon_sym_parent] = ACTIONS(843),
    [sym_string] = ACTIONS(841),
    [sym_boolean] = ACTIONS(843),
    [sym_null] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(841),
    [anon_sym_yield] = ACTIONS(843),
    [anon_sym_include] = ACTIONS(843),
    [anon_sym_include_once] = ACTIONS(843),
    [anon_sym_require] = ACTIONS(843),
    [anon_sym_require_once] = ACTIONS(843),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(841),
  },
  [269] = {
    [sym_text_interpolation] = STATE(269),
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_name] = ACTIONS(847),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_static] = ACTIONS(847),
    [anon_sym_global] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_use] = ACTIONS(847),
    [anon_sym_BSLASH] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_const] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_trait] = ACTIONS(847),
    [anon_sym_interface] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(847),
    [anon_sym_abstract] = ACTIONS(847),
    [anon_sym_final] = ACTIONS(847),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_array] = ACTIONS(847),
    [anon_sym_unset] = ACTIONS(847),
    [anon_sym_echo] = ACTIONS(847),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_enddeclare] = ACTIONS(847),
    [sym_float] = ACTIONS(847),
    [anon_sym_try] = ACTIONS(847),
    [anon_sym_goto] = ACTIONS(847),
    [anon_sym_continue] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(847),
    [sym_integer] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(847),
    [anon_sym_throw] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_endwhile] = ACTIONS(847),
    [anon_sym_do] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(847),
    [anon_sym_endfor] = ACTIONS(847),
    [anon_sym_foreach] = ACTIONS(847),
    [anon_sym_endforeach] = ACTIONS(847),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_endif] = ACTIONS(847),
    [anon_sym_elseif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(847),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_endswitch] = ACTIONS(847),
    [anon_sym_case] = ACTIONS(847),
    [anon_sym_default] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_clone] = ACTIONS(847),
    [anon_sym_print] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_PLUS_PLUS] = ACTIONS(845),
    [anon_sym_DASH_DASH] = ACTIONS(845),
    [sym_shell_command_expression] = ACTIONS(845),
    [anon_sym_list] = ACTIONS(847),
    [anon_sym_self] = ACTIONS(847),
    [anon_sym_parent] = ACTIONS(847),
    [sym_string] = ACTIONS(845),
    [sym_boolean] = ACTIONS(847),
    [sym_null] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(845),
    [anon_sym_yield] = ACTIONS(847),
    [anon_sym_include] = ACTIONS(847),
    [anon_sym_include_once] = ACTIONS(847),
    [anon_sym_require] = ACTIONS(847),
    [anon_sym_require_once] = ACTIONS(847),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(845),
  },
  [270] = {
    [sym_text_interpolation] = STATE(270),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_name] = ACTIONS(851),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_use] = ACTIONS(851),
    [anon_sym_BSLASH] = ACTIONS(849),
    [anon_sym_function] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_trait] = ACTIONS(851),
    [anon_sym_interface] = ACTIONS(851),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_abstract] = ACTIONS(851),
    [anon_sym_final] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_array] = ACTIONS(851),
    [anon_sym_unset] = ACTIONS(851),
    [anon_sym_echo] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_enddeclare] = ACTIONS(851),
    [sym_float] = ACTIONS(851),
    [anon_sym_try] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [sym_integer] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_throw] = ACTIONS(851),
    [anon_sym_while] = ACTIONS(851),
    [anon_sym_endwhile] = ACTIONS(851),
    [anon_sym_do] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_endfor] = ACTIONS(851),
    [anon_sym_foreach] = ACTIONS(851),
    [anon_sym_endforeach] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_endif] = ACTIONS(851),
    [anon_sym_elseif] = ACTIONS(851),
    [anon_sym_else] = ACTIONS(851),
    [anon_sym_switch] = ACTIONS(851),
    [anon_sym_endswitch] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(851),
    [anon_sym_default] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(849),
    [anon_sym_clone] = ACTIONS(851),
    [anon_sym_print] = ACTIONS(851),
    [anon_sym_new] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [sym_shell_command_expression] = ACTIONS(849),
    [anon_sym_list] = ACTIONS(851),
    [anon_sym_self] = ACTIONS(851),
    [anon_sym_parent] = ACTIONS(851),
    [sym_string] = ACTIONS(849),
    [sym_boolean] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_include] = ACTIONS(851),
    [anon_sym_include_once] = ACTIONS(851),
    [anon_sym_require] = ACTIONS(851),
    [anon_sym_require_once] = ACTIONS(851),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(849),
  },
  [271] = {
    [sym_text_interpolation] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_name] = ACTIONS(855),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(853),
    [anon_sym_static] = ACTIONS(855),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_use] = ACTIONS(855),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_function] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_trait] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_class] = ACTIONS(855),
    [anon_sym_abstract] = ACTIONS(855),
    [anon_sym_final] = ACTIONS(855),
    [anon_sym_public] = ACTIONS(855),
    [anon_sym_protected] = ACTIONS(855),
    [anon_sym_private] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_array] = ACTIONS(855),
    [anon_sym_unset] = ACTIONS(855),
    [anon_sym_echo] = ACTIONS(855),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_enddeclare] = ACTIONS(855),
    [sym_float] = ACTIONS(855),
    [anon_sym_try] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [sym_integer] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_throw] = ACTIONS(855),
    [anon_sym_while] = ACTIONS(855),
    [anon_sym_endwhile] = ACTIONS(855),
    [anon_sym_do] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_endfor] = ACTIONS(855),
    [anon_sym_foreach] = ACTIONS(855),
    [anon_sym_endforeach] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_endif] = ACTIONS(855),
    [anon_sym_elseif] = ACTIONS(855),
    [anon_sym_else] = ACTIONS(855),
    [anon_sym_switch] = ACTIONS(855),
    [anon_sym_endswitch] = ACTIONS(855),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_default] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_clone] = ACTIONS(855),
    [anon_sym_print] = ACTIONS(855),
    [anon_sym_new] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [sym_shell_command_expression] = ACTIONS(853),
    [anon_sym_list] = ACTIONS(855),
    [anon_sym_self] = ACTIONS(855),
    [anon_sym_parent] = ACTIONS(855),
    [sym_string] = ACTIONS(853),
    [sym_boolean] = ACTIONS(855),
    [sym_null] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_include] = ACTIONS(855),
    [anon_sym_include_once] = ACTIONS(855),
    [anon_sym_require] = ACTIONS(855),
    [anon_sym_require_once] = ACTIONS(855),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(853),
  },
  [272] = {
    [sym_text_interpolation] = STATE(272),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_name] = ACTIONS(859),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_global] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_use] = ACTIONS(859),
    [anon_sym_BSLASH] = ACTIONS(857),
    [anon_sym_function] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_trait] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_class] = ACTIONS(859),
    [anon_sym_abstract] = ACTIONS(859),
    [anon_sym_final] = ACTIONS(859),
    [anon_sym_public] = ACTIONS(859),
    [anon_sym_protected] = ACTIONS(859),
    [anon_sym_private] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_array] = ACTIONS(859),
    [anon_sym_unset] = ACTIONS(859),
    [anon_sym_echo] = ACTIONS(859),
    [anon_sym_declare] = ACTIONS(859),
    [anon_sym_enddeclare] = ACTIONS(859),
    [sym_float] = ACTIONS(859),
    [anon_sym_try] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [sym_integer] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_throw] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_endwhile] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_endfor] = ACTIONS(859),
    [anon_sym_foreach] = ACTIONS(859),
    [anon_sym_endforeach] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_endif] = ACTIONS(859),
    [anon_sym_elseif] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_endswitch] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_clone] = ACTIONS(859),
    [anon_sym_print] = ACTIONS(859),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [sym_shell_command_expression] = ACTIONS(857),
    [anon_sym_list] = ACTIONS(859),
    [anon_sym_self] = ACTIONS(859),
    [anon_sym_parent] = ACTIONS(859),
    [sym_string] = ACTIONS(857),
    [sym_boolean] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_yield] = ACTIONS(859),
    [anon_sym_include] = ACTIONS(859),
    [anon_sym_include_once] = ACTIONS(859),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_require_once] = ACTIONS(859),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(857),
  },
  [273] = {
    [sym_text_interpolation] = STATE(273),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_name] = ACTIONS(863),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_global] = ACTIONS(863),
    [anon_sym_namespace] = ACTIONS(863),
    [anon_sym_use] = ACTIONS(863),
    [anon_sym_BSLASH] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(863),
    [anon_sym_const] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_trait] = ACTIONS(863),
    [anon_sym_interface] = ACTIONS(863),
    [anon_sym_class] = ACTIONS(863),
    [anon_sym_abstract] = ACTIONS(863),
    [anon_sym_final] = ACTIONS(863),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(861),
    [anon_sym_array] = ACTIONS(863),
    [anon_sym_unset] = ACTIONS(863),
    [anon_sym_echo] = ACTIONS(863),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_enddeclare] = ACTIONS(863),
    [sym_float] = ACTIONS(863),
    [anon_sym_try] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(863),
    [anon_sym_continue] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(863),
    [sym_integer] = ACTIONS(863),
    [anon_sym_return] = ACTIONS(863),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_while] = ACTIONS(863),
    [anon_sym_endwhile] = ACTIONS(863),
    [anon_sym_do] = ACTIONS(863),
    [anon_sym_for] = ACTIONS(863),
    [anon_sym_endfor] = ACTIONS(863),
    [anon_sym_foreach] = ACTIONS(863),
    [anon_sym_endforeach] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_endif] = ACTIONS(863),
    [anon_sym_elseif] = ACTIONS(863),
    [anon_sym_else] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(863),
    [anon_sym_endswitch] = ACTIONS(863),
    [anon_sym_case] = ACTIONS(863),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(861),
    [anon_sym_clone] = ACTIONS(863),
    [anon_sym_print] = ACTIONS(863),
    [anon_sym_new] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [sym_shell_command_expression] = ACTIONS(861),
    [anon_sym_list] = ACTIONS(863),
    [anon_sym_self] = ACTIONS(863),
    [anon_sym_parent] = ACTIONS(863),
    [sym_string] = ACTIONS(861),
    [sym_boolean] = ACTIONS(863),
    [sym_null] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(863),
    [anon_sym_include] = ACTIONS(863),
    [anon_sym_include_once] = ACTIONS(863),
    [anon_sym_require] = ACTIONS(863),
    [anon_sym_require_once] = ACTIONS(863),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(861),
  },
  [274] = {
    [sym_text_interpolation] = STATE(274),
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_name] = ACTIONS(867),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_static] = ACTIONS(867),
    [anon_sym_global] = ACTIONS(867),
    [anon_sym_namespace] = ACTIONS(867),
    [anon_sym_use] = ACTIONS(867),
    [anon_sym_BSLASH] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_const] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_trait] = ACTIONS(867),
    [anon_sym_interface] = ACTIONS(867),
    [anon_sym_class] = ACTIONS(867),
    [anon_sym_abstract] = ACTIONS(867),
    [anon_sym_final] = ACTIONS(867),
    [anon_sym_public] = ACTIONS(867),
    [anon_sym_protected] = ACTIONS(867),
    [anon_sym_private] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_array] = ACTIONS(867),
    [anon_sym_unset] = ACTIONS(867),
    [anon_sym_echo] = ACTIONS(867),
    [anon_sym_declare] = ACTIONS(867),
    [anon_sym_enddeclare] = ACTIONS(867),
    [sym_float] = ACTIONS(867),
    [anon_sym_try] = ACTIONS(867),
    [anon_sym_goto] = ACTIONS(867),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_break] = ACTIONS(867),
    [sym_integer] = ACTIONS(867),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_throw] = ACTIONS(867),
    [anon_sym_while] = ACTIONS(867),
    [anon_sym_endwhile] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(867),
    [anon_sym_endfor] = ACTIONS(867),
    [anon_sym_foreach] = ACTIONS(867),
    [anon_sym_endforeach] = ACTIONS(867),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_endif] = ACTIONS(867),
    [anon_sym_elseif] = ACTIONS(867),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_switch] = ACTIONS(867),
    [anon_sym_endswitch] = ACTIONS(867),
    [anon_sym_case] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_clone] = ACTIONS(867),
    [anon_sym_print] = ACTIONS(867),
    [anon_sym_new] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [sym_shell_command_expression] = ACTIONS(865),
    [anon_sym_list] = ACTIONS(867),
    [anon_sym_self] = ACTIONS(867),
    [anon_sym_parent] = ACTIONS(867),
    [sym_string] = ACTIONS(865),
    [sym_boolean] = ACTIONS(867),
    [sym_null] = ACTIONS(867),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_yield] = ACTIONS(867),
    [anon_sym_include] = ACTIONS(867),
    [anon_sym_include_once] = ACTIONS(867),
    [anon_sym_require] = ACTIONS(867),
    [anon_sym_require_once] = ACTIONS(867),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(865),
  },
  [275] = {
    [sym_text_interpolation] = STATE(275),
    [ts_builtin_sym_end] = ACTIONS(869),
    [sym_name] = ACTIONS(871),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_static] = ACTIONS(871),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_namespace] = ACTIONS(871),
    [anon_sym_use] = ACTIONS(871),
    [anon_sym_BSLASH] = ACTIONS(869),
    [anon_sym_function] = ACTIONS(871),
    [anon_sym_const] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_RBRACE] = ACTIONS(869),
    [anon_sym_trait] = ACTIONS(871),
    [anon_sym_interface] = ACTIONS(871),
    [anon_sym_class] = ACTIONS(871),
    [anon_sym_abstract] = ACTIONS(871),
    [anon_sym_final] = ACTIONS(871),
    [anon_sym_public] = ACTIONS(871),
    [anon_sym_protected] = ACTIONS(871),
    [anon_sym_private] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_array] = ACTIONS(871),
    [anon_sym_unset] = ACTIONS(871),
    [anon_sym_echo] = ACTIONS(871),
    [anon_sym_declare] = ACTIONS(871),
    [anon_sym_enddeclare] = ACTIONS(871),
    [sym_float] = ACTIONS(871),
    [anon_sym_try] = ACTIONS(871),
    [anon_sym_goto] = ACTIONS(871),
    [anon_sym_continue] = ACTIONS(871),
    [anon_sym_break] = ACTIONS(871),
    [sym_integer] = ACTIONS(871),
    [anon_sym_return] = ACTIONS(871),
    [anon_sym_throw] = ACTIONS(871),
    [anon_sym_while] = ACTIONS(871),
    [anon_sym_endwhile] = ACTIONS(871),
    [anon_sym_do] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(871),
    [anon_sym_endfor] = ACTIONS(871),
    [anon_sym_foreach] = ACTIONS(871),
    [anon_sym_endforeach] = ACTIONS(871),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_endif] = ACTIONS(871),
    [anon_sym_elseif] = ACTIONS(871),
    [anon_sym_else] = ACTIONS(871),
    [anon_sym_switch] = ACTIONS(871),
    [anon_sym_endswitch] = ACTIONS(871),
    [anon_sym_case] = ACTIONS(871),
    [anon_sym_default] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_clone] = ACTIONS(871),
    [anon_sym_print] = ACTIONS(871),
    [anon_sym_new] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [sym_shell_command_expression] = ACTIONS(869),
    [anon_sym_list] = ACTIONS(871),
    [anon_sym_self] = ACTIONS(871),
    [anon_sym_parent] = ACTIONS(871),
    [sym_string] = ACTIONS(869),
    [sym_boolean] = ACTIONS(871),
    [sym_null] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(871),
    [anon_sym_include] = ACTIONS(871),
    [anon_sym_include_once] = ACTIONS(871),
    [anon_sym_require] = ACTIONS(871),
    [anon_sym_require_once] = ACTIONS(871),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(869),
  },
  [276] = {
    [sym_text_interpolation] = STATE(276),
    [ts_builtin_sym_end] = ACTIONS(873),
    [sym_name] = ACTIONS(875),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_static] = ACTIONS(875),
    [anon_sym_global] = ACTIONS(875),
    [anon_sym_namespace] = ACTIONS(875),
    [anon_sym_use] = ACTIONS(875),
    [anon_sym_BSLASH] = ACTIONS(873),
    [anon_sym_function] = ACTIONS(875),
    [anon_sym_const] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_trait] = ACTIONS(875),
    [anon_sym_interface] = ACTIONS(875),
    [anon_sym_class] = ACTIONS(875),
    [anon_sym_abstract] = ACTIONS(875),
    [anon_sym_final] = ACTIONS(875),
    [anon_sym_public] = ACTIONS(875),
    [anon_sym_protected] = ACTIONS(875),
    [anon_sym_private] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_array] = ACTIONS(875),
    [anon_sym_unset] = ACTIONS(875),
    [anon_sym_echo] = ACTIONS(875),
    [anon_sym_declare] = ACTIONS(875),
    [anon_sym_enddeclare] = ACTIONS(875),
    [sym_float] = ACTIONS(875),
    [anon_sym_try] = ACTIONS(875),
    [anon_sym_goto] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(875),
    [anon_sym_break] = ACTIONS(875),
    [sym_integer] = ACTIONS(875),
    [anon_sym_return] = ACTIONS(875),
    [anon_sym_throw] = ACTIONS(875),
    [anon_sym_while] = ACTIONS(875),
    [anon_sym_endwhile] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(875),
    [anon_sym_endfor] = ACTIONS(875),
    [anon_sym_foreach] = ACTIONS(875),
    [anon_sym_endforeach] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_endif] = ACTIONS(875),
    [anon_sym_elseif] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_switch] = ACTIONS(875),
    [anon_sym_endswitch] = ACTIONS(875),
    [anon_sym_case] = ACTIONS(875),
    [anon_sym_default] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_clone] = ACTIONS(875),
    [anon_sym_print] = ACTIONS(875),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(873),
    [sym_shell_command_expression] = ACTIONS(873),
    [anon_sym_list] = ACTIONS(875),
    [anon_sym_self] = ACTIONS(875),
    [anon_sym_parent] = ACTIONS(875),
    [sym_string] = ACTIONS(873),
    [sym_boolean] = ACTIONS(875),
    [sym_null] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_yield] = ACTIONS(875),
    [anon_sym_include] = ACTIONS(875),
    [anon_sym_include_once] = ACTIONS(875),
    [anon_sym_require] = ACTIONS(875),
    [anon_sym_require_once] = ACTIONS(875),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(873),
  },
  [277] = {
    [sym_text_interpolation] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym_name] = ACTIONS(879),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(877),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_global] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(879),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_BSLASH] = ACTIONS(877),
    [anon_sym_function] = ACTIONS(879),
    [anon_sym_const] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_trait] = ACTIONS(879),
    [anon_sym_interface] = ACTIONS(879),
    [anon_sym_class] = ACTIONS(879),
    [anon_sym_abstract] = ACTIONS(879),
    [anon_sym_final] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_array] = ACTIONS(879),
    [anon_sym_unset] = ACTIONS(879),
    [anon_sym_echo] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_enddeclare] = ACTIONS(879),
    [sym_float] = ACTIONS(879),
    [anon_sym_try] = ACTIONS(879),
    [anon_sym_goto] = ACTIONS(879),
    [anon_sym_continue] = ACTIONS(879),
    [anon_sym_break] = ACTIONS(879),
    [sym_integer] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(879),
    [anon_sym_throw] = ACTIONS(879),
    [anon_sym_while] = ACTIONS(879),
    [anon_sym_endwhile] = ACTIONS(879),
    [anon_sym_do] = ACTIONS(879),
    [anon_sym_for] = ACTIONS(879),
    [anon_sym_endfor] = ACTIONS(879),
    [anon_sym_foreach] = ACTIONS(879),
    [anon_sym_endforeach] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_endif] = ACTIONS(879),
    [anon_sym_elseif] = ACTIONS(879),
    [anon_sym_else] = ACTIONS(879),
    [anon_sym_switch] = ACTIONS(879),
    [anon_sym_endswitch] = ACTIONS(879),
    [anon_sym_case] = ACTIONS(879),
    [anon_sym_default] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_clone] = ACTIONS(879),
    [anon_sym_print] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [sym_shell_command_expression] = ACTIONS(877),
    [anon_sym_list] = ACTIONS(879),
    [anon_sym_self] = ACTIONS(879),
    [anon_sym_parent] = ACTIONS(879),
    [sym_string] = ACTIONS(877),
    [sym_boolean] = ACTIONS(879),
    [sym_null] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_include] = ACTIONS(879),
    [anon_sym_include_once] = ACTIONS(879),
    [anon_sym_require] = ACTIONS(879),
    [anon_sym_require_once] = ACTIONS(879),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(877),
  },
  [278] = {
    [sym_text_interpolation] = STATE(278),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_name] = ACTIONS(883),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_static] = ACTIONS(883),
    [anon_sym_global] = ACTIONS(883),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_use] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(881),
    [anon_sym_function] = ACTIONS(883),
    [anon_sym_const] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_trait] = ACTIONS(883),
    [anon_sym_interface] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(883),
    [anon_sym_abstract] = ACTIONS(883),
    [anon_sym_final] = ACTIONS(883),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_array] = ACTIONS(883),
    [anon_sym_unset] = ACTIONS(883),
    [anon_sym_echo] = ACTIONS(883),
    [anon_sym_declare] = ACTIONS(883),
    [anon_sym_enddeclare] = ACTIONS(883),
    [sym_float] = ACTIONS(883),
    [anon_sym_try] = ACTIONS(883),
    [anon_sym_goto] = ACTIONS(883),
    [anon_sym_continue] = ACTIONS(883),
    [anon_sym_break] = ACTIONS(883),
    [sym_integer] = ACTIONS(883),
    [anon_sym_return] = ACTIONS(883),
    [anon_sym_throw] = ACTIONS(883),
    [anon_sym_while] = ACTIONS(883),
    [anon_sym_endwhile] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_endfor] = ACTIONS(883),
    [anon_sym_foreach] = ACTIONS(883),
    [anon_sym_endforeach] = ACTIONS(883),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_endif] = ACTIONS(883),
    [anon_sym_elseif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_switch] = ACTIONS(883),
    [anon_sym_endswitch] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(883),
    [anon_sym_default] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_BANG] = ACTIONS(881),
    [anon_sym_clone] = ACTIONS(883),
    [anon_sym_print] = ACTIONS(883),
    [anon_sym_new] = ACTIONS(883),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [sym_shell_command_expression] = ACTIONS(881),
    [anon_sym_list] = ACTIONS(883),
    [anon_sym_self] = ACTIONS(883),
    [anon_sym_parent] = ACTIONS(883),
    [sym_string] = ACTIONS(881),
    [sym_boolean] = ACTIONS(883),
    [sym_null] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(881),
    [anon_sym_yield] = ACTIONS(883),
    [anon_sym_include] = ACTIONS(883),
    [anon_sym_include_once] = ACTIONS(883),
    [anon_sym_require] = ACTIONS(883),
    [anon_sym_require_once] = ACTIONS(883),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(881),
  },
  [279] = {
    [sym_text_interpolation] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(885),
    [sym_name] = ACTIONS(887),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(887),
    [anon_sym_global] = ACTIONS(887),
    [anon_sym_namespace] = ACTIONS(887),
    [anon_sym_use] = ACTIONS(887),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(887),
    [anon_sym_const] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_trait] = ACTIONS(887),
    [anon_sym_interface] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_abstract] = ACTIONS(887),
    [anon_sym_final] = ACTIONS(887),
    [anon_sym_public] = ACTIONS(887),
    [anon_sym_protected] = ACTIONS(887),
    [anon_sym_private] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_array] = ACTIONS(887),
    [anon_sym_unset] = ACTIONS(887),
    [anon_sym_echo] = ACTIONS(887),
    [anon_sym_declare] = ACTIONS(887),
    [anon_sym_enddeclare] = ACTIONS(887),
    [sym_float] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_goto] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [sym_integer] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_throw] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_endwhile] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_endfor] = ACTIONS(887),
    [anon_sym_foreach] = ACTIONS(887),
    [anon_sym_endforeach] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_endif] = ACTIONS(887),
    [anon_sym_elseif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_switch] = ACTIONS(887),
    [anon_sym_endswitch] = ACTIONS(887),
    [anon_sym_case] = ACTIONS(887),
    [anon_sym_default] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_clone] = ACTIONS(887),
    [anon_sym_print] = ACTIONS(887),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [sym_shell_command_expression] = ACTIONS(885),
    [anon_sym_list] = ACTIONS(887),
    [anon_sym_self] = ACTIONS(887),
    [anon_sym_parent] = ACTIONS(887),
    [sym_string] = ACTIONS(885),
    [sym_boolean] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_include] = ACTIONS(887),
    [anon_sym_include_once] = ACTIONS(887),
    [anon_sym_require] = ACTIONS(887),
    [anon_sym_require_once] = ACTIONS(887),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(885),
  },
  [280] = {
    [sym_text_interpolation] = STATE(280),
    [ts_builtin_sym_end] = ACTIONS(889),
    [sym_name] = ACTIONS(891),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_global] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_use] = ACTIONS(891),
    [anon_sym_BSLASH] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_trait] = ACTIONS(891),
    [anon_sym_interface] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(891),
    [anon_sym_abstract] = ACTIONS(891),
    [anon_sym_final] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [anon_sym_array] = ACTIONS(891),
    [anon_sym_unset] = ACTIONS(891),
    [anon_sym_echo] = ACTIONS(891),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_enddeclare] = ACTIONS(891),
    [sym_float] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(891),
    [anon_sym_goto] = ACTIONS(891),
    [anon_sym_continue] = ACTIONS(891),
    [anon_sym_break] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [anon_sym_return] = ACTIONS(891),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_endwhile] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_for] = ACTIONS(891),
    [anon_sym_endfor] = ACTIONS(891),
    [anon_sym_foreach] = ACTIONS(891),
    [anon_sym_endforeach] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_endif] = ACTIONS(891),
    [anon_sym_elseif] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_switch] = ACTIONS(891),
    [anon_sym_endswitch] = ACTIONS(891),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_default] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_clone] = ACTIONS(891),
    [anon_sym_print] = ACTIONS(891),
    [anon_sym_new] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(889),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [sym_shell_command_expression] = ACTIONS(889),
    [anon_sym_list] = ACTIONS(891),
    [anon_sym_self] = ACTIONS(891),
    [anon_sym_parent] = ACTIONS(891),
    [sym_string] = ACTIONS(889),
    [sym_boolean] = ACTIONS(891),
    [sym_null] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(889),
    [anon_sym_yield] = ACTIONS(891),
    [anon_sym_include] = ACTIONS(891),
    [anon_sym_include_once] = ACTIONS(891),
    [anon_sym_require] = ACTIONS(891),
    [anon_sym_require_once] = ACTIONS(891),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(889),
  },
  [281] = {
    [sym_text_interpolation] = STATE(281),
    [ts_builtin_sym_end] = ACTIONS(893),
    [sym_name] = ACTIONS(895),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(895),
    [anon_sym_global] = ACTIONS(895),
    [anon_sym_namespace] = ACTIONS(895),
    [anon_sym_use] = ACTIONS(895),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(895),
    [anon_sym_const] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_trait] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(895),
    [anon_sym_class] = ACTIONS(895),
    [anon_sym_abstract] = ACTIONS(895),
    [anon_sym_final] = ACTIONS(895),
    [anon_sym_public] = ACTIONS(895),
    [anon_sym_protected] = ACTIONS(895),
    [anon_sym_private] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_array] = ACTIONS(895),
    [anon_sym_unset] = ACTIONS(895),
    [anon_sym_echo] = ACTIONS(895),
    [anon_sym_declare] = ACTIONS(895),
    [anon_sym_enddeclare] = ACTIONS(895),
    [sym_float] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(895),
    [anon_sym_goto] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(895),
    [anon_sym_break] = ACTIONS(895),
    [sym_integer] = ACTIONS(895),
    [anon_sym_return] = ACTIONS(895),
    [anon_sym_throw] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(895),
    [anon_sym_endwhile] = ACTIONS(895),
    [anon_sym_do] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_endfor] = ACTIONS(895),
    [anon_sym_foreach] = ACTIONS(895),
    [anon_sym_endforeach] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(895),
    [anon_sym_endif] = ACTIONS(895),
    [anon_sym_elseif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_switch] = ACTIONS(895),
    [anon_sym_endswitch] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_clone] = ACTIONS(895),
    [anon_sym_print] = ACTIONS(895),
    [anon_sym_new] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_shell_command_expression] = ACTIONS(893),
    [anon_sym_list] = ACTIONS(895),
    [anon_sym_self] = ACTIONS(895),
    [anon_sym_parent] = ACTIONS(895),
    [sym_string] = ACTIONS(893),
    [sym_boolean] = ACTIONS(895),
    [sym_null] = ACTIONS(895),
    [anon_sym_DOLLAR] = ACTIONS(893),
    [anon_sym_yield] = ACTIONS(895),
    [anon_sym_include] = ACTIONS(895),
    [anon_sym_include_once] = ACTIONS(895),
    [anon_sym_require] = ACTIONS(895),
    [anon_sym_require_once] = ACTIONS(895),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(893),
  },
  [282] = {
    [sym_text_interpolation] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_name] = ACTIONS(899),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_static] = ACTIONS(899),
    [anon_sym_global] = ACTIONS(899),
    [anon_sym_namespace] = ACTIONS(899),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_BSLASH] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(899),
    [anon_sym_const] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_trait] = ACTIONS(899),
    [anon_sym_interface] = ACTIONS(899),
    [anon_sym_class] = ACTIONS(899),
    [anon_sym_abstract] = ACTIONS(899),
    [anon_sym_final] = ACTIONS(899),
    [anon_sym_public] = ACTIONS(899),
    [anon_sym_protected] = ACTIONS(899),
    [anon_sym_private] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(897),
    [anon_sym_array] = ACTIONS(899),
    [anon_sym_unset] = ACTIONS(899),
    [anon_sym_echo] = ACTIONS(899),
    [anon_sym_declare] = ACTIONS(899),
    [anon_sym_enddeclare] = ACTIONS(899),
    [sym_float] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_goto] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [sym_integer] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_throw] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_endwhile] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_endfor] = ACTIONS(899),
    [anon_sym_foreach] = ACTIONS(899),
    [anon_sym_endforeach] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_endif] = ACTIONS(899),
    [anon_sym_elseif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_switch] = ACTIONS(899),
    [anon_sym_endswitch] = ACTIONS(899),
    [anon_sym_case] = ACTIONS(899),
    [anon_sym_default] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_clone] = ACTIONS(899),
    [anon_sym_print] = ACTIONS(899),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(897),
    [sym_shell_command_expression] = ACTIONS(897),
    [anon_sym_list] = ACTIONS(899),
    [anon_sym_self] = ACTIONS(899),
    [anon_sym_parent] = ACTIONS(899),
    [sym_string] = ACTIONS(897),
    [sym_boolean] = ACTIONS(899),
    [sym_null] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(899),
    [anon_sym_include] = ACTIONS(899),
    [anon_sym_include_once] = ACTIONS(899),
    [anon_sym_require] = ACTIONS(899),
    [anon_sym_require_once] = ACTIONS(899),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(897),
  },
  [283] = {
    [sym_text_interpolation] = STATE(283),
    [ts_builtin_sym_end] = ACTIONS(901),
    [sym_name] = ACTIONS(903),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(903),
    [anon_sym_global] = ACTIONS(903),
    [anon_sym_namespace] = ACTIONS(903),
    [anon_sym_use] = ACTIONS(903),
    [anon_sym_BSLASH] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_trait] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(903),
    [anon_sym_class] = ACTIONS(903),
    [anon_sym_abstract] = ACTIONS(903),
    [anon_sym_final] = ACTIONS(903),
    [anon_sym_public] = ACTIONS(903),
    [anon_sym_protected] = ACTIONS(903),
    [anon_sym_private] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_array] = ACTIONS(903),
    [anon_sym_unset] = ACTIONS(903),
    [anon_sym_echo] = ACTIONS(903),
    [anon_sym_declare] = ACTIONS(903),
    [anon_sym_enddeclare] = ACTIONS(903),
    [sym_float] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(903),
    [anon_sym_goto] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [sym_integer] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_throw] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_endwhile] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_endfor] = ACTIONS(903),
    [anon_sym_foreach] = ACTIONS(903),
    [anon_sym_endforeach] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_endif] = ACTIONS(903),
    [anon_sym_elseif] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(903),
    [anon_sym_endswitch] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_clone] = ACTIONS(903),
    [anon_sym_print] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(901),
    [anon_sym_DASH_DASH] = ACTIONS(901),
    [sym_shell_command_expression] = ACTIONS(901),
    [anon_sym_list] = ACTIONS(903),
    [anon_sym_self] = ACTIONS(903),
    [anon_sym_parent] = ACTIONS(903),
    [sym_string] = ACTIONS(901),
    [sym_boolean] = ACTIONS(903),
    [sym_null] = ACTIONS(903),
    [anon_sym_DOLLAR] = ACTIONS(901),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_include] = ACTIONS(903),
    [anon_sym_include_once] = ACTIONS(903),
    [anon_sym_require] = ACTIONS(903),
    [anon_sym_require_once] = ACTIONS(903),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(901),
  },
  [284] = {
    [sym_text_interpolation] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(905),
    [sym_name] = ACTIONS(907),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_static] = ACTIONS(907),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_namespace] = ACTIONS(907),
    [anon_sym_use] = ACTIONS(907),
    [anon_sym_BSLASH] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(907),
    [anon_sym_const] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_trait] = ACTIONS(907),
    [anon_sym_interface] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_abstract] = ACTIONS(907),
    [anon_sym_final] = ACTIONS(907),
    [anon_sym_public] = ACTIONS(907),
    [anon_sym_protected] = ACTIONS(907),
    [anon_sym_private] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_array] = ACTIONS(907),
    [anon_sym_unset] = ACTIONS(907),
    [anon_sym_echo] = ACTIONS(907),
    [anon_sym_declare] = ACTIONS(907),
    [anon_sym_enddeclare] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_goto] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [sym_integer] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_endwhile] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_endfor] = ACTIONS(907),
    [anon_sym_foreach] = ACTIONS(907),
    [anon_sym_endforeach] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_endif] = ACTIONS(907),
    [anon_sym_elseif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_switch] = ACTIONS(907),
    [anon_sym_endswitch] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_clone] = ACTIONS(907),
    [anon_sym_print] = ACTIONS(907),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [sym_shell_command_expression] = ACTIONS(905),
    [anon_sym_list] = ACTIONS(907),
    [anon_sym_self] = ACTIONS(907),
    [anon_sym_parent] = ACTIONS(907),
    [sym_string] = ACTIONS(905),
    [sym_boolean] = ACTIONS(907),
    [sym_null] = ACTIONS(907),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_include] = ACTIONS(907),
    [anon_sym_include_once] = ACTIONS(907),
    [anon_sym_require] = ACTIONS(907),
    [anon_sym_require_once] = ACTIONS(907),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(905),
  },
  [285] = {
    [sym_text_interpolation] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_name] = ACTIONS(911),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(911),
    [anon_sym_global] = ACTIONS(911),
    [anon_sym_namespace] = ACTIONS(911),
    [anon_sym_use] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(909),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_const] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_trait] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_abstract] = ACTIONS(911),
    [anon_sym_final] = ACTIONS(911),
    [anon_sym_public] = ACTIONS(911),
    [anon_sym_protected] = ACTIONS(911),
    [anon_sym_private] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_array] = ACTIONS(911),
    [anon_sym_unset] = ACTIONS(911),
    [anon_sym_echo] = ACTIONS(911),
    [anon_sym_declare] = ACTIONS(911),
    [anon_sym_enddeclare] = ACTIONS(911),
    [sym_float] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_goto] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [sym_integer] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_throw] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_endwhile] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_endfor] = ACTIONS(911),
    [anon_sym_foreach] = ACTIONS(911),
    [anon_sym_endforeach] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_endif] = ACTIONS(911),
    [anon_sym_elseif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_switch] = ACTIONS(911),
    [anon_sym_endswitch] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(911),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_clone] = ACTIONS(911),
    [anon_sym_print] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [sym_shell_command_expression] = ACTIONS(909),
    [anon_sym_list] = ACTIONS(911),
    [anon_sym_self] = ACTIONS(911),
    [anon_sym_parent] = ACTIONS(911),
    [sym_string] = ACTIONS(909),
    [sym_boolean] = ACTIONS(911),
    [sym_null] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_include] = ACTIONS(911),
    [anon_sym_include_once] = ACTIONS(911),
    [anon_sym_require] = ACTIONS(911),
    [anon_sym_require_once] = ACTIONS(911),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(909),
  },
  [286] = {
    [sym_text_interpolation] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_name] = ACTIONS(915),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_static] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(915),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_use] = ACTIONS(915),
    [anon_sym_BSLASH] = ACTIONS(913),
    [anon_sym_function] = ACTIONS(915),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_trait] = ACTIONS(915),
    [anon_sym_interface] = ACTIONS(915),
    [anon_sym_class] = ACTIONS(915),
    [anon_sym_abstract] = ACTIONS(915),
    [anon_sym_final] = ACTIONS(915),
    [anon_sym_public] = ACTIONS(915),
    [anon_sym_protected] = ACTIONS(915),
    [anon_sym_private] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_array] = ACTIONS(915),
    [anon_sym_unset] = ACTIONS(915),
    [anon_sym_echo] = ACTIONS(915),
    [anon_sym_declare] = ACTIONS(915),
    [anon_sym_enddeclare] = ACTIONS(915),
    [sym_float] = ACTIONS(915),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_goto] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [sym_integer] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_throw] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [anon_sym_endwhile] = ACTIONS(915),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_endfor] = ACTIONS(915),
    [anon_sym_foreach] = ACTIONS(915),
    [anon_sym_endforeach] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_endif] = ACTIONS(915),
    [anon_sym_elseif] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(915),
    [anon_sym_endswitch] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_default] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_clone] = ACTIONS(915),
    [anon_sym_print] = ACTIONS(915),
    [anon_sym_new] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(913),
    [sym_shell_command_expression] = ACTIONS(913),
    [anon_sym_list] = ACTIONS(915),
    [anon_sym_self] = ACTIONS(915),
    [anon_sym_parent] = ACTIONS(915),
    [sym_string] = ACTIONS(913),
    [sym_boolean] = ACTIONS(915),
    [sym_null] = ACTIONS(915),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(915),
    [anon_sym_include] = ACTIONS(915),
    [anon_sym_include_once] = ACTIONS(915),
    [anon_sym_require] = ACTIONS(915),
    [anon_sym_require_once] = ACTIONS(915),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(913),
  },
  [287] = {
    [sym_text_interpolation] = STATE(287),
    [ts_builtin_sym_end] = ACTIONS(917),
    [sym_name] = ACTIONS(919),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_static] = ACTIONS(919),
    [anon_sym_global] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_use] = ACTIONS(919),
    [anon_sym_BSLASH] = ACTIONS(917),
    [anon_sym_function] = ACTIONS(919),
    [anon_sym_const] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_trait] = ACTIONS(919),
    [anon_sym_interface] = ACTIONS(919),
    [anon_sym_class] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(919),
    [anon_sym_final] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_array] = ACTIONS(919),
    [anon_sym_unset] = ACTIONS(919),
    [anon_sym_echo] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_enddeclare] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_goto] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [sym_integer] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_endwhile] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_endfor] = ACTIONS(919),
    [anon_sym_foreach] = ACTIONS(919),
    [anon_sym_endforeach] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(919),
    [anon_sym_endif] = ACTIONS(919),
    [anon_sym_elseif] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_switch] = ACTIONS(919),
    [anon_sym_endswitch] = ACTIONS(919),
    [anon_sym_case] = ACTIONS(919),
    [anon_sym_default] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_clone] = ACTIONS(919),
    [anon_sym_print] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [sym_shell_command_expression] = ACTIONS(917),
    [anon_sym_list] = ACTIONS(919),
    [anon_sym_self] = ACTIONS(919),
    [anon_sym_parent] = ACTIONS(919),
    [sym_string] = ACTIONS(917),
    [sym_boolean] = ACTIONS(919),
    [sym_null] = ACTIONS(919),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_yield] = ACTIONS(919),
    [anon_sym_include] = ACTIONS(919),
    [anon_sym_include_once] = ACTIONS(919),
    [anon_sym_require] = ACTIONS(919),
    [anon_sym_require_once] = ACTIONS(919),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(917),
  },
  [288] = {
    [sym_text_interpolation] = STATE(288),
    [ts_builtin_sym_end] = ACTIONS(921),
    [sym_name] = ACTIONS(923),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(921),
    [anon_sym_static] = ACTIONS(923),
    [anon_sym_global] = ACTIONS(923),
    [anon_sym_namespace] = ACTIONS(923),
    [anon_sym_use] = ACTIONS(923),
    [anon_sym_BSLASH] = ACTIONS(921),
    [anon_sym_function] = ACTIONS(923),
    [anon_sym_const] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(921),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_trait] = ACTIONS(923),
    [anon_sym_interface] = ACTIONS(923),
    [anon_sym_class] = ACTIONS(923),
    [anon_sym_abstract] = ACTIONS(923),
    [anon_sym_final] = ACTIONS(923),
    [anon_sym_public] = ACTIONS(923),
    [anon_sym_protected] = ACTIONS(923),
    [anon_sym_private] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_array] = ACTIONS(923),
    [anon_sym_unset] = ACTIONS(923),
    [anon_sym_echo] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(923),
    [anon_sym_enddeclare] = ACTIONS(923),
    [sym_float] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_goto] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [sym_integer] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_throw] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_endwhile] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_endfor] = ACTIONS(923),
    [anon_sym_foreach] = ACTIONS(923),
    [anon_sym_endforeach] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_endif] = ACTIONS(923),
    [anon_sym_elseif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_switch] = ACTIONS(923),
    [anon_sym_endswitch] = ACTIONS(923),
    [anon_sym_case] = ACTIONS(923),
    [anon_sym_default] = ACTIONS(923),
    [anon_sym_AT] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_clone] = ACTIONS(923),
    [anon_sym_print] = ACTIONS(923),
    [anon_sym_new] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_PLUS_PLUS] = ACTIONS(921),
    [anon_sym_DASH_DASH] = ACTIONS(921),
    [sym_shell_command_expression] = ACTIONS(921),
    [anon_sym_list] = ACTIONS(923),
    [anon_sym_self] = ACTIONS(923),
    [anon_sym_parent] = ACTIONS(923),
    [sym_string] = ACTIONS(921),
    [sym_boolean] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(923),
    [anon_sym_include] = ACTIONS(923),
    [anon_sym_include_once] = ACTIONS(923),
    [anon_sym_require] = ACTIONS(923),
    [anon_sym_require_once] = ACTIONS(923),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(921),
  },
  [289] = {
    [sym_text_interpolation] = STATE(289),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_name] = ACTIONS(899),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_static] = ACTIONS(899),
    [anon_sym_global] = ACTIONS(899),
    [anon_sym_namespace] = ACTIONS(899),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_BSLASH] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(899),
    [anon_sym_const] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_trait] = ACTIONS(899),
    [anon_sym_interface] = ACTIONS(899),
    [anon_sym_class] = ACTIONS(899),
    [anon_sym_abstract] = ACTIONS(899),
    [anon_sym_final] = ACTIONS(899),
    [anon_sym_public] = ACTIONS(899),
    [anon_sym_protected] = ACTIONS(899),
    [anon_sym_private] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(897),
    [anon_sym_array] = ACTIONS(899),
    [anon_sym_unset] = ACTIONS(899),
    [anon_sym_echo] = ACTIONS(899),
    [anon_sym_declare] = ACTIONS(899),
    [anon_sym_enddeclare] = ACTIONS(899),
    [sym_float] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_goto] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [sym_integer] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_throw] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_endwhile] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_endfor] = ACTIONS(899),
    [anon_sym_foreach] = ACTIONS(899),
    [anon_sym_endforeach] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_endif] = ACTIONS(899),
    [anon_sym_elseif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_switch] = ACTIONS(899),
    [anon_sym_endswitch] = ACTIONS(899),
    [anon_sym_case] = ACTIONS(899),
    [anon_sym_default] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_clone] = ACTIONS(899),
    [anon_sym_print] = ACTIONS(899),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(897),
    [sym_shell_command_expression] = ACTIONS(897),
    [anon_sym_list] = ACTIONS(899),
    [anon_sym_self] = ACTIONS(899),
    [anon_sym_parent] = ACTIONS(899),
    [sym_string] = ACTIONS(897),
    [sym_boolean] = ACTIONS(899),
    [sym_null] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(899),
    [anon_sym_include] = ACTIONS(899),
    [anon_sym_include_once] = ACTIONS(899),
    [anon_sym_require] = ACTIONS(899),
    [anon_sym_require_once] = ACTIONS(899),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(897),
  },
  [290] = {
    [sym_text_interpolation] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(925),
    [sym_name] = ACTIONS(927),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_global] = ACTIONS(927),
    [anon_sym_namespace] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(927),
    [anon_sym_BSLASH] = ACTIONS(925),
    [anon_sym_function] = ACTIONS(927),
    [anon_sym_const] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_trait] = ACTIONS(927),
    [anon_sym_interface] = ACTIONS(927),
    [anon_sym_class] = ACTIONS(927),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_final] = ACTIONS(927),
    [anon_sym_public] = ACTIONS(927),
    [anon_sym_protected] = ACTIONS(927),
    [anon_sym_private] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_array] = ACTIONS(927),
    [anon_sym_unset] = ACTIONS(927),
    [anon_sym_echo] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(927),
    [anon_sym_enddeclare] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [anon_sym_try] = ACTIONS(927),
    [anon_sym_goto] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [sym_integer] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_throw] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_endwhile] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_endfor] = ACTIONS(927),
    [anon_sym_foreach] = ACTIONS(927),
    [anon_sym_endforeach] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_endif] = ACTIONS(927),
    [anon_sym_elseif] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_switch] = ACTIONS(927),
    [anon_sym_endswitch] = ACTIONS(927),
    [anon_sym_case] = ACTIONS(927),
    [anon_sym_default] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_clone] = ACTIONS(927),
    [anon_sym_print] = ACTIONS(927),
    [anon_sym_new] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_DASH_DASH] = ACTIONS(925),
    [sym_shell_command_expression] = ACTIONS(925),
    [anon_sym_list] = ACTIONS(927),
    [anon_sym_self] = ACTIONS(927),
    [anon_sym_parent] = ACTIONS(927),
    [sym_string] = ACTIONS(925),
    [sym_boolean] = ACTIONS(927),
    [sym_null] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(927),
    [anon_sym_include] = ACTIONS(927),
    [anon_sym_include_once] = ACTIONS(927),
    [anon_sym_require] = ACTIONS(927),
    [anon_sym_require_once] = ACTIONS(927),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(925),
  },
  [291] = {
    [sym_text_interpolation] = STATE(291),
    [ts_builtin_sym_end] = ACTIONS(929),
    [sym_name] = ACTIONS(931),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_static] = ACTIONS(931),
    [anon_sym_global] = ACTIONS(931),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_use] = ACTIONS(931),
    [anon_sym_BSLASH] = ACTIONS(929),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_const] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(929),
    [anon_sym_trait] = ACTIONS(931),
    [anon_sym_interface] = ACTIONS(931),
    [anon_sym_class] = ACTIONS(931),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_final] = ACTIONS(931),
    [anon_sym_public] = ACTIONS(931),
    [anon_sym_protected] = ACTIONS(931),
    [anon_sym_private] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_array] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_echo] = ACTIONS(931),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_enddeclare] = ACTIONS(931),
    [sym_float] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_goto] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [sym_integer] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_throw] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_endwhile] = ACTIONS(931),
    [anon_sym_do] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_endfor] = ACTIONS(931),
    [anon_sym_foreach] = ACTIONS(931),
    [anon_sym_endforeach] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_endif] = ACTIONS(931),
    [anon_sym_elseif] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(931),
    [anon_sym_switch] = ACTIONS(931),
    [anon_sym_endswitch] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_default] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_clone] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(929),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_shell_command_expression] = ACTIONS(929),
    [anon_sym_list] = ACTIONS(931),
    [anon_sym_self] = ACTIONS(931),
    [anon_sym_parent] = ACTIONS(931),
    [sym_string] = ACTIONS(929),
    [sym_boolean] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(931),
    [anon_sym_include] = ACTIONS(931),
    [anon_sym_include_once] = ACTIONS(931),
    [anon_sym_require] = ACTIONS(931),
    [anon_sym_require_once] = ACTIONS(931),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(929),
  },
  [292] = {
    [sym_text_interpolation] = STATE(292),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_name] = ACTIONS(935),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_global] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_use] = ACTIONS(935),
    [anon_sym_BSLASH] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_trait] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_final] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_array] = ACTIONS(935),
    [anon_sym_unset] = ACTIONS(935),
    [anon_sym_echo] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_enddeclare] = ACTIONS(935),
    [sym_float] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_goto] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [sym_integer] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_endwhile] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_endfor] = ACTIONS(935),
    [anon_sym_foreach] = ACTIONS(935),
    [anon_sym_endforeach] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_endif] = ACTIONS(935),
    [anon_sym_elseif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_endswitch] = ACTIONS(935),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_clone] = ACTIONS(935),
    [anon_sym_print] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [sym_shell_command_expression] = ACTIONS(933),
    [anon_sym_list] = ACTIONS(935),
    [anon_sym_self] = ACTIONS(935),
    [anon_sym_parent] = ACTIONS(935),
    [sym_string] = ACTIONS(933),
    [sym_boolean] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_include] = ACTIONS(935),
    [anon_sym_include_once] = ACTIONS(935),
    [anon_sym_require] = ACTIONS(935),
    [anon_sym_require_once] = ACTIONS(935),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(933),
  },
  [293] = {
    [sym_text_interpolation] = STATE(293),
    [ts_builtin_sym_end] = ACTIONS(937),
    [sym_name] = ACTIONS(939),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(937),
    [anon_sym_static] = ACTIONS(939),
    [anon_sym_global] = ACTIONS(939),
    [anon_sym_namespace] = ACTIONS(939),
    [anon_sym_use] = ACTIONS(939),
    [anon_sym_BSLASH] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_const] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_trait] = ACTIONS(939),
    [anon_sym_interface] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(939),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_final] = ACTIONS(939),
    [anon_sym_public] = ACTIONS(939),
    [anon_sym_protected] = ACTIONS(939),
    [anon_sym_private] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_array] = ACTIONS(939),
    [anon_sym_unset] = ACTIONS(939),
    [anon_sym_echo] = ACTIONS(939),
    [anon_sym_declare] = ACTIONS(939),
    [anon_sym_enddeclare] = ACTIONS(939),
    [sym_float] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_goto] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [sym_integer] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_throw] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_endwhile] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_endfor] = ACTIONS(939),
    [anon_sym_foreach] = ACTIONS(939),
    [anon_sym_endforeach] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_endif] = ACTIONS(939),
    [anon_sym_elseif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_switch] = ACTIONS(939),
    [anon_sym_endswitch] = ACTIONS(939),
    [anon_sym_case] = ACTIONS(939),
    [anon_sym_default] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_clone] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_PLUS_PLUS] = ACTIONS(937),
    [anon_sym_DASH_DASH] = ACTIONS(937),
    [sym_shell_command_expression] = ACTIONS(937),
    [anon_sym_list] = ACTIONS(939),
    [anon_sym_self] = ACTIONS(939),
    [anon_sym_parent] = ACTIONS(939),
    [sym_string] = ACTIONS(937),
    [sym_boolean] = ACTIONS(939),
    [sym_null] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(937),
    [anon_sym_yield] = ACTIONS(939),
    [anon_sym_include] = ACTIONS(939),
    [anon_sym_include_once] = ACTIONS(939),
    [anon_sym_require] = ACTIONS(939),
    [anon_sym_require_once] = ACTIONS(939),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(937),
  },
  [294] = {
    [sym_text_interpolation] = STATE(294),
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_name] = ACTIONS(943),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_global] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_use] = ACTIONS(943),
    [anon_sym_BSLASH] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_trait] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_final] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_array] = ACTIONS(943),
    [anon_sym_unset] = ACTIONS(943),
    [anon_sym_echo] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_enddeclare] = ACTIONS(943),
    [sym_float] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_goto] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [sym_integer] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_endwhile] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_endfor] = ACTIONS(943),
    [anon_sym_foreach] = ACTIONS(943),
    [anon_sym_endforeach] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_endif] = ACTIONS(943),
    [anon_sym_elseif] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_endswitch] = ACTIONS(943),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_clone] = ACTIONS(943),
    [anon_sym_print] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [sym_shell_command_expression] = ACTIONS(941),
    [anon_sym_list] = ACTIONS(943),
    [anon_sym_self] = ACTIONS(943),
    [anon_sym_parent] = ACTIONS(943),
    [sym_string] = ACTIONS(941),
    [sym_boolean] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(941),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_include] = ACTIONS(943),
    [anon_sym_include_once] = ACTIONS(943),
    [anon_sym_require] = ACTIONS(943),
    [anon_sym_require_once] = ACTIONS(943),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(941),
  },
  [295] = {
    [sym_text_interpolation] = STATE(295),
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym_name] = ACTIONS(947),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(947),
    [anon_sym_global] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(947),
    [anon_sym_use] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(945),
    [anon_sym_function] = ACTIONS(947),
    [anon_sym_const] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(947),
    [anon_sym_interface] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(947),
    [anon_sym_abstract] = ACTIONS(947),
    [anon_sym_final] = ACTIONS(947),
    [anon_sym_public] = ACTIONS(947),
    [anon_sym_protected] = ACTIONS(947),
    [anon_sym_private] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_array] = ACTIONS(947),
    [anon_sym_unset] = ACTIONS(947),
    [anon_sym_echo] = ACTIONS(947),
    [anon_sym_declare] = ACTIONS(947),
    [anon_sym_enddeclare] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_goto] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [sym_integer] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_throw] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_endwhile] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_endfor] = ACTIONS(947),
    [anon_sym_foreach] = ACTIONS(947),
    [anon_sym_endforeach] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_endif] = ACTIONS(947),
    [anon_sym_elseif] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_endswitch] = ACTIONS(947),
    [anon_sym_case] = ACTIONS(947),
    [anon_sym_default] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_clone] = ACTIONS(947),
    [anon_sym_print] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(945),
    [anon_sym_PLUS_PLUS] = ACTIONS(945),
    [anon_sym_DASH_DASH] = ACTIONS(945),
    [sym_shell_command_expression] = ACTIONS(945),
    [anon_sym_list] = ACTIONS(947),
    [anon_sym_self] = ACTIONS(947),
    [anon_sym_parent] = ACTIONS(947),
    [sym_string] = ACTIONS(945),
    [sym_boolean] = ACTIONS(947),
    [sym_null] = ACTIONS(947),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_include] = ACTIONS(947),
    [anon_sym_include_once] = ACTIONS(947),
    [anon_sym_require] = ACTIONS(947),
    [anon_sym_require_once] = ACTIONS(947),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(945),
  },
  [296] = {
    [sym_text_interpolation] = STATE(296),
    [ts_builtin_sym_end] = ACTIONS(949),
    [sym_name] = ACTIONS(951),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_static] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(951),
    [anon_sym_use] = ACTIONS(951),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_function] = ACTIONS(951),
    [anon_sym_const] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_trait] = ACTIONS(951),
    [anon_sym_interface] = ACTIONS(951),
    [anon_sym_class] = ACTIONS(951),
    [anon_sym_abstract] = ACTIONS(951),
    [anon_sym_final] = ACTIONS(951),
    [anon_sym_public] = ACTIONS(951),
    [anon_sym_protected] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_array] = ACTIONS(951),
    [anon_sym_unset] = ACTIONS(951),
    [anon_sym_echo] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(951),
    [anon_sym_enddeclare] = ACTIONS(951),
    [sym_float] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_goto] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [sym_integer] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_endwhile] = ACTIONS(951),
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_endfor] = ACTIONS(951),
    [anon_sym_foreach] = ACTIONS(951),
    [anon_sym_endforeach] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_endif] = ACTIONS(951),
    [anon_sym_elseif] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_endswitch] = ACTIONS(951),
    [anon_sym_case] = ACTIONS(951),
    [anon_sym_default] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_clone] = ACTIONS(951),
    [anon_sym_print] = ACTIONS(951),
    [anon_sym_new] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_PLUS_PLUS] = ACTIONS(949),
    [anon_sym_DASH_DASH] = ACTIONS(949),
    [sym_shell_command_expression] = ACTIONS(949),
    [anon_sym_list] = ACTIONS(951),
    [anon_sym_self] = ACTIONS(951),
    [anon_sym_parent] = ACTIONS(951),
    [sym_string] = ACTIONS(949),
    [sym_boolean] = ACTIONS(951),
    [sym_null] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_include] = ACTIONS(951),
    [anon_sym_include_once] = ACTIONS(951),
    [anon_sym_require] = ACTIONS(951),
    [anon_sym_require_once] = ACTIONS(951),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(949),
  },
  [297] = {
    [sym_text_interpolation] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(953),
    [sym_name] = ACTIONS(955),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(955),
    [anon_sym_BSLASH] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(955),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_trait] = ACTIONS(955),
    [anon_sym_interface] = ACTIONS(955),
    [anon_sym_class] = ACTIONS(955),
    [anon_sym_abstract] = ACTIONS(955),
    [anon_sym_final] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_array] = ACTIONS(955),
    [anon_sym_unset] = ACTIONS(955),
    [anon_sym_echo] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_enddeclare] = ACTIONS(955),
    [sym_float] = ACTIONS(955),
    [anon_sym_try] = ACTIONS(955),
    [anon_sym_goto] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(955),
    [anon_sym_break] = ACTIONS(955),
    [sym_integer] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(955),
    [anon_sym_throw] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_endwhile] = ACTIONS(955),
    [anon_sym_do] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_endfor] = ACTIONS(955),
    [anon_sym_foreach] = ACTIONS(955),
    [anon_sym_endforeach] = ACTIONS(955),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_endif] = ACTIONS(955),
    [anon_sym_elseif] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_endswitch] = ACTIONS(955),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_default] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_clone] = ACTIONS(955),
    [anon_sym_print] = ACTIONS(955),
    [anon_sym_new] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_DASH_DASH] = ACTIONS(953),
    [sym_shell_command_expression] = ACTIONS(953),
    [anon_sym_list] = ACTIONS(955),
    [anon_sym_self] = ACTIONS(955),
    [anon_sym_parent] = ACTIONS(955),
    [sym_string] = ACTIONS(953),
    [sym_boolean] = ACTIONS(955),
    [sym_null] = ACTIONS(955),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(955),
    [anon_sym_include] = ACTIONS(955),
    [anon_sym_include_once] = ACTIONS(955),
    [anon_sym_require] = ACTIONS(955),
    [anon_sym_require_once] = ACTIONS(955),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(953),
  },
  [298] = {
    [sym_text_interpolation] = STATE(298),
    [ts_builtin_sym_end] = ACTIONS(957),
    [sym_name] = ACTIONS(959),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(959),
    [anon_sym_namespace] = ACTIONS(959),
    [anon_sym_use] = ACTIONS(959),
    [anon_sym_BSLASH] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(959),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(959),
    [anon_sym_interface] = ACTIONS(959),
    [anon_sym_class] = ACTIONS(959),
    [anon_sym_abstract] = ACTIONS(959),
    [anon_sym_final] = ACTIONS(959),
    [anon_sym_public] = ACTIONS(959),
    [anon_sym_protected] = ACTIONS(959),
    [anon_sym_private] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_array] = ACTIONS(959),
    [anon_sym_unset] = ACTIONS(959),
    [anon_sym_echo] = ACTIONS(959),
    [anon_sym_declare] = ACTIONS(959),
    [anon_sym_enddeclare] = ACTIONS(959),
    [sym_float] = ACTIONS(959),
    [anon_sym_try] = ACTIONS(959),
    [anon_sym_goto] = ACTIONS(959),
    [anon_sym_continue] = ACTIONS(959),
    [anon_sym_break] = ACTIONS(959),
    [sym_integer] = ACTIONS(959),
    [anon_sym_return] = ACTIONS(959),
    [anon_sym_throw] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_endwhile] = ACTIONS(959),
    [anon_sym_do] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_endfor] = ACTIONS(959),
    [anon_sym_foreach] = ACTIONS(959),
    [anon_sym_endforeach] = ACTIONS(959),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_endif] = ACTIONS(959),
    [anon_sym_elseif] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_endswitch] = ACTIONS(959),
    [anon_sym_case] = ACTIONS(959),
    [anon_sym_default] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_clone] = ACTIONS(959),
    [anon_sym_print] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(957),
    [anon_sym_PLUS_PLUS] = ACTIONS(957),
    [anon_sym_DASH_DASH] = ACTIONS(957),
    [sym_shell_command_expression] = ACTIONS(957),
    [anon_sym_list] = ACTIONS(959),
    [anon_sym_self] = ACTIONS(959),
    [anon_sym_parent] = ACTIONS(959),
    [sym_string] = ACTIONS(957),
    [sym_boolean] = ACTIONS(959),
    [sym_null] = ACTIONS(959),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(959),
    [anon_sym_include] = ACTIONS(959),
    [anon_sym_include_once] = ACTIONS(959),
    [anon_sym_require] = ACTIONS(959),
    [anon_sym_require_once] = ACTIONS(959),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(957),
  },
  [299] = {
    [sym_text_interpolation] = STATE(299),
    [ts_builtin_sym_end] = ACTIONS(961),
    [sym_name] = ACTIONS(963),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_static] = ACTIONS(963),
    [anon_sym_global] = ACTIONS(963),
    [anon_sym_namespace] = ACTIONS(963),
    [anon_sym_use] = ACTIONS(963),
    [anon_sym_BSLASH] = ACTIONS(961),
    [anon_sym_function] = ACTIONS(963),
    [anon_sym_const] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(961),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_trait] = ACTIONS(963),
    [anon_sym_interface] = ACTIONS(963),
    [anon_sym_class] = ACTIONS(963),
    [anon_sym_abstract] = ACTIONS(963),
    [anon_sym_final] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(963),
    [anon_sym_protected] = ACTIONS(963),
    [anon_sym_private] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_array] = ACTIONS(963),
    [anon_sym_unset] = ACTIONS(963),
    [anon_sym_echo] = ACTIONS(963),
    [anon_sym_declare] = ACTIONS(963),
    [anon_sym_enddeclare] = ACTIONS(963),
    [sym_float] = ACTIONS(963),
    [anon_sym_try] = ACTIONS(963),
    [anon_sym_goto] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [sym_integer] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_throw] = ACTIONS(963),
    [anon_sym_while] = ACTIONS(963),
    [anon_sym_endwhile] = ACTIONS(963),
    [anon_sym_do] = ACTIONS(963),
    [anon_sym_for] = ACTIONS(963),
    [anon_sym_endfor] = ACTIONS(963),
    [anon_sym_foreach] = ACTIONS(963),
    [anon_sym_endforeach] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(963),
    [anon_sym_endif] = ACTIONS(963),
    [anon_sym_elseif] = ACTIONS(963),
    [anon_sym_else] = ACTIONS(963),
    [anon_sym_switch] = ACTIONS(963),
    [anon_sym_endswitch] = ACTIONS(963),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_default] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(961),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_clone] = ACTIONS(963),
    [anon_sym_print] = ACTIONS(963),
    [anon_sym_new] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(961),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [sym_shell_command_expression] = ACTIONS(961),
    [anon_sym_list] = ACTIONS(963),
    [anon_sym_self] = ACTIONS(963),
    [anon_sym_parent] = ACTIONS(963),
    [sym_string] = ACTIONS(961),
    [sym_boolean] = ACTIONS(963),
    [sym_null] = ACTIONS(963),
    [anon_sym_DOLLAR] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(963),
    [anon_sym_include] = ACTIONS(963),
    [anon_sym_include_once] = ACTIONS(963),
    [anon_sym_require] = ACTIONS(963),
    [anon_sym_require_once] = ACTIONS(963),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(961),
  },
  [300] = {
    [sym_text_interpolation] = STATE(300),
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym_name] = ACTIONS(967),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(967),
    [anon_sym_global] = ACTIONS(967),
    [anon_sym_namespace] = ACTIONS(967),
    [anon_sym_use] = ACTIONS(967),
    [anon_sym_BSLASH] = ACTIONS(965),
    [anon_sym_function] = ACTIONS(967),
    [anon_sym_const] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_trait] = ACTIONS(967),
    [anon_sym_interface] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(967),
    [anon_sym_abstract] = ACTIONS(967),
    [anon_sym_final] = ACTIONS(967),
    [anon_sym_public] = ACTIONS(967),
    [anon_sym_protected] = ACTIONS(967),
    [anon_sym_private] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_array] = ACTIONS(967),
    [anon_sym_unset] = ACTIONS(967),
    [anon_sym_echo] = ACTIONS(967),
    [anon_sym_declare] = ACTIONS(967),
    [anon_sym_enddeclare] = ACTIONS(967),
    [sym_float] = ACTIONS(967),
    [anon_sym_try] = ACTIONS(967),
    [anon_sym_goto] = ACTIONS(967),
    [anon_sym_continue] = ACTIONS(967),
    [anon_sym_break] = ACTIONS(967),
    [sym_integer] = ACTIONS(967),
    [anon_sym_return] = ACTIONS(967),
    [anon_sym_throw] = ACTIONS(967),
    [anon_sym_while] = ACTIONS(967),
    [anon_sym_endwhile] = ACTIONS(967),
    [anon_sym_do] = ACTIONS(967),
    [anon_sym_for] = ACTIONS(967),
    [anon_sym_endfor] = ACTIONS(967),
    [anon_sym_foreach] = ACTIONS(967),
    [anon_sym_endforeach] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(967),
    [anon_sym_endif] = ACTIONS(967),
    [anon_sym_elseif] = ACTIONS(967),
    [anon_sym_else] = ACTIONS(967),
    [anon_sym_switch] = ACTIONS(967),
    [anon_sym_endswitch] = ACTIONS(967),
    [anon_sym_case] = ACTIONS(967),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_clone] = ACTIONS(967),
    [anon_sym_print] = ACTIONS(967),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(965),
    [anon_sym_DASH_DASH] = ACTIONS(965),
    [sym_shell_command_expression] = ACTIONS(965),
    [anon_sym_list] = ACTIONS(967),
    [anon_sym_self] = ACTIONS(967),
    [anon_sym_parent] = ACTIONS(967),
    [sym_string] = ACTIONS(965),
    [sym_boolean] = ACTIONS(967),
    [sym_null] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(967),
    [anon_sym_include] = ACTIONS(967),
    [anon_sym_include_once] = ACTIONS(967),
    [anon_sym_require] = ACTIONS(967),
    [anon_sym_require_once] = ACTIONS(967),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(965),
  },
  [301] = {
    [sym_text_interpolation] = STATE(301),
    [ts_builtin_sym_end] = ACTIONS(969),
    [sym_name] = ACTIONS(971),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(971),
    [anon_sym_global] = ACTIONS(971),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_use] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(971),
    [anon_sym_const] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(971),
    [anon_sym_interface] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_abstract] = ACTIONS(971),
    [anon_sym_final] = ACTIONS(971),
    [anon_sym_public] = ACTIONS(971),
    [anon_sym_protected] = ACTIONS(971),
    [anon_sym_private] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_array] = ACTIONS(971),
    [anon_sym_unset] = ACTIONS(971),
    [anon_sym_echo] = ACTIONS(971),
    [anon_sym_declare] = ACTIONS(971),
    [anon_sym_enddeclare] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [anon_sym_try] = ACTIONS(971),
    [anon_sym_goto] = ACTIONS(971),
    [anon_sym_continue] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [sym_integer] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_throw] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_endwhile] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_endfor] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(971),
    [anon_sym_endforeach] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_endif] = ACTIONS(971),
    [anon_sym_elseif] = ACTIONS(971),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_switch] = ACTIONS(971),
    [anon_sym_endswitch] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_clone] = ACTIONS(971),
    [anon_sym_print] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(969),
    [anon_sym_PLUS_PLUS] = ACTIONS(969),
    [anon_sym_DASH_DASH] = ACTIONS(969),
    [sym_shell_command_expression] = ACTIONS(969),
    [anon_sym_list] = ACTIONS(971),
    [anon_sym_self] = ACTIONS(971),
    [anon_sym_parent] = ACTIONS(971),
    [sym_string] = ACTIONS(969),
    [sym_boolean] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_include] = ACTIONS(971),
    [anon_sym_include_once] = ACTIONS(971),
    [anon_sym_require] = ACTIONS(971),
    [anon_sym_require_once] = ACTIONS(971),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(969),
  },
  [302] = {
    [sym_text_interpolation] = STATE(302),
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_name] = ACTIONS(975),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_global] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_use] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_trait] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_final] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_array] = ACTIONS(975),
    [anon_sym_unset] = ACTIONS(975),
    [anon_sym_echo] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_enddeclare] = ACTIONS(975),
    [sym_float] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_goto] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [sym_integer] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_endwhile] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_endfor] = ACTIONS(975),
    [anon_sym_foreach] = ACTIONS(975),
    [anon_sym_endforeach] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_endif] = ACTIONS(975),
    [anon_sym_elseif] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_endswitch] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_clone] = ACTIONS(975),
    [anon_sym_print] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [sym_shell_command_expression] = ACTIONS(973),
    [anon_sym_list] = ACTIONS(975),
    [anon_sym_self] = ACTIONS(975),
    [anon_sym_parent] = ACTIONS(975),
    [sym_string] = ACTIONS(973),
    [sym_boolean] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [anon_sym_DOLLAR] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_include] = ACTIONS(975),
    [anon_sym_include_once] = ACTIONS(975),
    [anon_sym_require] = ACTIONS(975),
    [anon_sym_require_once] = ACTIONS(975),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(973),
  },
  [303] = {
    [sym_text_interpolation] = STATE(303),
    [ts_builtin_sym_end] = ACTIONS(977),
    [sym_name] = ACTIONS(979),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_static] = ACTIONS(979),
    [anon_sym_global] = ACTIONS(979),
    [anon_sym_namespace] = ACTIONS(979),
    [anon_sym_use] = ACTIONS(979),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_function] = ACTIONS(979),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_trait] = ACTIONS(979),
    [anon_sym_interface] = ACTIONS(979),
    [anon_sym_class] = ACTIONS(979),
    [anon_sym_abstract] = ACTIONS(979),
    [anon_sym_final] = ACTIONS(979),
    [anon_sym_public] = ACTIONS(979),
    [anon_sym_protected] = ACTIONS(979),
    [anon_sym_private] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_array] = ACTIONS(979),
    [anon_sym_unset] = ACTIONS(979),
    [anon_sym_echo] = ACTIONS(979),
    [anon_sym_declare] = ACTIONS(979),
    [anon_sym_enddeclare] = ACTIONS(979),
    [sym_float] = ACTIONS(979),
    [anon_sym_try] = ACTIONS(979),
    [anon_sym_goto] = ACTIONS(979),
    [anon_sym_continue] = ACTIONS(979),
    [anon_sym_break] = ACTIONS(979),
    [sym_integer] = ACTIONS(979),
    [anon_sym_return] = ACTIONS(979),
    [anon_sym_throw] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_endwhile] = ACTIONS(979),
    [anon_sym_do] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_endfor] = ACTIONS(979),
    [anon_sym_foreach] = ACTIONS(979),
    [anon_sym_endforeach] = ACTIONS(979),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_endif] = ACTIONS(979),
    [anon_sym_elseif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_endswitch] = ACTIONS(979),
    [anon_sym_case] = ACTIONS(979),
    [anon_sym_default] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_clone] = ACTIONS(979),
    [anon_sym_print] = ACTIONS(979),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [sym_shell_command_expression] = ACTIONS(977),
    [anon_sym_list] = ACTIONS(979),
    [anon_sym_self] = ACTIONS(979),
    [anon_sym_parent] = ACTIONS(979),
    [sym_string] = ACTIONS(977),
    [sym_boolean] = ACTIONS(979),
    [sym_null] = ACTIONS(979),
    [anon_sym_DOLLAR] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_include] = ACTIONS(979),
    [anon_sym_include_once] = ACTIONS(979),
    [anon_sym_require] = ACTIONS(979),
    [anon_sym_require_once] = ACTIONS(979),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(977),
  },
  [304] = {
    [sym_text_interpolation] = STATE(304),
    [ts_builtin_sym_end] = ACTIONS(981),
    [sym_name] = ACTIONS(983),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_static] = ACTIONS(983),
    [anon_sym_global] = ACTIONS(983),
    [anon_sym_namespace] = ACTIONS(983),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_BSLASH] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_trait] = ACTIONS(983),
    [anon_sym_interface] = ACTIONS(983),
    [anon_sym_class] = ACTIONS(983),
    [anon_sym_abstract] = ACTIONS(983),
    [anon_sym_final] = ACTIONS(983),
    [anon_sym_public] = ACTIONS(983),
    [anon_sym_protected] = ACTIONS(983),
    [anon_sym_private] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_array] = ACTIONS(983),
    [anon_sym_unset] = ACTIONS(983),
    [anon_sym_echo] = ACTIONS(983),
    [anon_sym_declare] = ACTIONS(983),
    [anon_sym_enddeclare] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [anon_sym_try] = ACTIONS(983),
    [anon_sym_goto] = ACTIONS(983),
    [anon_sym_continue] = ACTIONS(983),
    [anon_sym_break] = ACTIONS(983),
    [sym_integer] = ACTIONS(983),
    [anon_sym_return] = ACTIONS(983),
    [anon_sym_throw] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_endwhile] = ACTIONS(983),
    [anon_sym_do] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_endfor] = ACTIONS(983),
    [anon_sym_foreach] = ACTIONS(983),
    [anon_sym_endforeach] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_endif] = ACTIONS(983),
    [anon_sym_elseif] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_endswitch] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_default] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_clone] = ACTIONS(983),
    [anon_sym_print] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [sym_shell_command_expression] = ACTIONS(981),
    [anon_sym_list] = ACTIONS(983),
    [anon_sym_self] = ACTIONS(983),
    [anon_sym_parent] = ACTIONS(983),
    [sym_string] = ACTIONS(981),
    [sym_boolean] = ACTIONS(983),
    [sym_null] = ACTIONS(983),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_include] = ACTIONS(983),
    [anon_sym_include_once] = ACTIONS(983),
    [anon_sym_require] = ACTIONS(983),
    [anon_sym_require_once] = ACTIONS(983),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(981),
  },
  [305] = {
    [sym_text_interpolation] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(985),
    [sym_name] = ACTIONS(987),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(987),
    [anon_sym_namespace] = ACTIONS(987),
    [anon_sym_use] = ACTIONS(987),
    [anon_sym_BSLASH] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_trait] = ACTIONS(987),
    [anon_sym_interface] = ACTIONS(987),
    [anon_sym_class] = ACTIONS(987),
    [anon_sym_abstract] = ACTIONS(987),
    [anon_sym_final] = ACTIONS(987),
    [anon_sym_public] = ACTIONS(987),
    [anon_sym_protected] = ACTIONS(987),
    [anon_sym_private] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_array] = ACTIONS(987),
    [anon_sym_unset] = ACTIONS(987),
    [anon_sym_echo] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(987),
    [anon_sym_enddeclare] = ACTIONS(987),
    [sym_float] = ACTIONS(987),
    [anon_sym_try] = ACTIONS(987),
    [anon_sym_goto] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(987),
    [anon_sym_break] = ACTIONS(987),
    [sym_integer] = ACTIONS(987),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_throw] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_endwhile] = ACTIONS(987),
    [anon_sym_do] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_endfor] = ACTIONS(987),
    [anon_sym_foreach] = ACTIONS(987),
    [anon_sym_endforeach] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_endif] = ACTIONS(987),
    [anon_sym_elseif] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_endswitch] = ACTIONS(987),
    [anon_sym_case] = ACTIONS(987),
    [anon_sym_default] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_clone] = ACTIONS(987),
    [anon_sym_print] = ACTIONS(987),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_DASH_DASH] = ACTIONS(985),
    [sym_shell_command_expression] = ACTIONS(985),
    [anon_sym_list] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(987),
    [anon_sym_parent] = ACTIONS(987),
    [sym_string] = ACTIONS(985),
    [sym_boolean] = ACTIONS(987),
    [sym_null] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(987),
    [anon_sym_include] = ACTIONS(987),
    [anon_sym_include_once] = ACTIONS(987),
    [anon_sym_require] = ACTIONS(987),
    [anon_sym_require_once] = ACTIONS(987),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(985),
  },
  [306] = {
    [sym_text_interpolation] = STATE(306),
    [ts_builtin_sym_end] = ACTIONS(989),
    [sym_name] = ACTIONS(991),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_global] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_use] = ACTIONS(991),
    [anon_sym_BSLASH] = ACTIONS(989),
    [anon_sym_function] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_trait] = ACTIONS(991),
    [anon_sym_interface] = ACTIONS(991),
    [anon_sym_class] = ACTIONS(991),
    [anon_sym_abstract] = ACTIONS(991),
    [anon_sym_final] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(989),
    [anon_sym_array] = ACTIONS(991),
    [anon_sym_unset] = ACTIONS(991),
    [anon_sym_echo] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_enddeclare] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [anon_sym_try] = ACTIONS(991),
    [anon_sym_goto] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [sym_integer] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_throw] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_endwhile] = ACTIONS(991),
    [anon_sym_do] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_endfor] = ACTIONS(991),
    [anon_sym_foreach] = ACTIONS(991),
    [anon_sym_endforeach] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_endif] = ACTIONS(991),
    [anon_sym_elseif] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_endswitch] = ACTIONS(991),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_default] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_clone] = ACTIONS(991),
    [anon_sym_print] = ACTIONS(991),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(989),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(989),
    [sym_shell_command_expression] = ACTIONS(989),
    [anon_sym_list] = ACTIONS(991),
    [anon_sym_self] = ACTIONS(991),
    [anon_sym_parent] = ACTIONS(991),
    [sym_string] = ACTIONS(989),
    [sym_boolean] = ACTIONS(991),
    [sym_null] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_yield] = ACTIONS(991),
    [anon_sym_include] = ACTIONS(991),
    [anon_sym_include_once] = ACTIONS(991),
    [anon_sym_require] = ACTIONS(991),
    [anon_sym_require_once] = ACTIONS(991),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(989),
  },
  [307] = {
    [sym_text_interpolation] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(989),
    [sym_name] = ACTIONS(991),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_global] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_use] = ACTIONS(991),
    [anon_sym_BSLASH] = ACTIONS(989),
    [anon_sym_function] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_trait] = ACTIONS(991),
    [anon_sym_interface] = ACTIONS(991),
    [anon_sym_class] = ACTIONS(991),
    [anon_sym_abstract] = ACTIONS(991),
    [anon_sym_final] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(989),
    [anon_sym_array] = ACTIONS(991),
    [anon_sym_unset] = ACTIONS(991),
    [anon_sym_echo] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_enddeclare] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [anon_sym_try] = ACTIONS(991),
    [anon_sym_goto] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [sym_integer] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_throw] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_endwhile] = ACTIONS(991),
    [anon_sym_do] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_endfor] = ACTIONS(991),
    [anon_sym_foreach] = ACTIONS(991),
    [anon_sym_endforeach] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_endif] = ACTIONS(991),
    [anon_sym_elseif] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_endswitch] = ACTIONS(991),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_default] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_clone] = ACTIONS(991),
    [anon_sym_print] = ACTIONS(991),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(989),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(989),
    [sym_shell_command_expression] = ACTIONS(989),
    [anon_sym_list] = ACTIONS(991),
    [anon_sym_self] = ACTIONS(991),
    [anon_sym_parent] = ACTIONS(991),
    [sym_string] = ACTIONS(989),
    [sym_boolean] = ACTIONS(991),
    [sym_null] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_yield] = ACTIONS(991),
    [anon_sym_include] = ACTIONS(991),
    [anon_sym_include_once] = ACTIONS(991),
    [anon_sym_require] = ACTIONS(991),
    [anon_sym_require_once] = ACTIONS(991),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(989),
  },
  [308] = {
    [sym_text_interpolation] = STATE(308),
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_name] = ACTIONS(995),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_global] = ACTIONS(995),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_use] = ACTIONS(995),
    [anon_sym_BSLASH] = ACTIONS(993),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_trait] = ACTIONS(995),
    [anon_sym_interface] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_abstract] = ACTIONS(995),
    [anon_sym_final] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_array] = ACTIONS(995),
    [anon_sym_unset] = ACTIONS(995),
    [anon_sym_echo] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_enddeclare] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [anon_sym_goto] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [sym_integer] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_throw] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_endwhile] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_endfor] = ACTIONS(995),
    [anon_sym_foreach] = ACTIONS(995),
    [anon_sym_endforeach] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_endif] = ACTIONS(995),
    [anon_sym_elseif] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_endswitch] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_clone] = ACTIONS(995),
    [anon_sym_print] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [sym_shell_command_expression] = ACTIONS(993),
    [anon_sym_list] = ACTIONS(995),
    [anon_sym_self] = ACTIONS(995),
    [anon_sym_parent] = ACTIONS(995),
    [sym_string] = ACTIONS(993),
    [sym_boolean] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_include] = ACTIONS(995),
    [anon_sym_include_once] = ACTIONS(995),
    [anon_sym_require] = ACTIONS(995),
    [anon_sym_require_once] = ACTIONS(995),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(993),
  },
  [309] = {
    [sym_text_interpolation] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_name] = ACTIONS(999),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(999),
    [anon_sym_global] = ACTIONS(999),
    [anon_sym_namespace] = ACTIONS(999),
    [anon_sym_use] = ACTIONS(999),
    [anon_sym_BSLASH] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(999),
    [anon_sym_const] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_trait] = ACTIONS(999),
    [anon_sym_interface] = ACTIONS(999),
    [anon_sym_class] = ACTIONS(999),
    [anon_sym_abstract] = ACTIONS(999),
    [anon_sym_final] = ACTIONS(999),
    [anon_sym_public] = ACTIONS(999),
    [anon_sym_protected] = ACTIONS(999),
    [anon_sym_private] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_array] = ACTIONS(999),
    [anon_sym_unset] = ACTIONS(999),
    [anon_sym_echo] = ACTIONS(999),
    [anon_sym_declare] = ACTIONS(999),
    [anon_sym_enddeclare] = ACTIONS(999),
    [sym_float] = ACTIONS(999),
    [anon_sym_try] = ACTIONS(999),
    [anon_sym_goto] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [sym_integer] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_throw] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_endwhile] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_endfor] = ACTIONS(999),
    [anon_sym_foreach] = ACTIONS(999),
    [anon_sym_endforeach] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_endif] = ACTIONS(999),
    [anon_sym_elseif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_switch] = ACTIONS(999),
    [anon_sym_endswitch] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_clone] = ACTIONS(999),
    [anon_sym_print] = ACTIONS(999),
    [anon_sym_new] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(997),
    [sym_shell_command_expression] = ACTIONS(997),
    [anon_sym_list] = ACTIONS(999),
    [anon_sym_self] = ACTIONS(999),
    [anon_sym_parent] = ACTIONS(999),
    [sym_string] = ACTIONS(997),
    [sym_boolean] = ACTIONS(999),
    [sym_null] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(999),
    [anon_sym_include] = ACTIONS(999),
    [anon_sym_include_once] = ACTIONS(999),
    [anon_sym_require] = ACTIONS(999),
    [anon_sym_require_once] = ACTIONS(999),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(997),
  },
  [310] = {
    [sym_text_interpolation] = STATE(310),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_name] = ACTIONS(999),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(999),
    [anon_sym_global] = ACTIONS(999),
    [anon_sym_namespace] = ACTIONS(999),
    [anon_sym_use] = ACTIONS(999),
    [anon_sym_BSLASH] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(999),
    [anon_sym_const] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_trait] = ACTIONS(999),
    [anon_sym_interface] = ACTIONS(999),
    [anon_sym_class] = ACTIONS(999),
    [anon_sym_abstract] = ACTIONS(999),
    [anon_sym_final] = ACTIONS(999),
    [anon_sym_public] = ACTIONS(999),
    [anon_sym_protected] = ACTIONS(999),
    [anon_sym_private] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_array] = ACTIONS(999),
    [anon_sym_unset] = ACTIONS(999),
    [anon_sym_echo] = ACTIONS(999),
    [anon_sym_declare] = ACTIONS(999),
    [anon_sym_enddeclare] = ACTIONS(999),
    [sym_float] = ACTIONS(999),
    [anon_sym_try] = ACTIONS(999),
    [anon_sym_goto] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [sym_integer] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_throw] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_endwhile] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_endfor] = ACTIONS(999),
    [anon_sym_foreach] = ACTIONS(999),
    [anon_sym_endforeach] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_endif] = ACTIONS(999),
    [anon_sym_elseif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_switch] = ACTIONS(999),
    [anon_sym_endswitch] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_clone] = ACTIONS(999),
    [anon_sym_print] = ACTIONS(999),
    [anon_sym_new] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(997),
    [sym_shell_command_expression] = ACTIONS(997),
    [anon_sym_list] = ACTIONS(999),
    [anon_sym_self] = ACTIONS(999),
    [anon_sym_parent] = ACTIONS(999),
    [sym_string] = ACTIONS(997),
    [sym_boolean] = ACTIONS(999),
    [sym_null] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(999),
    [anon_sym_include] = ACTIONS(999),
    [anon_sym_include_once] = ACTIONS(999),
    [anon_sym_require] = ACTIONS(999),
    [anon_sym_require_once] = ACTIONS(999),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(997),
  },
  [311] = {
    [sym_text_interpolation] = STATE(311),
    [ts_builtin_sym_end] = ACTIONS(1001),
    [sym_name] = ACTIONS(1003),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1003),
    [anon_sym_use] = ACTIONS(1003),
    [anon_sym_BSLASH] = ACTIONS(1001),
    [anon_sym_function] = ACTIONS(1003),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_trait] = ACTIONS(1003),
    [anon_sym_interface] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_abstract] = ACTIONS(1003),
    [anon_sym_final] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_array] = ACTIONS(1003),
    [anon_sym_unset] = ACTIONS(1003),
    [anon_sym_echo] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_enddeclare] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [anon_sym_try] = ACTIONS(1003),
    [anon_sym_goto] = ACTIONS(1003),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_endwhile] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_endfor] = ACTIONS(1003),
    [anon_sym_foreach] = ACTIONS(1003),
    [anon_sym_endforeach] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_endif] = ACTIONS(1003),
    [anon_sym_elseif] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_endswitch] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_clone] = ACTIONS(1003),
    [anon_sym_print] = ACTIONS(1003),
    [anon_sym_new] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1001),
    [anon_sym_DASH_DASH] = ACTIONS(1001),
    [sym_shell_command_expression] = ACTIONS(1001),
    [anon_sym_list] = ACTIONS(1003),
    [anon_sym_self] = ACTIONS(1003),
    [anon_sym_parent] = ACTIONS(1003),
    [sym_string] = ACTIONS(1001),
    [sym_boolean] = ACTIONS(1003),
    [sym_null] = ACTIONS(1003),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_include] = ACTIONS(1003),
    [anon_sym_include_once] = ACTIONS(1003),
    [anon_sym_require] = ACTIONS(1003),
    [anon_sym_require_once] = ACTIONS(1003),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1001),
  },
  [312] = {
    [sym_text_interpolation] = STATE(312),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_name] = ACTIONS(1007),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_global] = ACTIONS(1007),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_use] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_trait] = ACTIONS(1007),
    [anon_sym_interface] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_abstract] = ACTIONS(1007),
    [anon_sym_final] = ACTIONS(1007),
    [anon_sym_public] = ACTIONS(1007),
    [anon_sym_protected] = ACTIONS(1007),
    [anon_sym_private] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_array] = ACTIONS(1007),
    [anon_sym_unset] = ACTIONS(1007),
    [anon_sym_echo] = ACTIONS(1007),
    [anon_sym_declare] = ACTIONS(1007),
    [anon_sym_enddeclare] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [anon_sym_try] = ACTIONS(1007),
    [anon_sym_goto] = ACTIONS(1007),
    [anon_sym_continue] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_throw] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_endwhile] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_endfor] = ACTIONS(1007),
    [anon_sym_foreach] = ACTIONS(1007),
    [anon_sym_endforeach] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_endif] = ACTIONS(1007),
    [anon_sym_elseif] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1007),
    [anon_sym_endswitch] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_default] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1005),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_clone] = ACTIONS(1007),
    [anon_sym_print] = ACTIONS(1007),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_PLUS_PLUS] = ACTIONS(1005),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [sym_shell_command_expression] = ACTIONS(1005),
    [anon_sym_list] = ACTIONS(1007),
    [anon_sym_self] = ACTIONS(1007),
    [anon_sym_parent] = ACTIONS(1007),
    [sym_string] = ACTIONS(1005),
    [sym_boolean] = ACTIONS(1007),
    [sym_null] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_include] = ACTIONS(1007),
    [anon_sym_include_once] = ACTIONS(1007),
    [anon_sym_require] = ACTIONS(1007),
    [anon_sym_require_once] = ACTIONS(1007),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1005),
  },
  [313] = {
    [sym_text_interpolation] = STATE(313),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_name] = ACTIONS(1011),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1011),
    [anon_sym_use] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_trait] = ACTIONS(1011),
    [anon_sym_interface] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_abstract] = ACTIONS(1011),
    [anon_sym_final] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1009),
    [anon_sym_array] = ACTIONS(1011),
    [anon_sym_unset] = ACTIONS(1011),
    [anon_sym_echo] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_enddeclare] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1011),
    [anon_sym_goto] = ACTIONS(1011),
    [anon_sym_continue] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_endwhile] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_endfor] = ACTIONS(1011),
    [anon_sym_foreach] = ACTIONS(1011),
    [anon_sym_endforeach] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_endif] = ACTIONS(1011),
    [anon_sym_elseif] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_switch] = ACTIONS(1011),
    [anon_sym_endswitch] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_default] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_clone] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1011),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1009),
    [sym_shell_command_expression] = ACTIONS(1009),
    [anon_sym_list] = ACTIONS(1011),
    [anon_sym_self] = ACTIONS(1011),
    [anon_sym_parent] = ACTIONS(1011),
    [sym_string] = ACTIONS(1009),
    [sym_boolean] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_include] = ACTIONS(1011),
    [anon_sym_include_once] = ACTIONS(1011),
    [anon_sym_require] = ACTIONS(1011),
    [anon_sym_require_once] = ACTIONS(1011),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1009),
  },
  [314] = {
    [sym_text_interpolation] = STATE(314),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [sym_name] = ACTIONS(1015),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_static] = ACTIONS(1015),
    [anon_sym_global] = ACTIONS(1015),
    [anon_sym_namespace] = ACTIONS(1015),
    [anon_sym_use] = ACTIONS(1015),
    [anon_sym_BSLASH] = ACTIONS(1013),
    [anon_sym_function] = ACTIONS(1015),
    [anon_sym_const] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_trait] = ACTIONS(1015),
    [anon_sym_interface] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(1015),
    [anon_sym_abstract] = ACTIONS(1015),
    [anon_sym_final] = ACTIONS(1015),
    [anon_sym_public] = ACTIONS(1015),
    [anon_sym_protected] = ACTIONS(1015),
    [anon_sym_private] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_array] = ACTIONS(1015),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_echo] = ACTIONS(1015),
    [anon_sym_declare] = ACTIONS(1015),
    [anon_sym_enddeclare] = ACTIONS(1015),
    [sym_float] = ACTIONS(1015),
    [anon_sym_try] = ACTIONS(1015),
    [anon_sym_goto] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1015),
    [anon_sym_break] = ACTIONS(1015),
    [sym_integer] = ACTIONS(1015),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_throw] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1015),
    [anon_sym_endwhile] = ACTIONS(1015),
    [anon_sym_do] = ACTIONS(1015),
    [anon_sym_for] = ACTIONS(1015),
    [anon_sym_endfor] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1015),
    [anon_sym_endforeach] = ACTIONS(1015),
    [anon_sym_if] = ACTIONS(1015),
    [anon_sym_endif] = ACTIONS(1015),
    [anon_sym_elseif] = ACTIONS(1015),
    [anon_sym_else] = ACTIONS(1015),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_endswitch] = ACTIONS(1015),
    [anon_sym_case] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_clone] = ACTIONS(1015),
    [anon_sym_print] = ACTIONS(1015),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [sym_shell_command_expression] = ACTIONS(1013),
    [anon_sym_list] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1015),
    [anon_sym_parent] = ACTIONS(1015),
    [sym_string] = ACTIONS(1013),
    [sym_boolean] = ACTIONS(1015),
    [sym_null] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1013),
    [anon_sym_yield] = ACTIONS(1015),
    [anon_sym_include] = ACTIONS(1015),
    [anon_sym_include_once] = ACTIONS(1015),
    [anon_sym_require] = ACTIONS(1015),
    [anon_sym_require_once] = ACTIONS(1015),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1013),
  },
  [315] = {
    [sym_text_interpolation] = STATE(315),
    [ts_builtin_sym_end] = ACTIONS(1017),
    [sym_name] = ACTIONS(1019),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym_static] = ACTIONS(1019),
    [anon_sym_global] = ACTIONS(1019),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_use] = ACTIONS(1019),
    [anon_sym_BSLASH] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_const] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_trait] = ACTIONS(1019),
    [anon_sym_interface] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_final] = ACTIONS(1019),
    [anon_sym_public] = ACTIONS(1019),
    [anon_sym_protected] = ACTIONS(1019),
    [anon_sym_private] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_array] = ACTIONS(1019),
    [anon_sym_unset] = ACTIONS(1019),
    [anon_sym_echo] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1019),
    [anon_sym_enddeclare] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_throw] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_endwhile] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_endfor] = ACTIONS(1019),
    [anon_sym_foreach] = ACTIONS(1019),
    [anon_sym_endforeach] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_endif] = ACTIONS(1019),
    [anon_sym_elseif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_switch] = ACTIONS(1019),
    [anon_sym_endswitch] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_default] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_clone] = ACTIONS(1019),
    [anon_sym_print] = ACTIONS(1019),
    [anon_sym_new] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1017),
    [anon_sym_PLUS_PLUS] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1017),
    [sym_shell_command_expression] = ACTIONS(1017),
    [anon_sym_list] = ACTIONS(1019),
    [anon_sym_self] = ACTIONS(1019),
    [anon_sym_parent] = ACTIONS(1019),
    [sym_string] = ACTIONS(1017),
    [sym_boolean] = ACTIONS(1019),
    [sym_null] = ACTIONS(1019),
    [anon_sym_DOLLAR] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_include] = ACTIONS(1019),
    [anon_sym_include_once] = ACTIONS(1019),
    [anon_sym_require] = ACTIONS(1019),
    [anon_sym_require_once] = ACTIONS(1019),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1017),
  },
  [316] = {
    [sym_text_interpolation] = STATE(316),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [sym_name] = ACTIONS(1023),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_static] = ACTIONS(1023),
    [anon_sym_global] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(1023),
    [anon_sym_use] = ACTIONS(1023),
    [anon_sym_BSLASH] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1023),
    [anon_sym_const] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_trait] = ACTIONS(1023),
    [anon_sym_interface] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_abstract] = ACTIONS(1023),
    [anon_sym_final] = ACTIONS(1023),
    [anon_sym_public] = ACTIONS(1023),
    [anon_sym_protected] = ACTIONS(1023),
    [anon_sym_private] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1021),
    [anon_sym_array] = ACTIONS(1023),
    [anon_sym_unset] = ACTIONS(1023),
    [anon_sym_echo] = ACTIONS(1023),
    [anon_sym_declare] = ACTIONS(1023),
    [anon_sym_enddeclare] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [anon_sym_try] = ACTIONS(1023),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_continue] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_throw] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_endwhile] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_endfor] = ACTIONS(1023),
    [anon_sym_foreach] = ACTIONS(1023),
    [anon_sym_endforeach] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_endif] = ACTIONS(1023),
    [anon_sym_elseif] = ACTIONS(1023),
    [anon_sym_else] = ACTIONS(1023),
    [anon_sym_switch] = ACTIONS(1023),
    [anon_sym_endswitch] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_default] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_clone] = ACTIONS(1023),
    [anon_sym_print] = ACTIONS(1023),
    [anon_sym_new] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1021),
    [anon_sym_DASH_DASH] = ACTIONS(1021),
    [sym_shell_command_expression] = ACTIONS(1021),
    [anon_sym_list] = ACTIONS(1023),
    [anon_sym_self] = ACTIONS(1023),
    [anon_sym_parent] = ACTIONS(1023),
    [sym_string] = ACTIONS(1021),
    [sym_boolean] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_include] = ACTIONS(1023),
    [anon_sym_include_once] = ACTIONS(1023),
    [anon_sym_require] = ACTIONS(1023),
    [anon_sym_require_once] = ACTIONS(1023),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1021),
  },
  [317] = {
    [sym_text_interpolation] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [sym_name] = ACTIONS(1027),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_global] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1027),
    [anon_sym_use] = ACTIONS(1027),
    [anon_sym_BSLASH] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_trait] = ACTIONS(1027),
    [anon_sym_interface] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(1027),
    [anon_sym_final] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_array] = ACTIONS(1027),
    [anon_sym_unset] = ACTIONS(1027),
    [anon_sym_echo] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_enddeclare] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1027),
    [anon_sym_goto] = ACTIONS(1027),
    [anon_sym_continue] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_throw] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_endwhile] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_endfor] = ACTIONS(1027),
    [anon_sym_foreach] = ACTIONS(1027),
    [anon_sym_endforeach] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_endif] = ACTIONS(1027),
    [anon_sym_elseif] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1027),
    [anon_sym_switch] = ACTIONS(1027),
    [anon_sym_endswitch] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_default] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_clone] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1027),
    [anon_sym_new] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [sym_shell_command_expression] = ACTIONS(1025),
    [anon_sym_list] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1027),
    [anon_sym_parent] = ACTIONS(1027),
    [sym_string] = ACTIONS(1025),
    [sym_boolean] = ACTIONS(1027),
    [sym_null] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_include] = ACTIONS(1027),
    [anon_sym_include_once] = ACTIONS(1027),
    [anon_sym_require] = ACTIONS(1027),
    [anon_sym_require_once] = ACTIONS(1027),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1025),
  },
  [318] = {
    [sym_text_interpolation] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [sym_name] = ACTIONS(1027),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_global] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1027),
    [anon_sym_use] = ACTIONS(1027),
    [anon_sym_BSLASH] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_trait] = ACTIONS(1027),
    [anon_sym_interface] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(1027),
    [anon_sym_final] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_array] = ACTIONS(1027),
    [anon_sym_unset] = ACTIONS(1027),
    [anon_sym_echo] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_enddeclare] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1027),
    [anon_sym_goto] = ACTIONS(1027),
    [anon_sym_continue] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_throw] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_endwhile] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_endfor] = ACTIONS(1027),
    [anon_sym_foreach] = ACTIONS(1027),
    [anon_sym_endforeach] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_endif] = ACTIONS(1027),
    [anon_sym_elseif] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1027),
    [anon_sym_switch] = ACTIONS(1027),
    [anon_sym_endswitch] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_default] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_clone] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1027),
    [anon_sym_new] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [sym_shell_command_expression] = ACTIONS(1025),
    [anon_sym_list] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1027),
    [anon_sym_parent] = ACTIONS(1027),
    [sym_string] = ACTIONS(1025),
    [sym_boolean] = ACTIONS(1027),
    [sym_null] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_include] = ACTIONS(1027),
    [anon_sym_include_once] = ACTIONS(1027),
    [anon_sym_require] = ACTIONS(1027),
    [anon_sym_require_once] = ACTIONS(1027),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1025),
  },
  [319] = {
    [sym_text_interpolation] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_name] = ACTIONS(1031),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1031),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_use] = ACTIONS(1031),
    [anon_sym_BSLASH] = ACTIONS(1029),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_trait] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_final] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_array] = ACTIONS(1031),
    [anon_sym_unset] = ACTIONS(1031),
    [anon_sym_echo] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_enddeclare] = ACTIONS(1031),
    [sym_float] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_goto] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_endwhile] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_endfor] = ACTIONS(1031),
    [anon_sym_foreach] = ACTIONS(1031),
    [anon_sym_endforeach] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_endif] = ACTIONS(1031),
    [anon_sym_elseif] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_endswitch] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_clone] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [sym_shell_command_expression] = ACTIONS(1029),
    [anon_sym_list] = ACTIONS(1031),
    [anon_sym_self] = ACTIONS(1031),
    [anon_sym_parent] = ACTIONS(1031),
    [sym_string] = ACTIONS(1029),
    [sym_boolean] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_include] = ACTIONS(1031),
    [anon_sym_include_once] = ACTIONS(1031),
    [anon_sym_require] = ACTIONS(1031),
    [anon_sym_require_once] = ACTIONS(1031),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1029),
  },
  [320] = {
    [sym_text_interpolation] = STATE(320),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_name] = ACTIONS(1035),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1035),
    [anon_sym_global] = ACTIONS(1035),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1035),
    [anon_sym_BSLASH] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_const] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_trait] = ACTIONS(1035),
    [anon_sym_interface] = ACTIONS(1035),
    [anon_sym_class] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(1035),
    [anon_sym_final] = ACTIONS(1035),
    [anon_sym_public] = ACTIONS(1035),
    [anon_sym_protected] = ACTIONS(1035),
    [anon_sym_private] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_array] = ACTIONS(1035),
    [anon_sym_unset] = ACTIONS(1035),
    [anon_sym_echo] = ACTIONS(1035),
    [anon_sym_declare] = ACTIONS(1035),
    [anon_sym_enddeclare] = ACTIONS(1035),
    [sym_float] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_goto] = ACTIONS(1035),
    [anon_sym_continue] = ACTIONS(1035),
    [anon_sym_break] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1035),
    [anon_sym_return] = ACTIONS(1035),
    [anon_sym_throw] = ACTIONS(1035),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_endwhile] = ACTIONS(1035),
    [anon_sym_do] = ACTIONS(1035),
    [anon_sym_for] = ACTIONS(1035),
    [anon_sym_endfor] = ACTIONS(1035),
    [anon_sym_foreach] = ACTIONS(1035),
    [anon_sym_endforeach] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_endif] = ACTIONS(1035),
    [anon_sym_elseif] = ACTIONS(1035),
    [anon_sym_else] = ACTIONS(1035),
    [anon_sym_switch] = ACTIONS(1035),
    [anon_sym_endswitch] = ACTIONS(1035),
    [anon_sym_case] = ACTIONS(1035),
    [anon_sym_default] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_clone] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1035),
    [anon_sym_new] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [sym_shell_command_expression] = ACTIONS(1033),
    [anon_sym_list] = ACTIONS(1035),
    [anon_sym_self] = ACTIONS(1035),
    [anon_sym_parent] = ACTIONS(1035),
    [sym_string] = ACTIONS(1033),
    [sym_boolean] = ACTIONS(1035),
    [sym_null] = ACTIONS(1035),
    [anon_sym_DOLLAR] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1035),
    [anon_sym_include] = ACTIONS(1035),
    [anon_sym_include_once] = ACTIONS(1035),
    [anon_sym_require] = ACTIONS(1035),
    [anon_sym_require_once] = ACTIONS(1035),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1033),
  },
  [321] = {
    [sym_text_interpolation] = STATE(321),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_name] = ACTIONS(1039),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_use] = ACTIONS(1039),
    [anon_sym_BSLASH] = ACTIONS(1037),
    [anon_sym_function] = ACTIONS(1039),
    [anon_sym_const] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_trait] = ACTIONS(1039),
    [anon_sym_interface] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_abstract] = ACTIONS(1039),
    [anon_sym_final] = ACTIONS(1039),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_array] = ACTIONS(1039),
    [anon_sym_unset] = ACTIONS(1039),
    [anon_sym_echo] = ACTIONS(1039),
    [anon_sym_declare] = ACTIONS(1039),
    [anon_sym_enddeclare] = ACTIONS(1039),
    [sym_float] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [sym_integer] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_throw] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_endwhile] = ACTIONS(1039),
    [anon_sym_do] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_endfor] = ACTIONS(1039),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_endforeach] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_endif] = ACTIONS(1039),
    [anon_sym_elseif] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1039),
    [anon_sym_endswitch] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1037),
    [anon_sym_PLUS] = ACTIONS(1039),
    [anon_sym_DASH] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(1037),
    [anon_sym_clone] = ACTIONS(1039),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_new] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1037),
    [sym_shell_command_expression] = ACTIONS(1037),
    [anon_sym_list] = ACTIONS(1039),
    [anon_sym_self] = ACTIONS(1039),
    [anon_sym_parent] = ACTIONS(1039),
    [sym_string] = ACTIONS(1037),
    [sym_boolean] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [anon_sym_DOLLAR] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_include] = ACTIONS(1039),
    [anon_sym_include_once] = ACTIONS(1039),
    [anon_sym_require] = ACTIONS(1039),
    [anon_sym_require_once] = ACTIONS(1039),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1037),
  },
  [322] = {
    [sym_text_interpolation] = STATE(322),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_name] = ACTIONS(1031),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1031),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_use] = ACTIONS(1031),
    [anon_sym_BSLASH] = ACTIONS(1029),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_trait] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_final] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_array] = ACTIONS(1031),
    [anon_sym_unset] = ACTIONS(1031),
    [anon_sym_echo] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_enddeclare] = ACTIONS(1031),
    [sym_float] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_goto] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_endwhile] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_endfor] = ACTIONS(1031),
    [anon_sym_foreach] = ACTIONS(1031),
    [anon_sym_endforeach] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_endif] = ACTIONS(1031),
    [anon_sym_elseif] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_endswitch] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_clone] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [sym_shell_command_expression] = ACTIONS(1029),
    [anon_sym_list] = ACTIONS(1031),
    [anon_sym_self] = ACTIONS(1031),
    [anon_sym_parent] = ACTIONS(1031),
    [sym_string] = ACTIONS(1029),
    [sym_boolean] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_include] = ACTIONS(1031),
    [anon_sym_include_once] = ACTIONS(1031),
    [anon_sym_require] = ACTIONS(1031),
    [anon_sym_require_once] = ACTIONS(1031),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1029),
  },
  [323] = {
    [sym_text_interpolation] = STATE(323),
    [ts_builtin_sym_end] = ACTIONS(1041),
    [sym_name] = ACTIONS(1043),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1043),
    [anon_sym_global] = ACTIONS(1043),
    [anon_sym_namespace] = ACTIONS(1043),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_BSLASH] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_trait] = ACTIONS(1043),
    [anon_sym_interface] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1043),
    [anon_sym_abstract] = ACTIONS(1043),
    [anon_sym_final] = ACTIONS(1043),
    [anon_sym_public] = ACTIONS(1043),
    [anon_sym_protected] = ACTIONS(1043),
    [anon_sym_private] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_array] = ACTIONS(1043),
    [anon_sym_unset] = ACTIONS(1043),
    [anon_sym_echo] = ACTIONS(1043),
    [anon_sym_declare] = ACTIONS(1043),
    [anon_sym_enddeclare] = ACTIONS(1043),
    [sym_float] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_goto] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [sym_integer] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_throw] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_endwhile] = ACTIONS(1043),
    [anon_sym_do] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_endfor] = ACTIONS(1043),
    [anon_sym_foreach] = ACTIONS(1043),
    [anon_sym_endforeach] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_endif] = ACTIONS(1043),
    [anon_sym_elseif] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_endswitch] = ACTIONS(1043),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_clone] = ACTIONS(1043),
    [anon_sym_print] = ACTIONS(1043),
    [anon_sym_new] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1041),
    [anon_sym_DASH_DASH] = ACTIONS(1041),
    [sym_shell_command_expression] = ACTIONS(1041),
    [anon_sym_list] = ACTIONS(1043),
    [anon_sym_self] = ACTIONS(1043),
    [anon_sym_parent] = ACTIONS(1043),
    [sym_string] = ACTIONS(1041),
    [sym_boolean] = ACTIONS(1043),
    [sym_null] = ACTIONS(1043),
    [anon_sym_DOLLAR] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1043),
    [anon_sym_include] = ACTIONS(1043),
    [anon_sym_include_once] = ACTIONS(1043),
    [anon_sym_require] = ACTIONS(1043),
    [anon_sym_require_once] = ACTIONS(1043),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1041),
  },
  [324] = {
    [sym_text_interpolation] = STATE(324),
    [ts_builtin_sym_end] = ACTIONS(1045),
    [sym_name] = ACTIONS(1047),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(1047),
    [anon_sym_BSLASH] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_trait] = ACTIONS(1047),
    [anon_sym_interface] = ACTIONS(1047),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_abstract] = ACTIONS(1047),
    [anon_sym_final] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [anon_sym_array] = ACTIONS(1047),
    [anon_sym_unset] = ACTIONS(1047),
    [anon_sym_echo] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_enddeclare] = ACTIONS(1047),
    [sym_float] = ACTIONS(1047),
    [anon_sym_try] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [sym_integer] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_throw] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_endwhile] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_endfor] = ACTIONS(1047),
    [anon_sym_foreach] = ACTIONS(1047),
    [anon_sym_endforeach] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_endif] = ACTIONS(1047),
    [anon_sym_elseif] = ACTIONS(1047),
    [anon_sym_else] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_endswitch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_AT] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_clone] = ACTIONS(1047),
    [anon_sym_print] = ACTIONS(1047),
    [anon_sym_new] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [sym_shell_command_expression] = ACTIONS(1045),
    [anon_sym_list] = ACTIONS(1047),
    [anon_sym_self] = ACTIONS(1047),
    [anon_sym_parent] = ACTIONS(1047),
    [sym_string] = ACTIONS(1045),
    [sym_boolean] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [anon_sym_DOLLAR] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_include] = ACTIONS(1047),
    [anon_sym_include_once] = ACTIONS(1047),
    [anon_sym_require] = ACTIONS(1047),
    [anon_sym_require_once] = ACTIONS(1047),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1045),
  },
  [325] = {
    [sym_text_interpolation] = STATE(325),
    [ts_builtin_sym_end] = ACTIONS(1041),
    [sym_name] = ACTIONS(1043),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1043),
    [anon_sym_global] = ACTIONS(1043),
    [anon_sym_namespace] = ACTIONS(1043),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_BSLASH] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_trait] = ACTIONS(1043),
    [anon_sym_interface] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1043),
    [anon_sym_abstract] = ACTIONS(1043),
    [anon_sym_final] = ACTIONS(1043),
    [anon_sym_public] = ACTIONS(1043),
    [anon_sym_protected] = ACTIONS(1043),
    [anon_sym_private] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_array] = ACTIONS(1043),
    [anon_sym_unset] = ACTIONS(1043),
    [anon_sym_echo] = ACTIONS(1043),
    [anon_sym_declare] = ACTIONS(1043),
    [anon_sym_enddeclare] = ACTIONS(1043),
    [sym_float] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_goto] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [sym_integer] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_throw] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_endwhile] = ACTIONS(1043),
    [anon_sym_do] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_endfor] = ACTIONS(1043),
    [anon_sym_foreach] = ACTIONS(1043),
    [anon_sym_endforeach] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_endif] = ACTIONS(1043),
    [anon_sym_elseif] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_endswitch] = ACTIONS(1043),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_clone] = ACTIONS(1043),
    [anon_sym_print] = ACTIONS(1043),
    [anon_sym_new] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1041),
    [anon_sym_DASH_DASH] = ACTIONS(1041),
    [sym_shell_command_expression] = ACTIONS(1041),
    [anon_sym_list] = ACTIONS(1043),
    [anon_sym_self] = ACTIONS(1043),
    [anon_sym_parent] = ACTIONS(1043),
    [sym_string] = ACTIONS(1041),
    [sym_boolean] = ACTIONS(1043),
    [sym_null] = ACTIONS(1043),
    [anon_sym_DOLLAR] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1043),
    [anon_sym_include] = ACTIONS(1043),
    [anon_sym_include_once] = ACTIONS(1043),
    [anon_sym_require] = ACTIONS(1043),
    [anon_sym_require_once] = ACTIONS(1043),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1041),
  },
  [326] = {
    [sym_text_interpolation] = STATE(326),
    [sym_name] = ACTIONS(1049),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1049),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_namespace] = ACTIONS(1049),
    [anon_sym_use] = ACTIONS(1049),
    [anon_sym_BSLASH] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1049),
    [anon_sym_const] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_trait] = ACTIONS(1049),
    [anon_sym_interface] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_abstract] = ACTIONS(1049),
    [anon_sym_final] = ACTIONS(1049),
    [anon_sym_public] = ACTIONS(1049),
    [anon_sym_protected] = ACTIONS(1049),
    [anon_sym_private] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_array] = ACTIONS(1049),
    [anon_sym_unset] = ACTIONS(1049),
    [anon_sym_COLON] = ACTIONS(1051),
    [anon_sym_echo] = ACTIONS(1049),
    [anon_sym_declare] = ACTIONS(1049),
    [sym_float] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_goto] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_break] = ACTIONS(1049),
    [sym_integer] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_throw] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_do] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_foreach] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_clone] = ACTIONS(1049),
    [anon_sym_print] = ACTIONS(1049),
    [anon_sym_new] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [sym_shell_command_expression] = ACTIONS(1051),
    [anon_sym_list] = ACTIONS(1049),
    [anon_sym_self] = ACTIONS(1049),
    [anon_sym_parent] = ACTIONS(1049),
    [sym_string] = ACTIONS(1051),
    [sym_boolean] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_include] = ACTIONS(1049),
    [anon_sym_include_once] = ACTIONS(1049),
    [anon_sym_require] = ACTIONS(1049),
    [anon_sym_require_once] = ACTIONS(1049),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1051),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(327), 1,
      sym_text_interpolation,
    ACTIONS(1055), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1053), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [74] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(328), 1,
      sym_text_interpolation,
    ACTIONS(1059), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1057), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [148] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(329), 1,
      sym_text_interpolation,
    ACTIONS(1063), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1061), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [222] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(330), 1,
      sym_text_interpolation,
    STATE(341), 1,
      sym_arguments,
    ACTIONS(1067), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1065), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [299] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    STATE(331), 1,
      sym_text_interpolation,
    STATE(338), 1,
      sym_arguments,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1081), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [384] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(332), 1,
      sym_text_interpolation,
    STATE(345), 1,
      sym_arguments,
    ACTIONS(1085), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1083), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [461] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(333), 1,
      sym_text_interpolation,
    STATE(336), 1,
      sym_arguments,
    ACTIONS(1089), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1087), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [538] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    STATE(334), 1,
      sym_text_interpolation,
    STATE(338), 1,
      sym_arguments,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [623] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(492), 1,
      anon_sym_AT,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 1,
      sym_shell_command_expression,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    STATE(335), 1,
      sym_text_interpolation,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(430), 1,
      sym_class_constant_access_expression,
    STATE(432), 1,
      sym_qualified_name,
    STATE(506), 1,
      sym__unary_expression,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(942), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    STATE(1367), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(496), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(506), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(510), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(495), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(350), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(396), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(493), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(535), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(331), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [761] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(336), 1,
      sym_text_interpolation,
    ACTIONS(1097), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1095), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [833] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(337), 1,
      sym_text_interpolation,
    ACTIONS(1101), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [905] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(338), 1,
      sym_text_interpolation,
    ACTIONS(1105), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1103), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [977] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(339), 1,
      sym_text_interpolation,
    ACTIONS(1109), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1107), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1049] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(340), 1,
      sym_text_interpolation,
    ACTIONS(1113), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1111), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1121] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(341), 1,
      sym_text_interpolation,
    ACTIONS(1117), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1115), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1193] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(342), 1,
      sym_text_interpolation,
    ACTIONS(1121), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1119), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1265] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(343), 1,
      sym_text_interpolation,
    ACTIONS(1125), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1123), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1337] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(204), 1,
      anon_sym_LPAREN,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(242), 1,
      anon_sym_AT,
    ACTIONS(248), 1,
      anon_sym_clone,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(254), 1,
      anon_sym_LBRACK,
    ACTIONS(258), 1,
      sym_shell_command_expression,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    STATE(344), 1,
      sym_text_interpolation,
    STATE(518), 1,
      sym_class_constant_access_expression,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(539), 1,
      sym_qualified_name,
    STATE(552), 1,
      sym__unary_expression,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1327), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(244), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(246), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(256), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(262), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(553), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(375), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(446), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(557), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(570), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(354), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [1475] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(345), 1,
      sym_text_interpolation,
    ACTIONS(1129), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1127), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1547] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(492), 1,
      anon_sym_AT,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 1,
      sym_shell_command_expression,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(608), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_text_interpolation,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(430), 1,
      sym_class_constant_access_expression,
    STATE(432), 1,
      sym_qualified_name,
    STATE(506), 1,
      sym__unary_expression,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(942), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    STATE(1367), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(496), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(506), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(510), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(495), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(378), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(396), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(493), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(535), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(368), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [1685] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(347), 1,
      sym_text_interpolation,
    ACTIONS(1133), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1131), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1757] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(348), 1,
      sym_text_interpolation,
    ACTIONS(1137), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1135), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1829] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    STATE(349), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1908] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    STATE(350), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1081), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1987] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(351), 1,
      sym_text_interpolation,
    STATE(367), 1,
      sym_arguments,
    ACTIONS(1067), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1065), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2060] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(352), 1,
      sym_text_interpolation,
    STATE(1004), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2147] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_EQ,
    STATE(353), 1,
      sym_text_interpolation,
    STATE(361), 1,
      sym_arguments,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1147), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2228] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(354), 1,
      sym_text_interpolation,
    STATE(361), 1,
      sym_arguments,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1081), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2309] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_text_interpolation,
    STATE(359), 1,
      sym_arguments,
    ACTIONS(1089), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1087), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2382] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(356), 1,
      sym_text_interpolation,
    STATE(366), 1,
      sym_arguments,
    ACTIONS(1085), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1083), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2455] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(357), 1,
      sym_text_interpolation,
    ACTIONS(1125), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1123), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2523] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(358), 1,
      sym_text_interpolation,
    ACTIONS(1137), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1135), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2591] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(359), 1,
      sym_text_interpolation,
    ACTIONS(1097), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1095), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2659] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(360), 1,
      sym_text_interpolation,
    ACTIONS(1055), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1053), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2727] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(361), 1,
      sym_text_interpolation,
    ACTIONS(1105), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1103), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2795] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(362), 1,
      sym_text_interpolation,
    ACTIONS(1121), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1119), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2863] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(363), 1,
      sym_text_interpolation,
    ACTIONS(1109), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1107), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2931] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(364), 1,
      sym_text_interpolation,
    ACTIONS(1063), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1061), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2999] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(365), 1,
      sym_text_interpolation,
    ACTIONS(1113), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1111), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3067] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(366), 1,
      sym_text_interpolation,
    ACTIONS(1129), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1127), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3135] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(367), 1,
      sym_text_interpolation,
    ACTIONS(1117), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1115), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3203] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    STATE(338), 1,
      sym_arguments,
    STATE(368), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1081), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3283] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(369), 1,
      sym_text_interpolation,
    ACTIONS(1101), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3351] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(370), 1,
      sym_text_interpolation,
    ACTIONS(1059), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1057), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3419] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(371), 1,
      sym_text_interpolation,
    ACTIONS(1133), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1131), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3487] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    STATE(338), 1,
      sym_arguments,
    STATE(372), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1149), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3569] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(373), 1,
      sym_text_interpolation,
    ACTIONS(693), 12,
      anon_sym_final,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(691), 41,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_COMMA,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_abstract,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [3636] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    STATE(374), 1,
      sym_text_interpolation,
    STATE(1004), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3717] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    STATE(375), 1,
      sym_text_interpolation,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1081), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3792] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(376), 1,
      sym_text_interpolation,
    ACTIONS(711), 12,
      anon_sym_final,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(709), 41,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_COMMA,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_abstract,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [3859] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_EQ,
    STATE(377), 1,
      sym_text_interpolation,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1147), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3934] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_EQ,
    STATE(378), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1081), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4008] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    STATE(379), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1149), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1093), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1071), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4084] = 34,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(248), 1,
      anon_sym_clone,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(254), 1,
      anon_sym_LBRACK,
    ACTIONS(258), 1,
      sym_shell_command_expression,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    ACTIONS(1151), 1,
      anon_sym_LPAREN,
    STATE(380), 1,
      sym_text_interpolation,
    STATE(518), 1,
      sym_class_constant_access_expression,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(539), 1,
      sym_qualified_name,
    STATE(567), 1,
      sym_exponentiation_expression,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1327), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(256), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(262), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(563), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(446), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(449), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(570), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(426), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4206] = 34,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 1,
      sym_shell_command_expression,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    STATE(381), 1,
      sym_text_interpolation,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(430), 1,
      sym_class_constant_access_expression,
    STATE(432), 1,
      sym_qualified_name,
    STATE(517), 1,
      sym_exponentiation_expression,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(942), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    STATE(1367), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(506), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(510), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(516), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(396), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(401), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(535), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(385), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4328] = 32,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(254), 1,
      anon_sym_LBRACK,
    ACTIONS(258), 1,
      sym_shell_command_expression,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    ACTIONS(1151), 1,
      anon_sym_LPAREN,
    STATE(382), 1,
      sym_text_interpolation,
    STATE(518), 1,
      sym_class_constant_access_expression,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(539), 1,
      sym_qualified_name,
    STATE(581), 1,
      sym__primary_expression,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1327), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(256), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(262), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(446), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(449), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(570), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(426), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4443] = 32,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 1,
      sym_shell_command_expression,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    STATE(383), 1,
      sym_text_interpolation,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(430), 1,
      sym_class_constant_access_expression,
    STATE(432), 1,
      sym_qualified_name,
    STATE(484), 1,
      sym__primary_expression,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(942), 1,
      sym__dereferencable_expression,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    STATE(1367), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(506), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(510), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(396), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(401), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(535), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(385), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4558] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(384), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4624] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(385), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4692] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_EQ,
    STATE(338), 1,
      sym_arguments,
    STATE(386), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4759] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(387), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4822] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(345), 1,
      sym_arguments,
    STATE(388), 1,
      sym_text_interpolation,
    ACTIONS(1164), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1162), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_insteadof,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4885] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(389), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4945] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(390), 1,
      sym_text_interpolation,
    STATE(417), 1,
      sym_arguments,
    ACTIONS(1067), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1065), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5007] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(391), 1,
      sym_text_interpolation,
    ACTIONS(1170), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5065] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(392), 1,
      sym_text_interpolation,
    ACTIONS(1174), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5123] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(393), 1,
      sym_text_interpolation,
    ACTIONS(1178), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1176), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5181] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(394), 1,
      sym_text_interpolation,
    STATE(414), 1,
      sym_arguments,
    ACTIONS(1089), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1087), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5243] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(395), 1,
      sym_text_interpolation,
    STATE(416), 1,
      sym_arguments,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5307] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(396), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5371] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(397), 1,
      sym_text_interpolation,
    ACTIONS(1182), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1180), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5429] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(398), 1,
      sym_text_interpolation,
    ACTIONS(1186), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5487] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(399), 1,
      sym_text_interpolation,
    STATE(416), 1,
      sym_arguments,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1190), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5551] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(400), 1,
      sym_text_interpolation,
    STATE(413), 1,
      sym_arguments,
    ACTIONS(1085), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5613] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(401), 1,
      sym_text_interpolation,
    ACTIONS(1079), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5675] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    ACTIONS(1194), 1,
      anon_sym_LBRACE,
    ACTIONS(1198), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1200), 1,
      anon_sym_LBRACK,
    ACTIONS(1202), 1,
      anon_sym_DASH_GT,
    STATE(402), 1,
      sym_text_interpolation,
    STATE(524), 1,
      sym_arguments,
    ACTIONS(1196), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5745] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(403), 1,
      sym_text_interpolation,
    ACTIONS(1125), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1123), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5802] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(404), 1,
      sym_text_interpolation,
    ACTIONS(1133), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1131), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5859] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(405), 1,
      sym_text_interpolation,
    ACTIONS(1206), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1204), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5916] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(406), 1,
      sym_text_interpolation,
    ACTIONS(1137), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1135), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5973] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(407), 1,
      sym_text_interpolation,
    ACTIONS(1063), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6030] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(408), 1,
      sym_text_interpolation,
    ACTIONS(1121), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1119), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6087] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(409), 1,
      sym_text_interpolation,
    ACTIONS(1113), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1111), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6144] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(410), 1,
      sym_text_interpolation,
    ACTIONS(1059), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1057), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6201] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(411), 1,
      sym_text_interpolation,
    ACTIONS(1109), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6258] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(412), 1,
      sym_text_interpolation,
    ACTIONS(1210), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1208), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6315] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(413), 1,
      sym_text_interpolation,
    ACTIONS(1129), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1127), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6372] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(414), 1,
      sym_text_interpolation,
    ACTIONS(1097), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1095), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6429] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(415), 1,
      sym_text_interpolation,
    ACTIONS(1214), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1212), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6486] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(416), 1,
      sym_text_interpolation,
    ACTIONS(1105), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1103), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6543] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(417), 1,
      sym_text_interpolation,
    ACTIONS(1117), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1115), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6600] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(418), 1,
      sym_text_interpolation,
    ACTIONS(1049), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1051), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6657] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(419), 1,
      sym_text_interpolation,
    ACTIONS(1218), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1216), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6714] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(420), 1,
      sym_text_interpolation,
    ACTIONS(1160), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6771] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(421), 1,
      sym_text_interpolation,
    ACTIONS(1222), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1220), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6828] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(422), 1,
      sym_text_interpolation,
    ACTIONS(1226), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1224), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6885] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(423), 1,
      sym_text_interpolation,
    ACTIONS(1101), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1099), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6942] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(424), 1,
      sym_text_interpolation,
    ACTIONS(1055), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1053), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6999] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(425), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7057] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_arguments,
    STATE(426), 1,
      sym_text_interpolation,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7121] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(427), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1190), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7179] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1194), 1,
      anon_sym_LBRACE,
    ACTIONS(1198), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1200), 1,
      anon_sym_LBRACK,
    ACTIONS(1202), 1,
      anon_sym_DASH_GT,
    STATE(428), 1,
      sym_text_interpolation,
    ACTIONS(1230), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7243] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_arguments,
    STATE(429), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7305] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(430), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7363] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_EQ,
    STATE(361), 1,
      sym_arguments,
    STATE(431), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7426] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(338), 1,
      sym_arguments,
    STATE(432), 1,
      sym_text_interpolation,
    ACTIONS(1077), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7487] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(433), 1,
      sym_text_interpolation,
    ACTIONS(749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(747), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7542] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    ACTIONS(1198), 1,
      anon_sym_COLON_COLON,
    STATE(434), 1,
      sym_text_interpolation,
    STATE(524), 1,
      sym_arguments,
    ACTIONS(1196), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7603] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(435), 1,
      sym_text_interpolation,
    ACTIONS(745), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(743), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7658] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    STATE(436), 1,
      sym_text_interpolation,
    ACTIONS(1109), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7717] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(437), 1,
      sym_text_interpolation,
    ACTIONS(1186), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7771] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LBRACE,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    ACTIONS(1242), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1244), 1,
      anon_sym_LBRACK,
    ACTIONS(1246), 1,
      anon_sym_DASH_GT,
    STATE(438), 1,
      sym_text_interpolation,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1196), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7837] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(439), 1,
      sym_text_interpolation,
    ACTIONS(1109), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7891] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(440), 1,
      sym_text_interpolation,
    STATE(467), 1,
      sym_arguments,
    ACTIONS(1067), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1065), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7949] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(441), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8005] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(442), 1,
      sym_text_interpolation,
    ACTIONS(1170), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8059] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym_text_interpolation,
    STATE(459), 1,
      sym_arguments,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1190), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8119] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(444), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8177] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(445), 1,
      sym_text_interpolation,
    STATE(466), 1,
      sym_arguments,
    ACTIONS(1085), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8235] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_arguments,
    STATE(446), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8295] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym_arguments,
    STATE(447), 1,
      sym_text_interpolation,
    ACTIONS(1164), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1162), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8353] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(448), 1,
      sym_text_interpolation,
    ACTIONS(1182), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1180), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8407] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(449), 1,
      sym_text_interpolation,
    ACTIONS(1145), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8465] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(450), 1,
      sym_text_interpolation,
    ACTIONS(1174), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8519] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(451), 1,
      sym_text_interpolation,
    STATE(459), 1,
      sym_arguments,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8579] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(452), 1,
      sym_text_interpolation,
    ACTIONS(1178), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1176), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8633] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(453), 1,
      sym_text_interpolation,
    STATE(470), 1,
      sym_arguments,
    ACTIONS(1089), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1087), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8691] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    STATE(454), 1,
      sym_text_interpolation,
    ACTIONS(1109), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8747] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(455), 1,
      sym_text_interpolation,
    ACTIONS(1125), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1123), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8800] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(456), 1,
      sym_text_interpolation,
    ACTIONS(1214), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1212), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8853] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(457), 1,
      sym_text_interpolation,
    ACTIONS(1133), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1131), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8906] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(458), 1,
      sym_text_interpolation,
    ACTIONS(1101), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1099), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8959] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(459), 1,
      sym_text_interpolation,
    ACTIONS(1105), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1103), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9012] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(460), 1,
      sym_text_interpolation,
    ACTIONS(1218), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1216), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9065] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(461), 1,
      sym_text_interpolation,
    ACTIONS(1055), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1053), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9118] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(462), 1,
      sym_text_interpolation,
    ACTIONS(1206), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1204), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9171] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(463), 1,
      sym_text_interpolation,
    ACTIONS(1137), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1135), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9224] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(464), 1,
      sym_text_interpolation,
    ACTIONS(1113), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1111), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9277] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(465), 1,
      sym_text_interpolation,
    ACTIONS(1059), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1057), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9330] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(466), 1,
      sym_text_interpolation,
    ACTIONS(1129), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1127), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9383] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(467), 1,
      sym_text_interpolation,
    ACTIONS(1117), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1115), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9436] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(468), 1,
      sym_text_interpolation,
    ACTIONS(1063), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9489] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(469), 1,
      sym_text_interpolation,
    ACTIONS(1121), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1119), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9542] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(470), 1,
      sym_text_interpolation,
    ACTIONS(1097), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1095), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9595] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(471), 1,
      sym_text_interpolation,
    ACTIONS(1210), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1208), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9648] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1198), 1,
      anon_sym_COLON_COLON,
    STATE(472), 1,
      sym_text_interpolation,
    ACTIONS(1230), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9703] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(473), 1,
      sym_text_interpolation,
    ACTIONS(1222), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1220), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9756] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(474), 1,
      sym_text_interpolation,
    ACTIONS(1049), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1051), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9809] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1252), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(475), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1248), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [9889] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(476), 1,
      sym_text_interpolation,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1230), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1228), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [9953] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(477), 1,
      sym_text_interpolation,
    ACTIONS(1282), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1280), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10005] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(478), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1284), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10091] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(479), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1190), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10145] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1296), 1,
      anon_sym_QMARK,
    STATE(480), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1294), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [10225] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(481), 1,
      sym_text_interpolation,
    ACTIONS(1298), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1284), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10277] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(482), 1,
      sym_text_interpolation,
    ACTIONS(1302), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1300), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10329] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(483), 1,
      sym_text_interpolation,
    ACTIONS(1306), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1304), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10381] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(484), 1,
      sym_text_interpolation,
    ACTIONS(1310), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1308), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10433] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(485), 1,
      sym_text_interpolation,
    ACTIONS(1314), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1312), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10485] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(486), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1316), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10571] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(487), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1318), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10657] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1322), 1,
      anon_sym_EQ_GT,
    STATE(488), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1320), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10745] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1324), 1,
      anon_sym_function,
    ACTIONS(1326), 1,
      anon_sym_DOLLAR,
    STATE(489), 1,
      sym_text_interpolation,
    STATE(907), 1,
      sym_static_variable_declaration,
    STATE(916), 1,
      sym_variable_name,
    ACTIONS(1109), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10807] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(490), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10859] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(491), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1332), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10945] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_instanceof,
    STATE(492), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10999] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(493), 1,
      sym_text_interpolation,
    ACTIONS(1342), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1340), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11051] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(494), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1344), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [11137] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1346), 1,
      anon_sym_STAR_STAR,
    STATE(495), 1,
      sym_text_interpolation,
    ACTIONS(1342), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1340), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11191] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1324), 1,
      anon_sym_function,
    ACTIONS(1326), 1,
      anon_sym_DOLLAR,
    STATE(496), 1,
      sym_text_interpolation,
    STATE(916), 1,
      sym_variable_name,
    STATE(921), 1,
      sym_static_variable_declaration,
    ACTIONS(1109), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11253] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(497), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11305] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LBRACE,
    ACTIONS(1242), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1244), 1,
      anon_sym_LBRACK,
    ACTIONS(1246), 1,
      anon_sym_DASH_GT,
    STATE(498), 1,
      sym_text_interpolation,
    ACTIONS(1230), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11365] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(499), 1,
      sym_text_interpolation,
    ACTIONS(1350), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11417] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(500), 1,
      sym_text_interpolation,
    ACTIONS(1354), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1352), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11469] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(501), 1,
      sym_text_interpolation,
    ACTIONS(1358), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1356), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11521] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    STATE(502), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1360), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [11601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(503), 1,
      sym_text_interpolation,
    ACTIONS(1226), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1224), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11653] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1364), 1,
      anon_sym_QMARK,
    STATE(504), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1362), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [11733] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(505), 1,
      sym_text_interpolation,
    ACTIONS(1368), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1366), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11785] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(506), 1,
      sym_text_interpolation,
    ACTIONS(1372), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1370), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11837] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(507), 1,
      sym_text_interpolation,
    ACTIONS(1376), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1374), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11889] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(508), 1,
      sym_text_interpolation,
    ACTIONS(1380), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1378), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11941] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(509), 1,
      sym_text_interpolation,
    ACTIONS(1384), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1382), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11993] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(510), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1386), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12079] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(511), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1388), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12165] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    STATE(512), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1390), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [12245] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(513), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1392), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12331] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(514), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1394), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12417] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    STATE(515), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1396), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [12497] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1346), 1,
      anon_sym_STAR_STAR,
    STATE(516), 1,
      sym_text_interpolation,
    ACTIONS(1400), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1398), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12551] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(517), 1,
      sym_text_interpolation,
    ACTIONS(1400), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1398), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12603] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(518), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1077), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12657] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(519), 1,
      sym_text_interpolation,
    ACTIONS(1190), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12709] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(520), 1,
      sym_text_interpolation,
    ACTIONS(1230), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12761] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(521), 1,
      sym_text_interpolation,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12813] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(522), 1,
      sym_text_interpolation,
    ACTIONS(1404), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1402), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12865] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(523), 1,
      sym_text_interpolation,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12923] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(524), 1,
      sym_text_interpolation,
    ACTIONS(1408), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1406), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12975] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(525), 1,
      sym_text_interpolation,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [13035] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(526), 1,
      sym_text_interpolation,
    ACTIONS(1230), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [13105] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(527), 1,
      sym_text_interpolation,
    ACTIONS(1230), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [13177] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_QMARK,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(528), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [13251] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(529), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1410), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [13337] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(530), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1230), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [13405] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(531), 1,
      sym_text_interpolation,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [13461] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(532), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1081), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13515] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    STATE(533), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [13595] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(534), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
  [13679] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(535), 1,
      sym_text_interpolation,
    ACTIONS(1077), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13731] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_QMARK,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    STATE(536), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
  [13807] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1278), 1,
      anon_sym_PERCENT,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    STATE(537), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [13889] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1412), 1,
      anon_sym_COLON,
    STATE(538), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13946] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(361), 1,
      sym_arguments,
    STATE(539), 1,
      sym_text_interpolation,
    ACTIONS(1077), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14003] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    ACTIONS(1242), 1,
      anon_sym_COLON_COLON,
    STATE(540), 1,
      sym_text_interpolation,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1196), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14060] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(541), 1,
      sym_text_interpolation,
    ACTIONS(749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(747), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14111] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(542), 1,
      sym_text_interpolation,
    ACTIONS(745), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(743), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14162] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1414), 1,
      anon_sym_COLON,
    STATE(543), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14219] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1324), 1,
      anon_sym_function,
    STATE(544), 1,
      sym_text_interpolation,
    ACTIONS(1109), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14274] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1416), 1,
      sym_name,
    ACTIONS(1418), 1,
      anon_sym_RBRACE,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(545), 1,
      sym_text_interpolation,
    STATE(548), 1,
      aux_sym_use_list_repeat1,
    STATE(815), 1,
      sym_class_constant_access_expression,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(1239), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(956), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [14364] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1422), 1,
      sym_name,
    ACTIONS(1428), 1,
      anon_sym_namespace,
    ACTIONS(1431), 1,
      anon_sym_BSLASH,
    ACTIONS(1434), 1,
      anon_sym_RBRACE,
    ACTIONS(1436), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_array,
    ACTIONS(1442), 1,
      anon_sym_LBRACK,
    ACTIONS(1448), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(815), 1,
      sym_class_constant_access_expression,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(1445), 2,
      sym_heredoc,
      sym_string,
    STATE(546), 2,
      sym_text_interpolation,
      aux_sym_use_list_repeat1,
    STATE(1239), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(1425), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(956), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [14452] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_COLON_COLON,
    STATE(547), 1,
      sym_text_interpolation,
    ACTIONS(1109), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14504] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1416), 1,
      sym_name,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    ACTIONS(1451), 1,
      anon_sym_RBRACE,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(546), 1,
      aux_sym_use_list_repeat1,
    STATE(548), 1,
      sym_text_interpolation,
    STATE(815), 1,
      sym_class_constant_access_expression,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(1239), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(956), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [14594] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_COLON_COLON,
    STATE(549), 1,
      sym_text_interpolation,
    ACTIONS(1230), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14645] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(550), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [14721] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(551), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1230), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [14785] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(552), 1,
      sym_text_interpolation,
    ACTIONS(1372), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1370), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14833] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1483), 1,
      anon_sym_STAR_STAR,
    STATE(553), 1,
      sym_text_interpolation,
    ACTIONS(1342), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1340), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14883] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(554), 1,
      sym_text_interpolation,
    ACTIONS(1404), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1402), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14931] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(555), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1390), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15007] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(556), 1,
      sym_text_interpolation,
    ACTIONS(1354), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1352), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15055] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(557), 1,
      sym_text_interpolation,
    ACTIONS(1342), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1340), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15103] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(558), 1,
      sym_text_interpolation,
    ACTIONS(1190), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15151] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(559), 1,
      sym_text_interpolation,
    ACTIONS(1358), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1356), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15199] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(560), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1318), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [15281] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_instanceof,
    STATE(561), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15331] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(562), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1396), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15407] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1483), 1,
      anon_sym_STAR_STAR,
    STATE(563), 1,
      sym_text_interpolation,
    ACTIONS(1400), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1398), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15457] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(564), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1394), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [15539] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(565), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1360), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15615] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1364), 1,
      anon_sym_QMARK,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(566), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1362), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15691] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(567), 1,
      sym_text_interpolation,
    ACTIONS(1400), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1398), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15739] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(568), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1392), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [15821] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(569), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1388), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [15903] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(570), 1,
      sym_text_interpolation,
    ACTIONS(1077), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1071), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15951] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(571), 1,
      sym_text_interpolation,
    ACTIONS(1376), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1374), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15999] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(572), 1,
      sym_text_interpolation,
    ACTIONS(1314), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1312), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16047] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(573), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1284), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16129] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(574), 1,
      sym_text_interpolation,
    ACTIONS(1350), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16177] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1252), 1,
      anon_sym_QMARK,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(575), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1248), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [16253] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(576), 1,
      sym_text_interpolation,
    ACTIONS(1298), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1284), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16301] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(577), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1386), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16383] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(578), 1,
      sym_text_interpolation,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [16435] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(579), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 7,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
  [16515] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1493), 1,
      anon_sym_EQ_GT,
    STATE(580), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1320), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16599] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(581), 1,
      sym_text_interpolation,
    ACTIONS(1310), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1308), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16647] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(582), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1316), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16729] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    STATE(583), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [16807] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(584), 1,
      sym_text_interpolation,
    ACTIONS(1282), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1280), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16855] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(585), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16903] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(586), 1,
      sym_text_interpolation,
    ACTIONS(1230), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1228), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16951] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(587), 1,
      sym_text_interpolation,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 20,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [17005] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(588), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17053] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(260), 1,
      anon_sym_list,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(589), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1157), 1,
      sym_list_literal,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(790), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(769), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17141] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(590), 1,
      sym_text_interpolation,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1230), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1228), 18,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [17197] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(591), 1,
      sym_text_interpolation,
    ACTIONS(711), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(709), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17245] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(592), 1,
      sym_text_interpolation,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1230), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1228), 17,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [17305] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(593), 1,
      sym_text_interpolation,
    ACTIONS(1408), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1406), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17353] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(260), 1,
      anon_sym_list,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(594), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1043), 1,
      sym_list_literal,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(771), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(747), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17441] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(595), 1,
      sym_text_interpolation,
    ACTIONS(693), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(691), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17489] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(596), 1,
      sym_text_interpolation,
    ACTIONS(1230), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [17555] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(597), 1,
      sym_text_interpolation,
    ACTIONS(1230), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [17623] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_QMARK,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(598), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [17693] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1296), 1,
      anon_sym_QMARK,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(599), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1294), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [17769] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(600), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1332), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [17851] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(601), 1,
      sym_text_interpolation,
    ACTIONS(1368), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1366), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17899] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(602), 1,
      sym_text_interpolation,
    ACTIONS(1302), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1300), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17947] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_QMARK,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    STATE(603), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1228), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
  [18019] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(604), 1,
      sym_text_interpolation,
    ACTIONS(1306), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1304), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18067] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(605), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1344), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [18149] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(606), 1,
      sym_text_interpolation,
    ACTIONS(1380), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1378), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18197] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1481), 1,
      anon_sym_PERCENT,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(607), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1479), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1410), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [18279] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(608), 1,
      sym_text_interpolation,
    ACTIONS(1384), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1382), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18327] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(609), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(909), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(993), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1322), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(532), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(813), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(451), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18409] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(610), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(909), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(993), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1322), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(479), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(813), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(443), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18491] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_LPAREN,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(611), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(950), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1132), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1311), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(427), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(802), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(399), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18573] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(612), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(942), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(389), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(384), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18655] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_LPAREN,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(613), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(950), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1132), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1311), 1,
      sym__scope_resolution_qualifier,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(425), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(802), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(395), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18737] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(614), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(389), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(384), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18819] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(1503), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(615), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1036), 1,
      sym_qualified_name,
    STATE(1298), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(441), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(805), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(429), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18901] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(616), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(774), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(751), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18983] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(617), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(798), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(767), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19065] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(504), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      anon_sym_LPAREN,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(618), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(952), 1,
      sym__dereferencable_expression,
    STATE(956), 1,
      sym_class_constant_access_expression,
    STATE(1056), 1,
      sym_qualified_name,
    STATE(1297), 1,
      sym__scope_resolution_qualifier,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1329), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(775), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(814), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(749), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19147] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1507), 1,
      anon_sym_COMMA,
    STATE(619), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1505), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19228] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
    STATE(620), 1,
      sym_text_interpolation,
    STATE(1001), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19311] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(621), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1513), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19390] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      sym_text_interpolation,
    STATE(1070), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19473] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym_text_interpolation,
    STATE(1040), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19556] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(624), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1519), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19635] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1521), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1505), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19716] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1521), 1,
      anon_sym_COMMA,
    STATE(626), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19797] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    STATE(627), 1,
      sym_text_interpolation,
    STATE(1031), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19880] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(628), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1527), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [19959] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1507), 1,
      anon_sym_COMMA,
    STATE(629), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1523), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20040] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(630), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1529), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20118] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(631), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1531), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20196] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(632), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20274] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(633), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1535), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20352] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(634), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1537), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20430] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(635), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20508] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
    ACTIONS(1543), 1,
      anon_sym_EQ_GT,
    STATE(636), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20588] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(637), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20666] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1543), 1,
      anon_sym_EQ_GT,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
    STATE(638), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20746] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(639), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20824] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(640), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1551), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20902] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(641), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1553), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20980] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(642), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21058] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(643), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1557), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21136] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(644), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21214] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(645), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1561), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21292] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(646), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1563), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21370] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_AMP,
    ACTIONS(1455), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1461), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1465), 1,
      anon_sym_PIPE,
    ACTIONS(1467), 1,
      anon_sym_CARET,
    ACTIONS(1475), 1,
      anon_sym_GT_EQ,
    ACTIONS(1479), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1487), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1489), 1,
      aux_sym_binary_expression_token3,
    STATE(647), 1,
      sym_text_interpolation,
    ACTIONS(1469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1565), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1457), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1473), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1471), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21448] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    STATE(648), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21526] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
    STATE(649), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21603] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1571), 1,
      anon_sym_RBRACE,
    STATE(650), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21680] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1573), 1,
      sym_name,
    ACTIONS(1577), 1,
      anon_sym_AMP,
    ACTIONS(1579), 1,
      anon_sym_RPAREN,
    ACTIONS(1581), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1583), 1,
      anon_sym_QMARK,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(651), 1,
      sym_text_interpolation,
    STATE(863), 1,
      sym_namespace_name_as_prefix,
    STATE(923), 1,
      sym_qualified_name,
    STATE(926), 1,
      sym__type,
    STATE(1030), 1,
      sym__reserved_identifier,
    STATE(1067), 1,
      sym_variable_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(927), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1128), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [21755] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1589), 1,
      anon_sym_RPAREN,
    STATE(652), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21832] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
    STATE(653), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21909] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1593), 1,
      anon_sym_RPAREN,
    STATE(654), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21986] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1595), 1,
      anon_sym_RPAREN,
    STATE(655), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22063] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1597), 1,
      anon_sym_EQ_GT,
    STATE(656), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22140] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1599), 1,
      anon_sym_RBRACE,
    STATE(657), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22217] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1601), 1,
      anon_sym_RBRACE,
    STATE(658), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22294] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    STATE(659), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22371] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1601), 1,
      anon_sym_RBRACK,
    STATE(660), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22448] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1605), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22525] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1607), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22602] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1609), 1,
      anon_sym_EQ_GT,
    STATE(663), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22679] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1611), 1,
      anon_sym_RBRACE,
    STATE(664), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22756] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1613), 1,
      anon_sym_RBRACE,
    STATE(665), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22833] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1615), 1,
      anon_sym_as,
    STATE(666), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22910] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1611), 1,
      anon_sym_RBRACK,
    STATE(667), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22987] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1617), 1,
      anon_sym_RBRACE,
    STATE(668), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23064] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1619), 1,
      anon_sym_RBRACE,
    STATE(669), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23141] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1619), 1,
      anon_sym_RBRACK,
    STATE(670), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23218] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1621), 1,
      anon_sym_RBRACK,
    STATE(671), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23295] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1573), 1,
      sym_name,
    ACTIONS(1577), 1,
      anon_sym_AMP,
    ACTIONS(1581), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1583), 1,
      anon_sym_QMARK,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(1623), 1,
      anon_sym_RPAREN,
    STATE(672), 1,
      sym_text_interpolation,
    STATE(863), 1,
      sym_namespace_name_as_prefix,
    STATE(923), 1,
      sym_qualified_name,
    STATE(926), 1,
      sym__type,
    STATE(1030), 1,
      sym__reserved_identifier,
    STATE(1067), 1,
      sym_variable_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(927), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1068), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [23370] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1625), 1,
      anon_sym_RBRACK,
    STATE(673), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23447] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    STATE(674), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23524] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1625), 1,
      anon_sym_RBRACE,
    STATE(675), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23601] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1629), 1,
      anon_sym_RBRACE,
    STATE(676), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23678] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    STATE(677), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23755] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1633), 1,
      anon_sym_RBRACE,
    STATE(678), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23832] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1635), 1,
      anon_sym_RBRACE,
    STATE(679), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23909] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1637), 1,
      anon_sym_RBRACE,
    STATE(680), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23986] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1639), 1,
      anon_sym_COLON,
    STATE(681), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24063] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1641), 1,
      anon_sym_RBRACE,
    STATE(682), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24140] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1643), 1,
      anon_sym_RPAREN,
    STATE(683), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24217] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1621), 1,
      anon_sym_RBRACE,
    STATE(684), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24294] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1645), 1,
      anon_sym_RBRACE,
    STATE(685), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24371] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1647), 1,
      anon_sym_RPAREN,
    STATE(686), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24448] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1649), 1,
      anon_sym_RBRACK,
    STATE(687), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24525] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1649), 1,
      anon_sym_RBRACE,
    STATE(688), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24602] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1262), 1,
      anon_sym_PIPE,
    ACTIONS(1264), 1,
      anon_sym_CARET,
    ACTIONS(1272), 1,
      anon_sym_GT_EQ,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    ACTIONS(1286), 1,
      anon_sym_QMARK,
    ACTIONS(1288), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1290), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1292), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1651), 1,
      anon_sym_as,
    STATE(689), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1278), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1254), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1268), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24679] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1573), 1,
      sym_name,
    ACTIONS(1577), 1,
      anon_sym_AMP,
    ACTIONS(1581), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1583), 1,
      anon_sym_QMARK,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(690), 1,
      sym_text_interpolation,
    STATE(863), 1,
      sym_namespace_name_as_prefix,
    STATE(923), 1,
      sym_qualified_name,
    STATE(926), 1,
      sym__type,
    STATE(1030), 1,
      sym__reserved_identifier,
    STATE(1067), 1,
      sym_variable_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(927), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1250), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [24751] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1661), 1,
      anon_sym_RBRACE,
    ACTIONS(1665), 1,
      sym_var_modifier,
    STATE(691), 1,
      sym_text_interpolation,
    STATE(699), 1,
      aux_sym_declaration_list_repeat1,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [24816] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1669), 1,
      anon_sym_RBRACE,
    STATE(692), 1,
      sym_text_interpolation,
    STATE(697), 1,
      aux_sym_declaration_list_repeat1,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [24881] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1671), 1,
      anon_sym_RBRACE,
    STATE(693), 1,
      sym_text_interpolation,
    STATE(694), 1,
      aux_sym_declaration_list_repeat1,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [24946] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1673), 1,
      anon_sym_RBRACE,
    STATE(694), 1,
      sym_text_interpolation,
    STATE(697), 1,
      aux_sym_declaration_list_repeat1,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25011] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1675), 1,
      anon_sym_RBRACE,
    STATE(695), 1,
      sym_text_interpolation,
    STATE(698), 1,
      aux_sym_declaration_list_repeat1,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25076] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1677), 1,
      anon_sym_RBRACE,
    STATE(692), 1,
      aux_sym_declaration_list_repeat1,
    STATE(696), 1,
      sym_text_interpolation,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25141] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_static,
    ACTIONS(1682), 1,
      anon_sym_use,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1688), 1,
      anon_sym_const,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    ACTIONS(1696), 1,
      sym_var_modifier,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1693), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(697), 2,
      sym_text_interpolation,
      aux_sym_declaration_list_repeat1,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1699), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25204] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1702), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      aux_sym_declaration_list_repeat1,
    STATE(698), 1,
      sym_text_interpolation,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25269] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1655), 1,
      anon_sym_use,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1659), 1,
      anon_sym_const,
    ACTIONS(1665), 1,
      sym_var_modifier,
    ACTIONS(1704), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      aux_sym_declaration_list_repeat1,
    STATE(699), 1,
      sym_text_interpolation,
    STATE(705), 1,
      aux_sym_property_declaration_repeat1,
    STATE(729), 1,
      sym__member_declaration,
    STATE(738), 1,
      sym_visibility_modifier,
    STATE(756), 1,
      sym__modifier,
    STATE(885), 1,
      sym__function_definition_header,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(752), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(730), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25334] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(700), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(923), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1394), 1,
      sym__type,
    STATE(927), 2,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25390] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(701), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(1081), 1,
      sym__type,
    STATE(1100), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1102), 2,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1712), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25446] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(702), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(1084), 1,
      sym_primitive_type,
    STATE(1087), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1712), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25495] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1573), 1,
      sym_name,
    STATE(703), 1,
      sym_text_interpolation,
    STATE(863), 1,
      sym_namespace_name_as_prefix,
    STATE(948), 1,
      sym_qualified_name,
    STATE(954), 1,
      sym_primitive_type,
    STATE(1030), 1,
      sym__reserved_identifier,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25544] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(704), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(948), 1,
      sym_qualified_name,
    STATE(954), 1,
      sym_primitive_type,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1585), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25593] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1326), 1,
      anon_sym_DOLLAR,
    ACTIONS(1653), 1,
      anon_sym_static,
    ACTIONS(1657), 1,
      anon_sym_function,
    ACTIONS(1665), 1,
      sym_var_modifier,
    STATE(705), 1,
      sym_text_interpolation,
    STATE(714), 1,
      aux_sym_property_declaration_repeat1,
    STATE(756), 1,
      sym__modifier,
    STATE(851), 1,
      sym_variable_name,
    STATE(911), 1,
      sym__function_definition_header,
    STATE(912), 1,
      sym_property_element,
    ACTIONS(1663), 2,
      anon_sym_abstract,
      anon_sym_final,
    ACTIONS(1667), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(752), 3,
      sym_class_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [25644] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    ACTIONS(1714), 1,
      anon_sym_class,
    STATE(402), 1,
      sym_new_variable,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(434), 1,
      sym_qualified_name,
    STATE(706), 1,
      sym_text_interpolation,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(1306), 1,
      sym_relative_scope,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(412), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [25696] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    ACTIONS(1716), 1,
      anon_sym_class,
    STATE(438), 1,
      sym_new_variable,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(540), 1,
      sym_qualified_name,
    STATE(707), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1399), 1,
      sym_relative_scope,
    STATE(471), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(262), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [25748] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    STATE(498), 1,
      sym_new_variable,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(549), 1,
      sym_qualified_name,
    STATE(708), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(1399), 1,
      sym_relative_scope,
    STATE(471), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(262), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [25797] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(428), 1,
      sym_new_variable,
    STATE(472), 1,
      sym_qualified_name,
    STATE(709), 1,
      sym_text_interpolation,
    STATE(847), 1,
      sym_namespace_name_as_prefix,
    STATE(1306), 1,
      sym_relative_scope,
    STATE(1307), 1,
      sym_namespace_name,
    STATE(412), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(510), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [25846] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(811), 1,
      anon_sym_else,
    STATE(710), 1,
      sym_text_interpolation,
    ACTIONS(809), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [25874] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_else,
    STATE(711), 1,
      sym_text_interpolation,
    ACTIONS(845), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [25902] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_else,
    STATE(712), 1,
      sym_text_interpolation,
    ACTIONS(877), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [25930] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(713), 1,
      sym_text_interpolation,
    STATE(723), 1,
      sym_namespace_function_or_const,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(877), 1,
      sym_qualified_name,
    STATE(901), 1,
      sym_namespace_use_clause,
    STATE(1371), 1,
      sym_namespace_name,
    ACTIONS(1720), 2,
      anon_sym_function,
      anon_sym_const,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [25976] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1722), 1,
      anon_sym_static,
    ACTIONS(1730), 1,
      sym_var_modifier,
    STATE(756), 1,
      sym__modifier,
    ACTIONS(1725), 2,
      anon_sym_function,
      anon_sym_DOLLAR,
    ACTIONS(1727), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(714), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1733), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(752), 3,
      sym_class_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [26014] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1736), 1,
      anon_sym_BSLASH,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(715), 1,
      sym_text_interpolation,
    STATE(728), 1,
      sym_namespace_function_or_const,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(877), 1,
      sym_qualified_name,
    STATE(887), 1,
      sym_namespace_use_clause,
    STATE(1372), 1,
      sym_namespace_name,
    ACTIONS(1720), 2,
      anon_sym_function,
      anon_sym_const,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26060] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(716), 1,
      sym_text_interpolation,
    ACTIONS(1107), 14,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_implements,
      anon_sym_insteadof,
      anon_sym_AMP,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_DOLLAR,
  [26086] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(717), 1,
      sym_text_interpolation,
    ACTIONS(1738), 6,
      anon_sym_static,
      anon_sym_namespace,
      anon_sym_array,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(1434), 7,
      sym_heredoc,
      anon_sym_BSLASH,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym_string,
      anon_sym_DOLLAR,
  [26113] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(718), 1,
      sym_text_interpolation,
    ACTIONS(1740), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26136] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(719), 1,
      sym_text_interpolation,
    ACTIONS(1742), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26159] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(720), 1,
      sym_text_interpolation,
    ACTIONS(1744), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26182] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(721), 1,
      sym_text_interpolation,
    ACTIONS(1746), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26205] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(722), 1,
      sym_text_interpolation,
    ACTIONS(1748), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26228] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1750), 1,
      anon_sym_BSLASH,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(723), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(877), 1,
      sym_qualified_name,
    STATE(883), 1,
      sym_namespace_use_clause,
    STATE(1376), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26267] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(724), 1,
      sym_text_interpolation,
    ACTIONS(1752), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26290] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(725), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(877), 1,
      sym_qualified_name,
    STATE(1105), 1,
      sym_namespace_use_clause,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26329] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(726), 1,
      sym_text_interpolation,
    ACTIONS(1754), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26352] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(727), 1,
      sym_text_interpolation,
    ACTIONS(1756), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26375] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1758), 1,
      anon_sym_BSLASH,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(728), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(877), 1,
      sym_qualified_name,
    STATE(898), 1,
      sym_namespace_use_clause,
    STATE(1339), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26414] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(729), 1,
      sym_text_interpolation,
    ACTIONS(1760), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26437] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(730), 1,
      sym_text_interpolation,
    ACTIONS(1762), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26460] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(731), 1,
      sym_text_interpolation,
    ACTIONS(1764), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26483] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(732), 1,
      sym_text_interpolation,
    ACTIONS(1766), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26506] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(733), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1255), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26542] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(734), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1129), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26578] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(735), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1172), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26614] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(736), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(940), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26650] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(521), 1,
      sym__reserved_identifier,
    STATE(737), 1,
      sym_text_interpolation,
    STATE(826), 1,
      sym_qualified_name,
    STATE(875), 1,
      sym_namespace_name_as_prefix,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26686] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1770), 1,
      anon_sym_const,
    STATE(738), 1,
      sym_text_interpolation,
    ACTIONS(1768), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [26710] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(739), 1,
      sym_text_interpolation,
    ACTIONS(1772), 10,
      anon_sym_static,
      anon_sym_function,
      anon_sym_class,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [26732] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(740), 1,
      sym_text_interpolation,
    ACTIONS(1774), 10,
      anon_sym_static,
      anon_sym_function,
      anon_sym_const,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [26754] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(741), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1093), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26790] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(742), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1274), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26826] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(420), 1,
      sym__reserved_identifier,
    STATE(743), 1,
      sym_text_interpolation,
    STATE(849), 1,
      sym_namespace_name_as_prefix,
    STATE(1196), 1,
      sym_qualified_name,
    STATE(1307), 1,
      sym_namespace_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26862] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1776), 1,
      sym_name,
    ACTIONS(1778), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym__reserved_identifier,
    STATE(744), 1,
      sym_text_interpolation,
    STATE(356), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26893] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    ACTIONS(1780), 1,
      sym_name,
    ACTIONS(1782), 1,
      anon_sym_LBRACE,
    STATE(745), 1,
      sym_text_interpolation,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(456), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [26922] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1778), 1,
      anon_sym_LBRACE,
    ACTIONS(1784), 1,
      sym_name,
    STATE(746), 1,
      sym_text_interpolation,
    STATE(777), 1,
      sym__reserved_identifier,
    STATE(356), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26953] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1786), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(747), 1,
      sym_text_interpolation,
    STATE(1124), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [26984] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    ACTIONS(1788), 1,
      sym_name,
    ACTIONS(1792), 1,
      anon_sym_LBRACE,
    STATE(748), 1,
      sym_text_interpolation,
    ACTIONS(1790), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(415), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27013] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(1796), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(749), 1,
      sym_text_interpolation,
    STATE(1061), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27044] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1798), 1,
      sym_name,
    ACTIONS(1802), 1,
      anon_sym_LBRACE,
    STATE(750), 1,
      sym_text_interpolation,
    ACTIONS(1800), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(330), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27073] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(751), 1,
      sym_text_interpolation,
    STATE(1005), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27104] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(752), 1,
      sym_text_interpolation,
    ACTIONS(1768), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27125] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1798), 1,
      sym_name,
    ACTIONS(1802), 1,
      anon_sym_LBRACE,
    STATE(753), 1,
      sym_text_interpolation,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(330), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27154] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    ACTIONS(1806), 1,
      sym_name,
    ACTIONS(1808), 1,
      anon_sym_LBRACE,
    STATE(754), 1,
      sym_text_interpolation,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(440), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27183] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1810), 1,
      sym_name,
    ACTIONS(1812), 1,
      anon_sym_LBRACE,
    STATE(388), 1,
      sym__reserved_identifier,
    STATE(755), 1,
      sym_text_interpolation,
    STATE(332), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1790), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27214] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(756), 1,
      sym_text_interpolation,
    ACTIONS(1814), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27235] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1810), 1,
      sym_name,
    ACTIONS(1812), 1,
      anon_sym_LBRACE,
    STATE(388), 1,
      sym__reserved_identifier,
    STATE(757), 1,
      sym_text_interpolation,
    STATE(332), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27266] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(758), 1,
      sym_text_interpolation,
    ACTIONS(1816), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27287] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    ACTIONS(1818), 1,
      sym_name,
    ACTIONS(1820), 1,
      anon_sym_LBRACE,
    STATE(759), 1,
      sym_text_interpolation,
    STATE(822), 1,
      sym__reserved_identifier,
    STATE(445), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27318] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1822), 1,
      sym_name,
    ACTIONS(1826), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_text_interpolation,
    ACTIONS(1824), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(351), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27347] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    ACTIONS(1828), 1,
      sym_name,
    ACTIONS(1830), 1,
      anon_sym_LBRACE,
    STATE(761), 1,
      sym_text_interpolation,
    STATE(808), 1,
      sym__reserved_identifier,
    STATE(400), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27378] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    ACTIONS(1832), 1,
      sym_name,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(762), 1,
      sym_text_interpolation,
    ACTIONS(1790), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(390), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27407] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(552), 1,
      anon_sym_else,
    ACTIONS(1836), 1,
      anon_sym_catch,
    ACTIONS(1839), 1,
      anon_sym_finally,
    ACTIONS(550), 2,
      anon_sym_while,
      anon_sym_elseif,
    STATE(763), 2,
      sym_text_interpolation,
      aux_sym_try_statement_repeat1,
    STATE(857), 2,
      sym_catch_clause,
      sym_finally_clause,
  [27435] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1842), 1,
      sym_name,
    ACTIONS(1844), 1,
      anon_sym_AMP,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(764), 1,
      sym_text_interpolation,
    STATE(828), 1,
      sym_formal_parameters,
    STATE(1182), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27465] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(544), 1,
      anon_sym_else,
    ACTIONS(1848), 1,
      anon_sym_catch,
    ACTIONS(1850), 1,
      anon_sym_finally,
    STATE(763), 1,
      aux_sym_try_statement_repeat1,
    STATE(765), 1,
      sym_text_interpolation,
    ACTIONS(542), 2,
      anon_sym_while,
      anon_sym_elseif,
    STATE(857), 2,
      sym_catch_clause,
      sym_finally_clause,
  [27495] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    STATE(524), 1,
      sym_declaration_list,
    STATE(766), 1,
      sym_text_interpolation,
    STATE(810), 1,
      sym_arguments,
    STATE(896), 1,
      sym_class_base_clause,
    STATE(1161), 1,
      sym_class_interface_clause,
  [27529] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(767), 1,
      sym_text_interpolation,
    ACTIONS(1858), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27555] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_declaration_list,
    STATE(768), 1,
      sym_text_interpolation,
    STATE(823), 1,
      sym_arguments,
    STATE(951), 1,
      sym_class_base_clause,
    STATE(1171), 1,
      sym_class_interface_clause,
  [27589] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(769), 1,
      sym_text_interpolation,
    ACTIONS(1862), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27615] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_case,
    ACTIONS(1869), 1,
      anon_sym_default,
    ACTIONS(1864), 2,
      anon_sym_RBRACE,
      anon_sym_endswitch,
    STATE(770), 2,
      sym_text_interpolation,
      aux_sym_switch_block_repeat1,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27640] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1786), 1,
      anon_sym_RPAREN,
    STATE(771), 1,
      sym_text_interpolation,
    STATE(1124), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27665] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      sym_name,
    STATE(772), 1,
      sym_text_interpolation,
    STATE(830), 1,
      sym_formal_parameters,
    STATE(1187), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27692] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_integer,
    STATE(773), 1,
      sym_text_interpolation,
    STATE(1352), 1,
      sym__string,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(1874), 3,
      sym_float,
      sym_boolean,
      sym_null,
  [27717] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(774), 1,
      sym_text_interpolation,
    STATE(1005), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27742] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(1796), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      sym_text_interpolation,
    STATE(1061), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27767] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1878), 1,
      anon_sym_endswitch,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    STATE(776), 1,
      sym_text_interpolation,
    STATE(785), 1,
      aux_sym_switch_block_repeat1,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27793] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym_arguments,
    STATE(777), 1,
      sym_text_interpolation,
    ACTIONS(1162), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [27815] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1884), 1,
      anon_sym_endswitch,
    STATE(778), 1,
      sym_text_interpolation,
    STATE(784), 1,
      aux_sym_switch_block_repeat1,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27841] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1886), 1,
      anon_sym_RBRACE,
    STATE(779), 1,
      sym_text_interpolation,
    STATE(782), 1,
      aux_sym_switch_block_repeat1,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27867] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1888), 1,
      anon_sym_endif,
    ACTIONS(1890), 1,
      anon_sym_elseif,
    ACTIONS(1892), 1,
      anon_sym_else,
    STATE(780), 1,
      sym_text_interpolation,
    STATE(827), 1,
      aux_sym_if_statement_repeat2,
    STATE(1107), 1,
      sym_else_if_clause_2,
    STATE(1353), 1,
      sym_else_clause_2,
  [27895] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(781), 1,
      sym_text_interpolation,
    STATE(1261), 1,
      sym_namespace_use_group,
    ACTIONS(1894), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [27917] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1898), 1,
      anon_sym_RBRACE,
    STATE(770), 1,
      aux_sym_switch_block_repeat1,
    STATE(782), 1,
      sym_text_interpolation,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27943] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(783), 1,
      sym_text_interpolation,
    STATE(1220), 1,
      sym_namespace_use_group,
    ACTIONS(1894), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [27965] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1900), 1,
      anon_sym_endswitch,
    STATE(770), 1,
      aux_sym_switch_block_repeat1,
    STATE(784), 1,
      sym_text_interpolation,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [27991] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1902), 1,
      anon_sym_endswitch,
    STATE(770), 1,
      aux_sym_switch_block_repeat1,
    STATE(785), 1,
      sym_text_interpolation,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [28017] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1890), 1,
      anon_sym_elseif,
    ACTIONS(1892), 1,
      anon_sym_else,
    ACTIONS(1904), 1,
      anon_sym_endif,
    STATE(786), 1,
      sym_text_interpolation,
    STATE(843), 1,
      aux_sym_if_statement_repeat2,
    STATE(1107), 1,
      sym_else_if_clause_2,
    STATE(1338), 1,
      sym_else_clause_2,
  [28045] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(522), 1,
      sym_compound_statement,
    STATE(787), 1,
      sym_text_interpolation,
    STATE(893), 1,
      sym_anonymous_function_use_clause,
    STATE(1148), 1,
      sym__return_type,
  [28073] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(788), 1,
      sym_text_interpolation,
    STATE(1208), 1,
      sym_namespace_use_group,
    ACTIONS(1910), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28095] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(789), 1,
      sym_text_interpolation,
    STATE(1208), 1,
      sym_namespace_use_group,
    ACTIONS(1894), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28117] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(790), 1,
      sym_text_interpolation,
    ACTIONS(1862), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28137] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(791), 1,
      sym_text_interpolation,
    STATE(856), 1,
      sym_declaration_list,
    STATE(889), 1,
      sym_class_base_clause,
    STATE(1154), 1,
      sym_class_interface_clause,
  [28165] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1890), 1,
      anon_sym_elseif,
    ACTIONS(1892), 1,
      anon_sym_else,
    ACTIONS(1912), 1,
      anon_sym_endif,
    STATE(786), 1,
      aux_sym_if_statement_repeat2,
    STATE(792), 1,
      sym_text_interpolation,
    STATE(1107), 1,
      sym_else_if_clause_2,
    STATE(1326), 1,
      sym_else_clause_2,
  [28193] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(160), 1,
      sym_declaration_list,
    STATE(793), 1,
      sym_text_interpolation,
    STATE(880), 1,
      sym_class_base_clause,
    STATE(1151), 1,
      sym_class_interface_clause,
  [28221] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(794), 1,
      sym_text_interpolation,
    STATE(1179), 1,
      sym_namespace_use_group,
    ACTIONS(1910), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28243] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      sym_name,
    STATE(795), 1,
      sym_text_interpolation,
    STATE(943), 1,
      sym_const_element,
    STATE(1382), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28267] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_compound_statement,
    STATE(796), 1,
      sym_text_interpolation,
    STATE(938), 1,
      sym_anonymous_function_use_clause,
    STATE(1273), 1,
      sym__return_type,
  [28295] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      sym_name,
    STATE(797), 1,
      sym_text_interpolation,
    STATE(903), 1,
      sym_const_element,
    STATE(1382), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28319] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(798), 1,
      sym_text_interpolation,
    ACTIONS(1858), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28339] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_BSLASH,
    STATE(799), 1,
      sym_text_interpolation,
    ACTIONS(1920), 5,
      anon_sym_static,
      anon_sym_namespace,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28359] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      sym_name,
    STATE(800), 1,
      sym_text_interpolation,
    STATE(894), 1,
      sym_const_element,
    STATE(1382), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28383] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_while,
    ACTIONS(1924), 1,
      anon_sym_elseif,
    ACTIONS(1926), 1,
      anon_sym_else,
    STATE(801), 1,
      sym_text_interpolation,
    STATE(804), 1,
      aux_sym_if_statement_repeat1,
    STATE(1044), 1,
      sym_else_clause,
    STATE(1046), 1,
      sym_else_if_clause,
  [28411] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym_arguments,
    STATE(802), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28433] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_declaration_list,
    STATE(803), 1,
      sym_text_interpolation,
    STATE(937), 1,
      sym_class_base_clause,
    STATE(1271), 1,
      sym_class_interface_clause,
  [28461] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(632), 1,
      anon_sym_while,
    ACTIONS(1924), 1,
      anon_sym_elseif,
    ACTIONS(1926), 1,
      anon_sym_else,
    STATE(804), 1,
      sym_text_interpolation,
    STATE(874), 1,
      aux_sym_if_statement_repeat1,
    STATE(982), 1,
      sym_else_clause,
    STATE(1046), 1,
      sym_else_if_clause,
  [28489] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_arguments,
    STATE(805), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28511] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(508), 1,
      sym_compound_statement,
    STATE(806), 1,
      sym_text_interpolation,
    STATE(913), 1,
      sym_anonymous_function_use_clause,
    STATE(1176), 1,
      sym__return_type,
  [28539] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    STATE(807), 1,
      sym_text_interpolation,
    STATE(825), 1,
      aux_sym_switch_block_repeat1,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [28565] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(413), 1,
      sym_arguments,
    STATE(808), 1,
      sym_text_interpolation,
    ACTIONS(1162), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28587] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(809), 1,
      sym_text_interpolation,
    STATE(1284), 1,
      sym_namespace_use_group,
    ACTIONS(1894), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28609] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    STATE(505), 1,
      sym_declaration_list,
    STATE(810), 1,
      sym_text_interpolation,
    STATE(917), 1,
      sym_class_base_clause,
    STATE(1195), 1,
      sym_class_interface_clause,
  [28637] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(811), 1,
      sym_text_interpolation,
    STATE(833), 1,
      sym_declaration_list,
    STATE(924), 1,
      sym_class_base_clause,
    STATE(1202), 1,
      sym_class_interface_clause,
  [28665] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(812), 1,
      sym_text_interpolation,
    STATE(1261), 1,
      sym_namespace_use_group,
    ACTIONS(1910), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28687] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(459), 1,
      sym_arguments,
    STATE(813), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28709] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(338), 1,
      sym_arguments,
    STATE(814), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28731] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1930), 1,
      anon_sym_as,
    ACTIONS(1932), 1,
      anon_sym_insteadof,
    STATE(815), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28753] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(501), 1,
      sym_compound_statement,
    STATE(816), 1,
      sym_text_interpolation,
    STATE(929), 1,
      sym_anonymous_function_use_clause,
    STATE(1205), 1,
      sym__return_type,
  [28781] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1934), 1,
      sym_name,
    ACTIONS(1936), 1,
      anon_sym_AMP,
    STATE(817), 1,
      sym_text_interpolation,
    STATE(1166), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28805] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      sym_name,
    STATE(818), 1,
      sym_text_interpolation,
    STATE(1063), 1,
      sym_const_element,
    STATE(1382), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28829] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_COMMA,
    ACTIONS(1942), 1,
      anon_sym_LBRACE,
    STATE(718), 1,
      sym_use_list,
    STATE(819), 1,
      sym_text_interpolation,
    STATE(840), 1,
      aux_sym_interface_base_clause_repeat1,
    ACTIONS(1938), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28855] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LBRACE,
    STATE(820), 1,
      sym_text_interpolation,
    STATE(1248), 1,
      sym_namespace_use_group,
    ACTIONS(1910), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28877] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1944), 1,
      sym_name,
    STATE(821), 1,
      sym_text_interpolation,
    STATE(934), 1,
      sym_namespace_name,
    STATE(1143), 1,
      sym_namespace_use_group_clause,
    STATE(1257), 1,
      sym_namespace_function_or_const,
    ACTIONS(1720), 2,
      anon_sym_function,
      anon_sym_const,
  [28903] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(466), 1,
      sym_arguments,
    STATE(822), 1,
      sym_text_interpolation,
    ACTIONS(1162), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [28925] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_extends,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_declaration_list,
    STATE(823), 1,
      sym_text_interpolation,
    STATE(946), 1,
      sym_class_base_clause,
    STATE(1243), 1,
      sym_class_interface_clause,
  [28953] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1930), 1,
      anon_sym_as,
    ACTIONS(1932), 1,
      anon_sym_insteadof,
    STATE(824), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1155), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
  [28979] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    ACTIONS(1946), 1,
      anon_sym_RBRACE,
    STATE(770), 1,
      aux_sym_switch_block_repeat1,
    STATE(825), 1,
      sym_text_interpolation,
    STATE(947), 2,
      sym_case_statement,
      sym_default_statement,
  [29005] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_COMMA,
    ACTIONS(1942), 1,
      anon_sym_LBRACE,
    STATE(731), 1,
      sym_use_list,
    STATE(819), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(826), 1,
      sym_text_interpolation,
    ACTIONS(1948), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29031] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1890), 1,
      anon_sym_elseif,
    ACTIONS(1892), 1,
      anon_sym_else,
    ACTIONS(1950), 1,
      anon_sym_endif,
    STATE(827), 1,
      sym_text_interpolation,
    STATE(843), 1,
      aux_sym_if_statement_repeat2,
    STATE(1107), 1,
      sym_else_if_clause_2,
    STATE(1391), 1,
      sym_else_clause_2,
  [29059] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_compound_statement,
    STATE(828), 1,
      sym_text_interpolation,
    STATE(932), 1,
      sym_anonymous_function_use_clause,
    STATE(1238), 1,
      sym__return_type,
  [29087] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      sym_name,
    STATE(829), 1,
      sym_text_interpolation,
    STATE(919), 1,
      sym_const_element,
    STATE(1382), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29111] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_use,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_compound_statement,
    STATE(830), 1,
      sym_text_interpolation,
    STATE(884), 1,
      sym_anonymous_function_use_clause,
    STATE(1149), 1,
      sym__return_type,
  [29139] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1944), 1,
      sym_name,
    STATE(831), 1,
      sym_text_interpolation,
    STATE(934), 1,
      sym_namespace_name,
    STATE(1047), 1,
      sym_namespace_use_group_clause,
    STATE(1257), 1,
      sym_namespace_function_or_const,
    ACTIONS(1720), 2,
      anon_sym_function,
      anon_sym_const,
  [29165] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_catch,
    ACTIONS(1954), 1,
      anon_sym_finally,
    STATE(74), 1,
      aux_sym_try_statement_repeat1,
    STATE(832), 1,
      sym_text_interpolation,
    STATE(134), 2,
      sym_catch_clause,
      sym_finally_clause,
  [29188] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_else,
    STATE(833), 1,
      sym_text_interpolation,
    ACTIONS(737), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1956), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29209] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1958), 1,
      sym_name,
    ACTIONS(1960), 1,
      anon_sym_BSLASH,
    STATE(834), 1,
      sym_text_interpolation,
    STATE(848), 1,
      sym_namespace_name,
    STATE(1050), 1,
      sym_compound_statement,
  [29234] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(733), 1,
      anon_sym_else,
    STATE(835), 1,
      sym_text_interpolation,
    ACTIONS(731), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29255] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1966), 1,
      anon_sym_BSLASH,
    STATE(836), 1,
      sym_text_interpolation,
    STATE(845), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1964), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [29276] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_text_interpolation,
    STATE(969), 1,
      sym__return_type,
    ACTIONS(1969), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [29297] = 6,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(1973), 1,
      ts_builtin_sym_end,
    ACTIONS(1975), 1,
      sym_php_tag,
    ACTIONS(1977), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
    STATE(838), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [29318] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym_name,
    STATE(839), 1,
      sym_text_interpolation,
    STATE(1145), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29339] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_COMMA,
    STATE(840), 2,
      sym_text_interpolation,
      aux_sym_interface_base_clause_repeat1,
    ACTIONS(1982), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [29358] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1987), 1,
      sym_name,
    STATE(841), 1,
      sym_text_interpolation,
    STATE(1377), 1,
      sym_namespace_name,
    ACTIONS(1990), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29379] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    ACTIONS(1992), 1,
      sym_name,
    ACTIONS(1994), 1,
      anon_sym_LBRACE,
    STATE(842), 1,
      sym_text_interpolation,
    STATE(458), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [29402] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1996), 1,
      anon_sym_endif,
    ACTIONS(1998), 1,
      anon_sym_elseif,
    ACTIONS(2001), 1,
      anon_sym_else,
    STATE(1107), 1,
      sym_else_if_clause_2,
    STATE(843), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat2,
  [29425] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(2003), 1,
      sym_name,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    STATE(844), 1,
      sym_text_interpolation,
    STATE(337), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [29448] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_BSLASH,
    STATE(845), 1,
      sym_text_interpolation,
    STATE(871), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2007), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [29469] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    ACTIONS(1958), 1,
      sym_name,
    ACTIONS(1960), 1,
      anon_sym_BSLASH,
    STATE(253), 1,
      sym_compound_statement,
    STATE(846), 1,
      sym_text_interpolation,
    STATE(861), 1,
      sym_namespace_name,
  [29494] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2012), 1,
      sym_name,
    STATE(422), 1,
      sym__reserved_identifier,
    STATE(847), 1,
      sym_text_interpolation,
    ACTIONS(1790), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29515] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      anon_sym_BSLASH,
    STATE(848), 1,
      sym_text_interpolation,
    STATE(1092), 1,
      sym_compound_statement,
    ACTIONS(2014), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29538] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2012), 1,
      sym_name,
    STATE(422), 1,
      sym__reserved_identifier,
    STATE(849), 1,
      sym_text_interpolation,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29559] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_else,
    STATE(850), 1,
      sym_text_interpolation,
    ACTIONS(725), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(2018), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29580] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_EQ,
    STATE(851), 1,
      sym_text_interpolation,
    STATE(1072), 1,
      sym_property_initializer,
    ACTIONS(2020), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [29601] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2024), 1,
      sym_name,
    STATE(852), 1,
      sym_text_interpolation,
    STATE(1362), 1,
      sym_namespace_name,
    ACTIONS(1910), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29622] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_COLON,
    STATE(853), 1,
      sym_text_interpolation,
    STATE(1083), 1,
      sym__return_type,
    ACTIONS(2027), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [29643] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(703), 1,
      anon_sym_else,
    STATE(854), 1,
      sym_text_interpolation,
    ACTIONS(701), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [29662] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BSLASH,
    STATE(855), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2029), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [29681] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_else,
    STATE(856), 1,
      sym_text_interpolation,
    ACTIONS(751), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(2034), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29702] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(699), 1,
      anon_sym_else,
    STATE(857), 1,
      sym_text_interpolation,
    ACTIONS(697), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [29721] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_else,
    STATE(858), 1,
      sym_text_interpolation,
    ACTIONS(713), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(2036), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29742] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    ACTIONS(2038), 1,
      sym_name,
    ACTIONS(2040), 1,
      anon_sym_LBRACE,
    STATE(859), 1,
      sym_text_interpolation,
    STATE(423), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [29765] = 7,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2042), 1,
      ts_builtin_sym_end,
    ACTIONS(2044), 1,
      sym_php_tag,
    STATE(838), 1,
      aux_sym_text_repeat1,
    STATE(860), 1,
      sym_text_interpolation,
    ACTIONS(13), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [29788] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      anon_sym_BSLASH,
    STATE(248), 1,
      sym_compound_statement,
    STATE(861), 1,
      sym_text_interpolation,
    ACTIONS(2046), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29811] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1987), 1,
      sym_name,
    STATE(862), 1,
      sym_text_interpolation,
    STATE(1349), 1,
      sym_namespace_name,
    ACTIONS(1990), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29832] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2048), 1,
      sym_name,
    STATE(863), 1,
      sym_text_interpolation,
    STATE(1039), 1,
      sym__reserved_identifier,
    ACTIONS(1575), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29853] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1987), 1,
      sym_name,
    STATE(864), 1,
      sym_text_interpolation,
    STATE(1375), 1,
      sym_namespace_name,
    ACTIONS(1990), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29874] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2050), 1,
      sym_name,
    STATE(865), 1,
      sym_text_interpolation,
    STATE(1119), 1,
      sym_visibility_modifier,
    ACTIONS(2052), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [29895] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2054), 1,
      anon_sym_BSLASH,
    STATE(855), 1,
      aux_sym_namespace_name_repeat1,
    STATE(866), 1,
      sym_text_interpolation,
    ACTIONS(2007), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [29916] = 7,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2056), 1,
      sym_php_tag,
    ACTIONS(2060), 1,
      sym__eof,
    STATE(867), 1,
      sym_text_interpolation,
    STATE(958), 1,
      aux_sym_text_repeat1,
    STATE(1390), 1,
      sym_text,
    ACTIONS(2058), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [29939] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1987), 1,
      sym_name,
    STATE(868), 1,
      sym_text_interpolation,
    STATE(1379), 1,
      sym_namespace_name,
    ACTIONS(1990), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29960] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(869), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1155), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [29981] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_else,
    STATE(870), 1,
      sym_text_interpolation,
    ACTIONS(719), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(2062), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30002] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_BSLASH,
    STATE(871), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2029), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30021] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1987), 1,
      sym_name,
    STATE(872), 1,
      sym_text_interpolation,
    STATE(1358), 1,
      sym_namespace_name,
    ACTIONS(1990), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30042] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_catch,
    ACTIONS(1850), 1,
      anon_sym_finally,
    STATE(765), 1,
      aux_sym_try_statement_repeat1,
    STATE(873), 1,
      sym_text_interpolation,
    STATE(857), 2,
      sym_catch_clause,
      sym_finally_clause,
  [30065] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_while,
    ACTIONS(672), 1,
      anon_sym_else,
    ACTIONS(2067), 1,
      anon_sym_elseif,
    STATE(1046), 1,
      sym_else_if_clause,
    STATE(874), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat1,
  [30088] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2070), 1,
      sym_name,
    STATE(503), 1,
      sym__reserved_identifier,
    STATE(875), 1,
      sym_text_interpolation,
    ACTIONS(1708), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30109] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2054), 1,
      anon_sym_BSLASH,
    STATE(866), 1,
      aux_sym_namespace_name_repeat1,
    STATE(876), 1,
      sym_text_interpolation,
    ACTIONS(1964), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [30130] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2074), 1,
      anon_sym_as,
    STATE(877), 1,
      sym_text_interpolation,
    STATE(1117), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2072), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [30151] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_else,
    STATE(878), 1,
      sym_text_interpolation,
    ACTIONS(660), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [30170] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(2076), 1,
      sym_name,
    ACTIONS(2078), 1,
      anon_sym_LBRACE,
    STATE(879), 1,
      sym_text_interpolation,
    STATE(369), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [30193] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      sym_declaration_list,
    STATE(880), 1,
      sym_text_interpolation,
    STATE(1280), 1,
      sym_class_interface_clause,
  [30215] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(881), 1,
      sym_text_interpolation,
    ACTIONS(2029), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LBRACE,
  [30231] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      sym_text_interpolation,
    STATE(905), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2080), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30251] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(883), 1,
      sym_text_interpolation,
    STATE(914), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2084), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30271] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(556), 1,
      sym_compound_statement,
    STATE(884), 1,
      sym_text_interpolation,
    STATE(1270), 1,
      sym__return_type,
  [30293] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(720), 1,
      sym_compound_statement,
    STATE(885), 1,
      sym_text_interpolation,
    ACTIONS(2086), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30313] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2090), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      sym_text_interpolation,
    STATE(895), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(2088), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30333] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(887), 1,
      sym_text_interpolation,
    ACTIONS(2092), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30353] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_COMMA,
    STATE(888), 1,
      sym_text_interpolation,
    STATE(892), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(2094), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30373] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(835), 1,
      sym_declaration_list,
    STATE(889), 1,
      sym_text_interpolation,
    STATE(1183), 1,
      sym_class_interface_clause,
  [30395] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(890), 1,
      sym_text_interpolation,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2098), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30415] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(2102), 1,
      anon_sym_extends,
    STATE(891), 1,
      sym_text_interpolation,
    STATE(1123), 1,
      sym_declaration_list,
    STATE(1152), 1,
      sym_interface_base_clause,
  [30437] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_COMMA,
    ACTIONS(2104), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(892), 2,
      sym_text_interpolation,
      aux_sym_function_static_declaration_repeat1,
  [30455] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(507), 1,
      sym_compound_statement,
    STATE(893), 1,
      sym_text_interpolation,
    STATE(1181), 1,
      sym__return_type,
  [30477] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(890), 1,
      aux_sym_const_declaration_repeat1,
    STATE(894), 1,
      sym_text_interpolation,
    ACTIONS(2109), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30497] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2113), 1,
      anon_sym_COMMA,
    ACTIONS(2111), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(895), 2,
      sym_text_interpolation,
      aux_sym_global_declaration_repeat1,
  [30515] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1856), 1,
      anon_sym_implements,
    STATE(505), 1,
      sym_declaration_list,
    STATE(896), 1,
      sym_text_interpolation,
    STATE(1195), 1,
      sym_class_interface_clause,
  [30537] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(897), 1,
      sym_text_interpolation,
    ACTIONS(2116), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [30553] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(898), 1,
      sym_text_interpolation,
    STATE(900), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2080), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30573] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(899), 1,
      sym_text_interpolation,
    STATE(905), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2084), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30593] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(900), 1,
      sym_text_interpolation,
    STATE(905), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2118), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30613] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(899), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(901), 1,
      sym_text_interpolation,
    ACTIONS(2120), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30633] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(902), 1,
      sym_text_interpolation,
    ACTIONS(2029), 4,
      anon_sym_COMMA,
      anon_sym_BSLASH,
      anon_sym_as,
      anon_sym_RBRACE,
  [30649] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(903), 1,
      sym_text_interpolation,
    STATE(928), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2098), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30669] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2090), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym_global_declaration_repeat1,
    STATE(904), 1,
      sym_text_interpolation,
    ACTIONS(2122), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30689] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2126), 1,
      anon_sym_COMMA,
    ACTIONS(2124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(905), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_declaration_repeat1,
  [30707] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2090), 1,
      anon_sym_COMMA,
    STATE(895), 1,
      aux_sym_global_declaration_repeat1,
    STATE(906), 1,
      sym_text_interpolation,
    ACTIONS(2129), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30727] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_COMMA,
    STATE(888), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(907), 1,
      sym_text_interpolation,
    ACTIONS(2131), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30747] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_COMMA,
    STATE(892), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(908), 1,
      sym_text_interpolation,
    ACTIONS(2133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30767] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2135), 1,
      anon_sym_LBRACE,
    ACTIONS(2137), 1,
      anon_sym_LBRACK,
    ACTIONS(2139), 1,
      anon_sym_DASH_GT,
    STATE(909), 1,
      sym_text_interpolation,
  [30789] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(910), 1,
      sym_text_interpolation,
    ACTIONS(2141), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [30805] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_compound_statement,
    STATE(911), 1,
      sym_text_interpolation,
    ACTIONS(2143), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30825] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COMMA,
    STATE(912), 1,
      sym_text_interpolation,
    STATE(949), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(2145), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30845] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(500), 1,
      sym_compound_statement,
    STATE(913), 1,
      sym_text_interpolation,
    STATE(1207), 1,
      sym__return_type,
  [30867] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(905), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(914), 1,
      sym_text_interpolation,
    ACTIONS(2149), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30887] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2090), 1,
      anon_sym_COMMA,
    STATE(906), 1,
      aux_sym_global_declaration_repeat1,
    STATE(915), 1,
      sym_text_interpolation,
    ACTIONS(2151), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30907] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2155), 1,
      anon_sym_EQ,
    STATE(916), 1,
      sym_text_interpolation,
    ACTIONS(2153), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [30925] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1856), 1,
      anon_sym_implements,
    STATE(477), 1,
      sym_declaration_list,
    STATE(917), 1,
      sym_text_interpolation,
    STATE(1215), 1,
      sym_class_interface_clause,
  [30947] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(918), 1,
      sym_text_interpolation,
    ACTIONS(2157), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [30963] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(919), 1,
      sym_text_interpolation,
    STATE(935), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2159), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30983] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2102), 1,
      anon_sym_extends,
    ACTIONS(2161), 1,
      anon_sym_LBRACE,
    STATE(264), 1,
      sym_declaration_list,
    STATE(920), 1,
      sym_text_interpolation,
    STATE(1141), 1,
      sym_interface_base_clause,
  [31005] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_COMMA,
    STATE(908), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(921), 1,
      sym_text_interpolation,
    ACTIONS(2163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31025] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(922), 1,
      sym_text_interpolation,
    ACTIONS(2165), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31041] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(923), 1,
      sym_text_interpolation,
    ACTIONS(2167), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31057] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_declaration_list,
    STATE(924), 1,
      sym_text_interpolation,
    STATE(1264), 1,
      sym_class_interface_clause,
  [31079] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(925), 1,
      sym_text_interpolation,
    STATE(1313), 1,
      sym_declare_directive,
    ACTIONS(2169), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [31097] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(2171), 1,
      anon_sym_AMP,
    ACTIONS(2173), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(926), 1,
      sym_text_interpolation,
    STATE(1048), 1,
      sym_variable_name,
  [31119] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(927), 1,
      sym_text_interpolation,
    ACTIONS(2175), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31135] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(928), 1,
      sym_text_interpolation,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2177), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31155] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(482), 1,
      sym_compound_statement,
    STATE(929), 1,
      sym_text_interpolation,
    STATE(1219), 1,
      sym__return_type,
  [31177] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_COMMA,
    ACTIONS(2179), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(930), 2,
      sym_text_interpolation,
      aux_sym_const_declaration_repeat1,
  [31195] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2184), 1,
      anon_sym_LBRACE,
    ACTIONS(2186), 1,
      anon_sym_LBRACK,
    ACTIONS(2188), 1,
      anon_sym_DASH_GT,
    STATE(931), 1,
      sym_text_interpolation,
  [31217] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_compound_statement,
    STATE(932), 1,
      sym_text_interpolation,
    STATE(1228), 1,
      sym__return_type,
  [31239] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2192), 1,
      anon_sym_COMMA,
    ACTIONS(2190), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(933), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat2,
  [31257] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_as,
    STATE(934), 1,
      sym_text_interpolation,
    STATE(1285), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2195), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [31277] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    STATE(935), 1,
      sym_text_interpolation,
    ACTIONS(2199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31297] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(936), 1,
      sym_text_interpolation,
    ACTIONS(1894), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [31313] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_declaration_list,
    STATE(937), 1,
      sym_text_interpolation,
    STATE(1204), 1,
      sym_class_interface_clause,
  [31335] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_compound_statement,
    STATE(938), 1,
      sym_text_interpolation,
    STATE(1282), 1,
      sym__return_type,
  [31357] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    STATE(939), 1,
      sym_text_interpolation,
    ACTIONS(2201), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31377] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(940), 1,
      sym_text_interpolation,
    ACTIONS(1982), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [31393] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(2206), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(941), 2,
      sym_text_interpolation,
      aux_sym_array_creation_expression_repeat1,
  [31411] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2208), 1,
      anon_sym_LBRACE,
    ACTIONS(2210), 1,
      anon_sym_LBRACK,
    ACTIONS(2212), 1,
      anon_sym_DASH_GT,
    STATE(942), 1,
      sym_text_interpolation,
  [31433] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(939), 1,
      aux_sym_const_declaration_repeat1,
    STATE(943), 1,
      sym_text_interpolation,
    ACTIONS(2199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31453] = 5,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(1973), 1,
      sym__eof,
    ACTIONS(1975), 1,
      sym_php_tag,
    ACTIONS(2214), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
    STATE(944), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [31471] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(945), 1,
      sym_text_interpolation,
    ACTIONS(1910), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [31487] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_declaration_list,
    STATE(946), 1,
      sym_text_interpolation,
    STATE(1254), 1,
      sym_class_interface_clause,
  [31509] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(947), 1,
      sym_text_interpolation,
    ACTIONS(2217), 4,
      anon_sym_RBRACE,
      anon_sym_endswitch,
      anon_sym_case,
      anon_sym_default,
  [31525] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(948), 1,
      sym_text_interpolation,
    ACTIONS(2219), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31541] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COMMA,
    STATE(933), 1,
      aux_sym_property_declaration_repeat2,
    STATE(949), 1,
      sym_text_interpolation,
    ACTIONS(2221), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31561] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2227), 1,
      anon_sym_DASH_GT,
    STATE(950), 1,
      sym_text_interpolation,
  [31583] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_implements,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_declaration_list,
    STATE(951), 1,
      sym_text_interpolation,
    STATE(1243), 1,
      sym_class_interface_clause,
  [31605] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2208), 1,
      anon_sym_LBRACE,
    ACTIONS(2210), 1,
      anon_sym_LBRACK,
    ACTIONS(2229), 1,
      anon_sym_DASH_GT,
    STATE(952), 1,
      sym_text_interpolation,
  [31627] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(953), 1,
      sym_text_interpolation,
    STATE(1314), 1,
      sym_declare_directive,
    ACTIONS(2169), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [31645] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(954), 1,
      sym_text_interpolation,
    ACTIONS(2231), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31661] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_as,
    STATE(955), 1,
      sym_text_interpolation,
    STATE(1278), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2233), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [31681] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(956), 1,
      sym_text_interpolation,
    ACTIONS(1075), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
  [31697] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(957), 1,
      sym_text_interpolation,
    ACTIONS(2235), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [31713] = 6,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2042), 1,
      sym__eof,
    ACTIONS(2044), 1,
      sym_php_tag,
    STATE(944), 1,
      aux_sym_text_repeat1,
    STATE(958), 1,
      sym_text_interpolation,
    ACTIONS(2237), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [31733] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(959), 1,
      sym_text_interpolation,
    STATE(1004), 1,
      aux_sym_list_literal_repeat1,
  [31755] = 5,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2241), 1,
      ts_builtin_sym_end,
    STATE(960), 1,
      sym_text_interpolation,
    ACTIONS(2243), 3,
      sym_php_tag,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [31773] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(961), 1,
      sym_text_interpolation,
    ACTIONS(2245), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [31788] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(967), 1,
      anon_sym_else,
    STATE(962), 1,
      sym_text_interpolation,
    ACTIONS(965), 2,
      anon_sym_while,
      anon_sym_elseif,
  [31805] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(1969), 1,
      anon_sym_LBRACE,
    STATE(963), 1,
      sym_text_interpolation,
    STATE(1318), 1,
      sym__return_type,
  [31824] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(871), 1,
      anon_sym_else,
    STATE(964), 1,
      sym_text_interpolation,
    ACTIONS(869), 2,
      anon_sym_while,
      anon_sym_elseif,
  [31841] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(965), 1,
      sym_text_interpolation,
    ACTIONS(2206), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [31856] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1326), 1,
      anon_sym_DOLLAR,
    STATE(851), 1,
      sym_variable_name,
    STATE(966), 1,
      sym_text_interpolation,
    STATE(1051), 1,
      sym_property_element,
  [31875] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_COMMA,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      sym_text_interpolation,
    STATE(1069), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [31894] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_else,
    STATE(968), 1,
      sym_text_interpolation,
    ACTIONS(801), 2,
      anon_sym_while,
      anon_sym_elseif,
  [31911] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(969), 1,
      sym_text_interpolation,
    ACTIONS(2251), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [31926] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    ACTIONS(2253), 1,
      anon_sym_AMP,
    STATE(806), 1,
      sym_formal_parameters,
    STATE(970), 1,
      sym_text_interpolation,
  [31945] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(2255), 1,
      anon_sym_AMP,
    STATE(971), 1,
      sym_text_interpolation,
    STATE(1194), 1,
      sym_variable_name,
  [31964] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_COMMA,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    STATE(972), 1,
      sym_text_interpolation,
    STATE(1098), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [31983] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(819), 1,
      anon_sym_else,
    STATE(973), 1,
      sym_text_interpolation,
    ACTIONS(817), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32000] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(887), 1,
      anon_sym_else,
    STATE(974), 1,
      sym_text_interpolation,
    ACTIONS(885), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32017] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(827), 1,
      anon_sym_else,
    STATE(975), 1,
      sym_text_interpolation,
    ACTIONS(825), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32034] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_else,
    STATE(976), 1,
      sym_text_interpolation,
    ACTIONS(829), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32051] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_else,
    STATE(977), 1,
      sym_text_interpolation,
    ACTIONS(829), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32068] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_else,
    STATE(978), 1,
      sym_text_interpolation,
    ACTIONS(837), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32085] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(843), 1,
      anon_sym_else,
    STATE(979), 1,
      sym_text_interpolation,
    ACTIONS(841), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32102] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_else,
    STATE(980), 1,
      sym_text_interpolation,
    ACTIONS(929), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32119] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(763), 1,
      anon_sym_else,
    STATE(981), 1,
      sym_text_interpolation,
    ACTIONS(761), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32136] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_else,
    STATE(982), 1,
      sym_text_interpolation,
    ACTIONS(849), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32153] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_else,
    STATE(983), 1,
      sym_text_interpolation,
    ACTIONS(853), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32170] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(859), 1,
      anon_sym_else,
    STATE(984), 1,
      sym_text_interpolation,
    ACTIONS(857), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32187] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    ACTIONS(2259), 1,
      anon_sym_RBRACE,
    STATE(985), 1,
      sym_text_interpolation,
    STATE(1116), 1,
      aux_sym_namespace_use_group_repeat1,
  [32206] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(986), 1,
      sym_text_interpolation,
    STATE(904), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [32223] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(987), 1,
      sym_text_interpolation,
    ACTIONS(1149), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32240] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_else,
    STATE(988), 1,
      sym_text_interpolation,
    ACTIONS(861), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32257] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_RPAREN,
    ACTIONS(2261), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      sym_text_interpolation,
    STATE(1065), 1,
      aux_sym_array_creation_expression_repeat1,
  [32276] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(990), 1,
      sym_text_interpolation,
    ACTIONS(2263), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [32291] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(883), 1,
      anon_sym_else,
    STATE(991), 1,
      sym_text_interpolation,
    ACTIONS(881), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32308] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_else,
    STATE(992), 1,
      sym_text_interpolation,
    ACTIONS(889), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32325] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(459), 1,
      sym_arguments,
    STATE(993), 1,
      sym_text_interpolation,
  [32344] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_else,
    STATE(994), 1,
      sym_text_interpolation,
    ACTIONS(893), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32361] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_else,
    STATE(995), 1,
      sym_text_interpolation,
    ACTIONS(897), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32378] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_else,
    STATE(996), 1,
      sym_text_interpolation,
    ACTIONS(897), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32395] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_else,
    STATE(997), 1,
      sym_text_interpolation,
    ACTIONS(941), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32412] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_else,
    STATE(998), 1,
      sym_text_interpolation,
    ACTIONS(949), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32429] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_else,
    STATE(999), 1,
      sym_text_interpolation,
    ACTIONS(953), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32446] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(975), 1,
      anon_sym_else,
    STATE(1000), 1,
      sym_text_interpolation,
    ACTIONS(973), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32463] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    STATE(1001), 1,
      sym_text_interpolation,
    STATE(1034), 1,
      aux_sym_arguments_repeat1,
  [32482] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    ACTIONS(2267), 1,
      anon_sym_COMMA,
    STATE(1002), 1,
      sym_text_interpolation,
    STATE(1079), 1,
      aux_sym_array_creation_expression_repeat1,
  [32501] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(979), 1,
      anon_sym_else,
    STATE(1003), 1,
      sym_text_interpolation,
    ACTIONS(977), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32518] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(2269), 1,
      anon_sym_RPAREN,
    STATE(1004), 1,
      sym_text_interpolation,
    STATE(1017), 1,
      aux_sym_list_literal_repeat1,
  [32537] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(2271), 1,
      anon_sym_RPAREN,
    STATE(1005), 1,
      sym_text_interpolation,
    STATE(1122), 1,
      aux_sym_unset_statement_repeat1,
  [32556] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1006), 1,
      sym_text_interpolation,
    ACTIONS(2157), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [32571] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(983), 1,
      anon_sym_else,
    STATE(1007), 1,
      sym_text_interpolation,
    ACTIONS(981), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32588] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_else,
    STATE(1008), 1,
      sym_text_interpolation,
    ACTIONS(985), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32605] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_else,
    STATE(1009), 1,
      sym_text_interpolation,
    ACTIONS(989), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32622] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_else,
    STATE(1010), 1,
      sym_text_interpolation,
    ACTIONS(989), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32639] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(999), 1,
      anon_sym_else,
    STATE(1011), 1,
      sym_text_interpolation,
    ACTIONS(997), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32656] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(999), 1,
      anon_sym_else,
    STATE(1012), 1,
      sym_text_interpolation,
    ACTIONS(997), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32673] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_else,
    STATE(1013), 1,
      sym_text_interpolation,
    ACTIONS(1001), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32690] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_else,
    STATE(1014), 1,
      sym_text_interpolation,
    ACTIONS(1005), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32707] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_else,
    STATE(1015), 1,
      sym_text_interpolation,
    ACTIONS(1013), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32724] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(759), 1,
      anon_sym_else,
    STATE(1016), 1,
      sym_text_interpolation,
    ACTIONS(757), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32741] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
    ACTIONS(2273), 1,
      anon_sym_COMMA,
    STATE(1017), 2,
      sym_text_interpolation,
      aux_sym_list_literal_repeat1,
  [32758] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_else,
    STATE(1018), 1,
      sym_text_interpolation,
    ACTIONS(1025), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32775] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_else,
    STATE(1019), 1,
      sym_text_interpolation,
    ACTIONS(1025), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32792] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_else,
    STATE(1020), 1,
      sym_text_interpolation,
    ACTIONS(1029), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32809] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_else,
    STATE(1021), 1,
      sym_text_interpolation,
    ACTIONS(1029), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32826] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1047), 1,
      anon_sym_else,
    STATE(1022), 1,
      sym_text_interpolation,
    ACTIONS(1045), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32843] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_else,
    STATE(1023), 1,
      sym_text_interpolation,
    ACTIONS(1041), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32860] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_else,
    STATE(1024), 1,
      sym_text_interpolation,
    ACTIONS(1041), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32877] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1039), 1,
      anon_sym_else,
    STATE(1025), 1,
      sym_text_interpolation,
    ACTIONS(1037), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32894] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_else,
    STATE(1026), 1,
      sym_text_interpolation,
    ACTIONS(1033), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32911] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_else,
    STATE(1027), 1,
      sym_text_interpolation,
    ACTIONS(1021), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32928] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_else,
    STATE(1028), 1,
      sym_text_interpolation,
    ACTIONS(1017), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32945] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1011), 1,
      anon_sym_else,
    STATE(1029), 1,
      sym_text_interpolation,
    ACTIONS(1009), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32962] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1030), 1,
      sym_text_interpolation,
    ACTIONS(1155), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [32977] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(2276), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_text_interpolation,
    STATE(1034), 1,
      aux_sym_arguments_repeat1,
  [32996] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
    STATE(1001), 1,
      aux_sym_arguments_repeat1,
    STATE(1032), 1,
      sym_text_interpolation,
  [33015] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1033), 1,
      sym_text_interpolation,
    ACTIONS(2278), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [33030] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
    STATE(1034), 2,
      sym_text_interpolation,
      aux_sym_arguments_repeat1,
  [33047] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(2283), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1035), 1,
      sym_text_interpolation,
    STATE(1062), 1,
      sym_variable_name,
  [33066] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(361), 1,
      sym_arguments,
    STATE(1036), 1,
      sym_text_interpolation,
  [33085] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1982), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_COMMA,
    STATE(1037), 2,
      sym_text_interpolation,
      aux_sym_interface_base_clause_repeat1,
  [33102] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1038), 1,
      sym_text_interpolation,
    ACTIONS(2288), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [33117] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1039), 1,
      sym_text_interpolation,
    ACTIONS(1224), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [33132] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_arguments_repeat1,
    STATE(1040), 1,
      sym_text_interpolation,
  [33151] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_else,
    STATE(1041), 1,
      sym_text_interpolation,
    ACTIONS(797), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33168] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_EQ,
    STATE(1042), 1,
      sym_text_interpolation,
    ACTIONS(2292), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33185] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1786), 1,
      anon_sym_RPAREN,
    STATE(1043), 1,
      sym_text_interpolation,
    STATE(1124), 1,
      aux_sym_list_literal_repeat1,
  [33204] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_else,
    STATE(1044), 1,
      sym_text_interpolation,
    ACTIONS(765), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33221] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
    STATE(1040), 1,
      aux_sym_arguments_repeat1,
    STATE(1045), 1,
      sym_text_interpolation,
  [33240] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_else,
    STATE(1046), 1,
      sym_text_interpolation,
    ACTIONS(777), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33257] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    ACTIONS(2296), 1,
      anon_sym_RBRACE,
    STATE(985), 1,
      aux_sym_namespace_use_group_repeat1,
    STATE(1047), 1,
      sym_text_interpolation,
  [33276] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2300), 1,
      anon_sym_EQ,
    STATE(1048), 1,
      sym_text_interpolation,
    ACTIONS(2298), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33293] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_list_literal_repeat1,
    STATE(1049), 1,
      sym_text_interpolation,
  [33312] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(795), 1,
      anon_sym_else,
    STATE(1050), 1,
      sym_text_interpolation,
    ACTIONS(793), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33329] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1051), 1,
      sym_text_interpolation,
    ACTIONS(2190), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [33344] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(2302), 1,
      anon_sym_AMP,
    STATE(1052), 1,
      sym_text_interpolation,
    STATE(1071), 1,
      sym_variable_name,
  [33363] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1053), 1,
      sym_text_interpolation,
    ACTIONS(2235), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [33378] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_else,
    STATE(1054), 1,
      sym_text_interpolation,
    ACTIONS(993), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33395] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1055), 1,
      sym_text_interpolation,
    ACTIONS(2304), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [33410] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(338), 1,
      sym_arguments,
    STATE(1056), 1,
      sym_text_interpolation,
  [33429] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_LBRACE,
    ACTIONS(2308), 1,
      anon_sym_COLON,
    STATE(300), 1,
      sym_switch_block,
    STATE(1057), 1,
      sym_text_interpolation,
  [33448] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    STATE(1058), 2,
      sym_text_interpolation,
      aux_sym_formal_parameters_repeat1,
  [33465] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_else,
    STATE(1059), 1,
      sym_text_interpolation,
    ACTIONS(969), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33482] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_else,
    STATE(1060), 1,
      sym_text_interpolation,
    ACTIONS(961), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33499] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COMMA,
    ACTIONS(2315), 1,
      anon_sym_RPAREN,
    STATE(1061), 1,
      sym_text_interpolation,
    STATE(1122), 1,
      aux_sym_unset_statement_repeat1,
  [33518] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_EQ,
    STATE(1062), 1,
      sym_text_interpolation,
    ACTIONS(2317), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33535] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1063), 1,
      sym_text_interpolation,
    ACTIONS(2179), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [33550] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    ACTIONS(2027), 1,
      anon_sym_LBRACE,
    STATE(1064), 1,
      sym_text_interpolation,
    STATE(1397), 1,
      sym__return_type,
  [33569] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    ACTIONS(2321), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1065), 1,
      sym_text_interpolation,
  [33588] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    STATE(830), 1,
      sym_formal_parameters,
    STATE(1066), 1,
      sym_text_interpolation,
  [33607] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_EQ,
    STATE(1067), 1,
      sym_text_interpolation,
    ACTIONS(2325), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33624] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_COMMA,
    ACTIONS(2331), 1,
      anon_sym_RPAREN,
    STATE(1068), 1,
      sym_text_interpolation,
    STATE(1114), 1,
      aux_sym_formal_parameters_repeat1,
  [33643] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2333), 1,
      anon_sym_COMMA,
    ACTIONS(2336), 1,
      anon_sym_RPAREN,
    STATE(1069), 2,
      sym_text_interpolation,
      aux_sym_anonymous_function_use_clause_repeat1,
  [33660] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(2338), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_arguments_repeat1,
    STATE(1070), 1,
      sym_text_interpolation,
  [33679] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_COMMA,
    ACTIONS(2340), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
    STATE(1071), 1,
      sym_text_interpolation,
  [33698] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1072), 1,
      sym_text_interpolation,
    ACTIONS(2342), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [33713] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(807), 1,
      anon_sym_else,
    STATE(1073), 1,
      sym_text_interpolation,
    ACTIONS(805), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33730] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(1074), 1,
      sym_text_interpolation,
    STATE(915), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [33747] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1075), 1,
      sym_text_interpolation,
    ACTIONS(2141), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [33762] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    ACTIONS(2344), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1042), 1,
      sym_variable_name,
    STATE(1076), 1,
      sym_text_interpolation,
  [33781] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    STATE(787), 1,
      sym_formal_parameters,
    STATE(1077), 1,
      sym_text_interpolation,
  [33800] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(815), 1,
      anon_sym_else,
    STATE(1078), 1,
      sym_text_interpolation,
    ACTIONS(813), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33817] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_RBRACK,
    ACTIONS(2348), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1079), 1,
      sym_text_interpolation,
  [33836] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(592), 1,
      anon_sym_RPAREN,
    ACTIONS(2350), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1080), 1,
      sym_text_interpolation,
  [33855] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1081), 1,
      sym_text_interpolation,
    ACTIONS(2352), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [33870] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_else,
    STATE(1082), 1,
      sym_text_interpolation,
    ACTIONS(937), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33887] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1083), 1,
      sym_text_interpolation,
    ACTIONS(2354), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [33902] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1084), 1,
      sym_text_interpolation,
    ACTIONS(2231), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [33917] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(903), 1,
      anon_sym_else,
    STATE(1085), 1,
      sym_text_interpolation,
    ACTIONS(901), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33934] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1086), 1,
      sym_text_interpolation,
    ACTIONS(1774), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      sym_name,
  [33949] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1087), 1,
      sym_text_interpolation,
    ACTIONS(2219), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [33964] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_DOLLAR,
    STATE(1088), 1,
      sym_text_interpolation,
    STATE(456), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [33981] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_COMMA,
    ACTIONS(2356), 1,
      anon_sym_RPAREN,
    STATE(1058), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1089), 1,
      sym_text_interpolation,
  [34000] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(867), 1,
      anon_sym_else,
    STATE(1090), 1,
      sym_text_interpolation,
    ACTIONS(865), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34017] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_else,
    STATE(1091), 1,
      sym_text_interpolation,
    ACTIONS(769), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34034] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(775), 1,
      anon_sym_else,
    STATE(1092), 1,
      sym_text_interpolation,
    ACTIONS(773), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34051] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2358), 1,
      anon_sym_COMMA,
    ACTIONS(2360), 1,
      anon_sym_LBRACE,
    STATE(1093), 1,
      sym_text_interpolation,
    STATE(1112), 1,
      aux_sym_interface_base_clause_repeat1,
  [34070] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_else,
    STATE(1094), 1,
      sym_text_interpolation,
    ACTIONS(933), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34087] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 1,
      anon_sym_else,
    STATE(1095), 1,
      sym_text_interpolation,
    ACTIONS(945), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34104] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(959), 1,
      anon_sym_else,
    STATE(1096), 1,
      sym_text_interpolation,
    ACTIONS(957), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34121] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(787), 1,
      anon_sym_else,
    STATE(1097), 1,
      sym_text_interpolation,
    ACTIONS(785), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34138] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_COMMA,
    ACTIONS(2362), 1,
      anon_sym_RPAREN,
    STATE(1069), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
    STATE(1098), 1,
      sym_text_interpolation,
  [34157] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1099), 1,
      sym_text_interpolation,
    ACTIONS(2165), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34172] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1100), 1,
      sym_text_interpolation,
    ACTIONS(2167), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34187] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
    STATE(1070), 1,
      aux_sym_arguments_repeat1,
    STATE(1101), 1,
      sym_text_interpolation,
  [34206] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1102), 1,
      sym_text_interpolation,
    ACTIONS(2175), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34221] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1326), 1,
      anon_sym_DOLLAR,
    STATE(916), 1,
      sym_variable_name,
    STATE(1103), 1,
      sym_text_interpolation,
    STATE(1126), 1,
      sym_static_variable_declaration,
  [34240] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(1104), 1,
      sym_text_interpolation,
    STATE(1111), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [34257] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1105), 1,
      sym_text_interpolation,
    ACTIONS(2124), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34272] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2358), 1,
      anon_sym_COMMA,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    STATE(1037), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(1106), 1,
      sym_text_interpolation,
  [34291] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2368), 1,
      anon_sym_else,
    STATE(1107), 1,
      sym_text_interpolation,
    ACTIONS(2366), 2,
      anon_sym_endif,
      anon_sym_elseif,
  [34308] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_RBRACK,
    ACTIONS(2370), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1108), 1,
      sym_text_interpolation,
  [34327] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_COMMA,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      aux_sym_arguments_repeat1,
    STATE(1109), 1,
      sym_text_interpolation,
  [34346] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_else,
    STATE(1110), 1,
      sym_text_interpolation,
    ACTIONS(2372), 2,
      anon_sym_endif,
      anon_sym_elseif,
  [34363] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1111), 1,
      sym_text_interpolation,
    ACTIONS(2111), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34378] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2358), 1,
      anon_sym_COMMA,
    ACTIONS(2376), 1,
      anon_sym_LBRACE,
    STATE(1037), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(1112), 1,
      sym_text_interpolation,
  [34397] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOLLAR,
    STATE(1113), 1,
      sym_text_interpolation,
    STATE(415), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [34414] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_COMMA,
    ACTIONS(2378), 1,
      anon_sym_RPAREN,
    STATE(1058), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1114), 1,
      sym_text_interpolation,
  [34433] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_AMP,
    STATE(828), 1,
      sym_formal_parameters,
    STATE(1115), 1,
      sym_text_interpolation,
  [34452] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_RBRACE,
    STATE(1116), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_group_repeat1,
  [34469] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1117), 1,
      sym_text_interpolation,
    ACTIONS(2387), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34484] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_RPAREN,
    ACTIONS(2389), 1,
      anon_sym_COMMA,
    STATE(1080), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1118), 1,
      sym_text_interpolation,
  [34503] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2391), 1,
      sym_name,
    STATE(1119), 1,
      sym_text_interpolation,
    ACTIONS(2393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34520] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1120), 1,
      sym_text_interpolation,
    ACTIONS(2395), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [34535] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(823), 1,
      anon_sym_else,
    STATE(1121), 1,
      sym_text_interpolation,
    ACTIONS(821), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34552] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_RPAREN,
    ACTIONS(2397), 1,
      anon_sym_COMMA,
    STATE(1122), 2,
      sym_text_interpolation,
      aux_sym_unset_statement_repeat1,
  [34569] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(835), 1,
      anon_sym_else,
    STATE(1123), 1,
      sym_text_interpolation,
    ACTIONS(833), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34586] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_COMMA,
    ACTIONS(2400), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_list_literal_repeat1,
    STATE(1124), 1,
      sym_text_interpolation,
  [34605] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(791), 1,
      anon_sym_else,
    STATE(1125), 1,
      sym_text_interpolation,
    ACTIONS(789), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34622] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1126), 1,
      sym_text_interpolation,
    ACTIONS(2104), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34637] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      anon_sym_COLON,
    STATE(962), 1,
      sym_switch_block,
    STATE(1127), 1,
      sym_text_interpolation,
  [34656] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_COMMA,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    STATE(1089), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1128), 1,
      sym_text_interpolation,
  [34675] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2358), 1,
      anon_sym_COMMA,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    STATE(1106), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(1129), 1,
      sym_text_interpolation,
  [34694] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_else,
    STATE(1130), 1,
      sym_text_interpolation,
    ACTIONS(873), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34711] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RBRACK,
    ACTIONS(2410), 1,
      anon_sym_COMMA,
    STATE(1108), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1131), 1,
      sym_text_interpolation,
  [34730] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(416), 1,
      sym_arguments,
    STATE(1132), 1,
      sym_text_interpolation,
  [34749] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 1,
      anon_sym_else,
    STATE(1133), 1,
      sym_text_interpolation,
    ACTIONS(925), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34766] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_else,
    STATE(1134), 1,
      sym_text_interpolation,
    ACTIONS(905), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34783] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_else,
    STATE(1135), 1,
      sym_text_interpolation,
    ACTIONS(921), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34800] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1960), 1,
      anon_sym_BSLASH,
    ACTIONS(2412), 1,
      sym_name,
    STATE(1136), 1,
      sym_text_interpolation,
    STATE(1377), 1,
      sym_namespace_name,
  [34819] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_else,
    STATE(1137), 1,
      sym_text_interpolation,
    ACTIONS(917), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34836] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_else,
    STATE(1138), 1,
      sym_text_interpolation,
    ACTIONS(913), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34853] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_else,
    STATE(1139), 1,
      sym_text_interpolation,
    ACTIONS(909), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34870] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(342), 1,
      sym_arguments,
    STATE(1140), 1,
      sym_text_interpolation,
  [34886] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2161), 1,
      anon_sym_LBRACE,
    STATE(259), 1,
      sym_declaration_list,
    STATE(1141), 1,
      sym_text_interpolation,
  [34902] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2414), 1,
      anon_sym_LPAREN,
    STATE(1057), 1,
      sym_parenthesized_expression,
    STATE(1142), 1,
      sym_text_interpolation,
  [34918] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1143), 1,
      sym_text_interpolation,
    ACTIONS(2385), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [34932] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1144), 1,
      sym_text_interpolation,
    ACTIONS(2416), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34946] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_LPAREN,
    STATE(837), 1,
      sym_formal_parameters,
    STATE(1145), 1,
      sym_text_interpolation,
  [34962] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1146), 1,
      sym_text_interpolation,
    ACTIONS(434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34976] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_parenthesized_expression,
    STATE(1147), 1,
      sym_text_interpolation,
  [34992] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_compound_statement,
    STATE(1148), 1,
      sym_text_interpolation,
  [35008] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(556), 1,
      sym_compound_statement,
    STATE(1149), 1,
      sym_text_interpolation,
  [35024] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1150), 1,
      sym_text_interpolation,
    ACTIONS(2422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35038] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      sym_declaration_list,
    STATE(1151), 1,
      sym_text_interpolation,
  [35054] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(1078), 1,
      sym_declaration_list,
    STATE(1152), 1,
      sym_text_interpolation,
  [35070] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1153), 1,
      sym_text_interpolation,
    ACTIONS(2424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35084] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(835), 1,
      sym_declaration_list,
    STATE(1154), 1,
      sym_text_interpolation,
  [35100] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(830), 1,
      sym_formal_parameters,
    STATE(1155), 1,
      sym_text_interpolation,
  [35116] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1156), 1,
      sym_text_interpolation,
    ACTIONS(2426), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35130] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1157), 1,
      sym_text_interpolation,
    ACTIONS(1862), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35144] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(854), 1,
      sym_compound_statement,
    STATE(1158), 1,
      sym_text_interpolation,
  [35160] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(22), 1,
      sym_parenthesized_expression,
    STATE(1159), 1,
      sym_text_interpolation,
  [35176] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1160), 1,
      sym_text_interpolation,
    ACTIONS(2428), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35190] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_declaration_list,
    STATE(1161), 1,
      sym_text_interpolation,
  [35206] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(832), 1,
      sym_compound_statement,
    STATE(1162), 1,
      sym_text_interpolation,
  [35222] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1163), 1,
      sym_text_interpolation,
    ACTIONS(2430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35236] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(1121), 1,
      sym_declaration_list,
    STATE(1164), 1,
      sym_text_interpolation,
  [35252] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1165), 1,
      sym_text_interpolation,
    ACTIONS(2432), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [35266] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_LPAREN,
    STATE(853), 1,
      sym_formal_parameters,
    STATE(1166), 1,
      sym_text_interpolation,
  [35282] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(298), 1,
      anon_sym_COLON,
    STATE(1167), 1,
      sym_text_interpolation,
    STATE(1387), 1,
      sym_colon_block,
  [35298] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2414), 1,
      anon_sym_LPAREN,
    STATE(1168), 1,
      sym_text_interpolation,
    STATE(1237), 1,
      sym_parenthesized_expression,
  [35314] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1169), 1,
      sym_text_interpolation,
    ACTIONS(2434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35328] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1170), 1,
      sym_text_interpolation,
    ACTIONS(2436), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [35342] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_declaration_list,
    STATE(1171), 1,
      sym_text_interpolation,
  [35358] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1172), 1,
      sym_text_interpolation,
    STATE(1383), 1,
      sym_variable_name,
  [35374] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(1059), 1,
      sym_compound_statement,
    STATE(1173), 1,
      sym_text_interpolation,
  [35390] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1174), 1,
      sym_text_interpolation,
    ACTIONS(2245), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35404] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1175), 1,
      sym_text_interpolation,
    ACTIONS(2438), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35418] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_compound_statement,
    STATE(1176), 1,
      sym_text_interpolation,
  [35434] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(60), 1,
      sym_parenthesized_expression,
    STATE(1177), 1,
      sym_text_interpolation,
  [35450] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1178), 1,
      sym_text_interpolation,
    ACTIONS(2440), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35464] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1179), 1,
      sym_text_interpolation,
    ACTIONS(2149), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35478] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(19), 1,
      sym_parenthesized_expression,
    STATE(1180), 1,
      sym_text_interpolation,
  [35494] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_compound_statement,
    STATE(1181), 1,
      sym_text_interpolation,
  [35510] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(1064), 1,
      sym_formal_parameters,
    STATE(1182), 1,
      sym_text_interpolation,
  [35526] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(850), 1,
      sym_declaration_list,
    STATE(1183), 1,
      sym_text_interpolation,
  [35542] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1184), 1,
      sym_text_interpolation,
    STATE(1287), 1,
      sym_variable_name,
  [35558] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2161), 1,
      anon_sym_LBRACE,
    STATE(261), 1,
      sym_declaration_list,
    STATE(1185), 1,
      sym_text_interpolation,
  [35574] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1186), 1,
      sym_text_interpolation,
    ACTIONS(2442), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35588] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(963), 1,
      sym_formal_parameters,
    STATE(1187), 1,
      sym_text_interpolation,
  [35604] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1188), 1,
      sym_text_interpolation,
    ACTIONS(2444), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35618] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1189), 1,
      sym_text_interpolation,
    ACTIONS(2446), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35632] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(57), 1,
      sym_parenthesized_expression,
    STATE(1190), 1,
      sym_text_interpolation,
  [35648] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1191), 1,
      sym_text_interpolation,
    ACTIONS(2448), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35662] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_RPAREN,
    STATE(1192), 1,
      sym_text_interpolation,
  [35678] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1193), 1,
      sym_text_interpolation,
    ACTIONS(1946), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35692] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1194), 1,
      sym_text_interpolation,
    ACTIONS(2336), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35706] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(477), 1,
      sym_declaration_list,
    STATE(1195), 1,
      sym_text_interpolation,
  [35722] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1196), 1,
      sym_text_interpolation,
    STATE(1340), 1,
      sym_variable_name,
  [35738] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1197), 1,
      sym_text_interpolation,
    ACTIONS(2454), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35752] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(972), 1,
      sym_variable_name,
    STATE(1198), 1,
      sym_text_interpolation,
  [35768] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1199), 1,
      sym_text_interpolation,
    STATE(1292), 1,
      sym_variable_name,
  [35784] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1200), 1,
      sym_text_interpolation,
    ACTIONS(1523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35798] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(1201), 1,
      sym_text_interpolation,
  [35814] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_declaration_list,
    STATE(1202), 1,
      sym_text_interpolation,
  [35830] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1203), 1,
      sym_text_interpolation,
    ACTIONS(2456), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35844] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(154), 1,
      sym_declaration_list,
    STATE(1204), 1,
      sym_text_interpolation,
  [35860] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(482), 1,
      sym_compound_statement,
    STATE(1205), 1,
      sym_text_interpolation,
  [35876] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(796), 1,
      sym_formal_parameters,
    STATE(1206), 1,
      sym_text_interpolation,
  [35892] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(483), 1,
      sym_compound_statement,
    STATE(1207), 1,
      sym_text_interpolation,
  [35908] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1208), 1,
      sym_text_interpolation,
    ACTIONS(2458), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35922] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1209), 1,
      sym_text_interpolation,
    ACTIONS(2393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35936] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1210), 1,
      sym_text_interpolation,
    ACTIONS(2460), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35950] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1211), 1,
      sym_text_interpolation,
    ACTIONS(2462), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35964] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1212), 1,
      sym_text_interpolation,
    ACTIONS(2464), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35978] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1213), 1,
      sym_text_interpolation,
    ACTIONS(2466), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35992] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1214), 1,
      sym_text_interpolation,
    ACTIONS(2468), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36006] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(485), 1,
      sym_declaration_list,
    STATE(1215), 1,
      sym_text_interpolation,
  [36022] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    STATE(17), 1,
      sym_parenthesized_expression,
    STATE(1216), 1,
      sym_text_interpolation,
  [36038] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(1217), 1,
      sym_text_interpolation,
  [36054] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_LPAREN,
    STATE(1218), 1,
      sym_text_interpolation,
    STATE(1241), 1,
      sym_parenthesized_expression,
  [36070] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_compound_statement,
    STATE(1219), 1,
      sym_text_interpolation,
  [36086] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1220), 1,
      sym_text_interpolation,
    ACTIONS(2472), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36100] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1221), 1,
      sym_text_interpolation,
    ACTIONS(2474), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36114] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1222), 1,
      sym_text_interpolation,
    ACTIONS(1898), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36128] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1223), 1,
      sym_text_interpolation,
    ACTIONS(1505), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [36142] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1224), 1,
      sym_text_interpolation,
    ACTIONS(2476), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36156] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1225), 1,
      sym_text_interpolation,
    ACTIONS(2478), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36170] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(878), 1,
      sym_compound_statement,
    STATE(1226), 1,
      sym_text_interpolation,
  [36186] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1227), 1,
      sym_text_interpolation,
    ACTIONS(442), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36200] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(574), 1,
      sym_compound_statement,
    STATE(1228), 1,
      sym_text_interpolation,
  [36216] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1229), 1,
      sym_text_interpolation,
    ACTIONS(2480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36230] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1230), 1,
      sym_text_interpolation,
    ACTIONS(452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36244] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1231), 1,
      sym_text_interpolation,
    ACTIONS(2482), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [36258] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1232), 1,
      sym_text_interpolation,
    ACTIONS(2484), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36272] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1233), 1,
      sym_text_interpolation,
    ACTIONS(2486), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36286] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1234), 1,
      sym_text_interpolation,
    ACTIONS(2488), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36300] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1235), 1,
      sym_text_interpolation,
    ACTIONS(2490), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36314] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1236), 1,
      sym_text_interpolation,
    ACTIONS(2492), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36328] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(298), 1,
      anon_sym_COLON,
    STATE(1110), 1,
      sym_colon_block,
    STATE(1237), 1,
      sym_text_interpolation,
  [36344] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_compound_statement,
    STATE(1238), 1,
      sym_text_interpolation,
  [36360] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1239), 1,
      sym_text_interpolation,
    ACTIONS(2494), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36374] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(136), 1,
      sym_compound_statement,
    STATE(1240), 1,
      sym_text_interpolation,
  [36390] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1241), 1,
      sym_text_interpolation,
    ACTIONS(2496), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36404] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1242), 1,
      sym_text_interpolation,
    ACTIONS(2498), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36418] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_declaration_list,
    STATE(1243), 1,
      sym_text_interpolation,
  [36434] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1244), 1,
      sym_text_interpolation,
    STATE(1288), 1,
      sym_variable_name,
  [36450] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(1245), 1,
      sym_text_interpolation,
    STATE(1295), 1,
      aux_sym_namespace_name_repeat1,
  [36466] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1246), 1,
      sym_text_interpolation,
    ACTIONS(2500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36480] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1247), 1,
      sym_text_interpolation,
    ACTIONS(2502), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36494] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1248), 1,
      sym_text_interpolation,
    ACTIONS(2118), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36508] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1249), 1,
      sym_text_interpolation,
    ACTIONS(2504), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36522] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1250), 1,
      sym_text_interpolation,
    ACTIONS(2313), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36536] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(446), 1,
      ts_builtin_sym_end,
    ACTIONS(2506), 1,
      sym_php_tag,
    STATE(1251), 1,
      sym_text_interpolation,
  [36552] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1252), 1,
      sym_text_interpolation,
    ACTIONS(2508), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36566] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1253), 1,
      sym_text_interpolation,
    ACTIONS(2510), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36580] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(572), 1,
      sym_declaration_list,
    STATE(1254), 1,
      sym_text_interpolation,
  [36596] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1255), 1,
      sym_text_interpolation,
    ACTIONS(2512), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [36610] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1256), 1,
      sym_text_interpolation,
    ACTIONS(2514), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36624] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2516), 1,
      sym_name,
    STATE(955), 1,
      sym_namespace_name,
    STATE(1257), 1,
      sym_text_interpolation,
  [36640] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1258), 1,
      sym_text_interpolation,
    ACTIONS(2518), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36654] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(120), 1,
      sym_compound_statement,
    STATE(1259), 1,
      sym_text_interpolation,
  [36670] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1252), 1,
      sym_variable_name,
    STATE(1260), 1,
      sym_text_interpolation,
  [36686] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1261), 1,
      sym_text_interpolation,
    ACTIONS(2520), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36700] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_LPAREN,
    STATE(469), 1,
      sym_arguments,
    STATE(1262), 1,
      sym_text_interpolation,
  [36716] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1263), 1,
      sym_text_interpolation,
    ACTIONS(460), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36730] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LBRACE,
    STATE(858), 1,
      sym_declaration_list,
    STATE(1264), 1,
      sym_text_interpolation,
  [36746] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_LPAREN,
    STATE(1189), 1,
      sym_parenthesized_expression,
    STATE(1265), 1,
      sym_text_interpolation,
  [36762] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1266), 1,
      sym_text_interpolation,
    ACTIONS(1523), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [36776] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(816), 1,
      sym_formal_parameters,
    STATE(1267), 1,
      sym_text_interpolation,
  [36792] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1268), 1,
      sym_text_interpolation,
    ACTIONS(1539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36806] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(1269), 1,
      sym_text_interpolation,
  [36822] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(604), 1,
      sym_compound_statement,
    STATE(1270), 1,
      sym_text_interpolation,
  [36838] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_declaration_list,
    STATE(1271), 1,
      sym_text_interpolation,
  [36854] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_LPAREN,
    STATE(806), 1,
      sym_formal_parameters,
    STATE(1272), 1,
      sym_text_interpolation,
  [36870] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_compound_statement,
    STATE(1273), 1,
      sym_text_interpolation,
  [36886] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1274), 1,
      sym_text_interpolation,
    ACTIONS(1982), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [36900] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1275), 1,
      sym_text_interpolation,
    ACTIONS(2522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36914] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_DOLLAR,
    STATE(1178), 1,
      sym_variable_name,
    STATE(1276), 1,
      sym_text_interpolation,
  [36930] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1277), 1,
      sym_text_interpolation,
    ACTIONS(2524), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36944] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1278), 1,
      sym_text_interpolation,
    ACTIONS(2526), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36958] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1279), 1,
      sym_text_interpolation,
    ACTIONS(1505), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36972] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LBRACE,
    STATE(147), 1,
      sym_declaration_list,
    STATE(1280), 1,
      sym_text_interpolation,
  [36988] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    STATE(362), 1,
      sym_arguments,
    STATE(1281), 1,
      sym_text_interpolation,
  [37004] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LBRACE,
    STATE(588), 1,
      sym_compound_statement,
    STATE(1282), 1,
      sym_text_interpolation,
  [37020] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(408), 1,
      sym_arguments,
    STATE(1283), 1,
      sym_text_interpolation,
  [37036] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1284), 1,
      sym_text_interpolation,
    ACTIONS(2528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37050] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1285), 1,
      sym_text_interpolation,
    ACTIONS(2233), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37064] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1286), 1,
      sym_text_interpolation,
    ACTIONS(2530), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37078] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1287), 1,
      sym_text_interpolation,
    ACTIONS(2532), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37092] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1288), 1,
      sym_text_interpolation,
    ACTIONS(2534), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37106] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(301), 1,
      sym_compound_statement,
    STATE(1289), 1,
      sym_text_interpolation,
  [37122] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    STATE(873), 1,
      sym_compound_statement,
    STATE(1290), 1,
      sym_text_interpolation,
  [37138] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2414), 1,
      anon_sym_LPAREN,
    STATE(1127), 1,
      sym_parenthesized_expression,
    STATE(1291), 1,
      sym_text_interpolation,
  [37154] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1292), 1,
      sym_text_interpolation,
    ACTIONS(2536), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37168] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1293), 1,
      sym_text_interpolation,
    ACTIONS(2538), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [37182] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1294), 1,
      sym_text_interpolation,
    ACTIONS(2540), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37196] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_BSLASH,
    STATE(855), 1,
      aux_sym_namespace_name_repeat1,
    STATE(1295), 1,
      sym_text_interpolation,
  [37212] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
    STATE(1296), 1,
      sym_text_interpolation,
  [37225] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_COLON_COLON,
    STATE(1297), 1,
      sym_text_interpolation,
  [37238] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_COLON_COLON,
    STATE(1298), 1,
      sym_text_interpolation,
  [37251] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2549), 1,
      sym_name,
    STATE(1299), 1,
      sym_text_interpolation,
  [37264] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_const,
    STATE(1300), 1,
      sym_text_interpolation,
  [37277] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2553), 1,
      sym_name,
    STATE(1301), 1,
      sym_text_interpolation,
  [37290] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2555), 1,
      sym_name,
    STATE(1302), 1,
      sym_text_interpolation,
  [37303] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2557), 1,
      sym_name,
    STATE(1303), 1,
      sym_text_interpolation,
  [37316] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2559), 1,
      sym_name,
    STATE(1304), 1,
      sym_text_interpolation,
  [37329] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_class,
    STATE(1305), 1,
      sym_text_interpolation,
  [37342] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1198), 1,
      anon_sym_COLON_COLON,
    STATE(1306), 1,
      sym_text_interpolation,
  [37355] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2563), 1,
      anon_sym_BSLASH,
    STATE(1307), 1,
      sym_text_interpolation,
  [37368] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2565), 1,
      sym_name,
    STATE(1308), 1,
      sym_text_interpolation,
  [37381] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_RPAREN,
    STATE(1309), 1,
      sym_text_interpolation,
  [37394] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    STATE(1310), 1,
      sym_text_interpolation,
  [37407] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_COLON_COLON,
    STATE(1311), 1,
      sym_text_interpolation,
  [37420] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_EQ,
    STATE(1312), 1,
      sym_text_interpolation,
  [37433] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2571), 1,
      anon_sym_RPAREN,
    STATE(1313), 1,
      sym_text_interpolation,
  [37446] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_RPAREN,
    STATE(1314), 1,
      sym_text_interpolation,
  [37459] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2575), 1,
      anon_sym_endwhile,
    STATE(1315), 1,
      sym_text_interpolation,
  [37472] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_endforeach,
    STATE(1316), 1,
      sym_text_interpolation,
  [37485] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    STATE(1317), 1,
      sym_text_interpolation,
  [37498] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    STATE(1318), 1,
      sym_text_interpolation,
  [37511] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_RPAREN,
    STATE(1319), 1,
      sym_text_interpolation,
  [37524] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN,
    STATE(1320), 1,
      sym_text_interpolation,
  [37537] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_RPAREN,
    STATE(1321), 1,
      sym_text_interpolation,
  [37550] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2587), 1,
      anon_sym_COLON_COLON,
    STATE(1322), 1,
      sym_text_interpolation,
  [37563] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_endwhile,
    STATE(1323), 1,
      sym_text_interpolation,
  [37576] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2591), 1,
      anon_sym_EQ,
    STATE(1324), 1,
      sym_text_interpolation,
  [37589] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_endforeach,
    STATE(1325), 1,
      sym_text_interpolation,
  [37602] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_endif,
    STATE(1326), 1,
      sym_text_interpolation,
  [37615] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_COLON_COLON,
    STATE(1327), 1,
      sym_text_interpolation,
  [37628] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_SEMI,
    STATE(1328), 1,
      sym_text_interpolation,
  [37641] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_COLON_COLON,
    STATE(1329), 1,
      sym_text_interpolation,
  [37654] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_LPAREN,
    STATE(1330), 1,
      sym_text_interpolation,
  [37667] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2239), 1,
      anon_sym_EQ,
    STATE(1331), 1,
      sym_text_interpolation,
  [37680] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2603), 1,
      anon_sym_LPAREN,
    STATE(1332), 1,
      sym_text_interpolation,
  [37693] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
    STATE(1333), 1,
      sym_text_interpolation,
  [37706] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2076), 1,
      sym_name,
    STATE(1334), 1,
      sym_text_interpolation,
  [37719] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
    STATE(1335), 1,
      sym_text_interpolation,
  [37732] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_RPAREN,
    STATE(1336), 1,
      sym_text_interpolation,
  [37745] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2605), 1,
      sym_name,
    STATE(1337), 1,
      sym_text_interpolation,
  [37758] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_endif,
    STATE(1338), 1,
      sym_text_interpolation,
  [37771] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_BSLASH,
    STATE(1339), 1,
      sym_text_interpolation,
  [37784] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_RPAREN,
    STATE(1340), 1,
      sym_text_interpolation,
  [37797] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2613), 1,
      sym_name,
    STATE(1341), 1,
      sym_text_interpolation,
  [37810] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    STATE(1342), 1,
      sym_text_interpolation,
  [37823] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RBRACK,
    STATE(1343), 1,
      sym_text_interpolation,
  [37836] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2615), 1,
      sym_name,
    STATE(1344), 1,
      sym_text_interpolation,
  [37849] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    STATE(1345), 1,
      sym_text_interpolation,
  [37862] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LPAREN,
    STATE(1346), 1,
      sym_text_interpolation,
  [37875] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_RPAREN,
    STATE(1347), 1,
      sym_text_interpolation,
  [37888] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_endforeach,
    STATE(1348), 1,
      sym_text_interpolation,
  [37901] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_BSLASH,
    STATE(1349), 1,
      sym_text_interpolation,
  [37914] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2627), 1,
      sym_name,
    STATE(1350), 1,
      sym_text_interpolation,
  [37927] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_endforeach,
    STATE(1351), 1,
      sym_text_interpolation,
  [37940] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_RPAREN,
    STATE(1352), 1,
      sym_text_interpolation,
  [37953] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_endif,
    STATE(1353), 1,
      sym_text_interpolation,
  [37966] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_LPAREN,
    STATE(1354), 1,
      sym_text_interpolation,
  [37979] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    STATE(1355), 1,
      sym_text_interpolation,
  [37992] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_LPAREN,
    STATE(1356), 1,
      sym_text_interpolation,
  [38005] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_RPAREN,
    STATE(1357), 1,
      sym_text_interpolation,
  [38018] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_BSLASH,
    STATE(1358), 1,
      sym_text_interpolation,
  [38031] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_RPAREN,
    STATE(1359), 1,
      sym_text_interpolation,
  [38044] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
    STATE(1360), 1,
      sym_text_interpolation,
  [38057] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2647), 1,
      sym_name,
    STATE(1361), 1,
      sym_text_interpolation,
  [38070] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_BSLASH,
    STATE(1362), 1,
      sym_text_interpolation,
  [38083] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2003), 1,
      sym_name,
    STATE(1363), 1,
      sym_text_interpolation,
  [38096] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2651), 1,
      sym_name,
    STATE(1364), 1,
      sym_text_interpolation,
  [38109] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2653), 1,
      sym_name,
    STATE(1365), 1,
      sym_text_interpolation,
  [38122] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2655), 1,
      anon_sym_RPAREN,
    STATE(1366), 1,
      sym_text_interpolation,
  [38135] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_COLON_COLON,
    STATE(1367), 1,
      sym_text_interpolation,
  [38148] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2659), 1,
      sym_name,
    STATE(1368), 1,
      sym_text_interpolation,
  [38161] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_class,
    STATE(1369), 1,
      sym_text_interpolation,
  [38174] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1770), 1,
      anon_sym_const,
    STATE(1370), 1,
      sym_text_interpolation,
  [38187] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_BSLASH,
    STATE(1371), 1,
      sym_text_interpolation,
  [38200] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_BSLASH,
    STATE(1372), 1,
      sym_text_interpolation,
  [38213] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_RPAREN,
    STATE(1373), 1,
      sym_text_interpolation,
  [38226] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_while,
    STATE(1374), 1,
      sym_text_interpolation,
  [38239] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_BSLASH,
    STATE(1375), 1,
      sym_text_interpolation,
  [38252] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_BSLASH,
    STATE(1376), 1,
      sym_text_interpolation,
  [38265] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_BSLASH,
    STATE(1377), 1,
      sym_text_interpolation,
  [38278] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_SEMI,
    STATE(1378), 1,
      sym_text_interpolation,
  [38291] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_BSLASH,
    STATE(1379), 1,
      sym_text_interpolation,
  [38304] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_SEMI,
    STATE(1380), 1,
      sym_text_interpolation,
  [38317] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_SEMI,
    STATE(1381), 1,
      sym_text_interpolation,
  [38330] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2677), 1,
      anon_sym_EQ,
    STATE(1382), 1,
      sym_text_interpolation,
  [38343] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    STATE(1383), 1,
      sym_text_interpolation,
  [38356] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_SEMI,
    STATE(1384), 1,
      sym_text_interpolation,
  [38369] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_RPAREN,
    STATE(1385), 1,
      sym_text_interpolation,
  [38382] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2683), 1,
      anon_sym_RPAREN,
    STATE(1386), 1,
      sym_text_interpolation,
  [38395] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_endif,
    STATE(1387), 1,
      sym_text_interpolation,
  [38408] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
    STATE(1388), 1,
      sym_text_interpolation,
  [38421] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_while,
    STATE(1389), 1,
      sym_text_interpolation,
  [38434] = 3,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1390), 1,
      sym_text_interpolation,
    ACTIONS(2691), 2,
      sym__eof,
      sym_php_tag,
  [38445] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_endif,
    STATE(1391), 1,
      sym_text_interpolation,
  [38458] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2695), 1,
      anon_sym_LPAREN,
    STATE(1392), 1,
      sym_text_interpolation,
  [38471] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_LPAREN,
    STATE(1393), 1,
      sym_text_interpolation,
  [38484] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2352), 1,
      anon_sym_LBRACE,
    STATE(1394), 1,
      sym_text_interpolation,
  [38497] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
    STATE(1395), 1,
      sym_text_interpolation,
  [38510] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2701), 1,
      ts_builtin_sym_end,
    STATE(1396), 1,
      sym_text_interpolation,
  [38523] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2354), 1,
      anon_sym_LBRACE,
    STATE(1397), 1,
      sym_text_interpolation,
  [38536] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_SEMI,
    STATE(1398), 1,
      sym_text_interpolation,
  [38549] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_COLON_COLON,
    STATE(1399), 1,
      sym_text_interpolation,
  [38562] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2705), 1,
      sym_name,
    STATE(1400), 1,
      sym_text_interpolation,
  [38575] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2707), 1,
      anon_sym_LPAREN,
    STATE(1401), 1,
      sym_text_interpolation,
  [38588] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    STATE(1402), 1,
      sym_text_interpolation,
  [38601] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_LPAREN,
    STATE(1403), 1,
      sym_text_interpolation,
  [38614] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    STATE(1404), 1,
      sym_text_interpolation,
  [38627] = 1,
    ACTIONS(2713), 1,
      ts_builtin_sym_end,
  [38631] = 1,
    ACTIONS(2715), 1,
      ts_builtin_sym_end,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(327)] = 0,
  [SMALL_STATE(328)] = 74,
  [SMALL_STATE(329)] = 148,
  [SMALL_STATE(330)] = 222,
  [SMALL_STATE(331)] = 299,
  [SMALL_STATE(332)] = 384,
  [SMALL_STATE(333)] = 461,
  [SMALL_STATE(334)] = 538,
  [SMALL_STATE(335)] = 623,
  [SMALL_STATE(336)] = 761,
  [SMALL_STATE(337)] = 833,
  [SMALL_STATE(338)] = 905,
  [SMALL_STATE(339)] = 977,
  [SMALL_STATE(340)] = 1049,
  [SMALL_STATE(341)] = 1121,
  [SMALL_STATE(342)] = 1193,
  [SMALL_STATE(343)] = 1265,
  [SMALL_STATE(344)] = 1337,
  [SMALL_STATE(345)] = 1475,
  [SMALL_STATE(346)] = 1547,
  [SMALL_STATE(347)] = 1685,
  [SMALL_STATE(348)] = 1757,
  [SMALL_STATE(349)] = 1829,
  [SMALL_STATE(350)] = 1908,
  [SMALL_STATE(351)] = 1987,
  [SMALL_STATE(352)] = 2060,
  [SMALL_STATE(353)] = 2147,
  [SMALL_STATE(354)] = 2228,
  [SMALL_STATE(355)] = 2309,
  [SMALL_STATE(356)] = 2382,
  [SMALL_STATE(357)] = 2455,
  [SMALL_STATE(358)] = 2523,
  [SMALL_STATE(359)] = 2591,
  [SMALL_STATE(360)] = 2659,
  [SMALL_STATE(361)] = 2727,
  [SMALL_STATE(362)] = 2795,
  [SMALL_STATE(363)] = 2863,
  [SMALL_STATE(364)] = 2931,
  [SMALL_STATE(365)] = 2999,
  [SMALL_STATE(366)] = 3067,
  [SMALL_STATE(367)] = 3135,
  [SMALL_STATE(368)] = 3203,
  [SMALL_STATE(369)] = 3283,
  [SMALL_STATE(370)] = 3351,
  [SMALL_STATE(371)] = 3419,
  [SMALL_STATE(372)] = 3487,
  [SMALL_STATE(373)] = 3569,
  [SMALL_STATE(374)] = 3636,
  [SMALL_STATE(375)] = 3717,
  [SMALL_STATE(376)] = 3792,
  [SMALL_STATE(377)] = 3859,
  [SMALL_STATE(378)] = 3934,
  [SMALL_STATE(379)] = 4008,
  [SMALL_STATE(380)] = 4084,
  [SMALL_STATE(381)] = 4206,
  [SMALL_STATE(382)] = 4328,
  [SMALL_STATE(383)] = 4443,
  [SMALL_STATE(384)] = 4558,
  [SMALL_STATE(385)] = 4624,
  [SMALL_STATE(386)] = 4692,
  [SMALL_STATE(387)] = 4759,
  [SMALL_STATE(388)] = 4822,
  [SMALL_STATE(389)] = 4885,
  [SMALL_STATE(390)] = 4945,
  [SMALL_STATE(391)] = 5007,
  [SMALL_STATE(392)] = 5065,
  [SMALL_STATE(393)] = 5123,
  [SMALL_STATE(394)] = 5181,
  [SMALL_STATE(395)] = 5243,
  [SMALL_STATE(396)] = 5307,
  [SMALL_STATE(397)] = 5371,
  [SMALL_STATE(398)] = 5429,
  [SMALL_STATE(399)] = 5487,
  [SMALL_STATE(400)] = 5551,
  [SMALL_STATE(401)] = 5613,
  [SMALL_STATE(402)] = 5675,
  [SMALL_STATE(403)] = 5745,
  [SMALL_STATE(404)] = 5802,
  [SMALL_STATE(405)] = 5859,
  [SMALL_STATE(406)] = 5916,
  [SMALL_STATE(407)] = 5973,
  [SMALL_STATE(408)] = 6030,
  [SMALL_STATE(409)] = 6087,
  [SMALL_STATE(410)] = 6144,
  [SMALL_STATE(411)] = 6201,
  [SMALL_STATE(412)] = 6258,
  [SMALL_STATE(413)] = 6315,
  [SMALL_STATE(414)] = 6372,
  [SMALL_STATE(415)] = 6429,
  [SMALL_STATE(416)] = 6486,
  [SMALL_STATE(417)] = 6543,
  [SMALL_STATE(418)] = 6600,
  [SMALL_STATE(419)] = 6657,
  [SMALL_STATE(420)] = 6714,
  [SMALL_STATE(421)] = 6771,
  [SMALL_STATE(422)] = 6828,
  [SMALL_STATE(423)] = 6885,
  [SMALL_STATE(424)] = 6942,
  [SMALL_STATE(425)] = 6999,
  [SMALL_STATE(426)] = 7057,
  [SMALL_STATE(427)] = 7121,
  [SMALL_STATE(428)] = 7179,
  [SMALL_STATE(429)] = 7243,
  [SMALL_STATE(430)] = 7305,
  [SMALL_STATE(431)] = 7363,
  [SMALL_STATE(432)] = 7426,
  [SMALL_STATE(433)] = 7487,
  [SMALL_STATE(434)] = 7542,
  [SMALL_STATE(435)] = 7603,
  [SMALL_STATE(436)] = 7658,
  [SMALL_STATE(437)] = 7717,
  [SMALL_STATE(438)] = 7771,
  [SMALL_STATE(439)] = 7837,
  [SMALL_STATE(440)] = 7891,
  [SMALL_STATE(441)] = 7949,
  [SMALL_STATE(442)] = 8005,
  [SMALL_STATE(443)] = 8059,
  [SMALL_STATE(444)] = 8119,
  [SMALL_STATE(445)] = 8177,
  [SMALL_STATE(446)] = 8235,
  [SMALL_STATE(447)] = 8295,
  [SMALL_STATE(448)] = 8353,
  [SMALL_STATE(449)] = 8407,
  [SMALL_STATE(450)] = 8465,
  [SMALL_STATE(451)] = 8519,
  [SMALL_STATE(452)] = 8579,
  [SMALL_STATE(453)] = 8633,
  [SMALL_STATE(454)] = 8691,
  [SMALL_STATE(455)] = 8747,
  [SMALL_STATE(456)] = 8800,
  [SMALL_STATE(457)] = 8853,
  [SMALL_STATE(458)] = 8906,
  [SMALL_STATE(459)] = 8959,
  [SMALL_STATE(460)] = 9012,
  [SMALL_STATE(461)] = 9065,
  [SMALL_STATE(462)] = 9118,
  [SMALL_STATE(463)] = 9171,
  [SMALL_STATE(464)] = 9224,
  [SMALL_STATE(465)] = 9277,
  [SMALL_STATE(466)] = 9330,
  [SMALL_STATE(467)] = 9383,
  [SMALL_STATE(468)] = 9436,
  [SMALL_STATE(469)] = 9489,
  [SMALL_STATE(470)] = 9542,
  [SMALL_STATE(471)] = 9595,
  [SMALL_STATE(472)] = 9648,
  [SMALL_STATE(473)] = 9703,
  [SMALL_STATE(474)] = 9756,
  [SMALL_STATE(475)] = 9809,
  [SMALL_STATE(476)] = 9889,
  [SMALL_STATE(477)] = 9953,
  [SMALL_STATE(478)] = 10005,
  [SMALL_STATE(479)] = 10091,
  [SMALL_STATE(480)] = 10145,
  [SMALL_STATE(481)] = 10225,
  [SMALL_STATE(482)] = 10277,
  [SMALL_STATE(483)] = 10329,
  [SMALL_STATE(484)] = 10381,
  [SMALL_STATE(485)] = 10433,
  [SMALL_STATE(486)] = 10485,
  [SMALL_STATE(487)] = 10571,
  [SMALL_STATE(488)] = 10657,
  [SMALL_STATE(489)] = 10745,
  [SMALL_STATE(490)] = 10807,
  [SMALL_STATE(491)] = 10859,
  [SMALL_STATE(492)] = 10945,
  [SMALL_STATE(493)] = 10999,
  [SMALL_STATE(494)] = 11051,
  [SMALL_STATE(495)] = 11137,
  [SMALL_STATE(496)] = 11191,
  [SMALL_STATE(497)] = 11253,
  [SMALL_STATE(498)] = 11305,
  [SMALL_STATE(499)] = 11365,
  [SMALL_STATE(500)] = 11417,
  [SMALL_STATE(501)] = 11469,
  [SMALL_STATE(502)] = 11521,
  [SMALL_STATE(503)] = 11601,
  [SMALL_STATE(504)] = 11653,
  [SMALL_STATE(505)] = 11733,
  [SMALL_STATE(506)] = 11785,
  [SMALL_STATE(507)] = 11837,
  [SMALL_STATE(508)] = 11889,
  [SMALL_STATE(509)] = 11941,
  [SMALL_STATE(510)] = 11993,
  [SMALL_STATE(511)] = 12079,
  [SMALL_STATE(512)] = 12165,
  [SMALL_STATE(513)] = 12245,
  [SMALL_STATE(514)] = 12331,
  [SMALL_STATE(515)] = 12417,
  [SMALL_STATE(516)] = 12497,
  [SMALL_STATE(517)] = 12551,
  [SMALL_STATE(518)] = 12603,
  [SMALL_STATE(519)] = 12657,
  [SMALL_STATE(520)] = 12709,
  [SMALL_STATE(521)] = 12761,
  [SMALL_STATE(522)] = 12813,
  [SMALL_STATE(523)] = 12865,
  [SMALL_STATE(524)] = 12923,
  [SMALL_STATE(525)] = 12975,
  [SMALL_STATE(526)] = 13035,
  [SMALL_STATE(527)] = 13105,
  [SMALL_STATE(528)] = 13177,
  [SMALL_STATE(529)] = 13251,
  [SMALL_STATE(530)] = 13337,
  [SMALL_STATE(531)] = 13405,
  [SMALL_STATE(532)] = 13461,
  [SMALL_STATE(533)] = 13515,
  [SMALL_STATE(534)] = 13595,
  [SMALL_STATE(535)] = 13679,
  [SMALL_STATE(536)] = 13731,
  [SMALL_STATE(537)] = 13807,
  [SMALL_STATE(538)] = 13889,
  [SMALL_STATE(539)] = 13946,
  [SMALL_STATE(540)] = 14003,
  [SMALL_STATE(541)] = 14060,
  [SMALL_STATE(542)] = 14111,
  [SMALL_STATE(543)] = 14162,
  [SMALL_STATE(544)] = 14219,
  [SMALL_STATE(545)] = 14274,
  [SMALL_STATE(546)] = 14364,
  [SMALL_STATE(547)] = 14452,
  [SMALL_STATE(548)] = 14504,
  [SMALL_STATE(549)] = 14594,
  [SMALL_STATE(550)] = 14645,
  [SMALL_STATE(551)] = 14721,
  [SMALL_STATE(552)] = 14785,
  [SMALL_STATE(553)] = 14833,
  [SMALL_STATE(554)] = 14883,
  [SMALL_STATE(555)] = 14931,
  [SMALL_STATE(556)] = 15007,
  [SMALL_STATE(557)] = 15055,
  [SMALL_STATE(558)] = 15103,
  [SMALL_STATE(559)] = 15151,
  [SMALL_STATE(560)] = 15199,
  [SMALL_STATE(561)] = 15281,
  [SMALL_STATE(562)] = 15331,
  [SMALL_STATE(563)] = 15407,
  [SMALL_STATE(564)] = 15457,
  [SMALL_STATE(565)] = 15539,
  [SMALL_STATE(566)] = 15615,
  [SMALL_STATE(567)] = 15691,
  [SMALL_STATE(568)] = 15739,
  [SMALL_STATE(569)] = 15821,
  [SMALL_STATE(570)] = 15903,
  [SMALL_STATE(571)] = 15951,
  [SMALL_STATE(572)] = 15999,
  [SMALL_STATE(573)] = 16047,
  [SMALL_STATE(574)] = 16129,
  [SMALL_STATE(575)] = 16177,
  [SMALL_STATE(576)] = 16253,
  [SMALL_STATE(577)] = 16301,
  [SMALL_STATE(578)] = 16383,
  [SMALL_STATE(579)] = 16435,
  [SMALL_STATE(580)] = 16515,
  [SMALL_STATE(581)] = 16599,
  [SMALL_STATE(582)] = 16647,
  [SMALL_STATE(583)] = 16729,
  [SMALL_STATE(584)] = 16807,
  [SMALL_STATE(585)] = 16855,
  [SMALL_STATE(586)] = 16903,
  [SMALL_STATE(587)] = 16951,
  [SMALL_STATE(588)] = 17005,
  [SMALL_STATE(589)] = 17053,
  [SMALL_STATE(590)] = 17141,
  [SMALL_STATE(591)] = 17197,
  [SMALL_STATE(592)] = 17245,
  [SMALL_STATE(593)] = 17305,
  [SMALL_STATE(594)] = 17353,
  [SMALL_STATE(595)] = 17441,
  [SMALL_STATE(596)] = 17489,
  [SMALL_STATE(597)] = 17555,
  [SMALL_STATE(598)] = 17623,
  [SMALL_STATE(599)] = 17693,
  [SMALL_STATE(600)] = 17769,
  [SMALL_STATE(601)] = 17851,
  [SMALL_STATE(602)] = 17899,
  [SMALL_STATE(603)] = 17947,
  [SMALL_STATE(604)] = 18019,
  [SMALL_STATE(605)] = 18067,
  [SMALL_STATE(606)] = 18149,
  [SMALL_STATE(607)] = 18197,
  [SMALL_STATE(608)] = 18279,
  [SMALL_STATE(609)] = 18327,
  [SMALL_STATE(610)] = 18409,
  [SMALL_STATE(611)] = 18491,
  [SMALL_STATE(612)] = 18573,
  [SMALL_STATE(613)] = 18655,
  [SMALL_STATE(614)] = 18737,
  [SMALL_STATE(615)] = 18819,
  [SMALL_STATE(616)] = 18901,
  [SMALL_STATE(617)] = 18983,
  [SMALL_STATE(618)] = 19065,
  [SMALL_STATE(619)] = 19147,
  [SMALL_STATE(620)] = 19228,
  [SMALL_STATE(621)] = 19311,
  [SMALL_STATE(622)] = 19390,
  [SMALL_STATE(623)] = 19473,
  [SMALL_STATE(624)] = 19556,
  [SMALL_STATE(625)] = 19635,
  [SMALL_STATE(626)] = 19716,
  [SMALL_STATE(627)] = 19797,
  [SMALL_STATE(628)] = 19880,
  [SMALL_STATE(629)] = 19959,
  [SMALL_STATE(630)] = 20040,
  [SMALL_STATE(631)] = 20118,
  [SMALL_STATE(632)] = 20196,
  [SMALL_STATE(633)] = 20274,
  [SMALL_STATE(634)] = 20352,
  [SMALL_STATE(635)] = 20430,
  [SMALL_STATE(636)] = 20508,
  [SMALL_STATE(637)] = 20588,
  [SMALL_STATE(638)] = 20666,
  [SMALL_STATE(639)] = 20746,
  [SMALL_STATE(640)] = 20824,
  [SMALL_STATE(641)] = 20902,
  [SMALL_STATE(642)] = 20980,
  [SMALL_STATE(643)] = 21058,
  [SMALL_STATE(644)] = 21136,
  [SMALL_STATE(645)] = 21214,
  [SMALL_STATE(646)] = 21292,
  [SMALL_STATE(647)] = 21370,
  [SMALL_STATE(648)] = 21448,
  [SMALL_STATE(649)] = 21526,
  [SMALL_STATE(650)] = 21603,
  [SMALL_STATE(651)] = 21680,
  [SMALL_STATE(652)] = 21755,
  [SMALL_STATE(653)] = 21832,
  [SMALL_STATE(654)] = 21909,
  [SMALL_STATE(655)] = 21986,
  [SMALL_STATE(656)] = 22063,
  [SMALL_STATE(657)] = 22140,
  [SMALL_STATE(658)] = 22217,
  [SMALL_STATE(659)] = 22294,
  [SMALL_STATE(660)] = 22371,
  [SMALL_STATE(661)] = 22448,
  [SMALL_STATE(662)] = 22525,
  [SMALL_STATE(663)] = 22602,
  [SMALL_STATE(664)] = 22679,
  [SMALL_STATE(665)] = 22756,
  [SMALL_STATE(666)] = 22833,
  [SMALL_STATE(667)] = 22910,
  [SMALL_STATE(668)] = 22987,
  [SMALL_STATE(669)] = 23064,
  [SMALL_STATE(670)] = 23141,
  [SMALL_STATE(671)] = 23218,
  [SMALL_STATE(672)] = 23295,
  [SMALL_STATE(673)] = 23370,
  [SMALL_STATE(674)] = 23447,
  [SMALL_STATE(675)] = 23524,
  [SMALL_STATE(676)] = 23601,
  [SMALL_STATE(677)] = 23678,
  [SMALL_STATE(678)] = 23755,
  [SMALL_STATE(679)] = 23832,
  [SMALL_STATE(680)] = 23909,
  [SMALL_STATE(681)] = 23986,
  [SMALL_STATE(682)] = 24063,
  [SMALL_STATE(683)] = 24140,
  [SMALL_STATE(684)] = 24217,
  [SMALL_STATE(685)] = 24294,
  [SMALL_STATE(686)] = 24371,
  [SMALL_STATE(687)] = 24448,
  [SMALL_STATE(688)] = 24525,
  [SMALL_STATE(689)] = 24602,
  [SMALL_STATE(690)] = 24679,
  [SMALL_STATE(691)] = 24751,
  [SMALL_STATE(692)] = 24816,
  [SMALL_STATE(693)] = 24881,
  [SMALL_STATE(694)] = 24946,
  [SMALL_STATE(695)] = 25011,
  [SMALL_STATE(696)] = 25076,
  [SMALL_STATE(697)] = 25141,
  [SMALL_STATE(698)] = 25204,
  [SMALL_STATE(699)] = 25269,
  [SMALL_STATE(700)] = 25334,
  [SMALL_STATE(701)] = 25390,
  [SMALL_STATE(702)] = 25446,
  [SMALL_STATE(703)] = 25495,
  [SMALL_STATE(704)] = 25544,
  [SMALL_STATE(705)] = 25593,
  [SMALL_STATE(706)] = 25644,
  [SMALL_STATE(707)] = 25696,
  [SMALL_STATE(708)] = 25748,
  [SMALL_STATE(709)] = 25797,
  [SMALL_STATE(710)] = 25846,
  [SMALL_STATE(711)] = 25874,
  [SMALL_STATE(712)] = 25902,
  [SMALL_STATE(713)] = 25930,
  [SMALL_STATE(714)] = 25976,
  [SMALL_STATE(715)] = 26014,
  [SMALL_STATE(716)] = 26060,
  [SMALL_STATE(717)] = 26086,
  [SMALL_STATE(718)] = 26113,
  [SMALL_STATE(719)] = 26136,
  [SMALL_STATE(720)] = 26159,
  [SMALL_STATE(721)] = 26182,
  [SMALL_STATE(722)] = 26205,
  [SMALL_STATE(723)] = 26228,
  [SMALL_STATE(724)] = 26267,
  [SMALL_STATE(725)] = 26290,
  [SMALL_STATE(726)] = 26329,
  [SMALL_STATE(727)] = 26352,
  [SMALL_STATE(728)] = 26375,
  [SMALL_STATE(729)] = 26414,
  [SMALL_STATE(730)] = 26437,
  [SMALL_STATE(731)] = 26460,
  [SMALL_STATE(732)] = 26483,
  [SMALL_STATE(733)] = 26506,
  [SMALL_STATE(734)] = 26542,
  [SMALL_STATE(735)] = 26578,
  [SMALL_STATE(736)] = 26614,
  [SMALL_STATE(737)] = 26650,
  [SMALL_STATE(738)] = 26686,
  [SMALL_STATE(739)] = 26710,
  [SMALL_STATE(740)] = 26732,
  [SMALL_STATE(741)] = 26754,
  [SMALL_STATE(742)] = 26790,
  [SMALL_STATE(743)] = 26826,
  [SMALL_STATE(744)] = 26862,
  [SMALL_STATE(745)] = 26893,
  [SMALL_STATE(746)] = 26922,
  [SMALL_STATE(747)] = 26953,
  [SMALL_STATE(748)] = 26984,
  [SMALL_STATE(749)] = 27013,
  [SMALL_STATE(750)] = 27044,
  [SMALL_STATE(751)] = 27073,
  [SMALL_STATE(752)] = 27104,
  [SMALL_STATE(753)] = 27125,
  [SMALL_STATE(754)] = 27154,
  [SMALL_STATE(755)] = 27183,
  [SMALL_STATE(756)] = 27214,
  [SMALL_STATE(757)] = 27235,
  [SMALL_STATE(758)] = 27266,
  [SMALL_STATE(759)] = 27287,
  [SMALL_STATE(760)] = 27318,
  [SMALL_STATE(761)] = 27347,
  [SMALL_STATE(762)] = 27378,
  [SMALL_STATE(763)] = 27407,
  [SMALL_STATE(764)] = 27435,
  [SMALL_STATE(765)] = 27465,
  [SMALL_STATE(766)] = 27495,
  [SMALL_STATE(767)] = 27529,
  [SMALL_STATE(768)] = 27555,
  [SMALL_STATE(769)] = 27589,
  [SMALL_STATE(770)] = 27615,
  [SMALL_STATE(771)] = 27640,
  [SMALL_STATE(772)] = 27665,
  [SMALL_STATE(773)] = 27692,
  [SMALL_STATE(774)] = 27717,
  [SMALL_STATE(775)] = 27742,
  [SMALL_STATE(776)] = 27767,
  [SMALL_STATE(777)] = 27793,
  [SMALL_STATE(778)] = 27815,
  [SMALL_STATE(779)] = 27841,
  [SMALL_STATE(780)] = 27867,
  [SMALL_STATE(781)] = 27895,
  [SMALL_STATE(782)] = 27917,
  [SMALL_STATE(783)] = 27943,
  [SMALL_STATE(784)] = 27965,
  [SMALL_STATE(785)] = 27991,
  [SMALL_STATE(786)] = 28017,
  [SMALL_STATE(787)] = 28045,
  [SMALL_STATE(788)] = 28073,
  [SMALL_STATE(789)] = 28095,
  [SMALL_STATE(790)] = 28117,
  [SMALL_STATE(791)] = 28137,
  [SMALL_STATE(792)] = 28165,
  [SMALL_STATE(793)] = 28193,
  [SMALL_STATE(794)] = 28221,
  [SMALL_STATE(795)] = 28243,
  [SMALL_STATE(796)] = 28267,
  [SMALL_STATE(797)] = 28295,
  [SMALL_STATE(798)] = 28319,
  [SMALL_STATE(799)] = 28339,
  [SMALL_STATE(800)] = 28359,
  [SMALL_STATE(801)] = 28383,
  [SMALL_STATE(802)] = 28411,
  [SMALL_STATE(803)] = 28433,
  [SMALL_STATE(804)] = 28461,
  [SMALL_STATE(805)] = 28489,
  [SMALL_STATE(806)] = 28511,
  [SMALL_STATE(807)] = 28539,
  [SMALL_STATE(808)] = 28565,
  [SMALL_STATE(809)] = 28587,
  [SMALL_STATE(810)] = 28609,
  [SMALL_STATE(811)] = 28637,
  [SMALL_STATE(812)] = 28665,
  [SMALL_STATE(813)] = 28687,
  [SMALL_STATE(814)] = 28709,
  [SMALL_STATE(815)] = 28731,
  [SMALL_STATE(816)] = 28753,
  [SMALL_STATE(817)] = 28781,
  [SMALL_STATE(818)] = 28805,
  [SMALL_STATE(819)] = 28829,
  [SMALL_STATE(820)] = 28855,
  [SMALL_STATE(821)] = 28877,
  [SMALL_STATE(822)] = 28903,
  [SMALL_STATE(823)] = 28925,
  [SMALL_STATE(824)] = 28953,
  [SMALL_STATE(825)] = 28979,
  [SMALL_STATE(826)] = 29005,
  [SMALL_STATE(827)] = 29031,
  [SMALL_STATE(828)] = 29059,
  [SMALL_STATE(829)] = 29087,
  [SMALL_STATE(830)] = 29111,
  [SMALL_STATE(831)] = 29139,
  [SMALL_STATE(832)] = 29165,
  [SMALL_STATE(833)] = 29188,
  [SMALL_STATE(834)] = 29209,
  [SMALL_STATE(835)] = 29234,
  [SMALL_STATE(836)] = 29255,
  [SMALL_STATE(837)] = 29276,
  [SMALL_STATE(838)] = 29297,
  [SMALL_STATE(839)] = 29318,
  [SMALL_STATE(840)] = 29339,
  [SMALL_STATE(841)] = 29358,
  [SMALL_STATE(842)] = 29379,
  [SMALL_STATE(843)] = 29402,
  [SMALL_STATE(844)] = 29425,
  [SMALL_STATE(845)] = 29448,
  [SMALL_STATE(846)] = 29469,
  [SMALL_STATE(847)] = 29494,
  [SMALL_STATE(848)] = 29515,
  [SMALL_STATE(849)] = 29538,
  [SMALL_STATE(850)] = 29559,
  [SMALL_STATE(851)] = 29580,
  [SMALL_STATE(852)] = 29601,
  [SMALL_STATE(853)] = 29622,
  [SMALL_STATE(854)] = 29643,
  [SMALL_STATE(855)] = 29662,
  [SMALL_STATE(856)] = 29681,
  [SMALL_STATE(857)] = 29702,
  [SMALL_STATE(858)] = 29721,
  [SMALL_STATE(859)] = 29742,
  [SMALL_STATE(860)] = 29765,
  [SMALL_STATE(861)] = 29788,
  [SMALL_STATE(862)] = 29811,
  [SMALL_STATE(863)] = 29832,
  [SMALL_STATE(864)] = 29853,
  [SMALL_STATE(865)] = 29874,
  [SMALL_STATE(866)] = 29895,
  [SMALL_STATE(867)] = 29916,
  [SMALL_STATE(868)] = 29939,
  [SMALL_STATE(869)] = 29960,
  [SMALL_STATE(870)] = 29981,
  [SMALL_STATE(871)] = 30002,
  [SMALL_STATE(872)] = 30021,
  [SMALL_STATE(873)] = 30042,
  [SMALL_STATE(874)] = 30065,
  [SMALL_STATE(875)] = 30088,
  [SMALL_STATE(876)] = 30109,
  [SMALL_STATE(877)] = 30130,
  [SMALL_STATE(878)] = 30151,
  [SMALL_STATE(879)] = 30170,
  [SMALL_STATE(880)] = 30193,
  [SMALL_STATE(881)] = 30215,
  [SMALL_STATE(882)] = 30231,
  [SMALL_STATE(883)] = 30251,
  [SMALL_STATE(884)] = 30271,
  [SMALL_STATE(885)] = 30293,
  [SMALL_STATE(886)] = 30313,
  [SMALL_STATE(887)] = 30333,
  [SMALL_STATE(888)] = 30353,
  [SMALL_STATE(889)] = 30373,
  [SMALL_STATE(890)] = 30395,
  [SMALL_STATE(891)] = 30415,
  [SMALL_STATE(892)] = 30437,
  [SMALL_STATE(893)] = 30455,
  [SMALL_STATE(894)] = 30477,
  [SMALL_STATE(895)] = 30497,
  [SMALL_STATE(896)] = 30515,
  [SMALL_STATE(897)] = 30537,
  [SMALL_STATE(898)] = 30553,
  [SMALL_STATE(899)] = 30573,
  [SMALL_STATE(900)] = 30593,
  [SMALL_STATE(901)] = 30613,
  [SMALL_STATE(902)] = 30633,
  [SMALL_STATE(903)] = 30649,
  [SMALL_STATE(904)] = 30669,
  [SMALL_STATE(905)] = 30689,
  [SMALL_STATE(906)] = 30707,
  [SMALL_STATE(907)] = 30727,
  [SMALL_STATE(908)] = 30747,
  [SMALL_STATE(909)] = 30767,
  [SMALL_STATE(910)] = 30789,
  [SMALL_STATE(911)] = 30805,
  [SMALL_STATE(912)] = 30825,
  [SMALL_STATE(913)] = 30845,
  [SMALL_STATE(914)] = 30867,
  [SMALL_STATE(915)] = 30887,
  [SMALL_STATE(916)] = 30907,
  [SMALL_STATE(917)] = 30925,
  [SMALL_STATE(918)] = 30947,
  [SMALL_STATE(919)] = 30963,
  [SMALL_STATE(920)] = 30983,
  [SMALL_STATE(921)] = 31005,
  [SMALL_STATE(922)] = 31025,
  [SMALL_STATE(923)] = 31041,
  [SMALL_STATE(924)] = 31057,
  [SMALL_STATE(925)] = 31079,
  [SMALL_STATE(926)] = 31097,
  [SMALL_STATE(927)] = 31119,
  [SMALL_STATE(928)] = 31135,
  [SMALL_STATE(929)] = 31155,
  [SMALL_STATE(930)] = 31177,
  [SMALL_STATE(931)] = 31195,
  [SMALL_STATE(932)] = 31217,
  [SMALL_STATE(933)] = 31239,
  [SMALL_STATE(934)] = 31257,
  [SMALL_STATE(935)] = 31277,
  [SMALL_STATE(936)] = 31297,
  [SMALL_STATE(937)] = 31313,
  [SMALL_STATE(938)] = 31335,
  [SMALL_STATE(939)] = 31357,
  [SMALL_STATE(940)] = 31377,
  [SMALL_STATE(941)] = 31393,
  [SMALL_STATE(942)] = 31411,
  [SMALL_STATE(943)] = 31433,
  [SMALL_STATE(944)] = 31453,
  [SMALL_STATE(945)] = 31471,
  [SMALL_STATE(946)] = 31487,
  [SMALL_STATE(947)] = 31509,
  [SMALL_STATE(948)] = 31525,
  [SMALL_STATE(949)] = 31541,
  [SMALL_STATE(950)] = 31561,
  [SMALL_STATE(951)] = 31583,
  [SMALL_STATE(952)] = 31605,
  [SMALL_STATE(953)] = 31627,
  [SMALL_STATE(954)] = 31645,
  [SMALL_STATE(955)] = 31661,
  [SMALL_STATE(956)] = 31681,
  [SMALL_STATE(957)] = 31697,
  [SMALL_STATE(958)] = 31713,
  [SMALL_STATE(959)] = 31733,
  [SMALL_STATE(960)] = 31755,
  [SMALL_STATE(961)] = 31773,
  [SMALL_STATE(962)] = 31788,
  [SMALL_STATE(963)] = 31805,
  [SMALL_STATE(964)] = 31824,
  [SMALL_STATE(965)] = 31841,
  [SMALL_STATE(966)] = 31856,
  [SMALL_STATE(967)] = 31875,
  [SMALL_STATE(968)] = 31894,
  [SMALL_STATE(969)] = 31911,
  [SMALL_STATE(970)] = 31926,
  [SMALL_STATE(971)] = 31945,
  [SMALL_STATE(972)] = 31964,
  [SMALL_STATE(973)] = 31983,
  [SMALL_STATE(974)] = 32000,
  [SMALL_STATE(975)] = 32017,
  [SMALL_STATE(976)] = 32034,
  [SMALL_STATE(977)] = 32051,
  [SMALL_STATE(978)] = 32068,
  [SMALL_STATE(979)] = 32085,
  [SMALL_STATE(980)] = 32102,
  [SMALL_STATE(981)] = 32119,
  [SMALL_STATE(982)] = 32136,
  [SMALL_STATE(983)] = 32153,
  [SMALL_STATE(984)] = 32170,
  [SMALL_STATE(985)] = 32187,
  [SMALL_STATE(986)] = 32206,
  [SMALL_STATE(987)] = 32223,
  [SMALL_STATE(988)] = 32240,
  [SMALL_STATE(989)] = 32257,
  [SMALL_STATE(990)] = 32276,
  [SMALL_STATE(991)] = 32291,
  [SMALL_STATE(992)] = 32308,
  [SMALL_STATE(993)] = 32325,
  [SMALL_STATE(994)] = 32344,
  [SMALL_STATE(995)] = 32361,
  [SMALL_STATE(996)] = 32378,
  [SMALL_STATE(997)] = 32395,
  [SMALL_STATE(998)] = 32412,
  [SMALL_STATE(999)] = 32429,
  [SMALL_STATE(1000)] = 32446,
  [SMALL_STATE(1001)] = 32463,
  [SMALL_STATE(1002)] = 32482,
  [SMALL_STATE(1003)] = 32501,
  [SMALL_STATE(1004)] = 32518,
  [SMALL_STATE(1005)] = 32537,
  [SMALL_STATE(1006)] = 32556,
  [SMALL_STATE(1007)] = 32571,
  [SMALL_STATE(1008)] = 32588,
  [SMALL_STATE(1009)] = 32605,
  [SMALL_STATE(1010)] = 32622,
  [SMALL_STATE(1011)] = 32639,
  [SMALL_STATE(1012)] = 32656,
  [SMALL_STATE(1013)] = 32673,
  [SMALL_STATE(1014)] = 32690,
  [SMALL_STATE(1015)] = 32707,
  [SMALL_STATE(1016)] = 32724,
  [SMALL_STATE(1017)] = 32741,
  [SMALL_STATE(1018)] = 32758,
  [SMALL_STATE(1019)] = 32775,
  [SMALL_STATE(1020)] = 32792,
  [SMALL_STATE(1021)] = 32809,
  [SMALL_STATE(1022)] = 32826,
  [SMALL_STATE(1023)] = 32843,
  [SMALL_STATE(1024)] = 32860,
  [SMALL_STATE(1025)] = 32877,
  [SMALL_STATE(1026)] = 32894,
  [SMALL_STATE(1027)] = 32911,
  [SMALL_STATE(1028)] = 32928,
  [SMALL_STATE(1029)] = 32945,
  [SMALL_STATE(1030)] = 32962,
  [SMALL_STATE(1031)] = 32977,
  [SMALL_STATE(1032)] = 32996,
  [SMALL_STATE(1033)] = 33015,
  [SMALL_STATE(1034)] = 33030,
  [SMALL_STATE(1035)] = 33047,
  [SMALL_STATE(1036)] = 33066,
  [SMALL_STATE(1037)] = 33085,
  [SMALL_STATE(1038)] = 33102,
  [SMALL_STATE(1039)] = 33117,
  [SMALL_STATE(1040)] = 33132,
  [SMALL_STATE(1041)] = 33151,
  [SMALL_STATE(1042)] = 33168,
  [SMALL_STATE(1043)] = 33185,
  [SMALL_STATE(1044)] = 33204,
  [SMALL_STATE(1045)] = 33221,
  [SMALL_STATE(1046)] = 33240,
  [SMALL_STATE(1047)] = 33257,
  [SMALL_STATE(1048)] = 33276,
  [SMALL_STATE(1049)] = 33293,
  [SMALL_STATE(1050)] = 33312,
  [SMALL_STATE(1051)] = 33329,
  [SMALL_STATE(1052)] = 33344,
  [SMALL_STATE(1053)] = 33363,
  [SMALL_STATE(1054)] = 33378,
  [SMALL_STATE(1055)] = 33395,
  [SMALL_STATE(1056)] = 33410,
  [SMALL_STATE(1057)] = 33429,
  [SMALL_STATE(1058)] = 33448,
  [SMALL_STATE(1059)] = 33465,
  [SMALL_STATE(1060)] = 33482,
  [SMALL_STATE(1061)] = 33499,
  [SMALL_STATE(1062)] = 33518,
  [SMALL_STATE(1063)] = 33535,
  [SMALL_STATE(1064)] = 33550,
  [SMALL_STATE(1065)] = 33569,
  [SMALL_STATE(1066)] = 33588,
  [SMALL_STATE(1067)] = 33607,
  [SMALL_STATE(1068)] = 33624,
  [SMALL_STATE(1069)] = 33643,
  [SMALL_STATE(1070)] = 33660,
  [SMALL_STATE(1071)] = 33679,
  [SMALL_STATE(1072)] = 33698,
  [SMALL_STATE(1073)] = 33713,
  [SMALL_STATE(1074)] = 33730,
  [SMALL_STATE(1075)] = 33747,
  [SMALL_STATE(1076)] = 33762,
  [SMALL_STATE(1077)] = 33781,
  [SMALL_STATE(1078)] = 33800,
  [SMALL_STATE(1079)] = 33817,
  [SMALL_STATE(1080)] = 33836,
  [SMALL_STATE(1081)] = 33855,
  [SMALL_STATE(1082)] = 33870,
  [SMALL_STATE(1083)] = 33887,
  [SMALL_STATE(1084)] = 33902,
  [SMALL_STATE(1085)] = 33917,
  [SMALL_STATE(1086)] = 33934,
  [SMALL_STATE(1087)] = 33949,
  [SMALL_STATE(1088)] = 33964,
  [SMALL_STATE(1089)] = 33981,
  [SMALL_STATE(1090)] = 34000,
  [SMALL_STATE(1091)] = 34017,
  [SMALL_STATE(1092)] = 34034,
  [SMALL_STATE(1093)] = 34051,
  [SMALL_STATE(1094)] = 34070,
  [SMALL_STATE(1095)] = 34087,
  [SMALL_STATE(1096)] = 34104,
  [SMALL_STATE(1097)] = 34121,
  [SMALL_STATE(1098)] = 34138,
  [SMALL_STATE(1099)] = 34157,
  [SMALL_STATE(1100)] = 34172,
  [SMALL_STATE(1101)] = 34187,
  [SMALL_STATE(1102)] = 34206,
  [SMALL_STATE(1103)] = 34221,
  [SMALL_STATE(1104)] = 34240,
  [SMALL_STATE(1105)] = 34257,
  [SMALL_STATE(1106)] = 34272,
  [SMALL_STATE(1107)] = 34291,
  [SMALL_STATE(1108)] = 34308,
  [SMALL_STATE(1109)] = 34327,
  [SMALL_STATE(1110)] = 34346,
  [SMALL_STATE(1111)] = 34363,
  [SMALL_STATE(1112)] = 34378,
  [SMALL_STATE(1113)] = 34397,
  [SMALL_STATE(1114)] = 34414,
  [SMALL_STATE(1115)] = 34433,
  [SMALL_STATE(1116)] = 34452,
  [SMALL_STATE(1117)] = 34469,
  [SMALL_STATE(1118)] = 34484,
  [SMALL_STATE(1119)] = 34503,
  [SMALL_STATE(1120)] = 34520,
  [SMALL_STATE(1121)] = 34535,
  [SMALL_STATE(1122)] = 34552,
  [SMALL_STATE(1123)] = 34569,
  [SMALL_STATE(1124)] = 34586,
  [SMALL_STATE(1125)] = 34605,
  [SMALL_STATE(1126)] = 34622,
  [SMALL_STATE(1127)] = 34637,
  [SMALL_STATE(1128)] = 34656,
  [SMALL_STATE(1129)] = 34675,
  [SMALL_STATE(1130)] = 34694,
  [SMALL_STATE(1131)] = 34711,
  [SMALL_STATE(1132)] = 34730,
  [SMALL_STATE(1133)] = 34749,
  [SMALL_STATE(1134)] = 34766,
  [SMALL_STATE(1135)] = 34783,
  [SMALL_STATE(1136)] = 34800,
  [SMALL_STATE(1137)] = 34819,
  [SMALL_STATE(1138)] = 34836,
  [SMALL_STATE(1139)] = 34853,
  [SMALL_STATE(1140)] = 34870,
  [SMALL_STATE(1141)] = 34886,
  [SMALL_STATE(1142)] = 34902,
  [SMALL_STATE(1143)] = 34918,
  [SMALL_STATE(1144)] = 34932,
  [SMALL_STATE(1145)] = 34946,
  [SMALL_STATE(1146)] = 34962,
  [SMALL_STATE(1147)] = 34976,
  [SMALL_STATE(1148)] = 34992,
  [SMALL_STATE(1149)] = 35008,
  [SMALL_STATE(1150)] = 35024,
  [SMALL_STATE(1151)] = 35038,
  [SMALL_STATE(1152)] = 35054,
  [SMALL_STATE(1153)] = 35070,
  [SMALL_STATE(1154)] = 35084,
  [SMALL_STATE(1155)] = 35100,
  [SMALL_STATE(1156)] = 35116,
  [SMALL_STATE(1157)] = 35130,
  [SMALL_STATE(1158)] = 35144,
  [SMALL_STATE(1159)] = 35160,
  [SMALL_STATE(1160)] = 35176,
  [SMALL_STATE(1161)] = 35190,
  [SMALL_STATE(1162)] = 35206,
  [SMALL_STATE(1163)] = 35222,
  [SMALL_STATE(1164)] = 35236,
  [SMALL_STATE(1165)] = 35252,
  [SMALL_STATE(1166)] = 35266,
  [SMALL_STATE(1167)] = 35282,
  [SMALL_STATE(1168)] = 35298,
  [SMALL_STATE(1169)] = 35314,
  [SMALL_STATE(1170)] = 35328,
  [SMALL_STATE(1171)] = 35342,
  [SMALL_STATE(1172)] = 35358,
  [SMALL_STATE(1173)] = 35374,
  [SMALL_STATE(1174)] = 35390,
  [SMALL_STATE(1175)] = 35404,
  [SMALL_STATE(1176)] = 35418,
  [SMALL_STATE(1177)] = 35434,
  [SMALL_STATE(1178)] = 35450,
  [SMALL_STATE(1179)] = 35464,
  [SMALL_STATE(1180)] = 35478,
  [SMALL_STATE(1181)] = 35494,
  [SMALL_STATE(1182)] = 35510,
  [SMALL_STATE(1183)] = 35526,
  [SMALL_STATE(1184)] = 35542,
  [SMALL_STATE(1185)] = 35558,
  [SMALL_STATE(1186)] = 35574,
  [SMALL_STATE(1187)] = 35588,
  [SMALL_STATE(1188)] = 35604,
  [SMALL_STATE(1189)] = 35618,
  [SMALL_STATE(1190)] = 35632,
  [SMALL_STATE(1191)] = 35648,
  [SMALL_STATE(1192)] = 35662,
  [SMALL_STATE(1193)] = 35678,
  [SMALL_STATE(1194)] = 35692,
  [SMALL_STATE(1195)] = 35706,
  [SMALL_STATE(1196)] = 35722,
  [SMALL_STATE(1197)] = 35738,
  [SMALL_STATE(1198)] = 35752,
  [SMALL_STATE(1199)] = 35768,
  [SMALL_STATE(1200)] = 35784,
  [SMALL_STATE(1201)] = 35798,
  [SMALL_STATE(1202)] = 35814,
  [SMALL_STATE(1203)] = 35830,
  [SMALL_STATE(1204)] = 35844,
  [SMALL_STATE(1205)] = 35860,
  [SMALL_STATE(1206)] = 35876,
  [SMALL_STATE(1207)] = 35892,
  [SMALL_STATE(1208)] = 35908,
  [SMALL_STATE(1209)] = 35922,
  [SMALL_STATE(1210)] = 35936,
  [SMALL_STATE(1211)] = 35950,
  [SMALL_STATE(1212)] = 35964,
  [SMALL_STATE(1213)] = 35978,
  [SMALL_STATE(1214)] = 35992,
  [SMALL_STATE(1215)] = 36006,
  [SMALL_STATE(1216)] = 36022,
  [SMALL_STATE(1217)] = 36038,
  [SMALL_STATE(1218)] = 36054,
  [SMALL_STATE(1219)] = 36070,
  [SMALL_STATE(1220)] = 36086,
  [SMALL_STATE(1221)] = 36100,
  [SMALL_STATE(1222)] = 36114,
  [SMALL_STATE(1223)] = 36128,
  [SMALL_STATE(1224)] = 36142,
  [SMALL_STATE(1225)] = 36156,
  [SMALL_STATE(1226)] = 36170,
  [SMALL_STATE(1227)] = 36186,
  [SMALL_STATE(1228)] = 36200,
  [SMALL_STATE(1229)] = 36216,
  [SMALL_STATE(1230)] = 36230,
  [SMALL_STATE(1231)] = 36244,
  [SMALL_STATE(1232)] = 36258,
  [SMALL_STATE(1233)] = 36272,
  [SMALL_STATE(1234)] = 36286,
  [SMALL_STATE(1235)] = 36300,
  [SMALL_STATE(1236)] = 36314,
  [SMALL_STATE(1237)] = 36328,
  [SMALL_STATE(1238)] = 36344,
  [SMALL_STATE(1239)] = 36360,
  [SMALL_STATE(1240)] = 36374,
  [SMALL_STATE(1241)] = 36390,
  [SMALL_STATE(1242)] = 36404,
  [SMALL_STATE(1243)] = 36418,
  [SMALL_STATE(1244)] = 36434,
  [SMALL_STATE(1245)] = 36450,
  [SMALL_STATE(1246)] = 36466,
  [SMALL_STATE(1247)] = 36480,
  [SMALL_STATE(1248)] = 36494,
  [SMALL_STATE(1249)] = 36508,
  [SMALL_STATE(1250)] = 36522,
  [SMALL_STATE(1251)] = 36536,
  [SMALL_STATE(1252)] = 36552,
  [SMALL_STATE(1253)] = 36566,
  [SMALL_STATE(1254)] = 36580,
  [SMALL_STATE(1255)] = 36596,
  [SMALL_STATE(1256)] = 36610,
  [SMALL_STATE(1257)] = 36624,
  [SMALL_STATE(1258)] = 36640,
  [SMALL_STATE(1259)] = 36654,
  [SMALL_STATE(1260)] = 36670,
  [SMALL_STATE(1261)] = 36686,
  [SMALL_STATE(1262)] = 36700,
  [SMALL_STATE(1263)] = 36716,
  [SMALL_STATE(1264)] = 36730,
  [SMALL_STATE(1265)] = 36746,
  [SMALL_STATE(1266)] = 36762,
  [SMALL_STATE(1267)] = 36776,
  [SMALL_STATE(1268)] = 36792,
  [SMALL_STATE(1269)] = 36806,
  [SMALL_STATE(1270)] = 36822,
  [SMALL_STATE(1271)] = 36838,
  [SMALL_STATE(1272)] = 36854,
  [SMALL_STATE(1273)] = 36870,
  [SMALL_STATE(1274)] = 36886,
  [SMALL_STATE(1275)] = 36900,
  [SMALL_STATE(1276)] = 36914,
  [SMALL_STATE(1277)] = 36930,
  [SMALL_STATE(1278)] = 36944,
  [SMALL_STATE(1279)] = 36958,
  [SMALL_STATE(1280)] = 36972,
  [SMALL_STATE(1281)] = 36988,
  [SMALL_STATE(1282)] = 37004,
  [SMALL_STATE(1283)] = 37020,
  [SMALL_STATE(1284)] = 37036,
  [SMALL_STATE(1285)] = 37050,
  [SMALL_STATE(1286)] = 37064,
  [SMALL_STATE(1287)] = 37078,
  [SMALL_STATE(1288)] = 37092,
  [SMALL_STATE(1289)] = 37106,
  [SMALL_STATE(1290)] = 37122,
  [SMALL_STATE(1291)] = 37138,
  [SMALL_STATE(1292)] = 37154,
  [SMALL_STATE(1293)] = 37168,
  [SMALL_STATE(1294)] = 37182,
  [SMALL_STATE(1295)] = 37196,
  [SMALL_STATE(1296)] = 37212,
  [SMALL_STATE(1297)] = 37225,
  [SMALL_STATE(1298)] = 37238,
  [SMALL_STATE(1299)] = 37251,
  [SMALL_STATE(1300)] = 37264,
  [SMALL_STATE(1301)] = 37277,
  [SMALL_STATE(1302)] = 37290,
  [SMALL_STATE(1303)] = 37303,
  [SMALL_STATE(1304)] = 37316,
  [SMALL_STATE(1305)] = 37329,
  [SMALL_STATE(1306)] = 37342,
  [SMALL_STATE(1307)] = 37355,
  [SMALL_STATE(1308)] = 37368,
  [SMALL_STATE(1309)] = 37381,
  [SMALL_STATE(1310)] = 37394,
  [SMALL_STATE(1311)] = 37407,
  [SMALL_STATE(1312)] = 37420,
  [SMALL_STATE(1313)] = 37433,
  [SMALL_STATE(1314)] = 37446,
  [SMALL_STATE(1315)] = 37459,
  [SMALL_STATE(1316)] = 37472,
  [SMALL_STATE(1317)] = 37485,
  [SMALL_STATE(1318)] = 37498,
  [SMALL_STATE(1319)] = 37511,
  [SMALL_STATE(1320)] = 37524,
  [SMALL_STATE(1321)] = 37537,
  [SMALL_STATE(1322)] = 37550,
  [SMALL_STATE(1323)] = 37563,
  [SMALL_STATE(1324)] = 37576,
  [SMALL_STATE(1325)] = 37589,
  [SMALL_STATE(1326)] = 37602,
  [SMALL_STATE(1327)] = 37615,
  [SMALL_STATE(1328)] = 37628,
  [SMALL_STATE(1329)] = 37641,
  [SMALL_STATE(1330)] = 37654,
  [SMALL_STATE(1331)] = 37667,
  [SMALL_STATE(1332)] = 37680,
  [SMALL_STATE(1333)] = 37693,
  [SMALL_STATE(1334)] = 37706,
  [SMALL_STATE(1335)] = 37719,
  [SMALL_STATE(1336)] = 37732,
  [SMALL_STATE(1337)] = 37745,
  [SMALL_STATE(1338)] = 37758,
  [SMALL_STATE(1339)] = 37771,
  [SMALL_STATE(1340)] = 37784,
  [SMALL_STATE(1341)] = 37797,
  [SMALL_STATE(1342)] = 37810,
  [SMALL_STATE(1343)] = 37823,
  [SMALL_STATE(1344)] = 37836,
  [SMALL_STATE(1345)] = 37849,
  [SMALL_STATE(1346)] = 37862,
  [SMALL_STATE(1347)] = 37875,
  [SMALL_STATE(1348)] = 37888,
  [SMALL_STATE(1349)] = 37901,
  [SMALL_STATE(1350)] = 37914,
  [SMALL_STATE(1351)] = 37927,
  [SMALL_STATE(1352)] = 37940,
  [SMALL_STATE(1353)] = 37953,
  [SMALL_STATE(1354)] = 37966,
  [SMALL_STATE(1355)] = 37979,
  [SMALL_STATE(1356)] = 37992,
  [SMALL_STATE(1357)] = 38005,
  [SMALL_STATE(1358)] = 38018,
  [SMALL_STATE(1359)] = 38031,
  [SMALL_STATE(1360)] = 38044,
  [SMALL_STATE(1361)] = 38057,
  [SMALL_STATE(1362)] = 38070,
  [SMALL_STATE(1363)] = 38083,
  [SMALL_STATE(1364)] = 38096,
  [SMALL_STATE(1365)] = 38109,
  [SMALL_STATE(1366)] = 38122,
  [SMALL_STATE(1367)] = 38135,
  [SMALL_STATE(1368)] = 38148,
  [SMALL_STATE(1369)] = 38161,
  [SMALL_STATE(1370)] = 38174,
  [SMALL_STATE(1371)] = 38187,
  [SMALL_STATE(1372)] = 38200,
  [SMALL_STATE(1373)] = 38213,
  [SMALL_STATE(1374)] = 38226,
  [SMALL_STATE(1375)] = 38239,
  [SMALL_STATE(1376)] = 38252,
  [SMALL_STATE(1377)] = 38265,
  [SMALL_STATE(1378)] = 38278,
  [SMALL_STATE(1379)] = 38291,
  [SMALL_STATE(1380)] = 38304,
  [SMALL_STATE(1381)] = 38317,
  [SMALL_STATE(1382)] = 38330,
  [SMALL_STATE(1383)] = 38343,
  [SMALL_STATE(1384)] = 38356,
  [SMALL_STATE(1385)] = 38369,
  [SMALL_STATE(1386)] = 38382,
  [SMALL_STATE(1387)] = 38395,
  [SMALL_STATE(1388)] = 38408,
  [SMALL_STATE(1389)] = 38421,
  [SMALL_STATE(1390)] = 38434,
  [SMALL_STATE(1391)] = 38445,
  [SMALL_STATE(1392)] = 38458,
  [SMALL_STATE(1393)] = 38471,
  [SMALL_STATE(1394)] = 38484,
  [SMALL_STATE(1395)] = 38497,
  [SMALL_STATE(1396)] = 38510,
  [SMALL_STATE(1397)] = 38523,
  [SMALL_STATE(1398)] = 38536,
  [SMALL_STATE(1399)] = 38549,
  [SMALL_STATE(1400)] = 38562,
  [SMALL_STATE(1401)] = 38575,
  [SMALL_STATE(1402)] = 38588,
  [SMALL_STATE(1403)] = 38601,
  [SMALL_STATE(1404)] = 38614,
  [SMALL_STATE(1405)] = 38627,
  [SMALL_STATE(1406)] = 38631,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT(867),
  [5] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(50),
  [11] = {.count = 1, .reusable = false}, SHIFT(867),
  [13] = {.count = 1, .reusable = false}, SHIFT(960),
  [15] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [17] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [19] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(538),
  [22] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(293),
  [25] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(496),
  [28] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1074),
  [31] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(846),
  [34] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(715),
  [37] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(841),
  [40] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(764),
  [43] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(829),
  [46] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [49] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1365),
  [52] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1364),
  [55] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1361),
  [58] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(739),
  [61] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(740),
  [64] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(73),
  [67] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1356),
  [70] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1355),
  [73] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(109),
  [76] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1354),
  [79] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [81] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(570),
  [84] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1162),
  [87] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1350),
  [90] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(111),
  [93] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(114),
  [96] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(115),
  [99] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(211),
  [102] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1159),
  [105] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(62),
  [108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1346),
  [111] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1345),
  [114] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1147),
  [117] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1142),
  [120] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(210),
  [123] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(209),
  [126] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(209),
  [129] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(382),
  [132] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(207),
  [135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(707),
  [138] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(79),
  [141] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(610),
  [144] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(570),
  [147] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1332),
  [150] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(547),
  [153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(460),
  [156] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(879),
  [159] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(64),
  [162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(202),
  [165] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(188),
  [168] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(182),
  [171] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(179),
  [174] = {.count = 1, .reusable = false}, SHIFT(538),
  [176] = {.count = 1, .reusable = true}, SHIFT(293),
  [178] = {.count = 1, .reusable = false}, SHIFT(496),
  [180] = {.count = 1, .reusable = false}, SHIFT(1074),
  [182] = {.count = 1, .reusable = false}, SHIFT(846),
  [184] = {.count = 1, .reusable = false}, SHIFT(715),
  [186] = {.count = 1, .reusable = true}, SHIFT(841),
  [188] = {.count = 1, .reusable = false}, SHIFT(764),
  [190] = {.count = 1, .reusable = false}, SHIFT(829),
  [192] = {.count = 1, .reusable = true}, SHIFT(21),
  [194] = {.count = 1, .reusable = false}, SHIFT(1365),
  [196] = {.count = 1, .reusable = false}, SHIFT(1364),
  [198] = {.count = 1, .reusable = false}, SHIFT(1361),
  [200] = {.count = 1, .reusable = false}, SHIFT(739),
  [202] = {.count = 1, .reusable = false}, SHIFT(740),
  [204] = {.count = 1, .reusable = true}, SHIFT(73),
  [206] = {.count = 1, .reusable = false}, SHIFT(1356),
  [208] = {.count = 1, .reusable = false}, SHIFT(1355),
  [210] = {.count = 1, .reusable = false}, SHIFT(109),
  [212] = {.count = 1, .reusable = false}, SHIFT(1354),
  [214] = {.count = 1, .reusable = false}, SHIFT(570),
  [216] = {.count = 1, .reusable = false}, SHIFT(1162),
  [218] = {.count = 1, .reusable = false}, SHIFT(1350),
  [220] = {.count = 1, .reusable = false}, SHIFT(111),
  [222] = {.count = 1, .reusable = false}, SHIFT(114),
  [224] = {.count = 1, .reusable = false}, SHIFT(115),
  [226] = {.count = 1, .reusable = false}, SHIFT(211),
  [228] = {.count = 1, .reusable = false}, SHIFT(1159),
  [230] = {.count = 1, .reusable = false}, REDUCE(sym_colon_block, 2),
  [232] = {.count = 1, .reusable = false}, SHIFT(62),
  [234] = {.count = 1, .reusable = false}, SHIFT(1346),
  [236] = {.count = 1, .reusable = false}, SHIFT(1345),
  [238] = {.count = 1, .reusable = false}, SHIFT(1147),
  [240] = {.count = 1, .reusable = false}, SHIFT(1142),
  [242] = {.count = 1, .reusable = true}, SHIFT(210),
  [244] = {.count = 1, .reusable = false}, SHIFT(209),
  [246] = {.count = 1, .reusable = true}, SHIFT(209),
  [248] = {.count = 1, .reusable = false}, SHIFT(382),
  [250] = {.count = 1, .reusable = false}, SHIFT(207),
  [252] = {.count = 1, .reusable = false}, SHIFT(707),
  [254] = {.count = 1, .reusable = true}, SHIFT(79),
  [256] = {.count = 1, .reusable = true}, SHIFT(610),
  [258] = {.count = 1, .reusable = true}, SHIFT(570),
  [260] = {.count = 1, .reusable = false}, SHIFT(1332),
  [262] = {.count = 1, .reusable = false}, SHIFT(547),
  [264] = {.count = 1, .reusable = true}, SHIFT(460),
  [266] = {.count = 1, .reusable = true}, SHIFT(879),
  [268] = {.count = 1, .reusable = false}, SHIFT(64),
  [270] = {.count = 1, .reusable = false}, SHIFT(202),
  [272] = {.count = 1, .reusable = false}, SHIFT(188),
  [274] = {.count = 1, .reusable = false}, SHIFT(182),
  [276] = {.count = 1, .reusable = false}, SHIFT(179),
  [278] = {.count = 1, .reusable = false}, REDUCE(sym_colon_block, 1),
  [280] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4, .production_id = 55),
  [282] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4, .production_id = 55),
  [284] = {.count = 1, .reusable = true}, REDUCE(sym_default_statement, 2),
  [286] = {.count = 1, .reusable = false}, REDUCE(sym_default_statement, 2),
  [288] = {.count = 1, .reusable = true}, REDUCE(sym_default_statement, 3),
  [290] = {.count = 1, .reusable = false}, REDUCE(sym_default_statement, 3),
  [292] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3, .production_id = 55),
  [294] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3, .production_id = 55),
  [296] = {.count = 1, .reusable = true}, SHIFT(322),
  [298] = {.count = 1, .reusable = true}, SHIFT(4),
  [300] = {.count = 1, .reusable = true}, SHIFT(319),
  [302] = {.count = 1, .reusable = false}, SHIFT(543),
  [304] = {.count = 1, .reusable = true}, SHIFT(1021),
  [306] = {.count = 1, .reusable = false}, SHIFT(489),
  [308] = {.count = 1, .reusable = false}, SHIFT(986),
  [310] = {.count = 1, .reusable = false}, SHIFT(834),
  [312] = {.count = 1, .reusable = false}, SHIFT(713),
  [314] = {.count = 1, .reusable = false}, SHIFT(800),
  [316] = {.count = 1, .reusable = true}, SHIFT(16),
  [318] = {.count = 1, .reusable = false}, SHIFT(1302),
  [320] = {.count = 1, .reusable = false}, SHIFT(1303),
  [322] = {.count = 1, .reusable = false}, SHIFT(1304),
  [324] = {.count = 1, .reusable = false}, SHIFT(1392),
  [326] = {.count = 1, .reusable = false}, SHIFT(118),
  [328] = {.count = 1, .reusable = false}, SHIFT(1393),
  [330] = {.count = 1, .reusable = false}, SHIFT(1290),
  [332] = {.count = 1, .reusable = false}, SHIFT(1299),
  [334] = {.count = 1, .reusable = false}, SHIFT(113),
  [336] = {.count = 1, .reusable = false}, SHIFT(112),
  [338] = {.count = 1, .reusable = false}, SHIFT(110),
  [340] = {.count = 1, .reusable = false}, SHIFT(169),
  [342] = {.count = 1, .reusable = false}, SHIFT(1180),
  [344] = {.count = 1, .reusable = false}, SHIFT(58),
  [346] = {.count = 1, .reusable = false}, SHIFT(1401),
  [348] = {.count = 1, .reusable = false}, SHIFT(1404),
  [350] = {.count = 1, .reusable = false}, SHIFT(1216),
  [352] = {.count = 1, .reusable = false}, SHIFT(1291),
  [354] = {.count = 1, .reusable = true}, SHIFT(1020),
  [356] = {.count = 1, .reusable = true}, SHIFT(1012),
  [358] = {.count = 1, .reusable = true}, SHIFT(1011),
  [360] = {.count = 1, .reusable = true}, SHIFT(310),
  [362] = {.count = 1, .reusable = true}, SHIFT(309),
  [364] = {.count = 1, .reusable = false}, SHIFT(1233),
  [366] = {.count = 1, .reusable = false}, SHIFT(1230),
  [368] = {.count = 1, .reusable = true}, SHIFT(373),
  [370] = {.count = 1, .reusable = true}, SHIFT(1082),
  [372] = {.count = 1, .reusable = true}, SHIFT(376),
  [374] = {.count = 1, .reusable = false}, SHIFT(1258),
  [376] = {.count = 1, .reusable = true}, SHIFT(132),
  [378] = {.count = 1, .reusable = true}, SHIFT(265),
  [380] = {.count = 1, .reusable = true}, SHIFT(56),
  [382] = {.count = 1, .reusable = true}, SHIFT(263),
  [384] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [386] = {.count = 1, .reusable = true}, SHIFT(977),
  [388] = {.count = 1, .reusable = true}, SHIFT(49),
  [390] = {.count = 1, .reusable = true}, SHIFT(976),
  [392] = {.count = 1, .reusable = true}, SHIFT(996),
  [394] = {.count = 1, .reusable = true}, SHIFT(41),
  [396] = {.count = 1, .reusable = true}, SHIFT(995),
  [398] = {.count = 1, .reusable = true}, SHIFT(1010),
  [400] = {.count = 1, .reusable = true}, SHIFT(37),
  [402] = {.count = 1, .reusable = true}, SHIFT(1009),
  [404] = {.count = 1, .reusable = false}, SHIFT(1236),
  [406] = {.count = 1, .reusable = false}, SHIFT(1235),
  [408] = {.count = 1, .reusable = true}, SHIFT(595),
  [410] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [412] = {.count = 1, .reusable = true}, SHIFT(307),
  [414] = {.count = 1, .reusable = true}, SHIFT(45),
  [416] = {.count = 1, .reusable = true}, SHIFT(306),
  [418] = {.count = 1, .reusable = false}, SHIFT(1263),
  [420] = {.count = 1, .reusable = false}, SHIFT(1146),
  [422] = {.count = 1, .reusable = true}, SHIFT(591),
  [424] = {.count = 1, .reusable = false}, SHIFT(1227),
  [426] = {.count = 1, .reusable = false}, SHIFT(1225),
  [428] = {.count = 1, .reusable = false}, SHIFT(1256),
  [430] = {.count = 1, .reusable = true}, SHIFT(323),
  [432] = {.count = 1, .reusable = true}, SHIFT(20),
  [434] = {.count = 1, .reusable = true}, SHIFT(325),
  [436] = {.count = 1, .reusable = false}, SHIFT(1169),
  [438] = {.count = 1, .reusable = true}, SHIFT(1019),
  [440] = {.count = 1, .reusable = true}, SHIFT(31),
  [442] = {.count = 1, .reusable = true}, SHIFT(1018),
  [444] = {.count = 1, .reusable = false}, SHIFT(1221),
  [446] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [448] = {.count = 1, .reusable = true}, SHIFT(1024),
  [450] = {.count = 1, .reusable = true}, SHIFT(29),
  [452] = {.count = 1, .reusable = true}, SHIFT(1023),
  [454] = {.count = 1, .reusable = true}, SHIFT(140),
  [456] = {.count = 1, .reusable = true}, SHIFT(318),
  [458] = {.count = 1, .reusable = true}, SHIFT(46),
  [460] = {.count = 1, .reusable = true}, SHIFT(317),
  [462] = {.count = 1, .reusable = false}, SHIFT(1249),
  [464] = {.count = 1, .reusable = true}, SHIFT(289),
  [466] = {.count = 1, .reusable = true}, SHIFT(35),
  [468] = {.count = 1, .reusable = true}, SHIFT(282),
  [470] = {.count = 1, .reusable = false}, SHIFT(1203),
  [472] = {.count = 1, .reusable = false}, SHIFT(387),
  [474] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [476] = {.count = 1, .reusable = false}, SHIFT(436),
  [478] = {.count = 1, .reusable = false}, SHIFT(1136),
  [480] = {.count = 1, .reusable = false}, SHIFT(1077),
  [482] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [484] = {.count = 1, .reusable = false}, SHIFT(157),
  [486] = {.count = 1, .reusable = true}, SHIFT(70),
  [488] = {.count = 1, .reusable = false}, SHIFT(1310),
  [490] = {.count = 1, .reusable = false}, SHIFT(535),
  [492] = {.count = 1, .reusable = true}, SHIFT(175),
  [494] = {.count = 1, .reusable = false}, SHIFT(180),
  [496] = {.count = 1, .reusable = true}, SHIFT(180),
  [498] = {.count = 1, .reusable = false}, SHIFT(383),
  [500] = {.count = 1, .reusable = false}, SHIFT(181),
  [502] = {.count = 1, .reusable = false}, SHIFT(706),
  [504] = {.count = 1, .reusable = true}, SHIFT(76),
  [506] = {.count = 1, .reusable = true}, SHIFT(611),
  [508] = {.count = 1, .reusable = true}, SHIFT(535),
  [510] = {.count = 1, .reusable = false}, SHIFT(454),
  [512] = {.count = 1, .reusable = true}, SHIFT(419),
  [514] = {.count = 1, .reusable = true}, SHIFT(844),
  [516] = {.count = 1, .reusable = false}, SHIFT(63),
  [518] = {.count = 1, .reusable = false}, SHIFT(236),
  [520] = {.count = 1, .reusable = false}, SHIFT(184),
  [522] = {.count = 1, .reusable = false}, SHIFT(185),
  [524] = {.count = 1, .reusable = false}, SHIFT(186),
  [526] = {.count = 1, .reusable = false}, SHIFT(203),
  [528] = {.count = 1, .reusable = false}, SHIFT(444),
  [530] = {.count = 1, .reusable = false}, SHIFT(544),
  [532] = {.count = 1, .reusable = false}, SHIFT(1115),
  [534] = {.count = 1, .reusable = false}, SHIFT(233),
  [536] = {.count = 1, .reusable = false}, SHIFT(170),
  [538] = {.count = 1, .reusable = false}, SHIFT(1192),
  [540] = {.count = 1, .reusable = false}, SHIFT(1385),
  [542] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 2),
  [544] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 2),
  [546] = {.count = 1, .reusable = false}, SHIFT(1320),
  [548] = {.count = 1, .reusable = false}, SHIFT(1240),
  [550] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [552] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [554] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1320),
  [557] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1240),
  [560] = {.count = 1, .reusable = true}, SHIFT(1343),
  [562] = {.count = 1, .reusable = true}, SHIFT(157),
  [564] = {.count = 1, .reusable = true}, SHIFT(398),
  [566] = {.count = 1, .reusable = true}, SHIFT(1336),
  [568] = {.count = 1, .reusable = true}, SHIFT(391),
  [570] = {.count = 1, .reusable = true}, SHIFT(1309),
  [572] = {.count = 1, .reusable = true}, SHIFT(442),
  [574] = {.count = 1, .reusable = true}, SHIFT(1402),
  [576] = {.count = 1, .reusable = true}, SHIFT(437),
  [578] = {.count = 1, .reusable = true}, SHIFT(91),
  [580] = {.count = 1, .reusable = true}, SHIFT(99),
  [582] = {.count = 1, .reusable = true}, SHIFT(450),
  [584] = {.count = 1, .reusable = true}, SHIFT(47),
  [586] = {.count = 1, .reusable = true}, SHIFT(53),
  [588] = {.count = 1, .reusable = true}, SHIFT(102),
  [590] = {.count = 1, .reusable = true}, SHIFT(397),
  [592] = {.count = 1, .reusable = true}, SHIFT(392),
  [594] = {.count = 1, .reusable = true}, SHIFT(360),
  [596] = {.count = 1, .reusable = true}, SHIFT(163),
  [598] = {.count = 1, .reusable = true}, SHIFT(393),
  [600] = {.count = 1, .reusable = true}, SHIFT(55),
  [602] = {.count = 1, .reusable = true}, SHIFT(327),
  [604] = {.count = 1, .reusable = true}, SHIFT(27),
  [606] = {.count = 1, .reusable = true}, SHIFT(119),
  [608] = {.count = 1, .reusable = true}, SHIFT(72),
  [610] = {.count = 1, .reusable = true}, SHIFT(1055),
  [612] = {.count = 1, .reusable = true}, SHIFT(448),
  [614] = {.count = 1, .reusable = true}, SHIFT(26),
  [616] = {.count = 1, .reusable = true}, SHIFT(80),
  [618] = {.count = 1, .reusable = true}, SHIFT(96),
  [620] = {.count = 1, .reusable = true}, SHIFT(93),
  [622] = {.count = 1, .reusable = true}, SHIFT(461),
  [624] = {.count = 1, .reusable = true}, SHIFT(34),
  [626] = {.count = 1, .reusable = true}, SHIFT(424),
  [628] = {.count = 1, .reusable = true}, SHIFT(452),
  [630] = {.count = 1, .reusable = true}, SHIFT(146),
  [632] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [634] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [636] = {.count = 1, .reusable = false}, SHIFT(1177),
  [638] = {.count = 1, .reusable = false}, SHIFT(61),
  [640] = {.count = 1, .reusable = true}, SHIFT(228),
  [642] = {.count = 1, .reusable = true}, SHIFT(980),
  [644] = {.count = 1, .reusable = true}, SHIFT(275),
  [646] = {.count = 1, .reusable = true}, SHIFT(974),
  [648] = {.count = 1, .reusable = true}, SHIFT(964),
  [650] = {.count = 1, .reusable = true}, SHIFT(279),
  [652] = {.count = 1, .reusable = true}, SHIFT(291),
  [654] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 10),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 10),
  [658] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_literal_repeat1, 1),
  [660] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 6, .production_id = 62),
  [662] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 6, .production_id = 62),
  [664] = {.count = 1, .reusable = true}, SHIFT(166),
  [666] = {.count = 1, .reusable = true}, SHIFT(456),
  [668] = {.count = 1, .reusable = true}, SHIFT(161),
  [670] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44),
  [672] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44),
  [674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1177),
  [677] = {.count = 1, .reusable = true}, SHIFT(151),
  [679] = {.count = 1, .reusable = true}, SHIFT(348),
  [681] = {.count = 1, .reusable = true}, SHIFT(406),
  [683] = {.count = 1, .reusable = true}, SHIFT(358),
  [685] = {.count = 1, .reusable = true}, SHIFT(463),
  [687] = {.count = 1, .reusable = true}, SHIFT(221),
  [689] = {.count = 1, .reusable = true}, SHIFT(415),
  [691] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [693] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [695] = {.count = 1, .reusable = true}, SHIFT(155),
  [697] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [699] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [701] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 2),
  [703] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 2),
  [705] = {.count = 1, .reusable = true}, SHIFT(183),
  [707] = {.count = 1, .reusable = true}, SHIFT(224),
  [709] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [711] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [713] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 56),
  [715] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 56),
  [717] = {.count = 1, .reusable = true}, SHIFT(314),
  [719] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [721] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [723] = {.count = 1, .reusable = true}, SHIFT(303),
  [725] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 41),
  [727] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 41),
  [729] = {.count = 1, .reusable = true}, SHIFT(280),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 23),
  [733] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 23),
  [735] = {.count = 1, .reusable = true}, SHIFT(260),
  [737] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 28),
  [739] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 28),
  [741] = {.count = 1, .reusable = true}, SHIFT(273),
  [743] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [745] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [747] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [749] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [751] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [753] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [755] = {.count = 1, .reusable = true}, SHIFT(256),
  [757] = {.count = 1, .reusable = true}, REDUCE(sym_declare_statement, 8),
  [759] = {.count = 1, .reusable = false}, REDUCE(sym_declare_statement, 8),
  [761] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 2, .production_id = 2),
  [763] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2, .production_id = 2),
  [765] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [767] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [769] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 3, .production_id = 5),
  [771] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 3, .production_id = 5),
  [773] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 3, .production_id = 6),
  [775] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 3, .production_id = 6),
  [777] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 25),
  [779] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 25),
  [781] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 1),
  [783] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 1),
  [785] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_declaration, 3),
  [787] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_use_declaration, 3),
  [789] = {.count = 1, .reusable = true}, REDUCE(sym__jump_statement, 1),
  [791] = {.count = 1, .reusable = false}, REDUCE(sym__jump_statement, 1),
  [793] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 2, .production_id = 2),
  [795] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 2, .production_id = 2),
  [797] = {.count = 1, .reusable = true}, REDUCE(sym_switch_block, 2),
  [799] = {.count = 1, .reusable = false}, REDUCE(sym_switch_block, 2),
  [801] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_declaration, 5),
  [803] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_use_declaration, 5),
  [805] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 6),
  [807] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 6),
  [809] = {.count = 1, .reusable = true}, REDUCE(sym_const_declaration, 3),
  [811] = {.count = 1, .reusable = false}, REDUCE(sym_const_declaration, 3),
  [813] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 23),
  [815] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 23),
  [817] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 23),
  [819] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 23),
  [821] = {.count = 1, .reusable = true}, REDUCE(sym_trait_declaration, 3, .production_id = 6),
  [823] = {.count = 1, .reusable = false}, REDUCE(sym_trait_declaration, 3, .production_id = 6),
  [825] = {.count = 1, .reusable = true}, REDUCE(sym_unset_statement, 5),
  [827] = {.count = 1, .reusable = false}, REDUCE(sym_unset_statement, 5),
  [829] = {.count = 1, .reusable = true}, REDUCE(sym_declare_statement, 5),
  [831] = {.count = 1, .reusable = false}, REDUCE(sym_declare_statement, 5),
  [833] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 6),
  [835] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 6),
  [837] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5, .production_id = 10),
  [839] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5, .production_id = 10),
  [841] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 42),
  [843] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 42),
  [845] = {.count = 1, .reusable = true}, REDUCE(sym_const_declaration, 4),
  [847] = {.count = 1, .reusable = false}, REDUCE(sym_const_declaration, 4),
  [849] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [851] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [853] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 10),
  [855] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 10),
  [857] = {.count = 1, .reusable = true}, REDUCE(sym_switch_block, 3),
  [859] = {.count = 1, .reusable = false}, REDUCE(sym_switch_block, 3),
  [861] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 28),
  [863] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 28),
  [865] = {.count = 1, .reusable = true}, REDUCE(sym_global_declaration, 3),
  [867] = {.count = 1, .reusable = false}, REDUCE(sym_global_declaration, 3),
  [869] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [871] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [873] = {.count = 1, .reusable = true}, REDUCE(sym_echo_statement, 3),
  [875] = {.count = 1, .reusable = false}, REDUCE(sym_echo_statement, 3),
  [877] = {.count = 1, .reusable = true}, REDUCE(sym_const_declaration, 5),
  [879] = {.count = 1, .reusable = false}, REDUCE(sym_const_declaration, 5),
  [881] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_declaration, 6),
  [883] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_use_declaration, 6),
  [885] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [887] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [889] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 41),
  [891] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 41),
  [893] = {.count = 1, .reusable = true}, REDUCE(sym_unset_statement, 6),
  [895] = {.count = 1, .reusable = false}, REDUCE(sym_unset_statement, 6),
  [897] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym_function_static_declaration, 3),
  [903] = {.count = 1, .reusable = false}, REDUCE(sym_function_static_declaration, 3),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3),
  [909] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3),
  [911] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3),
  [913] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3),
  [915] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3),
  [917] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [919] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [921] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [923] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [925] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [927] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [929] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [931] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [933] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_declaration, 4),
  [935] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_use_declaration, 4),
  [937] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [939] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [941] = {.count = 1, .reusable = true}, REDUCE(sym_else_if_clause, 3, .production_id = 10),
  [943] = {.count = 1, .reusable = false}, REDUCE(sym_else_if_clause, 3, .production_id = 10),
  [945] = {.count = 1, .reusable = true}, REDUCE(sym_global_declaration, 4),
  [947] = {.count = 1, .reusable = false}, REDUCE(sym_global_declaration, 4),
  [949] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 26),
  [951] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 26),
  [953] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 27),
  [955] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 27),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_function_static_declaration, 4),
  [959] = {.count = 1, .reusable = false}, REDUCE(sym_function_static_declaration, 4),
  [961] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [963] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [965] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 10),
  [967] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 10),
  [969] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 2, .production_id = 4),
  [971] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 2, .production_id = 4),
  [973] = {.count = 1, .reusable = true}, REDUCE(sym_switch_block, 4),
  [975] = {.count = 1, .reusable = false}, REDUCE(sym_switch_block, 4),
  [977] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [979] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [981] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_declaration, 7),
  [983] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_use_declaration, 7),
  [985] = {.count = 1, .reusable = true}, REDUCE(sym_declare_statement, 7),
  [987] = {.count = 1, .reusable = false}, REDUCE(sym_declare_statement, 7),
  [989] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [991] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [993] = {.count = 1, .reusable = true}, REDUCE(sym_named_label_statement, 2),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_named_label_statement, 2),
  [997] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 7),
  [999] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 7),
  [1001] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 7, .production_id = 61),
  [1003] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 7, .production_id = 61),
  [1005] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7, .production_id = 43),
  [1007] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7, .production_id = 43),
  [1009] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 12),
  [1011] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 12),
  [1013] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 56),
  [1015] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 56),
  [1017] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 11),
  [1019] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 11),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 10, .production_id = 63),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 10, .production_id = 63),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [1029] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 8),
  [1031] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 8),
  [1033] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [1035] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [1037] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 9, .production_id = 61),
  [1039] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 9, .production_id = 61),
  [1041] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [1043] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [1045] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_statement, 8, .production_id = 63),
  [1047] = {.count = 1, .reusable = false}, REDUCE(sym_foreach_statement, 8, .production_id = 63),
  [1049] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1053] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [1055] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [1057] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [1059] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [1061] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [1063] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [1065] = {.count = 1, .reusable = true}, REDUCE(sym_member_access_expression, 3, .production_id = 14),
  [1067] = {.count = 1, .reusable = false}, REDUCE(sym_member_access_expression, 3, .production_id = 14),
  [1069] = {.count = 1, .reusable = true}, SHIFT(92),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_cast_variable, 4, .production_id = 24),
  [1075] = {.count = 1, .reusable = true}, REDUCE(sym__dereferencable_expression, 1),
  [1077] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [1079] = {.count = 1, .reusable = true}, SHIFT(519),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_cast_variable, 4, .production_id = 24),
  [1083] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 13),
  [1085] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 13),
  [1087] = {.count = 1, .reusable = true}, REDUCE(sym_member_access_expression, 5, .production_id = 47),
  [1089] = {.count = 1, .reusable = false}, REDUCE(sym_member_access_expression, 5, .production_id = 47),
  [1091] = {.count = 1, .reusable = false}, SHIFT(130),
  [1093] = {.count = 1, .reusable = true}, SHIFT(234),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_member_call_expression, 6, .production_id = 58),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym_member_call_expression, 6, .production_id = 58),
  [1099] = {.count = 1, .reusable = true}, REDUCE(sym_dynamic_variable_name, 2),
  [1101] = {.count = 1, .reusable = false}, REDUCE(sym_dynamic_variable_name, 2),
  [1103] = {.count = 1, .reusable = true}, REDUCE(sym_function_call_expression, 2, .production_id = 3),
  [1105] = {.count = 1, .reusable = false}, REDUCE(sym_function_call_expression, 2, .production_id = 3),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym__reserved_identifier, 1),
  [1109] = {.count = 1, .reusable = false}, REDUCE(sym__reserved_identifier, 1),
  [1111] = {.count = 1, .reusable = true}, REDUCE(sym_dynamic_variable_name, 4),
  [1113] = {.count = 1, .reusable = false}, REDUCE(sym_dynamic_variable_name, 4),
  [1115] = {.count = 1, .reusable = true}, REDUCE(sym_member_call_expression, 4, .production_id = 32),
  [1117] = {.count = 1, .reusable = false}, REDUCE(sym_member_call_expression, 4, .production_id = 32),
  [1119] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_call_expression, 6, .production_id = 57),
  [1121] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_call_expression, 6, .production_id = 57),
  [1123] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [1125] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [1127] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_call_expression, 4, .production_id = 31),
  [1129] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_call_expression, 4, .production_id = 31),
  [1131] = {.count = 1, .reusable = true}, REDUCE(sym_variable_name, 2),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_variable_name, 2),
  [1135] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 3),
  [1137] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 3),
  [1139] = {.count = 1, .reusable = true}, SHIFT(88),
  [1141] = {.count = 1, .reusable = true}, SHIFT(990),
  [1143] = {.count = 1, .reusable = false}, SHIFT(125),
  [1145] = {.count = 1, .reusable = true}, SHIFT(558),
  [1147] = {.count = 1, .reusable = true}, SHIFT(206),
  [1149] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_literal_repeat1, 2),
  [1151] = {.count = 1, .reusable = true}, SHIFT(67),
  [1153] = {.count = 1, .reusable = true}, SHIFT(69),
  [1155] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_name, 1),
  [1157] = {.count = 2, .reusable = true}, REDUCE(sym_namespace_name, 1), SHIFT(1368),
  [1160] = {.count = 1, .reusable = false}, REDUCE(sym_qualified_name, 1),
  [1162] = {.count = 1, .reusable = true}, REDUCE(sym_class_constant_access_expression, 3),
  [1164] = {.count = 1, .reusable = false}, REDUCE(sym_class_constant_access_expression, 3),
  [1166] = {.count = 1, .reusable = true}, SHIFT(103),
  [1168] = {.count = 1, .reusable = true}, REDUCE(sym_array_creation_expression, 3),
  [1170] = {.count = 1, .reusable = false}, REDUCE(sym_array_creation_expression, 3),
  [1172] = {.count = 1, .reusable = true}, REDUCE(sym_array_creation_expression, 5),
  [1174] = {.count = 1, .reusable = false}, REDUCE(sym_array_creation_expression, 5),
  [1176] = {.count = 1, .reusable = true}, REDUCE(sym_array_creation_expression, 4),
  [1178] = {.count = 1, .reusable = false}, REDUCE(sym_array_creation_expression, 4),
  [1180] = {.count = 1, .reusable = true}, REDUCE(sym_array_creation_expression, 6),
  [1182] = {.count = 1, .reusable = false}, REDUCE(sym_array_creation_expression, 6),
  [1184] = {.count = 1, .reusable = true}, REDUCE(sym_array_creation_expression, 2),
  [1186] = {.count = 1, .reusable = false}, REDUCE(sym_array_creation_expression, 2),
  [1188] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2),
  [1190] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2),
  [1192] = {.count = 1, .reusable = true}, REDUCE(sym_object_creation_expression, 2),
  [1194] = {.count = 1, .reusable = true}, SHIFT(176),
  [1196] = {.count = 1, .reusable = false}, REDUCE(sym_object_creation_expression, 2),
  [1198] = {.count = 1, .reusable = true}, SHIFT(1113),
  [1200] = {.count = 1, .reusable = true}, SHIFT(131),
  [1202] = {.count = 1, .reusable = true}, SHIFT(748),
  [1204] = {.count = 1, .reusable = true}, REDUCE(sym_new_variable, 4),
  [1206] = {.count = 1, .reusable = false}, REDUCE(sym_new_variable, 4),
  [1208] = {.count = 1, .reusable = true}, REDUCE(sym_new_variable, 1),
  [1210] = {.count = 1, .reusable = false}, REDUCE(sym_new_variable, 1),
  [1212] = {.count = 1, .reusable = true}, REDUCE(sym_new_variable, 3),
  [1214] = {.count = 1, .reusable = false}, REDUCE(sym_new_variable, 3),
  [1216] = {.count = 1, .reusable = true}, REDUCE(sym__string, 1),
  [1218] = {.count = 1, .reusable = false}, REDUCE(sym__string, 1),
  [1220] = {.count = 1, .reusable = true}, REDUCE(sym_new_variable, 5),
  [1222] = {.count = 1, .reusable = false}, REDUCE(sym_new_variable, 5),
  [1224] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_name, 2),
  [1226] = {.count = 1, .reusable = false}, REDUCE(sym_qualified_name, 2),
  [1228] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 11),
  [1230] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 11),
  [1232] = {.count = 1, .reusable = true}, REDUCE(sym__scope_resolution_qualifier, 1),
  [1234] = {.count = 1, .reusable = true}, SHIFT(970),
  [1236] = {.count = 1, .reusable = true}, REDUCE(sym_relative_scope, 1),
  [1238] = {.count = 1, .reusable = true}, SHIFT(177),
  [1240] = {.count = 1, .reusable = true}, SHIFT(101),
  [1242] = {.count = 1, .reusable = true}, SHIFT(1088),
  [1244] = {.count = 1, .reusable = true}, SHIFT(122),
  [1246] = {.count = 1, .reusable = true}, SHIFT(745),
  [1248] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [1250] = {.count = 1, .reusable = false}, SHIFT(229),
  [1252] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [1254] = {.count = 1, .reusable = true}, SHIFT(226),
  [1256] = {.count = 1, .reusable = true}, SHIFT(225),
  [1258] = {.count = 1, .reusable = true}, SHIFT(172),
  [1260] = {.count = 1, .reusable = true}, SHIFT(243),
  [1262] = {.count = 1, .reusable = false}, SHIFT(242),
  [1264] = {.count = 1, .reusable = true}, SHIFT(241),
  [1266] = {.count = 1, .reusable = false}, SHIFT(240),
  [1268] = {.count = 1, .reusable = true}, SHIFT(240),
  [1270] = {.count = 1, .reusable = false}, SHIFT(239),
  [1272] = {.count = 1, .reusable = true}, SHIFT(239),
  [1274] = {.count = 1, .reusable = true}, SHIFT(238),
  [1276] = {.count = 1, .reusable = false}, SHIFT(237),
  [1278] = {.count = 1, .reusable = true}, SHIFT(237),
  [1280] = {.count = 1, .reusable = true}, REDUCE(sym_object_creation_expression, 5),
  [1282] = {.count = 1, .reusable = false}, REDUCE(sym_object_creation_expression, 5),
  [1284] = {.count = 1, .reusable = true}, REDUCE(sym_unary_op_expression, 2),
  [1286] = {.count = 1, .reusable = false}, SHIFT(138),
  [1288] = {.count = 1, .reusable = true}, SHIFT(223),
  [1290] = {.count = 1, .reusable = true}, SHIFT(222),
  [1292] = {.count = 1, .reusable = true}, SHIFT(220),
  [1294] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5, .production_id = 46),
  [1296] = {.count = 1, .reusable = false}, REDUCE(sym_conditional_expression, 5, .production_id = 46),
  [1298] = {.count = 1, .reusable = false}, REDUCE(sym_unary_op_expression, 2),
  [1300] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 48),
  [1302] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 48),
  [1304] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 49),
  [1306] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 49),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym_clone_expression, 2),
  [1310] = {.count = 1, .reusable = false}, REDUCE(sym_clone_expression, 2),
  [1312] = {.count = 1, .reusable = true}, REDUCE(sym_object_creation_expression, 6),
  [1314] = {.count = 1, .reusable = false}, REDUCE(sym_object_creation_expression, 6),
  [1316] = {.count = 1, .reusable = true}, REDUCE(sym_print_intrinsic, 2),
  [1318] = {.count = 1, .reusable = true}, REDUCE(sym_array_element_initializer, 3),
  [1320] = {.count = 1, .reusable = true}, REDUCE(sym_array_element_initializer, 1),
  [1322] = {.count = 1, .reusable = true}, SHIFT(121),
  [1324] = {.count = 1, .reusable = true}, SHIFT(1066),
  [1326] = {.count = 1, .reusable = true}, SHIFT(1334),
  [1328] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 59),
  [1330] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 59),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_array_element_initializer, 2),
  [1334] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1336] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1338] = {.count = 1, .reusable = true}, SHIFT(709),
  [1340] = {.count = 1, .reusable = true}, REDUCE(sym__unary_expression, 1),
  [1342] = {.count = 1, .reusable = false}, REDUCE(sym__unary_expression, 1),
  [1344] = {.count = 1, .reusable = true}, REDUCE(sym_array_element_initializer, 4),
  [1346] = {.count = 1, .reusable = true}, SHIFT(381),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 39),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 39),
  [1352] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 34),
  [1354] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 34),
  [1356] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 33),
  [1358] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 33),
  [1360] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 4, .production_id = 30),
  [1362] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 4, .production_id = 29),
  [1364] = {.count = 1, .reusable = false}, REDUCE(sym_conditional_expression, 4, .production_id = 29),
  [1366] = {.count = 1, .reusable = true}, REDUCE(sym_object_creation_expression, 4),
  [1368] = {.count = 1, .reusable = false}, REDUCE(sym_object_creation_expression, 4),
  [1370] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4, .production_id = 24),
  [1372] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4, .production_id = 24),
  [1374] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 22),
  [1376] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 22),
  [1378] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 15),
  [1380] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 15),
  [1382] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [1384] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [1386] = {.count = 1, .reusable = true}, REDUCE(sym_include_expression, 2),
  [1388] = {.count = 1, .reusable = true}, REDUCE(sym_include_once_expression, 2),
  [1390] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 11),
  [1392] = {.count = 1, .reusable = true}, REDUCE(sym_require_expression, 2),
  [1394] = {.count = 1, .reusable = true}, REDUCE(sym_require_once_expression, 2),
  [1396] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 12),
  [1398] = {.count = 1, .reusable = true}, REDUCE(sym_exponentiation_expression, 3),
  [1400] = {.count = 1, .reusable = false}, REDUCE(sym_exponentiation_expression, 3),
  [1402] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 9),
  [1404] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 9),
  [1406] = {.count = 1, .reusable = true}, REDUCE(sym_object_creation_expression, 3),
  [1408] = {.count = 1, .reusable = false}, REDUCE(sym_object_creation_expression, 3),
  [1410] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [1412] = {.count = 1, .reusable = false}, SHIFT(308),
  [1414] = {.count = 1, .reusable = false}, SHIFT(1054),
  [1416] = {.count = 1, .reusable = false}, SHIFT(824),
  [1418] = {.count = 1, .reusable = true}, SHIFT(726),
  [1420] = {.count = 1, .reusable = true}, SHIFT(66),
  [1422] = {.count = 2, .reusable = false}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(824),
  [1425] = {.count = 2, .reusable = false}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(454),
  [1428] = {.count = 2, .reusable = false}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1136),
  [1431] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(841),
  [1434] = {.count = 1, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1436] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(66),
  [1439] = {.count = 2, .reusable = false}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1310),
  [1442] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(76),
  [1445] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(419),
  [1448] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(844),
  [1451] = {.count = 1, .reusable = true}, SHIFT(719),
  [1453] = {.count = 1, .reusable = false}, SHIFT(187),
  [1455] = {.count = 1, .reusable = false}, SHIFT(123),
  [1457] = {.count = 1, .reusable = true}, SHIFT(189),
  [1459] = {.count = 1, .reusable = true}, SHIFT(190),
  [1461] = {.count = 1, .reusable = true}, SHIFT(194),
  [1463] = {.count = 1, .reusable = true}, SHIFT(195),
  [1465] = {.count = 1, .reusable = false}, SHIFT(196),
  [1467] = {.count = 1, .reusable = true}, SHIFT(197),
  [1469] = {.count = 1, .reusable = false}, SHIFT(198),
  [1471] = {.count = 1, .reusable = true}, SHIFT(198),
  [1473] = {.count = 1, .reusable = false}, SHIFT(199),
  [1475] = {.count = 1, .reusable = true}, SHIFT(199),
  [1477] = {.count = 1, .reusable = true}, SHIFT(200),
  [1479] = {.count = 1, .reusable = false}, SHIFT(201),
  [1481] = {.count = 1, .reusable = true}, SHIFT(201),
  [1483] = {.count = 1, .reusable = true}, SHIFT(380),
  [1485] = {.count = 1, .reusable = true}, SHIFT(191),
  [1487] = {.count = 1, .reusable = true}, SHIFT(192),
  [1489] = {.count = 1, .reusable = true}, SHIFT(193),
  [1491] = {.count = 1, .reusable = true}, SHIFT(708),
  [1493] = {.count = 1, .reusable = true}, SHIFT(137),
  [1495] = {.count = 1, .reusable = true}, SHIFT(71),
  [1497] = {.count = 1, .reusable = true}, SHIFT(842),
  [1499] = {.count = 1, .reusable = true}, SHIFT(68),
  [1501] = {.count = 1, .reusable = true}, SHIFT(859),
  [1503] = {.count = 1, .reusable = true}, SHIFT(65),
  [1505] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3),
  [1507] = {.count = 1, .reusable = true}, SHIFT(139),
  [1509] = {.count = 1, .reusable = true}, SHIFT(105),
  [1511] = {.count = 1, .reusable = true}, SHIFT(410),
  [1513] = {.count = 1, .reusable = true}, REDUCE(sym_static_variable_declaration, 3, .production_id = 16),
  [1515] = {.count = 1, .reusable = true}, SHIFT(328),
  [1517] = {.count = 1, .reusable = true}, SHIFT(465),
  [1519] = {.count = 1, .reusable = true}, REDUCE(sym_property_initializer, 2),
  [1521] = {.count = 1, .reusable = true}, SHIFT(135),
  [1523] = {.count = 1, .reusable = true}, REDUCE(sym__expressions, 1),
  [1525] = {.count = 1, .reusable = true}, SHIFT(370),
  [1527] = {.count = 1, .reusable = true}, REDUCE(sym_const_element, 3),
  [1529] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 4, .production_id = 50),
  [1531] = {.count = 1, .reusable = true}, SHIFT(8),
  [1533] = {.count = 1, .reusable = true}, SHIFT(285),
  [1535] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_unpacking, 2),
  [1537] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 4, .production_id = 52),
  [1539] = {.count = 1, .reusable = true}, REDUCE(aux_sym_arguments_repeat1, 2),
  [1541] = {.count = 1, .reusable = true}, SHIFT(12),
  [1543] = {.count = 1, .reusable = true}, SHIFT(133),
  [1545] = {.count = 1, .reusable = true}, SHIFT(1135),
  [1547] = {.count = 1, .reusable = true}, SHIFT(11),
  [1549] = {.count = 1, .reusable = true}, SHIFT(286),
  [1551] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 5, .production_id = 60),
  [1553] = {.count = 1, .reusable = true}, SHIFT(1060),
  [1555] = {.count = 1, .reusable = true}, SHIFT(287),
  [1557] = {.count = 1, .reusable = true}, SHIFT(299),
  [1559] = {.count = 1, .reusable = true}, SHIFT(288),
  [1561] = {.count = 1, .reusable = true}, SHIFT(1139),
  [1563] = {.count = 1, .reusable = true}, SHIFT(1138),
  [1565] = {.count = 1, .reusable = true}, SHIFT(1137),
  [1567] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 3, .production_id = 38),
  [1569] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_pair, 3),
  [1571] = {.count = 1, .reusable = true}, SHIFT(355),
  [1573] = {.count = 1, .reusable = false}, SHIFT(869),
  [1575] = {.count = 1, .reusable = false}, SHIFT(716),
  [1577] = {.count = 1, .reusable = true}, SHIFT(1076),
  [1579] = {.count = 1, .reusable = true}, SHIFT(910),
  [1581] = {.count = 1, .reusable = true}, SHIFT(1199),
  [1583] = {.count = 1, .reusable = false}, SHIFT(703),
  [1585] = {.count = 1, .reusable = false}, SHIFT(922),
  [1587] = {.count = 1, .reusable = true}, SHIFT(1363),
  [1589] = {.count = 1, .reusable = true}, SHIFT(418),
  [1591] = {.count = 1, .reusable = true}, SHIFT(9),
  [1593] = {.count = 1, .reusable = true}, SHIFT(10),
  [1595] = {.count = 1, .reusable = true}, SHIFT(474),
  [1597] = {.count = 1, .reusable = true}, SHIFT(594),
  [1599] = {.count = 1, .reusable = true}, SHIFT(1140),
  [1601] = {.count = 1, .reusable = true}, SHIFT(462),
  [1603] = {.count = 1, .reusable = true}, SHIFT(365),
  [1605] = {.count = 1, .reusable = true}, SHIFT(340),
  [1607] = {.count = 1, .reusable = true}, SHIFT(178),
  [1609] = {.count = 1, .reusable = true}, SHIFT(589),
  [1611] = {.count = 1, .reusable = true}, SHIFT(343),
  [1613] = {.count = 1, .reusable = true}, SHIFT(473),
  [1615] = {.count = 1, .reusable = true}, SHIFT(108),
  [1617] = {.count = 1, .reusable = true}, SHIFT(394),
  [1619] = {.count = 1, .reusable = true}, SHIFT(405),
  [1621] = {.count = 1, .reusable = true}, SHIFT(357),
  [1623] = {.count = 1, .reusable = true}, SHIFT(1075),
  [1625] = {.count = 1, .reusable = true}, SHIFT(403),
  [1627] = {.count = 1, .reusable = true}, SHIFT(333),
  [1629] = {.count = 1, .reusable = true}, SHIFT(409),
  [1631] = {.count = 1, .reusable = true}, SHIFT(1281),
  [1633] = {.count = 1, .reusable = true}, SHIFT(421),
  [1635] = {.count = 1, .reusable = true}, SHIFT(1262),
  [1637] = {.count = 1, .reusable = true}, SHIFT(453),
  [1639] = {.count = 1, .reusable = true}, SHIFT(162),
  [1641] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1643] = {.count = 1, .reusable = true}, SHIFT(326),
  [1645] = {.count = 1, .reusable = true}, SHIFT(464),
  [1647] = {.count = 1, .reusable = true}, REDUCE(sym_foreach_pair, 4),
  [1649] = {.count = 1, .reusable = true}, SHIFT(455),
  [1651] = {.count = 1, .reusable = true}, SHIFT(106),
  [1653] = {.count = 1, .reusable = true}, SHIFT(758),
  [1655] = {.count = 1, .reusable = true}, SHIFT(737),
  [1657] = {.count = 1, .reusable = true}, SHIFT(817),
  [1659] = {.count = 1, .reusable = true}, SHIFT(800),
  [1661] = {.count = 1, .reusable = true}, SHIFT(433),
  [1663] = {.count = 1, .reusable = true}, SHIFT(739),
  [1665] = {.count = 1, .reusable = true}, SHIFT(752),
  [1667] = {.count = 1, .reusable = true}, SHIFT(740),
  [1669] = {.count = 1, .reusable = true}, SHIFT(257),
  [1671] = {.count = 1, .reusable = true}, SHIFT(541),
  [1673] = {.count = 1, .reusable = true}, SHIFT(542),
  [1675] = {.count = 1, .reusable = true}, SHIFT(213),
  [1677] = {.count = 1, .reusable = true}, SHIFT(267),
  [1679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(758),
  [1682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(737),
  [1685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(817),
  [1688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(800),
  [1691] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [1693] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(739),
  [1696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(752),
  [1699] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(740),
  [1702] = {.count = 1, .reusable = true}, SHIFT(173),
  [1704] = {.count = 1, .reusable = true}, SHIFT(435),
  [1706] = {.count = 1, .reusable = false}, SHIFT(704),
  [1708] = {.count = 1, .reusable = false}, SHIFT(439),
  [1710] = {.count = 1, .reusable = false}, SHIFT(702),
  [1712] = {.count = 1, .reusable = false}, SHIFT(1099),
  [1714] = {.count = 1, .reusable = false}, SHIFT(766),
  [1716] = {.count = 1, .reusable = false}, SHIFT(768),
  [1718] = {.count = 1, .reusable = true}, SHIFT(864),
  [1720] = {.count = 1, .reusable = false}, SHIFT(799),
  [1722] = {.count = 2, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(758),
  [1725] = {.count = 1, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [1727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(739),
  [1730] = {.count = 2, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(752),
  [1733] = {.count = 2, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(740),
  [1736] = {.count = 1, .reusable = true}, SHIFT(862),
  [1738] = {.count = 1, .reusable = false}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1740] = {.count = 1, .reusable = true}, REDUCE(sym_use_declaration, 4),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 3),
  [1744] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 2, .production_id = 4),
  [1746] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 2, .production_id = 40),
  [1748] = {.count = 1, .reusable = true}, REDUCE(sym_property_declaration, 3),
  [1750] = {.count = 1, .reusable = true}, SHIFT(868),
  [1752] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 3, .production_id = 54),
  [1754] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 2),
  [1756] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 3, .production_id = 53),
  [1758] = {.count = 1, .reusable = true}, SHIFT(872),
  [1760] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [1762] = {.count = 1, .reusable = true}, REDUCE(sym__member_declaration, 1),
  [1764] = {.count = 1, .reusable = true}, REDUCE(sym_use_declaration, 3),
  [1766] = {.count = 1, .reusable = true}, REDUCE(sym_property_declaration, 4),
  [1768] = {.count = 1, .reusable = true}, REDUCE(sym__modifier, 1),
  [1770] = {.count = 1, .reusable = true}, SHIFT(797),
  [1772] = {.count = 1, .reusable = true}, REDUCE(sym_class_modifier, 1),
  [1774] = {.count = 1, .reusable = true}, REDUCE(sym_visibility_modifier, 1),
  [1776] = {.count = 1, .reusable = false}, SHIFT(447),
  [1778] = {.count = 1, .reusable = true}, SHIFT(149),
  [1780] = {.count = 1, .reusable = false}, SHIFT(456),
  [1782] = {.count = 1, .reusable = true}, SHIFT(164),
  [1784] = {.count = 1, .reusable = false}, SHIFT(777),
  [1786] = {.count = 1, .reusable = true}, SHIFT(1120),
  [1788] = {.count = 1, .reusable = false}, SHIFT(415),
  [1790] = {.count = 1, .reusable = false}, SHIFT(411),
  [1792] = {.count = 1, .reusable = true}, SHIFT(205),
  [1794] = {.count = 1, .reusable = true}, SHIFT(617),
  [1796] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1798] = {.count = 1, .reusable = false}, SHIFT(330),
  [1800] = {.count = 1, .reusable = false}, SHIFT(339),
  [1802] = {.count = 1, .reusable = true}, SHIFT(204),
  [1804] = {.count = 1, .reusable = true}, SHIFT(1275),
  [1806] = {.count = 1, .reusable = false}, SHIFT(440),
  [1808] = {.count = 1, .reusable = true}, SHIFT(215),
  [1810] = {.count = 1, .reusable = false}, SHIFT(388),
  [1812] = {.count = 1, .reusable = true}, SHIFT(227),
  [1814] = {.count = 1, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat1, 1),
  [1816] = {.count = 1, .reusable = true}, REDUCE(sym_static_modifier, 1),
  [1818] = {.count = 1, .reusable = false}, SHIFT(822),
  [1820] = {.count = 1, .reusable = true}, SHIFT(231),
  [1822] = {.count = 1, .reusable = false}, SHIFT(351),
  [1824] = {.count = 1, .reusable = false}, SHIFT(363),
  [1826] = {.count = 1, .reusable = true}, SHIFT(148),
  [1828] = {.count = 1, .reusable = false}, SHIFT(808),
  [1830] = {.count = 1, .reusable = true}, SHIFT(235),
  [1832] = {.count = 1, .reusable = false}, SHIFT(390),
  [1834] = {.count = 1, .reusable = true}, SHIFT(219),
  [1836] = {.count = 2, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1403),
  [1839] = {.count = 2, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1158),
  [1842] = {.count = 1, .reusable = false}, SHIFT(1182),
  [1844] = {.count = 1, .reusable = true}, SHIFT(772),
  [1846] = {.count = 1, .reusable = true}, SHIFT(672),
  [1848] = {.count = 1, .reusable = true}, SHIFT(1403),
  [1850] = {.count = 1, .reusable = true}, SHIFT(1158),
  [1852] = {.count = 1, .reusable = true}, SHIFT(691),
  [1854] = {.count = 1, .reusable = true}, SHIFT(733),
  [1856] = {.count = 1, .reusable = true}, SHIFT(741),
  [1858] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_statement_repeat1, 2),
  [1860] = {.count = 1, .reusable = true}, SHIFT(693),
  [1862] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_literal_repeat1, 4),
  [1864] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [1866] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(165),
  [1869] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1231),
  [1872] = {.count = 1, .reusable = false}, SHIFT(1187),
  [1874] = {.count = 1, .reusable = true}, SHIFT(1352),
  [1876] = {.count = 1, .reusable = false}, SHIFT(1352),
  [1878] = {.count = 1, .reusable = true}, SHIFT(1193),
  [1880] = {.count = 1, .reusable = true}, SHIFT(165),
  [1882] = {.count = 1, .reusable = true}, SHIFT(1231),
  [1884] = {.count = 1, .reusable = true}, SHIFT(1222),
  [1886] = {.count = 1, .reusable = true}, SHIFT(254),
  [1888] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1890] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1892] = {.count = 1, .reusable = false}, SHIFT(1167),
  [1894] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 3),
  [1896] = {.count = 1, .reusable = true}, SHIFT(831),
  [1898] = {.count = 1, .reusable = true}, SHIFT(272),
  [1900] = {.count = 1, .reusable = true}, SHIFT(1253),
  [1902] = {.count = 1, .reusable = true}, SHIFT(1214),
  [1904] = {.count = 1, .reusable = true}, SHIFT(1213),
  [1906] = {.count = 1, .reusable = true}, SHIFT(1330),
  [1908] = {.count = 1, .reusable = true}, SHIFT(700),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 2),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1191),
  [1914] = {.count = 1, .reusable = true}, SHIFT(695),
  [1916] = {.count = 1, .reusable = false}, SHIFT(1382),
  [1918] = {.count = 1, .reusable = true}, SHIFT(32),
  [1920] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_function_or_const, 1),
  [1922] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_function_or_const, 1),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1190),
  [1926] = {.count = 1, .reusable = false}, SHIFT(59),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1930] = {.count = 1, .reusable = true}, SHIFT(865),
  [1932] = {.count = 1, .reusable = true}, SHIFT(1301),
  [1934] = {.count = 1, .reusable = false}, SHIFT(1166),
  [1936] = {.count = 1, .reusable = true}, SHIFT(839),
  [1938] = {.count = 1, .reusable = true}, SHIFT(718),
  [1940] = {.count = 1, .reusable = true}, SHIFT(736),
  [1942] = {.count = 1, .reusable = true}, SHIFT(545),
  [1944] = {.count = 1, .reusable = false}, SHIFT(876),
  [1946] = {.count = 1, .reusable = true}, SHIFT(984),
  [1948] = {.count = 1, .reusable = true}, SHIFT(731),
  [1950] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1952] = {.count = 1, .reusable = true}, SHIFT(1320),
  [1954] = {.count = 1, .reusable = true}, SHIFT(1240),
  [1956] = {.count = 1, .reusable = true}, SHIFT(988),
  [1958] = {.count = 1, .reusable = true}, SHIFT(836),
  [1960] = {.count = 1, .reusable = true}, SHIFT(852),
  [1962] = {.count = 1, .reusable = true}, SHIFT(973),
  [1964] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_name, 1),
  [1966] = {.count = 2, .reusable = true}, REDUCE(sym_namespace_name, 1), SHIFT(1341),
  [1969] = {.count = 1, .reusable = true}, REDUCE(sym__function_definition_header, 4, .production_id = 17),
  [1971] = {.count = 1, .reusable = true}, SHIFT(701),
  [1973] = {.count = 1, .reusable = true}, REDUCE(aux_sym_text_repeat1, 2),
  [1975] = {.count = 1, .reusable = false}, REDUCE(aux_sym_text_repeat1, 2),
  [1977] = {.count = 2, .reusable = false}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(960),
  [1980] = {.count = 1, .reusable = false}, SHIFT(1145),
  [1982] = {.count = 1, .reusable = true}, REDUCE(aux_sym_interface_base_clause_repeat1, 2),
  [1984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_interface_base_clause_repeat1, 2), SHIFT_REPEAT(736),
  [1987] = {.count = 2, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 1), SHIFT(1245),
  [1990] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 1),
  [1992] = {.count = 1, .reusable = true}, SHIFT(457),
  [1994] = {.count = 1, .reusable = true}, SHIFT(212),
  [1996] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44),
  [1998] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44), SHIFT_REPEAT(1168),
  [2001] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44),
  [2003] = {.count = 1, .reusable = true}, SHIFT(347),
  [2005] = {.count = 1, .reusable = true}, SHIFT(141),
  [2007] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_name, 2),
  [2009] = {.count = 2, .reusable = true}, REDUCE(sym_namespace_name, 2), SHIFT(1341),
  [2012] = {.count = 1, .reusable = false}, SHIFT(422),
  [2014] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2016] = {.count = 1, .reusable = true}, SHIFT(936),
  [2018] = {.count = 1, .reusable = true}, SHIFT(992),
  [2020] = {.count = 1, .reusable = true}, REDUCE(sym_property_element, 1),
  [2022] = {.count = 1, .reusable = true}, SHIFT(143),
  [2024] = {.count = 2, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 2), SHIFT(1245),
  [2027] = {.count = 1, .reusable = true}, REDUCE(sym__function_definition_header, 3, .production_id = 8),
  [2029] = {.count = 1, .reusable = true}, REDUCE(aux_sym_namespace_name_repeat1, 2),
  [2031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(1368),
  [2034] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2036] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2038] = {.count = 1, .reusable = true}, SHIFT(404),
  [2040] = {.count = 1, .reusable = true}, SHIFT(216),
  [2042] = {.count = 1, .reusable = true}, REDUCE(sym_text, 1),
  [2044] = {.count = 1, .reusable = false}, REDUCE(sym_text, 1),
  [2046] = {.count = 1, .reusable = true}, SHIFT(247),
  [2048] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2050] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2052] = {.count = 1, .reusable = false}, SHIFT(1086),
  [2054] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2056] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2058] = {.count = 1, .reusable = false}, SHIFT(958),
  [2060] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2062] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(1341),
  [2067] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1190),
  [2070] = {.count = 1, .reusable = false}, SHIFT(503),
  [2072] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_clause, 1),
  [2074] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2076] = {.count = 1, .reusable = true}, SHIFT(371),
  [2078] = {.count = 1, .reusable = true}, SHIFT(167),
  [2080] = {.count = 1, .reusable = true}, SHIFT(292),
  [2082] = {.count = 1, .reusable = true}, SHIFT(725),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2086] = {.count = 1, .reusable = true}, SHIFT(721),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2092] = {.count = 1, .reusable = true}, SHIFT(251),
  [2094] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2096] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2098] = {.count = 1, .reusable = true}, SHIFT(711),
  [2100] = {.count = 1, .reusable = true}, SHIFT(818),
  [2102] = {.count = 1, .reusable = true}, SHIFT(734),
  [2104] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_static_declaration_repeat1, 2),
  [2106] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_static_declaration_repeat1, 2), SHIFT_REPEAT(1103),
  [2109] = {.count = 1, .reusable = true}, SHIFT(710),
  [2111] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_declaration_repeat1, 2),
  [2113] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_declaration_repeat1, 2), SHIFT_REPEAT(1104),
  [2116] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_name_as_prefix, 4),
  [2118] = {.count = 1, .reusable = true}, SHIFT(255),
  [2120] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2124] = {.count = 1, .reusable = true}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2),
  [2126] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2), SHIFT_REPEAT(725),
  [2129] = {.count = 1, .reusable = true}, SHIFT(295),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2133] = {.count = 1, .reusable = true}, SHIFT(298),
  [2135] = {.count = 1, .reusable = true}, SHIFT(214),
  [2137] = {.count = 1, .reusable = true}, SHIFT(129),
  [2139] = {.count = 1, .reusable = true}, SHIFT(754),
  [2141] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [2143] = {.count = 1, .reusable = true}, SHIFT(727),
  [2145] = {.count = 1, .reusable = true}, SHIFT(722),
  [2147] = {.count = 1, .reusable = true}, SHIFT(966),
  [2149] = {.count = 1, .reusable = true}, SHIFT(968),
  [2151] = {.count = 1, .reusable = true}, SHIFT(274),
  [2153] = {.count = 1, .reusable = true}, REDUCE(sym_static_variable_declaration, 1, .production_id = 1),
  [2155] = {.count = 1, .reusable = true}, SHIFT(218),
  [2157] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [2159] = {.count = 1, .reusable = true}, SHIFT(258),
  [2161] = {.count = 1, .reusable = true}, SHIFT(696),
  [2163] = {.count = 1, .reusable = true}, SHIFT(283),
  [2165] = {.count = 1, .reusable = true}, REDUCE(sym_primitive_type, 1),
  [2167] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1, .production_id = 7),
  [2169] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2171] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2175] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2177] = {.count = 1, .reusable = true}, SHIFT(712),
  [2179] = {.count = 1, .reusable = true}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [2181] = {.count = 2, .reusable = true}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(818),
  [2184] = {.count = 1, .reusable = true}, SHIFT(208),
  [2186] = {.count = 1, .reusable = true}, SHIFT(128),
  [2188] = {.count = 1, .reusable = true}, SHIFT(760),
  [2190] = {.count = 1, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat2, 2),
  [2192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_property_declaration_repeat2, 2), SHIFT_REPEAT(966),
  [2195] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_group_clause, 1),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2199] = {.count = 1, .reusable = true}, SHIFT(269),
  [2201] = {.count = 1, .reusable = true}, SHIFT(277),
  [2203] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(117),
  [2206] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2208] = {.count = 1, .reusable = true}, SHIFT(174),
  [2210] = {.count = 1, .reusable = true}, SHIFT(126),
  [2212] = {.count = 1, .reusable = true}, SHIFT(750),
  [2214] = {.count = 2, .reusable = false}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(944),
  [2217] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_block_repeat1, 1),
  [2219] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type, 2, .production_id = 18),
  [2221] = {.count = 1, .reusable = true}, SHIFT(732),
  [2223] = {.count = 1, .reusable = true}, SHIFT(217),
  [2225] = {.count = 1, .reusable = true}, SHIFT(127),
  [2227] = {.count = 1, .reusable = true}, SHIFT(762),
  [2229] = {.count = 1, .reusable = true}, SHIFT(753),
  [2231] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type, 2),
  [2233] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_group_clause, 2),
  [2235] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [2237] = {.count = 1, .reusable = false}, SHIFT(944),
  [2239] = {.count = 1, .reusable = true}, SHIFT(130),
  [2241] = {.count = 1, .reusable = true}, REDUCE(aux_sym_text_repeat1, 1),
  [2243] = {.count = 1, .reusable = false}, REDUCE(aux_sym_text_repeat1, 1),
  [2245] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_aliasing_clause, 2),
  [2247] = {.count = 1, .reusable = true}, SHIFT(971),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2251] = {.count = 1, .reusable = true}, REDUCE(sym__function_definition_header, 5, .production_id = 35),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2257] = {.count = 1, .reusable = true}, SHIFT(821),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2261] = {.count = 1, .reusable = true}, SHIFT(98),
  [2263] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 4),
  [2265] = {.count = 1, .reusable = true}, SHIFT(407),
  [2267] = {.count = 1, .reusable = true}, SHIFT(104),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_literal_repeat1, 2), SHIFT_REPEAT(119),
  [2276] = {.count = 1, .reusable = true}, SHIFT(364),
  [2278] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 7),
  [2280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(105),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2285] = {.count = 2, .reusable = true}, REDUCE(aux_sym_interface_base_clause_repeat1, 2), SHIFT_REPEAT(742),
  [2288] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 5),
  [2290] = {.count = 1, .reusable = true}, SHIFT(468),
  [2292] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 2, .production_id = 5),
  [2294] = {.count = 1, .reusable = true}, SHIFT(159),
  [2296] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2298] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 2, .production_id = 19),
  [2300] = {.count = 1, .reusable = true}, SHIFT(156),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2304] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 3),
  [2306] = {.count = 1, .reusable = true}, SHIFT(779),
  [2308] = {.count = 1, .reusable = true}, SHIFT(778),
  [2310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(690),
  [2313] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2317] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 3, .production_id = 37),
  [2319] = {.count = 1, .reusable = true}, SHIFT(142),
  [2321] = {.count = 1, .reusable = true}, SHIFT(95),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2325] = {.count = 1, .reusable = true}, REDUCE(sym_simple_parameter, 1, .production_id = 1),
  [2327] = {.count = 1, .reusable = true}, SHIFT(145),
  [2329] = {.count = 1, .reusable = true}, SHIFT(690),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2333] = {.count = 2, .reusable = true}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2), SHIFT_REPEAT(971),
  [2336] = {.count = 1, .reusable = true}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2),
  [2338] = {.count = 1, .reusable = true}, SHIFT(329),
  [2340] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2342] = {.count = 1, .reusable = true}, REDUCE(sym_property_element, 2),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2348] = {.count = 1, .reusable = true}, SHIFT(82),
  [2350] = {.count = 1, .reusable = true}, SHIFT(86),
  [2352] = {.count = 1, .reusable = true}, REDUCE(sym__return_type, 2, .production_id = 21),
  [2354] = {.count = 1, .reusable = true}, REDUCE(sym__function_definition_header, 4, .production_id = 20),
  [2356] = {.count = 1, .reusable = true}, SHIFT(957),
  [2358] = {.count = 1, .reusable = true}, SHIFT(742),
  [2360] = {.count = 1, .reusable = true}, REDUCE(sym_class_interface_clause, 2),
  [2362] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2364] = {.count = 1, .reusable = true}, REDUCE(sym_interface_base_clause, 3),
  [2366] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 25),
  [2368] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 25),
  [2370] = {.count = 1, .reusable = true}, SHIFT(87),
  [2372] = {.count = 1, .reusable = true}, REDUCE(sym_else_if_clause_2, 3, .production_id = 10),
  [2374] = {.count = 1, .reusable = false}, REDUCE(sym_else_if_clause_2, 3, .production_id = 10),
  [2376] = {.count = 1, .reusable = true}, REDUCE(sym_class_interface_clause, 3),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2380] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_use_group_repeat1, 2), SHIFT_REPEAT(821),
  [2385] = {.count = 1, .reusable = true}, REDUCE(aux_sym_namespace_use_group_repeat1, 2),
  [2387] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_clause, 2),
  [2389] = {.count = 1, .reusable = true}, SHIFT(89),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2393] = {.count = 1, .reusable = true}, REDUCE(sym_use_as_clause, 3),
  [2395] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 6),
  [2397] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_statement_repeat1, 2), SHIFT_REPEAT(617),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2402] = {.count = 1, .reusable = true}, SHIFT(807),
  [2404] = {.count = 1, .reusable = true}, SHIFT(776),
  [2406] = {.count = 1, .reusable = true}, SHIFT(918),
  [2408] = {.count = 1, .reusable = true}, REDUCE(sym_interface_base_clause, 2),
  [2410] = {.count = 1, .reusable = true}, SHIFT(90),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2414] = {.count = 1, .reusable = true}, SHIFT(171),
  [2416] = {.count = 1, .reusable = true}, REDUCE(sym_use_instead_of_clause, 3),
  [2418] = {.count = 1, .reusable = true}, SHIFT(651),
  [2420] = {.count = 1, .reusable = true}, SHIFT(144),
  [2422] = {.count = 1, .reusable = true}, SHIFT(281),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_group, 4),
  [2430] = {.count = 1, .reusable = true}, SHIFT(312),
  [2432] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_use_clause, 5),
  [2434] = {.count = 1, .reusable = true}, SHIFT(320),
  [2436] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_use_clause, 6),
  [2438] = {.count = 1, .reusable = true}, SHIFT(271),
  [2440] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_parameter, 3, .production_id = 37),
  [2442] = {.count = 1, .reusable = true}, SHIFT(975),
  [2444] = {.count = 1, .reusable = true}, SHIFT(978),
  [2446] = {.count = 1, .reusable = true}, SHIFT(979),
  [2448] = {.count = 1, .reusable = true}, SHIFT(983),
  [2450] = {.count = 1, .reusable = true}, SHIFT(77),
  [2452] = {.count = 1, .reusable = true}, REDUCE(sym_cast_type, 1),
  [2454] = {.count = 1, .reusable = true}, SHIFT(276),
  [2456] = {.count = 1, .reusable = true}, SHIFT(305),
  [2458] = {.count = 1, .reusable = true}, SHIFT(991),
  [2460] = {.count = 1, .reusable = true}, SHIFT(994),
  [2462] = {.count = 1, .reusable = true}, SHIFT(284),
  [2464] = {.count = 1, .reusable = true}, SHIFT(998),
  [2466] = {.count = 1, .reusable = true}, SHIFT(999),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2470] = {.count = 1, .reusable = true}, SHIFT(168),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2480] = {.count = 1, .reusable = true}, SHIFT(321),
  [2482] = {.count = 1, .reusable = true}, SHIFT(6),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2490] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2494] = {.count = 1, .reusable = true}, SHIFT(717),
  [2496] = {.count = 1, .reusable = true}, SHIFT(268),
  [2498] = {.count = 1, .reusable = true}, SHIFT(266),
  [2500] = {.count = 1, .reusable = true}, SHIFT(296),
  [2502] = {.count = 1, .reusable = true}, SHIFT(297),
  [2504] = {.count = 1, .reusable = true}, SHIFT(313),
  [2506] = {.count = 1, .reusable = true}, SHIFT(33),
  [2508] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_parameter, 3, .production_id = 36),
  [2510] = {.count = 1, .reusable = true}, SHIFT(302),
  [2512] = {.count = 1, .reusable = true}, REDUCE(sym_class_base_clause, 2),
  [2514] = {.count = 1, .reusable = true}, SHIFT(244),
  [2516] = {.count = 1, .reusable = true}, SHIFT(876),
  [2518] = {.count = 1, .reusable = true}, SHIFT(315),
  [2520] = {.count = 1, .reusable = true}, SHIFT(278),
  [2522] = {.count = 1, .reusable = true}, SHIFT(262),
  [2524] = {.count = 1, .reusable = true}, SHIFT(316),
  [2526] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_group_clause, 3),
  [2528] = {.count = 1, .reusable = true}, SHIFT(304),
  [2530] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_use_group, 3),
  [2532] = {.count = 1, .reusable = true}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 3),
  [2534] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_parameter, 4, .production_id = 51),
  [2536] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_parameter, 2, .production_id = 5),
  [2538] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_function_use_clause, 4),
  [2540] = {.count = 1, .reusable = true}, REDUCE(sym_use_as_clause, 4),
  [2542] = {.count = 2, .reusable = true}, REDUCE(sym_namespace_name, 2), SHIFT(1368),
  [2545] = {.count = 1, .reusable = true}, SHIFT(757),
  [2547] = {.count = 1, .reusable = true}, SHIFT(746),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2551] = {.count = 1, .reusable = true}, SHIFT(795),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2557] = {.count = 1, .reusable = true}, SHIFT(891),
  [2559] = {.count = 1, .reusable = true}, SHIFT(791),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2563] = {.count = 1, .reusable = true}, SHIFT(945),
  [2565] = {.count = 1, .reusable = true}, SHIFT(811),
  [2567] = {.count = 1, .reusable = true}, SHIFT(761),
  [2569] = {.count = 1, .reusable = true}, SHIFT(773),
  [2571] = {.count = 1, .reusable = true}, SHIFT(23),
  [2573] = {.count = 1, .reusable = true}, SHIFT(25),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2579] = {.count = 1, .reusable = true}, SHIFT(44),
  [2581] = {.count = 1, .reusable = true}, SHIFT(609),
  [2583] = {.count = 1, .reusable = true}, SHIFT(735),
  [2585] = {.count = 1, .reusable = true}, SHIFT(346),
  [2587] = {.count = 1, .reusable = true}, SHIFT(759),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2591] = {.count = 1, .reusable = true}, SHIFT(125),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2597] = {.count = 1, .reusable = true}, SHIFT(744),
  [2599] = {.count = 1, .reusable = true}, SHIFT(85),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2603] = {.count = 1, .reusable = true}, SHIFT(94),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2609] = {.count = 1, .reusable = true}, SHIFT(812),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2613] = {.count = 1, .reusable = true}, SHIFT(881),
  [2615] = {.count = 1, .reusable = true}, SHIFT(961),
  [2617] = {.count = 1, .reusable = true}, SHIFT(152),
  [2619] = {.count = 1, .reusable = true}, SHIFT(97),
  [2621] = {.count = 1, .reusable = true}, SHIFT(51),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2625] = {.count = 1, .reusable = true}, SHIFT(781),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2631] = {.count = 1, .reusable = true}, REDUCE(sym_declare_directive, 3),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2635] = {.count = 1, .reusable = true}, SHIFT(925),
  [2637] = {.count = 1, .reusable = true}, SHIFT(616),
  [2639] = {.count = 1, .reusable = true}, SHIFT(78),
  [2641] = {.count = 1, .reusable = true}, SHIFT(335),
  [2643] = {.count = 1, .reusable = true}, SHIFT(809),
  [2645] = {.count = 1, .reusable = true}, SHIFT(612),
  [2647] = {.count = 1, .reusable = true}, SHIFT(803),
  [2649] = {.count = 1, .reusable = true}, SHIFT(897),
  [2651] = {.count = 1, .reusable = true}, SHIFT(920),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2655] = {.count = 1, .reusable = true}, SHIFT(613),
  [2657] = {.count = 1, .reusable = true}, SHIFT(755),
  [2659] = {.count = 1, .reusable = true}, SHIFT(902),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2663] = {.count = 1, .reusable = true}, SHIFT(794),
  [2665] = {.count = 1, .reusable = true}, SHIFT(820),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2669] = {.count = 1, .reusable = true}, SHIFT(789),
  [2671] = {.count = 1, .reusable = true}, SHIFT(788),
  [2673] = {.count = 1, .reusable = true}, SHIFT(84),
  [2675] = {.count = 1, .reusable = true}, SHIFT(783),
  [2677] = {.count = 1, .reusable = true}, SHIFT(232),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2681] = {.count = 1, .reusable = true}, SHIFT(83),
  [2683] = {.count = 1, .reusable = true}, SHIFT(344),
  [2685] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause_2, 2, .production_id = 2),
  [2687] = {.count = 1, .reusable = true}, SHIFT(614),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2691] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2693] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2695] = {.count = 1, .reusable = true}, SHIFT(618),
  [2697] = {.count = 1, .reusable = true}, SHIFT(953),
  [2699] = {.count = 1, .reusable = true}, SHIFT(615),
  [2701] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [2703] = {.count = 1, .reusable = true}, SHIFT(100),
  [2705] = {.count = 1, .reusable = true}, SHIFT(793),
  [2707] = {.count = 1, .reusable = true}, SHIFT(81),
  [2709] = {.count = 1, .reusable = true}, SHIFT(743),
  [2711] = {.count = 1, .reusable = true}, SHIFT(153),
  [2713] = {.count = 1, .reusable = true}, REDUCE(sym_text_interpolation, 3),
  [2715] = {.count = 1, .reusable = true}, REDUCE(sym_text_interpolation, 2),
};

void *tree_sitter_php_external_scanner_create(void);
void tree_sitter_php_external_scanner_destroy(void *);
bool tree_sitter_php_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_php_external_scanner_serialize(void *, char *);
void tree_sitter_php_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_php(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_php_external_scanner_create,
      tree_sitter_php_external_scanner_destroy,
      tree_sitter_php_external_scanner_scan,
      tree_sitter_php_external_scanner_serialize,
      tree_sitter_php_external_scanner_deserialize,
    },
  };
  return &language;
}
